# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).  # noqa: E501

    OpenAPI spec version: 2024-05-20
    Contact: docs@zuora.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

from __future__ import absolute_import

import re  # noqa: F401

# python 2 and python 3 compatibility library
import six

from zuora_sdk.api_client import ApiClient


class ReportsApi(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    Ref: https://github.com/swagger-api/swagger-codegen
    """

    def __init__(self, api_client=None):
        if api_client is None:
            api_client = ApiClient()
        self.api_client = api_client

    def integration_v1_reports_download_filename_get(self, token, filename, **kwargs):  # noqa: E501
        """integration_v1_reports_download_filename_get  # noqa: E501

        Use this API to Download Reports from RevPro  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.integration_v1_reports_download_filename_get(token, filename, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str token: Authorization token issued by the authentication API (required)
        :param str filename: download report name (required)
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.integration_v1_reports_download_filename_get_with_http_info(token, filename, **kwargs)  # noqa: E501
        else:
            (data) = self.integration_v1_reports_download_filename_get_with_http_info(token, filename, **kwargs)  # noqa: E501
            return data

    def integration_v1_reports_download_filename_get_with_http_info(self, token, filename, **kwargs):  # noqa: E501
        """integration_v1_reports_download_filename_get  # noqa: E501

        Use this API to Download Reports from RevPro  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.integration_v1_reports_download_filename_get_with_http_info(token, filename, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str token: Authorization token issued by the authentication API (required)
        :param str filename: download report name (required)
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['token', 'filename']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method integration_v1_reports_download_filename_get" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'token' is set
        if ('token' not in params or
                params['token'] is None):
            raise ValueError("Missing the required parameter `token` when calling `integration_v1_reports_download_filename_get`")  # noqa: E501
        # verify the required parameter 'filename' is set
        if ('filename' not in params or
                params['filename'] is None):
            raise ValueError("Missing the required parameter `filename` when calling `integration_v1_reports_download_filename_get`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'filename' in params:
            path_params['filename'] = params['filename']  # noqa: E501

        query_params = []

        header_params = {}
        if 'token' in params:
            header_params['token'] = params['token']  # noqa: E501

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['bearerAuth']  # noqa: E501

        return self.api_client.call_api(
            '/integration/v1/reports/download/{filename}', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type=None,  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def integration_v1_reports_list_get(self, token, createddate, **kwargs):  # noqa: E501
        """integration_v1_reports_list_get  # noqa: E501

        Use this API to Fetch List of Reports available for provided date  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.integration_v1_reports_list_get(token, createddate, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str token: Authorization token issued by the authentication API (required)
        :param date createddate: date when report was created (required)
        :return: ExpandedReportList
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.integration_v1_reports_list_get_with_http_info(token, createddate, **kwargs)  # noqa: E501
        else:
            (data) = self.integration_v1_reports_list_get_with_http_info(token, createddate, **kwargs)  # noqa: E501
            return data

    def integration_v1_reports_list_get_with_http_info(self, token, createddate, **kwargs):  # noqa: E501
        """integration_v1_reports_list_get  # noqa: E501

        Use this API to Fetch List of Reports available for provided date  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.integration_v1_reports_list_get_with_http_info(token, createddate, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str token: Authorization token issued by the authentication API (required)
        :param date createddate: date when report was created (required)
        :return: ExpandedReportList
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['token', 'createddate']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method integration_v1_reports_list_get" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'token' is set
        if ('token' not in params or
                params['token'] is None):
            raise ValueError("Missing the required parameter `token` when calling `integration_v1_reports_list_get`")  # noqa: E501
        # verify the required parameter 'createddate' is set
        if ('createddate' not in params or
                params['createddate'] is None):
            raise ValueError("Missing the required parameter `createddate` when calling `integration_v1_reports_list_get`")  # noqa: E501

        collection_formats = {}

        path_params = {}

        query_params = []
        if 'createddate' in params:
            query_params.append(('createddate', params['createddate']))  # noqa: E501

        header_params = {}
        if 'token' in params:
            header_params['token'] = params['token']  # noqa: E501

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['bearerAuth']  # noqa: E501

        return self.api_client.call_api(
            '/integration/v1/reports/list', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='ExpandedReportList',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def integration_v1_reports_recent_n_number_of_records_get(self, token, number_of_records, **kwargs):  # noqa: E501
        """integration_v1_reports_recent_n_number_of_records_get  # noqa: E501

        Use this API to Fetch recent reports that are available for download  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.integration_v1_reports_recent_n_number_of_records_get(token, number_of_records, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str token: Authorization token issued by the authentication API (required)
        :param ModelInt number_of_records: number of records to download (required)
        :return: ExpandedReportGetRecent
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.integration_v1_reports_recent_n_number_of_records_get_with_http_info(token, number_of_records, **kwargs)  # noqa: E501
        else:
            (data) = self.integration_v1_reports_recent_n_number_of_records_get_with_http_info(token, number_of_records, **kwargs)  # noqa: E501
            return data

    def integration_v1_reports_recent_n_number_of_records_get_with_http_info(self, token, number_of_records, **kwargs):  # noqa: E501
        """integration_v1_reports_recent_n_number_of_records_get  # noqa: E501

        Use this API to Fetch recent reports that are available for download  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.integration_v1_reports_recent_n_number_of_records_get_with_http_info(token, number_of_records, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str token: Authorization token issued by the authentication API (required)
        :param ModelInt number_of_records: number of records to download (required)
        :return: ExpandedReportGetRecent
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['token', 'number_of_records']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method integration_v1_reports_recent_n_number_of_records_get" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'token' is set
        if ('token' not in params or
                params['token'] is None):
            raise ValueError("Missing the required parameter `token` when calling `integration_v1_reports_recent_n_number_of_records_get`")  # noqa: E501
        # verify the required parameter 'number_of_records' is set
        if ('number_of_records' not in params or
                params['number_of_records'] is None):
            raise ValueError("Missing the required parameter `number_of_records` when calling `integration_v1_reports_recent_n_number_of_records_get`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'number_of_records' in params:
            path_params['number_of_records'] = params['number_of_records']  # noqa: E501

        query_params = []

        header_params = {}
        if 'token' in params:
            header_params['token'] = params['token']  # noqa: E501

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['bearerAuth']  # noqa: E501

        return self.api_client.call_api(
            '/integration/v1/reports/recent-n/{number_of_records}', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='ExpandedReportGetRecent',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def integration_v1_reportsintreport_id_get(self, token, createddate, **kwargs):  # noqa: E501
        """integration_v1_reportsintreport_id_get  # noqa: E501

        Use this API to Fetch List of Reports available for provided date  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.integration_v1_reportsintreport_id_get(token, createddate, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str token: Authorization token issued by the authentication API (required)
        :param date createddate: date when report was created (required)
        :return: ExpandedReportList
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.integration_v1_reportsintreport_id_get_with_http_info(token, createddate, **kwargs)  # noqa: E501
        else:
            (data) = self.integration_v1_reportsintreport_id_get_with_http_info(token, createddate, **kwargs)  # noqa: E501
            return data

    def integration_v1_reportsintreport_id_get_with_http_info(self, token, createddate, **kwargs):  # noqa: E501
        """integration_v1_reportsintreport_id_get  # noqa: E501

        Use this API to Fetch List of Reports available for provided date  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.integration_v1_reportsintreport_id_get_with_http_info(token, createddate, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str token: Authorization token issued by the authentication API (required)
        :param date createddate: date when report was created (required)
        :return: ExpandedReportList
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['token', 'createddate']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method integration_v1_reportsintreport_id_get" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'token' is set
        if ('token' not in params or
                params['token'] is None):
            raise ValueError("Missing the required parameter `token` when calling `integration_v1_reportsintreport_id_get`")  # noqa: E501
        # verify the required parameter 'createddate' is set
        if ('createddate' not in params or
                params['createddate'] is None):
            raise ValueError("Missing the required parameter `createddate` when calling `integration_v1_reportsintreport_id_get`")  # noqa: E501

        collection_formats = {}

        path_params = {}

        query_params = []
        if 'createddate' in params:
            query_params.append(('createddate', params['createddate']))  # noqa: E501

        header_params = {}
        if 'token' in params:
            header_params['token'] = params['token']  # noqa: E501

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['bearerAuth']  # noqa: E501

        return self.api_client.call_api(
            '/integration/v1/reports/<int:report_id>', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='ExpandedReportList',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)
