# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).  # noqa: E501

    OpenAPI spec version: 2024-05-20
    Contact: docs@zuora.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

from __future__ import absolute_import

import re  # noqa: F401

# python 2 and python 3 compatibility library
import six

from zuora_sdk.api_client import ApiClient


class UploadApi(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    Ref: https://github.com/swagger-api/swagger-codegen
    """

    def __init__(self, api_client=None):
        if api_client is None:
            api_client = ApiClient()
        self.api_client = api_client

    def integration_v1_csv_upload_post(self, token, templatename, data, filename, **kwargs):  # noqa: E501
        """integration_v1_csv_upload_post  # noqa: E501

        Use this API to upload the Transaction/Events/Bundle config data in csv format into RevPro  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.integration_v1_csv_upload_post(token, templatename, data, filename, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str token: Authorization token issued by the authentication API (required)
        :param str templatename: File Template name (required)
        :param str data: Actual data to be uploaded (required)
        :param str filename: File name (required)
        :return: ExpandedUploadCsv
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.integration_v1_csv_upload_post_with_http_info(token, templatename, data, filename, **kwargs)  # noqa: E501
        else:
            (data) = self.integration_v1_csv_upload_post_with_http_info(token, templatename, data, filename, **kwargs)  # noqa: E501
            return data

    def integration_v1_csv_upload_post_with_http_info(self, token, templatename, data, filename, **kwargs):  # noqa: E501
        """integration_v1_csv_upload_post  # noqa: E501

        Use this API to upload the Transaction/Events/Bundle config data in csv format into RevPro  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.integration_v1_csv_upload_post_with_http_info(token, templatename, data, filename, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str token: Authorization token issued by the authentication API (required)
        :param str templatename: File Template name (required)
        :param str data: Actual data to be uploaded (required)
        :param str filename: File name (required)
        :return: ExpandedUploadCsv
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['token', 'templatename', 'data', 'filename']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method integration_v1_csv_upload_post" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'token' is set
        if ('token' not in params or
                params['token'] is None):
            raise ValueError("Missing the required parameter `token` when calling `integration_v1_csv_upload_post`")  # noqa: E501
        # verify the required parameter 'templatename' is set
        if ('templatename' not in params or
                params['templatename'] is None):
            raise ValueError("Missing the required parameter `templatename` when calling `integration_v1_csv_upload_post`")  # noqa: E501
        # verify the required parameter 'data' is set
        if ('data' not in params or
                params['data'] is None):
            raise ValueError("Missing the required parameter `data` when calling `integration_v1_csv_upload_post`")  # noqa: E501
        # verify the required parameter 'filename' is set
        if ('filename' not in params or
                params['filename'] is None):
            raise ValueError("Missing the required parameter `filename` when calling `integration_v1_csv_upload_post`")  # noqa: E501

        collection_formats = {}

        path_params = {}

        query_params = []
        if 'data' in params:
            query_params.append(('data', params['data']))  # noqa: E501

        header_params = {}
        if 'token' in params:
            header_params['token'] = params['token']  # noqa: E501
        if 'templatename' in params:
            header_params['templatename'] = params['templatename']  # noqa: E501
        if 'filename' in params:
            header_params['filename'] = params['filename']  # noqa: E501

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['bearerAuth']  # noqa: E501

        return self.api_client.call_api(
            '/integration/v1/csv/upload', 'POST',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='ExpandedUploadCsv',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def integration_v1_csv_upload_status_get(self, id, token, **kwargs):  # noqa: E501
        """integration_v1_csv_upload_status_get  # noqa: E501

        Use this API to get the csv upload status  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.integration_v1_csv_upload_status_get(id, token, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param int id: File id for which status to be fetched (required)
        :param str token: Authorization token issued by the authentication API (required)
        :return: ExpandedUploadCsvStatus
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.integration_v1_csv_upload_status_get_with_http_info(id, token, **kwargs)  # noqa: E501
        else:
            (data) = self.integration_v1_csv_upload_status_get_with_http_info(id, token, **kwargs)  # noqa: E501
            return data

    def integration_v1_csv_upload_status_get_with_http_info(self, id, token, **kwargs):  # noqa: E501
        """integration_v1_csv_upload_status_get  # noqa: E501

        Use this API to get the csv upload status  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.integration_v1_csv_upload_status_get_with_http_info(id, token, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param int id: File id for which status to be fetched (required)
        :param str token: Authorization token issued by the authentication API (required)
        :return: ExpandedUploadCsvStatus
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['id', 'token']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method integration_v1_csv_upload_status_get" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'id' is set
        if ('id' not in params or
                params['id'] is None):
            raise ValueError("Missing the required parameter `id` when calling `integration_v1_csv_upload_status_get`")  # noqa: E501
        # verify the required parameter 'token' is set
        if ('token' not in params or
                params['token'] is None):
            raise ValueError("Missing the required parameter `token` when calling `integration_v1_csv_upload_status_get`")  # noqa: E501

        collection_formats = {}

        path_params = {}

        query_params = []
        if 'id' in params:
            query_params.append(('id', params['id']))  # noqa: E501

        header_params = {}
        if 'token' in params:
            header_params['token'] = params['token']  # noqa: E501

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['bearerAuth']  # noqa: E501

        return self.api_client.call_api(
            '/integration/v1/csv/upload/status', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='ExpandedUploadCsvStatus',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def integration_v1_fileupload_status_file_request_id_get(self, token, file_request_id, **kwargs):  # noqa: E501
        """integration_v1_fileupload_status_file_request_id_get  # noqa: E501

        Use this API to get file upload status from RevPro  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.integration_v1_fileupload_status_file_request_id_get(token, file_request_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str token: Authorization token issued by the authentication API (required)
        :param int file_request_id: File Request id (required)
        :return: ExpandedUploadFileStatus
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.integration_v1_fileupload_status_file_request_id_get_with_http_info(token, file_request_id, **kwargs)  # noqa: E501
        else:
            (data) = self.integration_v1_fileupload_status_file_request_id_get_with_http_info(token, file_request_id, **kwargs)  # noqa: E501
            return data

    def integration_v1_fileupload_status_file_request_id_get_with_http_info(self, token, file_request_id, **kwargs):  # noqa: E501
        """integration_v1_fileupload_status_file_request_id_get  # noqa: E501

        Use this API to get file upload status from RevPro  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.integration_v1_fileupload_status_file_request_id_get_with_http_info(token, file_request_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str token: Authorization token issued by the authentication API (required)
        :param int file_request_id: File Request id (required)
        :return: ExpandedUploadFileStatus
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['token', 'file_request_id']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method integration_v1_fileupload_status_file_request_id_get" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'token' is set
        if ('token' not in params or
                params['token'] is None):
            raise ValueError("Missing the required parameter `token` when calling `integration_v1_fileupload_status_file_request_id_get`")  # noqa: E501
        # verify the required parameter 'file_request_id' is set
        if ('file_request_id' not in params or
                params['file_request_id'] is None):
            raise ValueError("Missing the required parameter `file_request_id` when calling `integration_v1_fileupload_status_file_request_id_get`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'file_request_id' in params:
            path_params['file_request_id'] = params['file_request_id']  # noqa: E501

        query_params = []

        header_params = {}
        if 'token' in params:
            header_params['token'] = params['token']  # noqa: E501

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['bearerAuth']  # noqa: E501

        return self.api_client.call_api(
            '/integration/v1/fileupload/status/{file_request_id}', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='ExpandedUploadFileStatus',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def integration_v1_upload_file_log_file_name_get(self, token, file_request_id, **kwargs):  # noqa: E501
        """integration_v1_upload_file_log_file_name_get  # noqa: E501

        Use this API to get file upload status from RevPro  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.integration_v1_upload_file_log_file_name_get(token, file_request_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str token: Authorization token issued by the authentication API (required)
        :param int file_request_id: File Request id (required)
        :return: ExpandedUploadFileStatus
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.integration_v1_upload_file_log_file_name_get_with_http_info(token, file_request_id, **kwargs)  # noqa: E501
        else:
            (data) = self.integration_v1_upload_file_log_file_name_get_with_http_info(token, file_request_id, **kwargs)  # noqa: E501
            return data

    def integration_v1_upload_file_log_file_name_get_with_http_info(self, token, file_request_id, **kwargs):  # noqa: E501
        """integration_v1_upload_file_log_file_name_get  # noqa: E501

        Use this API to get file upload status from RevPro  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.integration_v1_upload_file_log_file_name_get_with_http_info(token, file_request_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str token: Authorization token issued by the authentication API (required)
        :param int file_request_id: File Request id (required)
        :return: ExpandedUploadFileStatus
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['token', 'file_request_id']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method integration_v1_upload_file_log_file_name_get" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'token' is set
        if ('token' not in params or
                params['token'] is None):
            raise ValueError("Missing the required parameter `token` when calling `integration_v1_upload_file_log_file_name_get`")  # noqa: E501
        # verify the required parameter 'file_request_id' is set
        if ('file_request_id' not in params or
                params['file_request_id'] is None):
            raise ValueError("Missing the required parameter `file_request_id` when calling `integration_v1_upload_file_log_file_name_get`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'file_request_id' in params:
            path_params['file_request_id'] = params['file_request_id']  # noqa: E501

        query_params = []

        header_params = {}
        if 'token' in params:
            header_params['token'] = params['token']  # noqa: E501

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['bearerAuth']  # noqa: E501

        return self.api_client.call_api(
            '/integration/v1/upload/file/log/{file_name}', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='ExpandedUploadFileStatus',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def integration_v1_upload_file_post(self, token, file, templatename, **kwargs):  # noqa: E501
        """integration_v1_upload_file_post  # noqa: E501

        Use this API to Upload csv files to RevPro  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.integration_v1_upload_file_post(token, file, templatename, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str token: Authorization token issued by the authentication API (required)
        :param file file: File for uploading (required)
        :param str templatename: File template name (required)
        :return: ExpandedUploadFile
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.integration_v1_upload_file_post_with_http_info(token, file, templatename, **kwargs)  # noqa: E501
        else:
            (data) = self.integration_v1_upload_file_post_with_http_info(token, file, templatename, **kwargs)  # noqa: E501
            return data

    def integration_v1_upload_file_post_with_http_info(self, token, file, templatename, **kwargs):  # noqa: E501
        """integration_v1_upload_file_post  # noqa: E501

        Use this API to Upload csv files to RevPro  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.integration_v1_upload_file_post_with_http_info(token, file, templatename, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str token: Authorization token issued by the authentication API (required)
        :param file file: File for uploading (required)
        :param str templatename: File template name (required)
        :return: ExpandedUploadFile
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['token', 'file', 'templatename']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method integration_v1_upload_file_post" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'token' is set
        if ('token' not in params or
                params['token'] is None):
            raise ValueError("Missing the required parameter `token` when calling `integration_v1_upload_file_post`")  # noqa: E501
        # verify the required parameter 'file' is set
        if ('file' not in params or
                params['file'] is None):
            raise ValueError("Missing the required parameter `file` when calling `integration_v1_upload_file_post`")  # noqa: E501
        # verify the required parameter 'templatename' is set
        if ('templatename' not in params or
                params['templatename'] is None):
            raise ValueError("Missing the required parameter `templatename` when calling `integration_v1_upload_file_post`")  # noqa: E501

        collection_formats = {}

        path_params = {}

        query_params = []
        if 'file' in params:
            query_params.append(('file', params['file']))  # noqa: E501

        header_params = {}
        if 'token' in params:
            header_params['token'] = params['token']  # noqa: E501
        if 'templatename' in params:
            header_params['templatename'] = params['templatename']  # noqa: E501

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['bearerAuth']  # noqa: E501

        return self.api_client.call_api(
            '/integration/v1/upload/file', 'POST',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='ExpandedUploadFile',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)
