# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).  # noqa: E501

    OpenAPI spec version: 2024-05-20
    Contact: docs@zuora.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class AccountSummaryRatePlan(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'product_id': 'str',
        'product_name': 'str',
        'product_rate_plan_id': 'str',
        'product_sku': 'str',
        'rate_plan_name': 'str'
    }

    attribute_map = {
        'product_id': 'productId',
        'product_name': 'productName',
        'product_rate_plan_id': 'productRatePlanId',
        'product_sku': 'productSku',
        'rate_plan_name': 'ratePlanName'
    }

    def __init__(self, product_id=None, product_name=None, product_rate_plan_id=None, product_sku=None, rate_plan_name=None):  # noqa: E501
        """AccountSummaryRatePlan - a model defined in Swagger"""  # noqa: E501
        self._product_id = None
        self._product_name = None
        self._product_rate_plan_id = None
        self._product_sku = None
        self._rate_plan_name = None
        self.discriminator = None
        if product_id is not None:
            self.product_id = product_id
        if product_name is not None:
            self.product_name = product_name
        if product_rate_plan_id is not None:
            self.product_rate_plan_id = product_rate_plan_id
        if product_sku is not None:
            self.product_sku = product_sku
        if rate_plan_name is not None:
            self.rate_plan_name = rate_plan_name

    @property
    def product_id(self):
        """Gets the product_id of this AccountSummaryRatePlan.  # noqa: E501

        Product ID.   # noqa: E501

        :return: The product_id of this AccountSummaryRatePlan.  # noqa: E501
        :rtype: str
        """
        return self._product_id

    @product_id.setter
    def product_id(self, product_id):
        """Sets the product_id of this AccountSummaryRatePlan.

        Product ID.   # noqa: E501

        :param product_id: The product_id of this AccountSummaryRatePlan.  # noqa: E501
        :type: str
        """

        self._product_id = product_id

    @property
    def product_name(self):
        """Gets the product_name of this AccountSummaryRatePlan.  # noqa: E501

        Product name.   # noqa: E501

        :return: The product_name of this AccountSummaryRatePlan.  # noqa: E501
        :rtype: str
        """
        return self._product_name

    @product_name.setter
    def product_name(self, product_name):
        """Sets the product_name of this AccountSummaryRatePlan.

        Product name.   # noqa: E501

        :param product_name: The product_name of this AccountSummaryRatePlan.  # noqa: E501
        :type: str
        """

        self._product_name = product_name

    @property
    def product_rate_plan_id(self):
        """Gets the product_rate_plan_id of this AccountSummaryRatePlan.  # noqa: E501

        Product Rate Plan ID.   # noqa: E501

        :return: The product_rate_plan_id of this AccountSummaryRatePlan.  # noqa: E501
        :rtype: str
        """
        return self._product_rate_plan_id

    @product_rate_plan_id.setter
    def product_rate_plan_id(self, product_rate_plan_id):
        """Sets the product_rate_plan_id of this AccountSummaryRatePlan.

        Product Rate Plan ID.   # noqa: E501

        :param product_rate_plan_id: The product_rate_plan_id of this AccountSummaryRatePlan.  # noqa: E501
        :type: str
        """

        self._product_rate_plan_id = product_rate_plan_id

    @property
    def product_sku(self):
        """Gets the product_sku of this AccountSummaryRatePlan.  # noqa: E501


        :return: The product_sku of this AccountSummaryRatePlan.  # noqa: E501
        :rtype: str
        """
        return self._product_sku

    @product_sku.setter
    def product_sku(self, product_sku):
        """Sets the product_sku of this AccountSummaryRatePlan.


        :param product_sku: The product_sku of this AccountSummaryRatePlan.  # noqa: E501
        :type: str
        """

        self._product_sku = product_sku

    @property
    def rate_plan_name(self):
        """Gets the rate_plan_name of this AccountSummaryRatePlan.  # noqa: E501

        Rate plan name.   # noqa: E501

        :return: The rate_plan_name of this AccountSummaryRatePlan.  # noqa: E501
        :rtype: str
        """
        return self._rate_plan_name

    @rate_plan_name.setter
    def rate_plan_name(self, rate_plan_name):
        """Sets the rate_plan_name of this AccountSummaryRatePlan.

        Rate plan name.   # noqa: E501

        :param rate_plan_name: The rate_plan_name of this AccountSummaryRatePlan.  # noqa: E501
        :type: str
        """

        self._rate_plan_name = rate_plan_name

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(AccountSummaryRatePlan, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, AccountSummaryRatePlan):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
