# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).  # noqa: E501

    OpenAPI spec version: 2024-05-20
    Contact: docs@zuora.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class BillRunFilter(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'filter_type': 'str',
        'account_id': 'str',
        'subscription_id': 'str',
        'invoice_schedule_id': 'str',
        'invoice_schedule_item_id': 'str'
    }

    attribute_map = {
        'filter_type': 'filterType',
        'account_id': 'accountId',
        'subscription_id': 'subscriptionId',
        'invoice_schedule_id': 'invoiceScheduleId',
        'invoice_schedule_item_id': 'invoiceScheduleItemId'
    }

    def __init__(self, filter_type=None, account_id=None, subscription_id=None, invoice_schedule_id=None, invoice_schedule_item_id=None):  # noqa: E501
        """BillRunFilter - a model defined in Swagger"""  # noqa: E501
        self._filter_type = None
        self._account_id = None
        self._subscription_id = None
        self._invoice_schedule_id = None
        self._invoice_schedule_item_id = None
        self.discriminator = None
        if filter_type is not None:
            self.filter_type = filter_type
        if account_id is not None:
            self.account_id = account_id
        if subscription_id is not None:
            self.subscription_id = subscription_id
        if invoice_schedule_id is not None:
            self.invoice_schedule_id = invoice_schedule_id
        if invoice_schedule_item_id is not None:
            self.invoice_schedule_item_id = invoice_schedule_item_id

    @property
    def filter_type(self):
        """Gets the filter_type of this BillRunFilter.  # noqa: E501

        To create bill run at account level or subscription level.   # noqa: E501

        :return: The filter_type of this BillRunFilter.  # noqa: E501
        :rtype: str
        """
        return self._filter_type

    @filter_type.setter
    def filter_type(self, filter_type):
        """Sets the filter_type of this BillRunFilter.

        To create bill run at account level or subscription level.   # noqa: E501

        :param filter_type: The filter_type of this BillRunFilter.  # noqa: E501
        :type: str
        """
        allowed_values = ["Account", "Subscription", "InvoiceSchedule", "FilterCondition"]  # noqa: E501
        if filter_type not in allowed_values:
            raise ValueError(
                "Invalid value for `filter_type` ({0}), must be one of {1}"  # noqa: E501
                .format(filter_type, allowed_values)
            )

        self._filter_type = filter_type

    @property
    def account_id(self):
        """Gets the account_id of this BillRunFilter.  # noqa: E501

        The target account ID.   # noqa: E501

        :return: The account_id of this BillRunFilter.  # noqa: E501
        :rtype: str
        """
        return self._account_id

    @account_id.setter
    def account_id(self, account_id):
        """Sets the account_id of this BillRunFilter.

        The target account ID.   # noqa: E501

        :param account_id: The account_id of this BillRunFilter.  # noqa: E501
        :type: str
        """

        self._account_id = account_id

    @property
    def subscription_id(self):
        """Gets the subscription_id of this BillRunFilter.  # noqa: E501

        The target subscription ID.   # noqa: E501

        :return: The subscription_id of this BillRunFilter.  # noqa: E501
        :rtype: str
        """
        return self._subscription_id

    @subscription_id.setter
    def subscription_id(self, subscription_id):
        """Sets the subscription_id of this BillRunFilter.

        The target subscription ID.   # noqa: E501

        :param subscription_id: The subscription_id of this BillRunFilter.  # noqa: E501
        :type: str
        """

        self._subscription_id = subscription_id

    @property
    def invoice_schedule_id(self):
        """Gets the invoice_schedule_id of this BillRunFilter.  # noqa: E501

        The target invoice schedule ID.   # noqa: E501

        :return: The invoice_schedule_id of this BillRunFilter.  # noqa: E501
        :rtype: str
        """
        return self._invoice_schedule_id

    @invoice_schedule_id.setter
    def invoice_schedule_id(self, invoice_schedule_id):
        """Sets the invoice_schedule_id of this BillRunFilter.

        The target invoice schedule ID.   # noqa: E501

        :param invoice_schedule_id: The invoice_schedule_id of this BillRunFilter.  # noqa: E501
        :type: str
        """

        self._invoice_schedule_id = invoice_schedule_id

    @property
    def invoice_schedule_item_id(self):
        """Gets the invoice_schedule_item_id of this BillRunFilter.  # noqa: E501

        The target invoice schedule item ID.   # noqa: E501

        :return: The invoice_schedule_item_id of this BillRunFilter.  # noqa: E501
        :rtype: str
        """
        return self._invoice_schedule_item_id

    @invoice_schedule_item_id.setter
    def invoice_schedule_item_id(self, invoice_schedule_item_id):
        """Sets the invoice_schedule_item_id of this BillRunFilter.

        The target invoice schedule item ID.   # noqa: E501

        :param invoice_schedule_item_id: The invoice_schedule_item_id of this BillRunFilter.  # noqa: E501
        :type: str
        """

        self._invoice_schedule_item_id = invoice_schedule_item_id

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(BillRunFilter, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, BillRunFilter):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
