# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).  # noqa: E501

    OpenAPI spec version: 2024-05-20
    Contact: docs@zuora.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class BillingAdjustmentExclusion(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'charge_numbers': 'list[str]',
        'delivery_date': 'date'
    }

    attribute_map = {
        'charge_numbers': 'chargeNumbers',
        'delivery_date': 'deliveryDate'
    }

    def __init__(self, charge_numbers=None, delivery_date=None):  # noqa: E501
        """BillingAdjustmentExclusion - a model defined in Swagger"""  # noqa: E501
        self._charge_numbers = None
        self._delivery_date = None
        self.discriminator = None
        if charge_numbers is not None:
            self.charge_numbers = charge_numbers
        if delivery_date is not None:
            self.delivery_date = delivery_date

    @property
    def charge_numbers(self):
        """Gets the charge_numbers of this BillingAdjustmentExclusion.  # noqa: E501

        The charge numbers to be excluded from adjustment on the specified delivery date.   # noqa: E501

        :return: The charge_numbers of this BillingAdjustmentExclusion.  # noqa: E501
        :rtype: list[str]
        """
        return self._charge_numbers

    @charge_numbers.setter
    def charge_numbers(self, charge_numbers):
        """Sets the charge_numbers of this BillingAdjustmentExclusion.

        The charge numbers to be excluded from adjustment on the specified delivery date.   # noqa: E501

        :param charge_numbers: The charge_numbers of this BillingAdjustmentExclusion.  # noqa: E501
        :type: list[str]
        """

        self._charge_numbers = charge_numbers

    @property
    def delivery_date(self):
        """Gets the delivery_date of this BillingAdjustmentExclusion.  # noqa: E501

        The date on which the adjustment has to be excluded, in `yyyy-mm-dd` format.   # noqa: E501

        :return: The delivery_date of this BillingAdjustmentExclusion.  # noqa: E501
        :rtype: date
        """
        return self._delivery_date

    @delivery_date.setter
    def delivery_date(self, delivery_date):
        """Sets the delivery_date of this BillingAdjustmentExclusion.

        The date on which the adjustment has to be excluded, in `yyyy-mm-dd` format.   # noqa: E501

        :param delivery_date: The delivery_date of this BillingAdjustmentExclusion.  # noqa: E501
        :type: date
        """

        self._delivery_date = delivery_date

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(BillingAdjustmentExclusion, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, BillingAdjustmentExclusion):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
