# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).  # noqa: E501

    OpenAPI spec version: 2024-05-20
    Contact: docs@zuora.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class BillingDocVolumeSummaryRecord(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'total_failed_accounts': 'int',
        'total_generated_credit_memos': 'int',
        'total_generated_invoices': 'int'
    }

    attribute_map = {
        'total_failed_accounts': 'totalFailedAccounts',
        'total_generated_credit_memos': 'totalGeneratedCreditMemos',
        'total_generated_invoices': 'totalGeneratedInvoices'
    }

    def __init__(self, total_failed_accounts=None, total_generated_credit_memos=None, total_generated_invoices=None):  # noqa: E501
        """BillingDocVolumeSummaryRecord - a model defined in Swagger"""  # noqa: E501
        self._total_failed_accounts = None
        self._total_generated_credit_memos = None
        self._total_generated_invoices = None
        self.discriminator = None
        if total_failed_accounts is not None:
            self.total_failed_accounts = total_failed_accounts
        if total_generated_credit_memos is not None:
            self.total_generated_credit_memos = total_generated_credit_memos
        if total_generated_invoices is not None:
            self.total_generated_invoices = total_generated_invoices

    @property
    def total_failed_accounts(self):
        """Gets the total_failed_accounts of this BillingDocVolumeSummaryRecord.  # noqa: E501

        The count of total accounts who have failed records.  # noqa: E501

        :return: The total_failed_accounts of this BillingDocVolumeSummaryRecord.  # noqa: E501
        :rtype: int
        """
        return self._total_failed_accounts

    @total_failed_accounts.setter
    def total_failed_accounts(self, total_failed_accounts):
        """Sets the total_failed_accounts of this BillingDocVolumeSummaryRecord.

        The count of total accounts who have failed records.  # noqa: E501

        :param total_failed_accounts: The total_failed_accounts of this BillingDocVolumeSummaryRecord.  # noqa: E501
        :type: int
        """

        self._total_failed_accounts = total_failed_accounts

    @property
    def total_generated_credit_memos(self):
        """Gets the total_generated_credit_memos of this BillingDocVolumeSummaryRecord.  # noqa: E501

        The count of total generated credit memos.   # noqa: E501

        :return: The total_generated_credit_memos of this BillingDocVolumeSummaryRecord.  # noqa: E501
        :rtype: int
        """
        return self._total_generated_credit_memos

    @total_generated_credit_memos.setter
    def total_generated_credit_memos(self, total_generated_credit_memos):
        """Sets the total_generated_credit_memos of this BillingDocVolumeSummaryRecord.

        The count of total generated credit memos.   # noqa: E501

        :param total_generated_credit_memos: The total_generated_credit_memos of this BillingDocVolumeSummaryRecord.  # noqa: E501
        :type: int
        """

        self._total_generated_credit_memos = total_generated_credit_memos

    @property
    def total_generated_invoices(self):
        """Gets the total_generated_invoices of this BillingDocVolumeSummaryRecord.  # noqa: E501

        The count of total generated invoices.   # noqa: E501

        :return: The total_generated_invoices of this BillingDocVolumeSummaryRecord.  # noqa: E501
        :rtype: int
        """
        return self._total_generated_invoices

    @total_generated_invoices.setter
    def total_generated_invoices(self, total_generated_invoices):
        """Sets the total_generated_invoices of this BillingDocVolumeSummaryRecord.

        The count of total generated invoices.   # noqa: E501

        :param total_generated_invoices: The total_generated_invoices of this BillingDocVolumeSummaryRecord.  # noqa: E501
        :type: int
        """

        self._total_generated_invoices = total_generated_invoices

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(BillingDocVolumeSummaryRecord, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, BillingDocVolumeSummaryRecord):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
