# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).  # noqa: E501

    OpenAPI spec version: 2024-05-20
    Contact: docs@zuora.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class BulkCreateInvoicesRequest(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'invoices': 'list[CreateInvoiceRequest]',
        'use_single_transaction': 'bool'
    }

    attribute_map = {
        'invoices': 'invoices',
        'use_single_transaction': 'useSingleTransaction'
    }

    def __init__(self, invoices=None, use_single_transaction=None):  # noqa: E501
        """BulkCreateInvoicesRequest - a model defined in Swagger"""  # noqa: E501
        self._invoices = None
        self._use_single_transaction = None
        self.discriminator = None
        if invoices is not None:
            self.invoices = invoices
        if use_single_transaction is not None:
            self.use_single_transaction = use_single_transaction

    @property
    def invoices(self):
        """Gets the invoices of this BulkCreateInvoicesRequest.  # noqa: E501

        Container for standalone invoices.   # noqa: E501

        :return: The invoices of this BulkCreateInvoicesRequest.  # noqa: E501
        :rtype: list[CreateInvoiceRequest]
        """
        return self._invoices

    @invoices.setter
    def invoices(self, invoices):
        """Sets the invoices of this BulkCreateInvoicesRequest.

        Container for standalone invoices.   # noqa: E501

        :param invoices: The invoices of this BulkCreateInvoicesRequest.  # noqa: E501
        :type: list[CreateInvoiceRequest]
        """

        self._invoices = invoices

    @property
    def use_single_transaction(self):
        """Gets the use_single_transaction of this BulkCreateInvoicesRequest.  # noqa: E501

        Whether a batch request is handled with a single transaction.  - `true` indicates that a batch request will be handled with a single transaction. - `false`  indicates that the standalone invoices to be created in a batch request will be handled with separated transactions.  If the field is set to `false`, a failure in the batch request will not cause the whole request to fail, so you have to retry the whole batch request.   # noqa: E501

        :return: The use_single_transaction of this BulkCreateInvoicesRequest.  # noqa: E501
        :rtype: bool
        """
        return self._use_single_transaction

    @use_single_transaction.setter
    def use_single_transaction(self, use_single_transaction):
        """Sets the use_single_transaction of this BulkCreateInvoicesRequest.

        Whether a batch request is handled with a single transaction.  - `true` indicates that a batch request will be handled with a single transaction. - `false`  indicates that the standalone invoices to be created in a batch request will be handled with separated transactions.  If the field is set to `false`, a failure in the batch request will not cause the whole request to fail, so you have to retry the whole batch request.   # noqa: E501

        :param use_single_transaction: The use_single_transaction of this BulkCreateInvoicesRequest.  # noqa: E501
        :type: bool
        """

        self._use_single_transaction = use_single_transaction

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(BulkCreateInvoicesRequest, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, BulkCreateInvoicesRequest):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
