# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).  # noqa: E501

    OpenAPI spec version: 2024-05-20
    Contact: docs@zuora.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class CalloutAuth(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'domain': 'str',
        'password': 'str',
        'preemptive': 'bool',
        'username': 'str'
    }

    attribute_map = {
        'domain': 'domain',
        'password': 'password',
        'preemptive': 'preemptive',
        'username': 'username'
    }

    def __init__(self, domain=None, password=None, preemptive=None, username=None):  # noqa: E501
        """CalloutAuth - a model defined in Swagger"""  # noqa: E501
        self._domain = None
        self._password = None
        self._preemptive = None
        self._username = None
        self.discriminator = None
        if domain is not None:
            self.domain = domain
        if password is not None:
            self.password = password
        if preemptive is not None:
            self.preemptive = preemptive
        if username is not None:
            self.username = username

    @property
    def domain(self):
        """Gets the domain of this CalloutAuth.  # noqa: E501

        The domain of the callout auth.  # noqa: E501

        :return: The domain of this CalloutAuth.  # noqa: E501
        :rtype: str
        """
        return self._domain

    @domain.setter
    def domain(self, domain):
        """Sets the domain of this CalloutAuth.

        The domain of the callout auth.  # noqa: E501

        :param domain: The domain of this CalloutAuth.  # noqa: E501
        :type: str
        """

        self._domain = domain

    @property
    def password(self):
        """Gets the password of this CalloutAuth.  # noqa: E501

        The field is required when requiredAuth is `true`.  # noqa: E501

        :return: The password of this CalloutAuth.  # noqa: E501
        :rtype: str
        """
        return self._password

    @password.setter
    def password(self, password):
        """Sets the password of this CalloutAuth.

        The field is required when requiredAuth is `true`.  # noqa: E501

        :param password: The password of this CalloutAuth.  # noqa: E501
        :type: str
        """

        self._password = password

    @property
    def preemptive(self):
        """Gets the preemptive of this CalloutAuth.  # noqa: E501

        Set this field to `true` if you want to enable the preemptive authentication.  # noqa: E501

        :return: The preemptive of this CalloutAuth.  # noqa: E501
        :rtype: bool
        """
        return self._preemptive

    @preemptive.setter
    def preemptive(self, preemptive):
        """Sets the preemptive of this CalloutAuth.

        Set this field to `true` if you want to enable the preemptive authentication.  # noqa: E501

        :param preemptive: The preemptive of this CalloutAuth.  # noqa: E501
        :type: bool
        """

        self._preemptive = preemptive

    @property
    def username(self):
        """Gets the username of this CalloutAuth.  # noqa: E501

        The field is required when requiredAuth is `true`.  # noqa: E501

        :return: The username of this CalloutAuth.  # noqa: E501
        :rtype: str
        """
        return self._username

    @username.setter
    def username(self, username):
        """Sets the username of this CalloutAuth.

        The field is required when requiredAuth is `true`.  # noqa: E501

        :param username: The username of this CalloutAuth.  # noqa: E501
        :type: str
        """

        self._username = username

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(CalloutAuth, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, CalloutAuth):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
