# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).  # noqa: E501

    OpenAPI spec version: 2024-05-20
    Contact: docs@zuora.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class CancelBillRunRequest(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'cancel_once': 'bool'
    }

    attribute_map = {
        'cancel_once': 'cancelOnce'
    }

    def __init__(self, cancel_once=True):  # noqa: E501
        """CancelBillRunRequest - a model defined in Swagger"""  # noqa: E501
        self._cancel_once = None
        self.discriminator = None
        if cancel_once is not None:
            self.cancel_once = cancel_once

    @property
    def cancel_once(self):
        """Gets the cancel_once of this CancelBillRunRequest.  # noqa: E501

        Whether to cancel the current bill run or cancel all future recurring bill runs, only valid for a scheduled bill run.   # noqa: E501

        :return: The cancel_once of this CancelBillRunRequest.  # noqa: E501
        :rtype: bool
        """
        return self._cancel_once

    @cancel_once.setter
    def cancel_once(self, cancel_once):
        """Sets the cancel_once of this CancelBillRunRequest.

        Whether to cancel the current bill run or cancel all future recurring bill runs, only valid for a scheduled bill run.   # noqa: E501

        :param cancel_once: The cancel_once of this CancelBillRunRequest.  # noqa: E501
        :type: bool
        """

        self._cancel_once = cancel_once

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(CancelBillRunRequest, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, CancelBillRunRequest):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
