# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).  # noqa: E501

    OpenAPI spec version: 2024-05-20
    Contact: docs@zuora.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six
from zuora_sdk.models.common_response import CommonResponse  # noqa: F401,E501

class CancelBillingAdjustmentResponse(CommonResponse):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'debit_memo_number': 'str'
    }
    if hasattr(CommonResponse, "swagger_types"):
        swagger_types.update(CommonResponse.swagger_types)

    attribute_map = {
        'debit_memo_number': 'debitMemoNumber'
    }
    if hasattr(CommonResponse, "attribute_map"):
        attribute_map.update(CommonResponse.attribute_map)

    def __init__(self, debit_memo_number=None, *args, **kwargs):  # noqa: E501
        """CancelBillingAdjustmentResponse - a model defined in Swagger"""  # noqa: E501
        self._debit_memo_number = None
        self.discriminator = None
        if debit_memo_number is not None:
            self.debit_memo_number = debit_memo_number
        CommonResponse.__init__(self, *args, **kwargs)

    @property
    def debit_memo_number(self):
        """Gets the debit_memo_number of this CancelBillingAdjustmentResponse.  # noqa: E501

        The Debit Memo generated for the cancelled adjustment.          # noqa: E501

        :return: The debit_memo_number of this CancelBillingAdjustmentResponse.  # noqa: E501
        :rtype: str
        """
        return self._debit_memo_number

    @debit_memo_number.setter
    def debit_memo_number(self, debit_memo_number):
        """Sets the debit_memo_number of this CancelBillingAdjustmentResponse.

        The Debit Memo generated for the cancelled adjustment.          # noqa: E501

        :param debit_memo_number: The debit_memo_number of this CancelBillingAdjustmentResponse.  # noqa: E501
        :type: str
        """

        self._debit_memo_number = debit_memo_number

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(CancelBillingAdjustmentResponse, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, CancelBillingAdjustmentResponse):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
