# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).  # noqa: E501

    OpenAPI spec version: 2024-05-20
    Contact: docs@zuora.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class CatalogGroup(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'id': 'str',
        'name': 'str',
        'catalog_group_number': 'str',
        'type': 'CatalogGroupType',
        'description': 'str',
        'product_rate_plans': 'list[CatalogGroupProductRatePlan]'
    }

    attribute_map = {
        'id': 'id',
        'name': 'name',
        'catalog_group_number': 'catalogGroupNumber',
        'type': 'type',
        'description': 'description',
        'product_rate_plans': 'productRatePlans'
    }

    def __init__(self, id=None, name=None, catalog_group_number=None, type=None, description=None, product_rate_plans=None):  # noqa: E501
        """CatalogGroup - a model defined in Swagger"""  # noqa: E501
        self._id = None
        self._name = None
        self._catalog_group_number = None
        self._type = None
        self._description = None
        self._product_rate_plans = None
        self.discriminator = None
        if id is not None:
            self.id = id
        if name is not None:
            self.name = name
        if catalog_group_number is not None:
            self.catalog_group_number = catalog_group_number
        if type is not None:
            self.type = type
        if description is not None:
            self.description = description
        if product_rate_plans is not None:
            self.product_rate_plans = product_rate_plans

    @property
    def id(self):
        """Gets the id of this CatalogGroup.  # noqa: E501

        The ID of the catalog group.   # noqa: E501

        :return: The id of this CatalogGroup.  # noqa: E501
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this CatalogGroup.

        The ID of the catalog group.   # noqa: E501

        :param id: The id of this CatalogGroup.  # noqa: E501
        :type: str
        """

        self._id = id

    @property
    def name(self):
        """Gets the name of this CatalogGroup.  # noqa: E501

        The name of the catalog group.   # noqa: E501

        :return: The name of this CatalogGroup.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this CatalogGroup.

        The name of the catalog group.   # noqa: E501

        :param name: The name of this CatalogGroup.  # noqa: E501
        :type: str
        """

        self._name = name

    @property
    def catalog_group_number(self):
        """Gets the catalog_group_number of this CatalogGroup.  # noqa: E501

        The automatically generated number of the catalog group with the CG- perfix. For example, CG-00000001.   # noqa: E501

        :return: The catalog_group_number of this CatalogGroup.  # noqa: E501
        :rtype: str
        """
        return self._catalog_group_number

    @catalog_group_number.setter
    def catalog_group_number(self, catalog_group_number):
        """Sets the catalog_group_number of this CatalogGroup.

        The automatically generated number of the catalog group with the CG- perfix. For example, CG-00000001.   # noqa: E501

        :param catalog_group_number: The catalog_group_number of this CatalogGroup.  # noqa: E501
        :type: str
        """

        self._catalog_group_number = catalog_group_number

    @property
    def type(self):
        """Gets the type of this CatalogGroup.  # noqa: E501


        :return: The type of this CatalogGroup.  # noqa: E501
        :rtype: CatalogGroupType
        """
        return self._type

    @type.setter
    def type(self, type):
        """Sets the type of this CatalogGroup.


        :param type: The type of this CatalogGroup.  # noqa: E501
        :type: CatalogGroupType
        """

        self._type = type

    @property
    def description(self):
        """Gets the description of this CatalogGroup.  # noqa: E501

        The description of the catalog group.   # noqa: E501

        :return: The description of this CatalogGroup.  # noqa: E501
        :rtype: str
        """
        return self._description

    @description.setter
    def description(self, description):
        """Sets the description of this CatalogGroup.

        The description of the catalog group.   # noqa: E501

        :param description: The description of this CatalogGroup.  # noqa: E501
        :type: str
        """

        self._description = description

    @property
    def product_rate_plans(self):
        """Gets the product_rate_plans of this CatalogGroup.  # noqa: E501

        The list of product rate plans in the catalog group.   # noqa: E501

        :return: The product_rate_plans of this CatalogGroup.  # noqa: E501
        :rtype: list[CatalogGroupProductRatePlan]
        """
        return self._product_rate_plans

    @product_rate_plans.setter
    def product_rate_plans(self, product_rate_plans):
        """Sets the product_rate_plans of this CatalogGroup.

        The list of product rate plans in the catalog group.   # noqa: E501

        :param product_rate_plans: The product_rate_plans of this CatalogGroup.  # noqa: E501
        :type: list[CatalogGroupProductRatePlan]
        """

        self._product_rate_plans = product_rate_plans

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(CatalogGroup, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, CatalogGroup):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
