# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).  # noqa: E501

    OpenAPI spec version: 2024-05-20
    Contact: docs@zuora.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class CatalogGroupProductRatePlan(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'description': 'str',
        'effective_end_date': 'str',
        'effective_start_date': 'str',
        'grade': 'float',
        'id': 'str',
        'name': 'str',
        'status': 'CatalogGroupStatus'
    }

    attribute_map = {
        'description': 'description',
        'effective_end_date': 'effectiveEndDate',
        'effective_start_date': 'effectiveStartDate',
        'grade': 'grade',
        'id': 'id',
        'name': 'name',
        'status': 'status'
    }

    def __init__(self, description=None, effective_end_date=None, effective_start_date=None, grade=None, id=None, name=None, status=None):  # noqa: E501
        """CatalogGroupProductRatePlan - a model defined in Swagger"""  # noqa: E501
        self._description = None
        self._effective_end_date = None
        self._effective_start_date = None
        self._grade = None
        self._id = None
        self._name = None
        self._status = None
        self.discriminator = None
        if description is not None:
            self.description = description
        if effective_end_date is not None:
            self.effective_end_date = effective_end_date
        if effective_start_date is not None:
            self.effective_start_date = effective_start_date
        if grade is not None:
            self.grade = grade
        if id is not None:
            self.id = id
        if name is not None:
            self.name = name
        if status is not None:
            self.status = status

    @property
    def description(self):
        """Gets the description of this CatalogGroupProductRatePlan.  # noqa: E501

        The description of the product rate plan.   # noqa: E501

        :return: The description of this CatalogGroupProductRatePlan.  # noqa: E501
        :rtype: str
        """
        return self._description

    @description.setter
    def description(self, description):
        """Sets the description of this CatalogGroupProductRatePlan.

        The description of the product rate plan.   # noqa: E501

        :param description: The description of this CatalogGroupProductRatePlan.  # noqa: E501
        :type: str
        """

        self._description = description

    @property
    def effective_end_date(self):
        """Gets the effective_end_date of this CatalogGroupProductRatePlan.  # noqa: E501

        The effective end Date of the product rate plan.   # noqa: E501

        :return: The effective_end_date of this CatalogGroupProductRatePlan.  # noqa: E501
        :rtype: str
        """
        return self._effective_end_date

    @effective_end_date.setter
    def effective_end_date(self, effective_end_date):
        """Sets the effective_end_date of this CatalogGroupProductRatePlan.

        The effective end Date of the product rate plan.   # noqa: E501

        :param effective_end_date: The effective_end_date of this CatalogGroupProductRatePlan.  # noqa: E501
        :type: str
        """

        self._effective_end_date = effective_end_date

    @property
    def effective_start_date(self):
        """Gets the effective_start_date of this CatalogGroupProductRatePlan.  # noqa: E501

        The effective start date of the product rate plan.   # noqa: E501

        :return: The effective_start_date of this CatalogGroupProductRatePlan.  # noqa: E501
        :rtype: str
        """
        return self._effective_start_date

    @effective_start_date.setter
    def effective_start_date(self, effective_start_date):
        """Sets the effective_start_date of this CatalogGroupProductRatePlan.

        The effective start date of the product rate plan.   # noqa: E501

        :param effective_start_date: The effective_start_date of this CatalogGroupProductRatePlan.  # noqa: E501
        :type: str
        """

        self._effective_start_date = effective_start_date

    @property
    def grade(self):
        """Gets the grade of this CatalogGroupProductRatePlan.  # noqa: E501

        The grade of the product rate plan.   # noqa: E501

        :return: The grade of this CatalogGroupProductRatePlan.  # noqa: E501
        :rtype: float
        """
        return self._grade

    @grade.setter
    def grade(self, grade):
        """Sets the grade of this CatalogGroupProductRatePlan.

        The grade of the product rate plan.   # noqa: E501

        :param grade: The grade of this CatalogGroupProductRatePlan.  # noqa: E501
        :type: float
        """

        self._grade = grade

    @property
    def id(self):
        """Gets the id of this CatalogGroupProductRatePlan.  # noqa: E501

        The ID of the product rate plan.   # noqa: E501

        :return: The id of this CatalogGroupProductRatePlan.  # noqa: E501
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this CatalogGroupProductRatePlan.

        The ID of the product rate plan.   # noqa: E501

        :param id: The id of this CatalogGroupProductRatePlan.  # noqa: E501
        :type: str
        """

        self._id = id

    @property
    def name(self):
        """Gets the name of this CatalogGroupProductRatePlan.  # noqa: E501

        The name of the product rate plan.   # noqa: E501

        :return: The name of this CatalogGroupProductRatePlan.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this CatalogGroupProductRatePlan.

        The name of the product rate plan.   # noqa: E501

        :param name: The name of this CatalogGroupProductRatePlan.  # noqa: E501
        :type: str
        """

        self._name = name

    @property
    def status(self):
        """Gets the status of this CatalogGroupProductRatePlan.  # noqa: E501


        :return: The status of this CatalogGroupProductRatePlan.  # noqa: E501
        :rtype: CatalogGroupStatus
        """
        return self._status

    @status.setter
    def status(self, status):
        """Sets the status of this CatalogGroupProductRatePlan.


        :param status: The status of this CatalogGroupProductRatePlan.  # noqa: E501
        :type: CatalogGroupStatus
        """

        self._status = status

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(CatalogGroupProductRatePlan, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, CatalogGroupProductRatePlan):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
