# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).  # noqa: E501

    OpenAPI spec version: 2024-05-20
    Contact: docs@zuora.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class ChargeMetrics(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'dmrr': 'float',
        'dtcv': 'float',
        'mrr': 'float',
        'number': 'str',
        'origin_rate_plan_id': 'str',
        'original_id': 'str',
        'product_rate_plan_charge_id': 'str',
        'product_rate_plan_id': 'str',
        'tcv': 'float'
    }

    attribute_map = {
        'dmrr': 'dmrr',
        'dtcv': 'dtcv',
        'mrr': 'mrr',
        'number': 'number',
        'origin_rate_plan_id': 'originRatePlanId',
        'original_id': 'originalId',
        'product_rate_plan_charge_id': 'productRatePlanChargeId',
        'product_rate_plan_id': 'productRatePlanId',
        'tcv': 'tcv'
    }

    def __init__(self, dmrr=None, dtcv=None, mrr=None, number=None, origin_rate_plan_id=None, original_id=None, product_rate_plan_charge_id=None, product_rate_plan_id=None, tcv=None):  # noqa: E501
        """ChargeMetrics - a model defined in Swagger"""  # noqa: E501
        self._dmrr = None
        self._dtcv = None
        self._mrr = None
        self._number = None
        self._origin_rate_plan_id = None
        self._original_id = None
        self._product_rate_plan_charge_id = None
        self._product_rate_plan_id = None
        self._tcv = None
        self.discriminator = None
        if dmrr is not None:
            self.dmrr = dmrr
        if dtcv is not None:
            self.dtcv = dtcv
        if mrr is not None:
            self.mrr = mrr
        if number is not None:
            self.number = number
        if origin_rate_plan_id is not None:
            self.origin_rate_plan_id = origin_rate_plan_id
        if original_id is not None:
            self.original_id = original_id
        if product_rate_plan_charge_id is not None:
            self.product_rate_plan_charge_id = product_rate_plan_charge_id
        if product_rate_plan_id is not None:
            self.product_rate_plan_id = product_rate_plan_id
        if tcv is not None:
            self.tcv = tcv

    @property
    def dmrr(self):
        """Gets the dmrr of this ChargeMetrics.  # noqa: E501

        Change in monthly recurring revenue.   # noqa: E501

        :return: The dmrr of this ChargeMetrics.  # noqa: E501
        :rtype: float
        """
        return self._dmrr

    @dmrr.setter
    def dmrr(self, dmrr):
        """Sets the dmrr of this ChargeMetrics.

        Change in monthly recurring revenue.   # noqa: E501

        :param dmrr: The dmrr of this ChargeMetrics.  # noqa: E501
        :type: float
        """

        self._dmrr = dmrr

    @property
    def dtcv(self):
        """Gets the dtcv of this ChargeMetrics.  # noqa: E501

        Change in total contract value.   # noqa: E501

        :return: The dtcv of this ChargeMetrics.  # noqa: E501
        :rtype: float
        """
        return self._dtcv

    @dtcv.setter
    def dtcv(self, dtcv):
        """Sets the dtcv of this ChargeMetrics.

        Change in total contract value.   # noqa: E501

        :param dtcv: The dtcv of this ChargeMetrics.  # noqa: E501
        :type: float
        """

        self._dtcv = dtcv

    @property
    def mrr(self):
        """Gets the mrr of this ChargeMetrics.  # noqa: E501

        Monthly recurring revenue.   # noqa: E501

        :return: The mrr of this ChargeMetrics.  # noqa: E501
        :rtype: float
        """
        return self._mrr

    @mrr.setter
    def mrr(self, mrr):
        """Sets the mrr of this ChargeMetrics.

        Monthly recurring revenue.   # noqa: E501

        :param mrr: The mrr of this ChargeMetrics.  # noqa: E501
        :type: float
        """

        self._mrr = mrr

    @property
    def number(self):
        """Gets the number of this ChargeMetrics.  # noqa: E501

        The charge number of the subscription. Only available for update subscription.   # noqa: E501

        :return: The number of this ChargeMetrics.  # noqa: E501
        :rtype: str
        """
        return self._number

    @number.setter
    def number(self, number):
        """Sets the number of this ChargeMetrics.

        The charge number of the subscription. Only available for update subscription.   # noqa: E501

        :param number: The number of this ChargeMetrics.  # noqa: E501
        :type: str
        """

        self._number = number

    @property
    def origin_rate_plan_id(self):
        """Gets the origin_rate_plan_id of this ChargeMetrics.  # noqa: E501

        The origin rate plan ID. Only available for update subscription.   # noqa: E501

        :return: The origin_rate_plan_id of this ChargeMetrics.  # noqa: E501
        :rtype: str
        """
        return self._origin_rate_plan_id

    @origin_rate_plan_id.setter
    def origin_rate_plan_id(self, origin_rate_plan_id):
        """Sets the origin_rate_plan_id of this ChargeMetrics.

        The origin rate plan ID. Only available for update subscription.   # noqa: E501

        :param origin_rate_plan_id: The origin_rate_plan_id of this ChargeMetrics.  # noqa: E501
        :type: str
        """

        self._origin_rate_plan_id = origin_rate_plan_id

    @property
    def original_id(self):
        """Gets the original_id of this ChargeMetrics.  # noqa: E501

        The original rate plan charge ID. Only available for update subscription.   # noqa: E501

        :return: The original_id of this ChargeMetrics.  # noqa: E501
        :rtype: str
        """
        return self._original_id

    @original_id.setter
    def original_id(self, original_id):
        """Sets the original_id of this ChargeMetrics.

        The original rate plan charge ID. Only available for update subscription.   # noqa: E501

        :param original_id: The original_id of this ChargeMetrics.  # noqa: E501
        :type: str
        """

        self._original_id = original_id

    @property
    def product_rate_plan_charge_id(self):
        """Gets the product_rate_plan_charge_id of this ChargeMetrics.  # noqa: E501

        The product rate plan charge ID.   # noqa: E501

        :return: The product_rate_plan_charge_id of this ChargeMetrics.  # noqa: E501
        :rtype: str
        """
        return self._product_rate_plan_charge_id

    @product_rate_plan_charge_id.setter
    def product_rate_plan_charge_id(self, product_rate_plan_charge_id):
        """Sets the product_rate_plan_charge_id of this ChargeMetrics.

        The product rate plan charge ID.   # noqa: E501

        :param product_rate_plan_charge_id: The product_rate_plan_charge_id of this ChargeMetrics.  # noqa: E501
        :type: str
        """

        self._product_rate_plan_charge_id = product_rate_plan_charge_id

    @property
    def product_rate_plan_id(self):
        """Gets the product_rate_plan_id of this ChargeMetrics.  # noqa: E501

        The product rate plan ID.   # noqa: E501

        :return: The product_rate_plan_id of this ChargeMetrics.  # noqa: E501
        :rtype: str
        """
        return self._product_rate_plan_id

    @product_rate_plan_id.setter
    def product_rate_plan_id(self, product_rate_plan_id):
        """Sets the product_rate_plan_id of this ChargeMetrics.

        The product rate plan ID.   # noqa: E501

        :param product_rate_plan_id: The product_rate_plan_id of this ChargeMetrics.  # noqa: E501
        :type: str
        """

        self._product_rate_plan_id = product_rate_plan_id

    @property
    def tcv(self):
        """Gets the tcv of this ChargeMetrics.  # noqa: E501

        Total contract value.   # noqa: E501

        :return: The tcv of this ChargeMetrics.  # noqa: E501
        :rtype: float
        """
        return self._tcv

    @tcv.setter
    def tcv(self, tcv):
        """Sets the tcv of this ChargeMetrics.

        Total contract value.   # noqa: E501

        :param tcv: The tcv of this ChargeMetrics.  # noqa: E501
        :type: float
        """

        self._tcv = tcv

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(ChargeMetrics, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ChargeMetrics):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
