# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).  # noqa: E501

    OpenAPI spec version: 2024-05-20
    Contact: docs@zuora.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class ChargeModelConfiguration(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'configuration_item': 'list[ChargeModelConfigurationItem]'
    }

    attribute_map = {
        'configuration_item': 'ConfigurationItem'
    }

    def __init__(self, configuration_item=None):  # noqa: E501
        """ChargeModelConfiguration - a model defined in Swagger"""  # noqa: E501
        self._configuration_item = None
        self.discriminator = None
        if configuration_item is not None:
            self.configuration_item = configuration_item

    @property
    def configuration_item(self):
        """Gets the configuration_item of this ChargeModelConfiguration.  # noqa: E501

        An array of Charge Model Configuration Key-Value pairs.   # noqa: E501

        :return: The configuration_item of this ChargeModelConfiguration.  # noqa: E501
        :rtype: list[ChargeModelConfigurationItem]
        """
        return self._configuration_item

    @configuration_item.setter
    def configuration_item(self, configuration_item):
        """Sets the configuration_item of this ChargeModelConfiguration.

        An array of Charge Model Configuration Key-Value pairs.   # noqa: E501

        :param configuration_item: The configuration_item of this ChargeModelConfiguration.  # noqa: E501
        :type: list[ChargeModelConfigurationItem]
        """

        self._configuration_item = configuration_item

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(ChargeModelConfiguration, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ChargeModelConfiguration):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
