# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).  # noqa: E501

    OpenAPI spec version: 2024-05-20
    Contact: docs@zuora.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class ChargeModelConfigurationForSubscription(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'custom_field_per_unit_rate': 'str',
        'custom_field_total_amount': 'str',
        'formula': 'str'
    }

    attribute_map = {
        'custom_field_per_unit_rate': 'customFieldPerUnitRate',
        'custom_field_total_amount': 'customFieldTotalAmount',
        'formula': 'formula'
    }

    def __init__(self, custom_field_per_unit_rate=None, custom_field_total_amount=None, formula=None):  # noqa: E501
        """ChargeModelConfigurationForSubscription - a model defined in Swagger"""  # noqa: E501
        self._custom_field_per_unit_rate = None
        self._custom_field_total_amount = None
        self._formula = None
        self.discriminator = None
        if custom_field_per_unit_rate is not None:
            self.custom_field_per_unit_rate = custom_field_per_unit_rate
        if custom_field_total_amount is not None:
            self.custom_field_total_amount = custom_field_total_amount
        if formula is not None:
            self.formula = formula

    @property
    def custom_field_per_unit_rate(self):
        """Gets the custom_field_per_unit_rate of this ChargeModelConfigurationForSubscription.  # noqa: E501

        The custom field that carries the per-unit rate for each usage record. For example, `perUnitAmount__c`.      This field is only available for the usage-based charges that use the Pre-Rated Per Unit Pricing charge model. The charge model is available for customers with Enterprise and Nine editions by default. If you are a Growth customer, see [Zuora Editions](https://knowledgecenter.zuora.com/BB_Introducing_Z_Business/C_Zuora_Editions) for pricing information.   # noqa: E501

        :return: The custom_field_per_unit_rate of this ChargeModelConfigurationForSubscription.  # noqa: E501
        :rtype: str
        """
        return self._custom_field_per_unit_rate

    @custom_field_per_unit_rate.setter
    def custom_field_per_unit_rate(self, custom_field_per_unit_rate):
        """Sets the custom_field_per_unit_rate of this ChargeModelConfigurationForSubscription.

        The custom field that carries the per-unit rate for each usage record. For example, `perUnitAmount__c`.      This field is only available for the usage-based charges that use the Pre-Rated Per Unit Pricing charge model. The charge model is available for customers with Enterprise and Nine editions by default. If you are a Growth customer, see [Zuora Editions](https://knowledgecenter.zuora.com/BB_Introducing_Z_Business/C_Zuora_Editions) for pricing information.   # noqa: E501

        :param custom_field_per_unit_rate: The custom_field_per_unit_rate of this ChargeModelConfigurationForSubscription.  # noqa: E501
        :type: str
        """

        self._custom_field_per_unit_rate = custom_field_per_unit_rate

    @property
    def custom_field_total_amount(self):
        """Gets the custom_field_total_amount of this ChargeModelConfigurationForSubscription.  # noqa: E501

        The custom field that carries the total amount to charge for a usage record. For example, `totalAmount__c`.       This field is only available for the usage-based charges that use the Pre-Rated Pricing charge model. The charge model is available for customers with Enterprise and Nine editions by default. If you are a Growth customer, see [Zuora Editions](https://knowledgecenter.zuora.com/BB_Introducing_Z_Business/C_Zuora_Editions) for pricing information.   # noqa: E501

        :return: The custom_field_total_amount of this ChargeModelConfigurationForSubscription.  # noqa: E501
        :rtype: str
        """
        return self._custom_field_total_amount

    @custom_field_total_amount.setter
    def custom_field_total_amount(self, custom_field_total_amount):
        """Sets the custom_field_total_amount of this ChargeModelConfigurationForSubscription.

        The custom field that carries the total amount to charge for a usage record. For example, `totalAmount__c`.       This field is only available for the usage-based charges that use the Pre-Rated Pricing charge model. The charge model is available for customers with Enterprise and Nine editions by default. If you are a Growth customer, see [Zuora Editions](https://knowledgecenter.zuora.com/BB_Introducing_Z_Business/C_Zuora_Editions) for pricing information.   # noqa: E501

        :param custom_field_total_amount: The custom_field_total_amount of this ChargeModelConfigurationForSubscription.  # noqa: E501
        :type: str
        """

        self._custom_field_total_amount = custom_field_total_amount

    @property
    def formula(self):
        """Gets the formula of this ChargeModelConfigurationForSubscription.  # noqa: E501

        The pricing formula to calculate actual rating amount for each usage record.  This field is only available for the usage-based charges that use the Multi-Attribute Pricing charge model. The charge model is available for customers with Enterprise and Nine editions by default. If you are a Growth customer, see [Zuora Editions](https://knowledgecenter.zuora.com/BB_Introducing_Z_Business/C_Zuora_Editions) for pricing information.   # noqa: E501

        :return: The formula of this ChargeModelConfigurationForSubscription.  # noqa: E501
        :rtype: str
        """
        return self._formula

    @formula.setter
    def formula(self, formula):
        """Sets the formula of this ChargeModelConfigurationForSubscription.

        The pricing formula to calculate actual rating amount for each usage record.  This field is only available for the usage-based charges that use the Multi-Attribute Pricing charge model. The charge model is available for customers with Enterprise and Nine editions by default. If you are a Growth customer, see [Zuora Editions](https://knowledgecenter.zuora.com/BB_Introducing_Z_Business/C_Zuora_Editions) for pricing information.   # noqa: E501

        :param formula: The formula of this ChargeModelConfigurationForSubscription.  # noqa: E501
        :type: str
        """

        self._formula = formula

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(ChargeModelConfigurationForSubscription, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ChargeModelConfigurationForSubscription):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
