# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).  # noqa: E501

    OpenAPI spec version: 2024-05-20
    Contact: docs@zuora.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class ChargeOverrideBilling(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'bill_cycle_day': 'int',
        'bill_cycle_type': 'BillCycleType',
        'billing_period': 'BillingPeriod',
        'billing_period_alignment': 'BillingPeriodAlignment',
        'billing_timing': 'BillingTiming',
        'specific_billing_period': 'int',
        'weekly_bill_cycle_day': 'WeeklyBillCycleDay'
    }

    attribute_map = {
        'bill_cycle_day': 'billCycleDay',
        'bill_cycle_type': 'billCycleType',
        'billing_period': 'billingPeriod',
        'billing_period_alignment': 'billingPeriodAlignment',
        'billing_timing': 'billingTiming',
        'specific_billing_period': 'specificBillingPeriod',
        'weekly_bill_cycle_day': 'weeklyBillCycleDay'
    }

    def __init__(self, bill_cycle_day=None, bill_cycle_type=None, billing_period=None, billing_period_alignment=None, billing_timing=None, specific_billing_period=None, weekly_bill_cycle_day=None):  # noqa: E501
        """ChargeOverrideBilling - a model defined in Swagger"""  # noqa: E501
        self._bill_cycle_day = None
        self._bill_cycle_type = None
        self._billing_period = None
        self._billing_period_alignment = None
        self._billing_timing = None
        self._specific_billing_period = None
        self._weekly_bill_cycle_day = None
        self.discriminator = None
        if bill_cycle_day is not None:
            self.bill_cycle_day = bill_cycle_day
        if bill_cycle_type is not None:
            self.bill_cycle_type = bill_cycle_type
        if billing_period is not None:
            self.billing_period = billing_period
        if billing_period_alignment is not None:
            self.billing_period_alignment = billing_period_alignment
        if billing_timing is not None:
            self.billing_timing = billing_timing
        if specific_billing_period is not None:
            self.specific_billing_period = specific_billing_period
        if weekly_bill_cycle_day is not None:
            self.weekly_bill_cycle_day = weekly_bill_cycle_day

    @property
    def bill_cycle_day(self):
        """Gets the bill_cycle_day of this ChargeOverrideBilling.  # noqa: E501

        Day of the month that each billing period begins on. Only applicable if the value of the `billCycleType` field is `SpecificDayofMonth`.   # noqa: E501

        :return: The bill_cycle_day of this ChargeOverrideBilling.  # noqa: E501
        :rtype: int
        """
        return self._bill_cycle_day

    @bill_cycle_day.setter
    def bill_cycle_day(self, bill_cycle_day):
        """Sets the bill_cycle_day of this ChargeOverrideBilling.

        Day of the month that each billing period begins on. Only applicable if the value of the `billCycleType` field is `SpecificDayofMonth`.   # noqa: E501

        :param bill_cycle_day: The bill_cycle_day of this ChargeOverrideBilling.  # noqa: E501
        :type: int
        """

        self._bill_cycle_day = bill_cycle_day

    @property
    def bill_cycle_type(self):
        """Gets the bill_cycle_type of this ChargeOverrideBilling.  # noqa: E501


        :return: The bill_cycle_type of this ChargeOverrideBilling.  # noqa: E501
        :rtype: BillCycleType
        """
        return self._bill_cycle_type

    @bill_cycle_type.setter
    def bill_cycle_type(self, bill_cycle_type):
        """Sets the bill_cycle_type of this ChargeOverrideBilling.


        :param bill_cycle_type: The bill_cycle_type of this ChargeOverrideBilling.  # noqa: E501
        :type: BillCycleType
        """

        self._bill_cycle_type = bill_cycle_type

    @property
    def billing_period(self):
        """Gets the billing_period of this ChargeOverrideBilling.  # noqa: E501


        :return: The billing_period of this ChargeOverrideBilling.  # noqa: E501
        :rtype: BillingPeriod
        """
        return self._billing_period

    @billing_period.setter
    def billing_period(self, billing_period):
        """Sets the billing_period of this ChargeOverrideBilling.


        :param billing_period: The billing_period of this ChargeOverrideBilling.  # noqa: E501
        :type: BillingPeriod
        """

        self._billing_period = billing_period

    @property
    def billing_period_alignment(self):
        """Gets the billing_period_alignment of this ChargeOverrideBilling.  # noqa: E501


        :return: The billing_period_alignment of this ChargeOverrideBilling.  # noqa: E501
        :rtype: BillingPeriodAlignment
        """
        return self._billing_period_alignment

    @billing_period_alignment.setter
    def billing_period_alignment(self, billing_period_alignment):
        """Sets the billing_period_alignment of this ChargeOverrideBilling.


        :param billing_period_alignment: The billing_period_alignment of this ChargeOverrideBilling.  # noqa: E501
        :type: BillingPeriodAlignment
        """

        self._billing_period_alignment = billing_period_alignment

    @property
    def billing_timing(self):
        """Gets the billing_timing of this ChargeOverrideBilling.  # noqa: E501


        :return: The billing_timing of this ChargeOverrideBilling.  # noqa: E501
        :rtype: BillingTiming
        """
        return self._billing_timing

    @billing_timing.setter
    def billing_timing(self, billing_timing):
        """Sets the billing_timing of this ChargeOverrideBilling.


        :param billing_timing: The billing_timing of this ChargeOverrideBilling.  # noqa: E501
        :type: BillingTiming
        """

        self._billing_timing = billing_timing

    @property
    def specific_billing_period(self):
        """Gets the specific_billing_period of this ChargeOverrideBilling.  # noqa: E501

        Duration of each billing period in months or weeks, depending on the value of the `billingPeriod` field. Only applicable if the value of the `billingPeriod` field is `Specific_Months` or `Specific_Weeks`.   # noqa: E501

        :return: The specific_billing_period of this ChargeOverrideBilling.  # noqa: E501
        :rtype: int
        """
        return self._specific_billing_period

    @specific_billing_period.setter
    def specific_billing_period(self, specific_billing_period):
        """Sets the specific_billing_period of this ChargeOverrideBilling.

        Duration of each billing period in months or weeks, depending on the value of the `billingPeriod` field. Only applicable if the value of the `billingPeriod` field is `Specific_Months` or `Specific_Weeks`.   # noqa: E501

        :param specific_billing_period: The specific_billing_period of this ChargeOverrideBilling.  # noqa: E501
        :type: int
        """

        self._specific_billing_period = specific_billing_period

    @property
    def weekly_bill_cycle_day(self):
        """Gets the weekly_bill_cycle_day of this ChargeOverrideBilling.  # noqa: E501


        :return: The weekly_bill_cycle_day of this ChargeOverrideBilling.  # noqa: E501
        :rtype: WeeklyBillCycleDay
        """
        return self._weekly_bill_cycle_day

    @weekly_bill_cycle_day.setter
    def weekly_bill_cycle_day(self, weekly_bill_cycle_day):
        """Sets the weekly_bill_cycle_day of this ChargeOverrideBilling.


        :param weekly_bill_cycle_day: The weekly_bill_cycle_day of this ChargeOverrideBilling.  # noqa: E501
        :type: WeeklyBillCycleDay
        """

        self._weekly_bill_cycle_day = weekly_bill_cycle_day

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(ChargeOverrideBilling, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ChargeOverrideBilling):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
