# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).  # noqa: E501

    OpenAPI spec version: 2024-05-20
    Contact: docs@zuora.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class CollectDebitMemoResponseAppliedCreditMemos(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'applied_amount': 'float',
        'id': 'str',
        'number': 'str',
        'unapplied_amount': 'float'
    }

    attribute_map = {
        'applied_amount': 'appliedAmount',
        'id': 'id',
        'number': 'number',
        'unapplied_amount': 'unappliedAmount'
    }

    def __init__(self, applied_amount=None, id=None, number=None, unapplied_amount=None):  # noqa: E501
        """CollectDebitMemoResponseAppliedCreditMemos - a model defined in Swagger"""  # noqa: E501
        self._applied_amount = None
        self._id = None
        self._number = None
        self._unapplied_amount = None
        self.discriminator = None
        if applied_amount is not None:
            self.applied_amount = applied_amount
        if id is not None:
            self.id = id
        if number is not None:
            self.number = number
        if unapplied_amount is not None:
            self.unapplied_amount = unapplied_amount

    @property
    def applied_amount(self):
        """Gets the applied_amount of this CollectDebitMemoResponseAppliedCreditMemos.  # noqa: E501

        The applied amount of the credit memo to the debit memo.   # noqa: E501

        :return: The applied_amount of this CollectDebitMemoResponseAppliedCreditMemos.  # noqa: E501
        :rtype: float
        """
        return self._applied_amount

    @applied_amount.setter
    def applied_amount(self, applied_amount):
        """Sets the applied_amount of this CollectDebitMemoResponseAppliedCreditMemos.

        The applied amount of the credit memo to the debit memo.   # noqa: E501

        :param applied_amount: The applied_amount of this CollectDebitMemoResponseAppliedCreditMemos.  # noqa: E501
        :type: float
        """

        self._applied_amount = applied_amount

    @property
    def id(self):
        """Gets the id of this CollectDebitMemoResponseAppliedCreditMemos.  # noqa: E501

        The unique ID of the credit memo.   # noqa: E501

        :return: The id of this CollectDebitMemoResponseAppliedCreditMemos.  # noqa: E501
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this CollectDebitMemoResponseAppliedCreditMemos.

        The unique ID of the credit memo.   # noqa: E501

        :param id: The id of this CollectDebitMemoResponseAppliedCreditMemos.  # noqa: E501
        :type: str
        """

        self._id = id

    @property
    def number(self):
        """Gets the number of this CollectDebitMemoResponseAppliedCreditMemos.  # noqa: E501

        The unique identification number of the credit memo.   # noqa: E501

        :return: The number of this CollectDebitMemoResponseAppliedCreditMemos.  # noqa: E501
        :rtype: str
        """
        return self._number

    @number.setter
    def number(self, number):
        """Sets the number of this CollectDebitMemoResponseAppliedCreditMemos.

        The unique identification number of the credit memo.   # noqa: E501

        :param number: The number of this CollectDebitMemoResponseAppliedCreditMemos.  # noqa: E501
        :type: str
        """

        self._number = number

    @property
    def unapplied_amount(self):
        """Gets the unapplied_amount of this CollectDebitMemoResponseAppliedCreditMemos.  # noqa: E501

        The unapplied amount of the credit memo after applied to the debit memo.   # noqa: E501

        :return: The unapplied_amount of this CollectDebitMemoResponseAppliedCreditMemos.  # noqa: E501
        :rtype: float
        """
        return self._unapplied_amount

    @unapplied_amount.setter
    def unapplied_amount(self, unapplied_amount):
        """Sets the unapplied_amount of this CollectDebitMemoResponseAppliedCreditMemos.

        The unapplied amount of the credit memo after applied to the debit memo.   # noqa: E501

        :param unapplied_amount: The unapplied_amount of this CollectDebitMemoResponseAppliedCreditMemos.  # noqa: E501
        :type: float
        """

        self._unapplied_amount = unapplied_amount

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(CollectDebitMemoResponseAppliedCreditMemos, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, CollectDebitMemoResponseAppliedCreditMemos):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
