# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).  # noqa: E501

    OpenAPI spec version: 2024-05-20
    Contact: docs@zuora.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class CompareSchemaKeyValue(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'difference': 'dict(str, list[str])',
        'response': 'list[MigrationComponentContent]',
        'segregation_keys': 'list[str]'
    }

    attribute_map = {
        'difference': 'difference',
        'response': 'response',
        'segregation_keys': 'segregationKeys'
    }

    def __init__(self, difference=None, response=None, segregation_keys=None):  # noqa: E501
        """CompareSchemaKeyValue - a model defined in Swagger"""  # noqa: E501
        self._difference = None
        self._response = None
        self._segregation_keys = None
        self.discriminator = None
        if difference is not None:
            self.difference = difference
        if response is not None:
            self.response = response
        if segregation_keys is not None:
            self.segregation_keys = segregation_keys

    @property
    def difference(self):
        """Gets the difference of this CompareSchemaKeyValue.  # noqa: E501

        Returns the different components list.  # noqa: E501

        :return: The difference of this CompareSchemaKeyValue.  # noqa: E501
        :rtype: dict(str, list[str])
        """
        return self._difference

    @difference.setter
    def difference(self, difference):
        """Sets the difference of this CompareSchemaKeyValue.

        Returns the different components list.  # noqa: E501

        :param difference: The difference of this CompareSchemaKeyValue.  # noqa: E501
        :type: dict(str, list[str])
        """

        self._difference = difference

    @property
    def response(self):
        """Gets the response of this CompareSchemaKeyValue.  # noqa: E501

        Provides the total reponse of the components.  # noqa: E501

        :return: The response of this CompareSchemaKeyValue.  # noqa: E501
        :rtype: list[MigrationComponentContent]
        """
        return self._response

    @response.setter
    def response(self, response):
        """Sets the response of this CompareSchemaKeyValue.

        Provides the total reponse of the components.  # noqa: E501

        :param response: The response of this CompareSchemaKeyValue.  # noqa: E501
        :type: list[MigrationComponentContent]
        """

        self._response = response

    @property
    def segregation_keys(self):
        """Gets the segregation_keys of this CompareSchemaKeyValue.  # noqa: E501

        Provides separation of components.  # noqa: E501

        :return: The segregation_keys of this CompareSchemaKeyValue.  # noqa: E501
        :rtype: list[str]
        """
        return self._segregation_keys

    @segregation_keys.setter
    def segregation_keys(self, segregation_keys):
        """Sets the segregation_keys of this CompareSchemaKeyValue.

        Provides separation of components.  # noqa: E501

        :param segregation_keys: The segregation_keys of this CompareSchemaKeyValue.  # noqa: E501
        :type: list[str]
        """

        self._segregation_keys = segregation_keys

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(CompareSchemaKeyValue, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, CompareSchemaKeyValue):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
