# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).  # noqa: E501

    OpenAPI spec version: 2024-05-20
    Contact: docs@zuora.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six
from zuora_sdk.models.update_account_contact import UpdateAccountContact  # noqa: F401,E501

class CreateAccountContact(UpdateAccountContact):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'contact_description': 'str'
    }
    if hasattr(UpdateAccountContact, "swagger_types"):
        swagger_types.update(UpdateAccountContact.swagger_types)

    attribute_map = {
        'contact_description': 'contactDescription'
    }
    if hasattr(UpdateAccountContact, "attribute_map"):
        attribute_map.update(UpdateAccountContact.attribute_map)

    def __init__(self, contact_description=None, *args, **kwargs):  # noqa: E501
        """CreateAccountContact - a model defined in Swagger"""  # noqa: E501
        self._contact_description = None
        self.discriminator = None
        if contact_description is not None:
            self.contact_description = contact_description
        UpdateAccountContact.__init__(self, *args, **kwargs)

    @property
    def contact_description(self):
        """Gets the contact_description of this CreateAccountContact.  # noqa: E501

        A description for the contact.   # noqa: E501

        :return: The contact_description of this CreateAccountContact.  # noqa: E501
        :rtype: str
        """
        return self._contact_description

    @contact_description.setter
    def contact_description(self, contact_description):
        """Sets the contact_description of this CreateAccountContact.

        A description for the contact.   # noqa: E501

        :param contact_description: The contact_description of this CreateAccountContact.  # noqa: E501
        :type: str
        """

        self._contact_description = contact_description

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(CreateAccountContact, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, CreateAccountContact):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
