# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).  # noqa: E501

    OpenAPI spec version: 2024-05-20
    Contact: docs@zuora.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class CreateBillingDocumentFilesDeletionJobRequest(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'account_ids': 'list[str]',
        'account_keys': 'list[str]'
    }

    attribute_map = {
        'account_ids': 'accountIds',
        'account_keys': 'accountKeys'
    }

    def __init__(self, account_ids=None, account_keys=None):  # noqa: E501
        """CreateBillingDocumentFilesDeletionJobRequest - a model defined in Swagger"""  # noqa: E501
        self._account_ids = None
        self._account_keys = None
        self.discriminator = None
        if account_ids is not None:
            self.account_ids = account_ids
        if account_keys is not None:
            self.account_keys = account_keys

    @property
    def account_ids(self):
        """Gets the account_ids of this CreateBillingDocumentFilesDeletionJobRequest.  # noqa: E501

        Container for the IDs of the accounts that you want to create the billing document files deletion job for.  **Note**: When creating jobs to delete billing document PDF files, you must specify either set of `accountIds` or `accountKeys` in the request body.   # noqa: E501

        :return: The account_ids of this CreateBillingDocumentFilesDeletionJobRequest.  # noqa: E501
        :rtype: list[str]
        """
        return self._account_ids

    @account_ids.setter
    def account_ids(self, account_ids):
        """Sets the account_ids of this CreateBillingDocumentFilesDeletionJobRequest.

        Container for the IDs of the accounts that you want to create the billing document files deletion job for.  **Note**: When creating jobs to delete billing document PDF files, you must specify either set of `accountIds` or `accountKeys` in the request body.   # noqa: E501

        :param account_ids: The account_ids of this CreateBillingDocumentFilesDeletionJobRequest.  # noqa: E501
        :type: list[str]
        """

        self._account_ids = account_ids

    @property
    def account_keys(self):
        """Gets the account_keys of this CreateBillingDocumentFilesDeletionJobRequest.  # noqa: E501

        Container for the IDs and/or numbers of the accounts that you want to create the billing document files deletion job for.  **Note**: When creating jobs to delete billing document PDF files, you must specify either set of `accountIds` or `accountKeys` in the request body.   # noqa: E501

        :return: The account_keys of this CreateBillingDocumentFilesDeletionJobRequest.  # noqa: E501
        :rtype: list[str]
        """
        return self._account_keys

    @account_keys.setter
    def account_keys(self, account_keys):
        """Sets the account_keys of this CreateBillingDocumentFilesDeletionJobRequest.

        Container for the IDs and/or numbers of the accounts that you want to create the billing document files deletion job for.  **Note**: When creating jobs to delete billing document PDF files, you must specify either set of `accountIds` or `accountKeys` in the request body.   # noqa: E501

        :param account_keys: The account_keys of this CreateBillingDocumentFilesDeletionJobRequest.  # noqa: E501
        :type: list[str]
        """

        self._account_keys = account_keys

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(CreateBillingDocumentFilesDeletionJobRequest, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, CreateBillingDocumentFilesDeletionJobRequest):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
