# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).  # noqa: E501

    OpenAPI spec version: 2024-05-20
    Contact: docs@zuora.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class CreateBillingPreviewCreditMemoItem(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'amount': 'float',
        'amount_without_tax': 'float',
        'applied_to_item_id': 'str',
        'charge_date': 'str',
        'charge_number': 'str',
        'charge_type': 'str',
        'comment': 'str',
        'id': 'str',
        'number_of_deliveries': 'str',
        'processing_type': 'str',
        'quantity': 'str',
        'rate_plan_charge_id': 'str',
        'service_end_date': 'date',
        'service_start_date': 'date',
        'sku': 'str',
        'sku_name': 'str',
        'subscription_id': 'str',
        'subscription_number': 'str',
        'unit_of_measure': 'str'
    }

    attribute_map = {
        'amount': 'amount',
        'amount_without_tax': 'amountWithoutTax',
        'applied_to_item_id': 'appliedToItemId',
        'charge_date': 'chargeDate',
        'charge_number': 'chargeNumber',
        'charge_type': 'chargeType',
        'comment': 'comment',
        'id': 'id',
        'number_of_deliveries': 'numberOfDeliveries',
        'processing_type': 'processingType',
        'quantity': 'quantity',
        'rate_plan_charge_id': 'ratePlanChargeId',
        'service_end_date': 'serviceEndDate',
        'service_start_date': 'serviceStartDate',
        'sku': 'sku',
        'sku_name': 'skuName',
        'subscription_id': 'subscriptionId',
        'subscription_number': 'subscriptionNumber',
        'unit_of_measure': 'unitOfMeasure'
    }

    def __init__(self, amount=None, amount_without_tax=None, applied_to_item_id=None, charge_date=None, charge_number=None, charge_type=None, comment=None, id=None, number_of_deliveries=None, processing_type=None, quantity=None, rate_plan_charge_id=None, service_end_date=None, service_start_date=None, sku=None, sku_name=None, subscription_id=None, subscription_number=None, unit_of_measure=None):  # noqa: E501
        """CreateBillingPreviewCreditMemoItem - a model defined in Swagger"""  # noqa: E501
        self._amount = None
        self._amount_without_tax = None
        self._applied_to_item_id = None
        self._charge_date = None
        self._charge_number = None
        self._charge_type = None
        self._comment = None
        self._id = None
        self._number_of_deliveries = None
        self._processing_type = None
        self._quantity = None
        self._rate_plan_charge_id = None
        self._service_end_date = None
        self._service_start_date = None
        self._sku = None
        self._sku_name = None
        self._subscription_id = None
        self._subscription_number = None
        self._unit_of_measure = None
        self.discriminator = None
        if amount is not None:
            self.amount = amount
        if amount_without_tax is not None:
            self.amount_without_tax = amount_without_tax
        if applied_to_item_id is not None:
            self.applied_to_item_id = applied_to_item_id
        if charge_date is not None:
            self.charge_date = charge_date
        if charge_number is not None:
            self.charge_number = charge_number
        if charge_type is not None:
            self.charge_type = charge_type
        if comment is not None:
            self.comment = comment
        if id is not None:
            self.id = id
        if number_of_deliveries is not None:
            self.number_of_deliveries = number_of_deliveries
        if processing_type is not None:
            self.processing_type = processing_type
        if quantity is not None:
            self.quantity = quantity
        if rate_plan_charge_id is not None:
            self.rate_plan_charge_id = rate_plan_charge_id
        if service_end_date is not None:
            self.service_end_date = service_end_date
        if service_start_date is not None:
            self.service_start_date = service_start_date
        if sku is not None:
            self.sku = sku
        if sku_name is not None:
            self.sku_name = sku_name
        if subscription_id is not None:
            self.subscription_id = subscription_id
        if subscription_number is not None:
            self.subscription_number = subscription_number
        if unit_of_measure is not None:
            self.unit_of_measure = unit_of_measure

    @property
    def amount(self):
        """Gets the amount of this CreateBillingPreviewCreditMemoItem.  # noqa: E501

        The amount of the credit memo item. For tax-inclusive credit memo items, the amount indicates the credit memo item amount including tax. For tax-exclusive credit memo items, the amount indicates the credit memo item amount excluding tax   # noqa: E501

        :return: The amount of this CreateBillingPreviewCreditMemoItem.  # noqa: E501
        :rtype: float
        """
        return self._amount

    @amount.setter
    def amount(self, amount):
        """Sets the amount of this CreateBillingPreviewCreditMemoItem.

        The amount of the credit memo item. For tax-inclusive credit memo items, the amount indicates the credit memo item amount including tax. For tax-exclusive credit memo items, the amount indicates the credit memo item amount excluding tax   # noqa: E501

        :param amount: The amount of this CreateBillingPreviewCreditMemoItem.  # noqa: E501
        :type: float
        """

        self._amount = amount

    @property
    def amount_without_tax(self):
        """Gets the amount_without_tax of this CreateBillingPreviewCreditMemoItem.  # noqa: E501

        The credit memo item amount excluding tax.   # noqa: E501

        :return: The amount_without_tax of this CreateBillingPreviewCreditMemoItem.  # noqa: E501
        :rtype: float
        """
        return self._amount_without_tax

    @amount_without_tax.setter
    def amount_without_tax(self, amount_without_tax):
        """Sets the amount_without_tax of this CreateBillingPreviewCreditMemoItem.

        The credit memo item amount excluding tax.   # noqa: E501

        :param amount_without_tax: The amount_without_tax of this CreateBillingPreviewCreditMemoItem.  # noqa: E501
        :type: float
        """

        self._amount_without_tax = amount_without_tax

    @property
    def applied_to_item_id(self):
        """Gets the applied_to_item_id of this CreateBillingPreviewCreditMemoItem.  # noqa: E501

        The unique ID of the credit memo item that the discount charge is applied to.   # noqa: E501

        :return: The applied_to_item_id of this CreateBillingPreviewCreditMemoItem.  # noqa: E501
        :rtype: str
        """
        return self._applied_to_item_id

    @applied_to_item_id.setter
    def applied_to_item_id(self, applied_to_item_id):
        """Sets the applied_to_item_id of this CreateBillingPreviewCreditMemoItem.

        The unique ID of the credit memo item that the discount charge is applied to.   # noqa: E501

        :param applied_to_item_id: The applied_to_item_id of this CreateBillingPreviewCreditMemoItem.  # noqa: E501
        :type: str
        """

        self._applied_to_item_id = applied_to_item_id

    @property
    def charge_date(self):
        """Gets the charge_date of this CreateBillingPreviewCreditMemoItem.  # noqa: E501

        The date when the credit memo item is created.   # noqa: E501

        :return: The charge_date of this CreateBillingPreviewCreditMemoItem.  # noqa: E501
        :rtype: str
        """
        return self._charge_date

    @charge_date.setter
    def charge_date(self, charge_date):
        """Sets the charge_date of this CreateBillingPreviewCreditMemoItem.

        The date when the credit memo item is created.   # noqa: E501

        :param charge_date: The charge_date of this CreateBillingPreviewCreditMemoItem.  # noqa: E501
        :type: str
        """

        self._charge_date = charge_date

    @property
    def charge_number(self):
        """Gets the charge_number of this CreateBillingPreviewCreditMemoItem.  # noqa: E501

        Number of the charge.   # noqa: E501

        :return: The charge_number of this CreateBillingPreviewCreditMemoItem.  # noqa: E501
        :rtype: str
        """
        return self._charge_number

    @charge_number.setter
    def charge_number(self, charge_number):
        """Sets the charge_number of this CreateBillingPreviewCreditMemoItem.

        Number of the charge.   # noqa: E501

        :param charge_number: The charge_number of this CreateBillingPreviewCreditMemoItem.  # noqa: E501
        :type: str
        """

        self._charge_number = charge_number

    @property
    def charge_type(self):
        """Gets the charge_type of this CreateBillingPreviewCreditMemoItem.  # noqa: E501

        The type of charge.   Possible values are `OneTime`, `Recurring`, and `Usage`.   # noqa: E501

        :return: The charge_type of this CreateBillingPreviewCreditMemoItem.  # noqa: E501
        :rtype: str
        """
        return self._charge_type

    @charge_type.setter
    def charge_type(self, charge_type):
        """Sets the charge_type of this CreateBillingPreviewCreditMemoItem.

        The type of charge.   Possible values are `OneTime`, `Recurring`, and `Usage`.   # noqa: E501

        :param charge_type: The charge_type of this CreateBillingPreviewCreditMemoItem.  # noqa: E501
        :type: str
        """

        self._charge_type = charge_type

    @property
    def comment(self):
        """Gets the comment of this CreateBillingPreviewCreditMemoItem.  # noqa: E501

        Comment of the credit memo item.   # noqa: E501

        :return: The comment of this CreateBillingPreviewCreditMemoItem.  # noqa: E501
        :rtype: str
        """
        return self._comment

    @comment.setter
    def comment(self, comment):
        """Sets the comment of this CreateBillingPreviewCreditMemoItem.

        Comment of the credit memo item.   # noqa: E501

        :param comment: The comment of this CreateBillingPreviewCreditMemoItem.  # noqa: E501
        :type: str
        """

        self._comment = comment

    @property
    def id(self):
        """Gets the id of this CreateBillingPreviewCreditMemoItem.  # noqa: E501

        Credit memo item id.   # noqa: E501

        :return: The id of this CreateBillingPreviewCreditMemoItem.  # noqa: E501
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this CreateBillingPreviewCreditMemoItem.

        Credit memo item id.   # noqa: E501

        :param id: The id of this CreateBillingPreviewCreditMemoItem.  # noqa: E501
        :type: str
        """

        self._id = id

    @property
    def number_of_deliveries(self):
        """Gets the number_of_deliveries of this CreateBillingPreviewCreditMemoItem.  # noqa: E501

        The number of delivery for charge.  **Note**: This field is available only if you have the Delivery Pricing feature enabled.   # noqa: E501

        :return: The number_of_deliveries of this CreateBillingPreviewCreditMemoItem.  # noqa: E501
        :rtype: str
        """
        return self._number_of_deliveries

    @number_of_deliveries.setter
    def number_of_deliveries(self, number_of_deliveries):
        """Sets the number_of_deliveries of this CreateBillingPreviewCreditMemoItem.

        The number of delivery for charge.  **Note**: This field is available only if you have the Delivery Pricing feature enabled.   # noqa: E501

        :param number_of_deliveries: The number_of_deliveries of this CreateBillingPreviewCreditMemoItem.  # noqa: E501
        :type: str
        """

        self._number_of_deliveries = number_of_deliveries

    @property
    def processing_type(self):
        """Gets the processing_type of this CreateBillingPreviewCreditMemoItem.  # noqa: E501

        Identifies the kind of charge.   Possible values: * charge * discount * prepayment * tax   # noqa: E501

        :return: The processing_type of this CreateBillingPreviewCreditMemoItem.  # noqa: E501
        :rtype: str
        """
        return self._processing_type

    @processing_type.setter
    def processing_type(self, processing_type):
        """Sets the processing_type of this CreateBillingPreviewCreditMemoItem.

        Identifies the kind of charge.   Possible values: * charge * discount * prepayment * tax   # noqa: E501

        :param processing_type: The processing_type of this CreateBillingPreviewCreditMemoItem.  # noqa: E501
        :type: str
        """

        self._processing_type = processing_type

    @property
    def quantity(self):
        """Gets the quantity of this CreateBillingPreviewCreditMemoItem.  # noqa: E501

        Quantity of this item, in the configured unit of measure for the charge.   # noqa: E501

        :return: The quantity of this CreateBillingPreviewCreditMemoItem.  # noqa: E501
        :rtype: str
        """
        return self._quantity

    @quantity.setter
    def quantity(self, quantity):
        """Sets the quantity of this CreateBillingPreviewCreditMemoItem.

        Quantity of this item, in the configured unit of measure for the charge.   # noqa: E501

        :param quantity: The quantity of this CreateBillingPreviewCreditMemoItem.  # noqa: E501
        :type: str
        """

        self._quantity = quantity

    @property
    def rate_plan_charge_id(self):
        """Gets the rate_plan_charge_id of this CreateBillingPreviewCreditMemoItem.  # noqa: E501

        Id of the rate plan charge associated with this item.   # noqa: E501

        :return: The rate_plan_charge_id of this CreateBillingPreviewCreditMemoItem.  # noqa: E501
        :rtype: str
        """
        return self._rate_plan_charge_id

    @rate_plan_charge_id.setter
    def rate_plan_charge_id(self, rate_plan_charge_id):
        """Sets the rate_plan_charge_id of this CreateBillingPreviewCreditMemoItem.

        Id of the rate plan charge associated with this item.   # noqa: E501

        :param rate_plan_charge_id: The rate_plan_charge_id of this CreateBillingPreviewCreditMemoItem.  # noqa: E501
        :type: str
        """

        self._rate_plan_charge_id = rate_plan_charge_id

    @property
    def service_end_date(self):
        """Gets the service_end_date of this CreateBillingPreviewCreditMemoItem.  # noqa: E501

        End date of the service period for this item, i.e., the last day of the service period, in yyyy-mm-dd format.   # noqa: E501

        :return: The service_end_date of this CreateBillingPreviewCreditMemoItem.  # noqa: E501
        :rtype: date
        """
        return self._service_end_date

    @service_end_date.setter
    def service_end_date(self, service_end_date):
        """Sets the service_end_date of this CreateBillingPreviewCreditMemoItem.

        End date of the service period for this item, i.e., the last day of the service period, in yyyy-mm-dd format.   # noqa: E501

        :param service_end_date: The service_end_date of this CreateBillingPreviewCreditMemoItem.  # noqa: E501
        :type: date
        """

        self._service_end_date = service_end_date

    @property
    def service_start_date(self):
        """Gets the service_start_date of this CreateBillingPreviewCreditMemoItem.  # noqa: E501

        Start date of the service period for this item, in yyyy-mm-dd format. If the charge is a one-time fee, this is the date of that charge.   # noqa: E501

        :return: The service_start_date of this CreateBillingPreviewCreditMemoItem.  # noqa: E501
        :rtype: date
        """
        return self._service_start_date

    @service_start_date.setter
    def service_start_date(self, service_start_date):
        """Sets the service_start_date of this CreateBillingPreviewCreditMemoItem.

        Start date of the service period for this item, in yyyy-mm-dd format. If the charge is a one-time fee, this is the date of that charge.   # noqa: E501

        :param service_start_date: The service_start_date of this CreateBillingPreviewCreditMemoItem.  # noqa: E501
        :type: date
        """

        self._service_start_date = service_start_date

    @property
    def sku(self):
        """Gets the sku of this CreateBillingPreviewCreditMemoItem.  # noqa: E501

        Unique SKU for the product associated with this item.   # noqa: E501

        :return: The sku of this CreateBillingPreviewCreditMemoItem.  # noqa: E501
        :rtype: str
        """
        return self._sku

    @sku.setter
    def sku(self, sku):
        """Sets the sku of this CreateBillingPreviewCreditMemoItem.

        Unique SKU for the product associated with this item.   # noqa: E501

        :param sku: The sku of this CreateBillingPreviewCreditMemoItem.  # noqa: E501
        :type: str
        """

        self._sku = sku

    @property
    def sku_name(self):
        """Gets the sku_name of this CreateBillingPreviewCreditMemoItem.  # noqa: E501

        Name of the unique SKU for the product associated with this item.   # noqa: E501

        :return: The sku_name of this CreateBillingPreviewCreditMemoItem.  # noqa: E501
        :rtype: str
        """
        return self._sku_name

    @sku_name.setter
    def sku_name(self, sku_name):
        """Sets the sku_name of this CreateBillingPreviewCreditMemoItem.

        Name of the unique SKU for the product associated with this item.   # noqa: E501

        :param sku_name: The sku_name of this CreateBillingPreviewCreditMemoItem.  # noqa: E501
        :type: str
        """

        self._sku_name = sku_name

    @property
    def subscription_id(self):
        """Gets the subscription_id of this CreateBillingPreviewCreditMemoItem.  # noqa: E501

        ID of the subscription associated with this item.   # noqa: E501

        :return: The subscription_id of this CreateBillingPreviewCreditMemoItem.  # noqa: E501
        :rtype: str
        """
        return self._subscription_id

    @subscription_id.setter
    def subscription_id(self, subscription_id):
        """Sets the subscription_id of this CreateBillingPreviewCreditMemoItem.

        ID of the subscription associated with this item.   # noqa: E501

        :param subscription_id: The subscription_id of this CreateBillingPreviewCreditMemoItem.  # noqa: E501
        :type: str
        """

        self._subscription_id = subscription_id

    @property
    def subscription_number(self):
        """Gets the subscription_number of this CreateBillingPreviewCreditMemoItem.  # noqa: E501

        Name of the subscription associated with this item.   # noqa: E501

        :return: The subscription_number of this CreateBillingPreviewCreditMemoItem.  # noqa: E501
        :rtype: str
        """
        return self._subscription_number

    @subscription_number.setter
    def subscription_number(self, subscription_number):
        """Sets the subscription_number of this CreateBillingPreviewCreditMemoItem.

        Name of the subscription associated with this item.   # noqa: E501

        :param subscription_number: The subscription_number of this CreateBillingPreviewCreditMemoItem.  # noqa: E501
        :type: str
        """

        self._subscription_number = subscription_number

    @property
    def unit_of_measure(self):
        """Gets the unit_of_measure of this CreateBillingPreviewCreditMemoItem.  # noqa: E501

        Unit used to measure consumption.   # noqa: E501

        :return: The unit_of_measure of this CreateBillingPreviewCreditMemoItem.  # noqa: E501
        :rtype: str
        """
        return self._unit_of_measure

    @unit_of_measure.setter
    def unit_of_measure(self, unit_of_measure):
        """Sets the unit_of_measure of this CreateBillingPreviewCreditMemoItem.

        Unit used to measure consumption.   # noqa: E501

        :param unit_of_measure: The unit_of_measure of this CreateBillingPreviewCreditMemoItem.  # noqa: E501
        :type: str
        """

        self._unit_of_measure = unit_of_measure

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(CreateBillingPreviewCreditMemoItem, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, CreateBillingPreviewCreditMemoItem):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
