# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).  # noqa: E501

    OpenAPI spec version: 2024-05-20
    Contact: docs@zuora.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class CreateBillingPreviewResponse(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'account_id': 'str',
        'credit_memo_items': 'list[CreateBillingPreviewCreditMemoItem]',
        'invoice_items': 'list[CreateBillingPreviewInvoiceItem]',
        'success': 'bool'
    }

    attribute_map = {
        'account_id': 'accountId',
        'credit_memo_items': 'creditMemoItems',
        'invoice_items': 'invoiceItems',
        'success': 'success'
    }

    def __init__(self, account_id=None, credit_memo_items=None, invoice_items=None, success=None):  # noqa: E501
        """CreateBillingPreviewResponse - a model defined in Swagger"""  # noqa: E501
        self._account_id = None
        self._credit_memo_items = None
        self._invoice_items = None
        self._success = None
        self.discriminator = None
        if account_id is not None:
            self.account_id = account_id
        if credit_memo_items is not None:
            self.credit_memo_items = credit_memo_items
        if invoice_items is not None:
            self.invoice_items = invoice_items
        if success is not None:
            self.success = success

    @property
    def account_id(self):
        """Gets the account_id of this CreateBillingPreviewResponse.  # noqa: E501

        ID of the customer account to which the billing preview applies.   # noqa: E501

        :return: The account_id of this CreateBillingPreviewResponse.  # noqa: E501
        :rtype: str
        """
        return self._account_id

    @account_id.setter
    def account_id(self, account_id):
        """Sets the account_id of this CreateBillingPreviewResponse.

        ID of the customer account to which the billing preview applies.   # noqa: E501

        :param account_id: The account_id of this CreateBillingPreviewResponse.  # noqa: E501
        :type: str
        """

        self._account_id = account_id

    @property
    def credit_memo_items(self):
        """Gets the credit_memo_items of this CreateBillingPreviewResponse.  # noqa: E501

        An array of credit memo items returned as the result of the billing preivew request.  **Note:** The credit memo items are only available if you have Invoice Settlement feature enabled. The Invoice Settlement feature is generally available as of Zuora Billing Release 296 (March 2021). This feature includes Unapplied Payments, Credit and Debit Memo, and Invoice Item Settlement. If you want to enable Invoice Settlement, see [Invoice Settlement Enablement and Checklist Guide](https://knowledgecenter.zuora.com/Billing/Billing_and_Payments/Invoice_Settlement/Invoice_Settlement_Migration_Checklist_and_Guide) for more information.   # noqa: E501

        :return: The credit_memo_items of this CreateBillingPreviewResponse.  # noqa: E501
        :rtype: list[CreateBillingPreviewCreditMemoItem]
        """
        return self._credit_memo_items

    @credit_memo_items.setter
    def credit_memo_items(self, credit_memo_items):
        """Sets the credit_memo_items of this CreateBillingPreviewResponse.

        An array of credit memo items returned as the result of the billing preivew request.  **Note:** The credit memo items are only available if you have Invoice Settlement feature enabled. The Invoice Settlement feature is generally available as of Zuora Billing Release 296 (March 2021). This feature includes Unapplied Payments, Credit and Debit Memo, and Invoice Item Settlement. If you want to enable Invoice Settlement, see [Invoice Settlement Enablement and Checklist Guide](https://knowledgecenter.zuora.com/Billing/Billing_and_Payments/Invoice_Settlement/Invoice_Settlement_Migration_Checklist_and_Guide) for more information.   # noqa: E501

        :param credit_memo_items: The credit_memo_items of this CreateBillingPreviewResponse.  # noqa: E501
        :type: list[CreateBillingPreviewCreditMemoItem]
        """

        self._credit_memo_items = credit_memo_items

    @property
    def invoice_items(self):
        """Gets the invoice_items of this CreateBillingPreviewResponse.  # noqa: E501

        An array of invoice items returned as the result of the billing preview request.   # noqa: E501

        :return: The invoice_items of this CreateBillingPreviewResponse.  # noqa: E501
        :rtype: list[CreateBillingPreviewInvoiceItem]
        """
        return self._invoice_items

    @invoice_items.setter
    def invoice_items(self, invoice_items):
        """Sets the invoice_items of this CreateBillingPreviewResponse.

        An array of invoice items returned as the result of the billing preview request.   # noqa: E501

        :param invoice_items: The invoice_items of this CreateBillingPreviewResponse.  # noqa: E501
        :type: list[CreateBillingPreviewInvoiceItem]
        """

        self._invoice_items = invoice_items

    @property
    def success(self):
        """Gets the success of this CreateBillingPreviewResponse.  # noqa: E501

        Returns `true` if the request was processed successfully.   # noqa: E501

        :return: The success of this CreateBillingPreviewResponse.  # noqa: E501
        :rtype: bool
        """
        return self._success

    @success.setter
    def success(self, success):
        """Sets the success of this CreateBillingPreviewResponse.

        Returns `true` if the request was processed successfully.   # noqa: E501

        :param success: The success of this CreateBillingPreviewResponse.  # noqa: E501
        :type: bool
        """

        self._success = success

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(CreateBillingPreviewResponse, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, CreateBillingPreviewResponse):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
