# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).  # noqa: E501

    OpenAPI spec version: 2024-05-20
    Contact: docs@zuora.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class CreateFulfillmentResponse(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'fulfillment_items': 'list[CreateFulfillmentItemResponse]',
        'fulfillment_number': 'str',
        'id': 'str'
    }

    attribute_map = {
        'fulfillment_items': 'fulfillmentItems',
        'fulfillment_number': 'fulfillmentNumber',
        'id': 'id'
    }

    def __init__(self, fulfillment_items=None, fulfillment_number=None, id=None):  # noqa: E501
        """CreateFulfillmentResponse - a model defined in Swagger"""  # noqa: E501
        self._fulfillment_items = None
        self._fulfillment_number = None
        self._id = None
        self.discriminator = None
        if fulfillment_items is not None:
            self.fulfillment_items = fulfillment_items
        if fulfillment_number is not None:
            self.fulfillment_number = fulfillment_number
        if id is not None:
            self.id = id

    @property
    def fulfillment_items(self):
        """Gets the fulfillment_items of this CreateFulfillmentResponse.  # noqa: E501


        :return: The fulfillment_items of this CreateFulfillmentResponse.  # noqa: E501
        :rtype: list[CreateFulfillmentItemResponse]
        """
        return self._fulfillment_items

    @fulfillment_items.setter
    def fulfillment_items(self, fulfillment_items):
        """Sets the fulfillment_items of this CreateFulfillmentResponse.


        :param fulfillment_items: The fulfillment_items of this CreateFulfillmentResponse.  # noqa: E501
        :type: list[CreateFulfillmentItemResponse]
        """

        self._fulfillment_items = fulfillment_items

    @property
    def fulfillment_number(self):
        """Gets the fulfillment_number of this CreateFulfillmentResponse.  # noqa: E501

        The sytem generated number for the Fulfillment.   # noqa: E501

        :return: The fulfillment_number of this CreateFulfillmentResponse.  # noqa: E501
        :rtype: str
        """
        return self._fulfillment_number

    @fulfillment_number.setter
    def fulfillment_number(self, fulfillment_number):
        """Sets the fulfillment_number of this CreateFulfillmentResponse.

        The sytem generated number for the Fulfillment.   # noqa: E501

        :param fulfillment_number: The fulfillment_number of this CreateFulfillmentResponse.  # noqa: E501
        :type: str
        """

        self._fulfillment_number = fulfillment_number

    @property
    def id(self):
        """Gets the id of this CreateFulfillmentResponse.  # noqa: E501

        The sytem generated Id.   # noqa: E501

        :return: The id of this CreateFulfillmentResponse.  # noqa: E501
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this CreateFulfillmentResponse.

        The sytem generated Id.   # noqa: E501

        :param id: The id of this CreateFulfillmentResponse.  # noqa: E501
        :type: str
        """

        self._id = id

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(CreateFulfillmentResponse, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, CreateFulfillmentResponse):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
