# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).  # noqa: E501

    OpenAPI spec version: 2024-05-20
    Contact: docs@zuora.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class CreateInvoiceCollectResponse(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'amount_collected': 'str',
        'credit_memos': 'list[CreateInvoiceCollectCreditMemos]',
        'invoices': 'list[CreateInvoiceCollectInvoices]',
        'payment_id': 'str',
        'success': 'bool'
    }

    attribute_map = {
        'amount_collected': 'amountCollected',
        'credit_memos': 'creditMemos',
        'invoices': 'invoices',
        'payment_id': 'paymentId',
        'success': 'success'
    }

    def __init__(self, amount_collected=None, credit_memos=None, invoices=None, payment_id=None, success=None):  # noqa: E501
        """CreateInvoiceCollectResponse - a model defined in Swagger"""  # noqa: E501
        self._amount_collected = None
        self._credit_memos = None
        self._invoices = None
        self._payment_id = None
        self._success = None
        self.discriminator = None
        if amount_collected is not None:
            self.amount_collected = amount_collected
        if credit_memos is not None:
            self.credit_memos = credit_memos
        if invoices is not None:
            self.invoices = invoices
        if payment_id is not None:
            self.payment_id = payment_id
        if success is not None:
            self.success = success

    @property
    def amount_collected(self):
        """Gets the amount_collected of this CreateInvoiceCollectResponse.  # noqa: E501

        Payment amount applied.   # noqa: E501

        :return: The amount_collected of this CreateInvoiceCollectResponse.  # noqa: E501
        :rtype: str
        """
        return self._amount_collected

    @amount_collected.setter
    def amount_collected(self, amount_collected):
        """Sets the amount_collected of this CreateInvoiceCollectResponse.

        Payment amount applied.   # noqa: E501

        :param amount_collected: The amount_collected of this CreateInvoiceCollectResponse.  # noqa: E501
        :type: str
        """

        self._amount_collected = amount_collected

    @property
    def credit_memos(self):
        """Gets the credit_memos of this CreateInvoiceCollectResponse.  # noqa: E501

        Information on one or more credit memos associated with this operation.   # noqa: E501

        :return: The credit_memos of this CreateInvoiceCollectResponse.  # noqa: E501
        :rtype: list[CreateInvoiceCollectCreditMemos]
        """
        return self._credit_memos

    @credit_memos.setter
    def credit_memos(self, credit_memos):
        """Sets the credit_memos of this CreateInvoiceCollectResponse.

        Information on one or more credit memos associated with this operation.   # noqa: E501

        :param credit_memos: The credit_memos of this CreateInvoiceCollectResponse.  # noqa: E501
        :type: list[CreateInvoiceCollectCreditMemos]
        """

        self._credit_memos = credit_memos

    @property
    def invoices(self):
        """Gets the invoices of this CreateInvoiceCollectResponse.  # noqa: E501

        Information on one or more invoices associated with this operation.   # noqa: E501

        :return: The invoices of this CreateInvoiceCollectResponse.  # noqa: E501
        :rtype: list[CreateInvoiceCollectInvoices]
        """
        return self._invoices

    @invoices.setter
    def invoices(self, invoices):
        """Sets the invoices of this CreateInvoiceCollectResponse.

        Information on one or more invoices associated with this operation.   # noqa: E501

        :param invoices: The invoices of this CreateInvoiceCollectResponse.  # noqa: E501
        :type: list[CreateInvoiceCollectInvoices]
        """

        self._invoices = invoices

    @property
    def payment_id(self):
        """Gets the payment_id of this CreateInvoiceCollectResponse.  # noqa: E501

        Payment ID.   # noqa: E501

        :return: The payment_id of this CreateInvoiceCollectResponse.  # noqa: E501
        :rtype: str
        """
        return self._payment_id

    @payment_id.setter
    def payment_id(self, payment_id):
        """Sets the payment_id of this CreateInvoiceCollectResponse.

        Payment ID.   # noqa: E501

        :param payment_id: The payment_id of this CreateInvoiceCollectResponse.  # noqa: E501
        :type: str
        """

        self._payment_id = payment_id

    @property
    def success(self):
        """Gets the success of this CreateInvoiceCollectResponse.  # noqa: E501

        Returns `true` if the request was processed successfully.   # noqa: E501

        :return: The success of this CreateInvoiceCollectResponse.  # noqa: E501
        :rtype: bool
        """
        return self._success

    @success.setter
    def success(self, success):
        """Sets the success of this CreateInvoiceCollectResponse.

        Returns `true` if the request was processed successfully.   # noqa: E501

        :param success: The success of this CreateInvoiceCollectResponse.  # noqa: E501
        :type: bool
        """

        self._success = success

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(CreateInvoiceCollectResponse, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, CreateInvoiceCollectResponse):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
