# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).  # noqa: E501

    OpenAPI spec version: 2024-05-20
    Contact: docs@zuora.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class CreateOrUpdateCatalogGroupProductRatePlan(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'grade': 'float',
        'id': 'str'
    }

    attribute_map = {
        'grade': 'grade',
        'id': 'id'
    }

    def __init__(self, grade=None, id=None):  # noqa: E501
        """CreateOrUpdateCatalogGroupProductRatePlan - a model defined in Swagger"""  # noqa: E501
        self._grade = None
        self._id = None
        self.discriminator = None
        if grade is not None:
            self.grade = grade
        if id is not None:
            self.id = id

    @property
    def grade(self):
        """Gets the grade of this CreateOrUpdateCatalogGroupProductRatePlan.  # noqa: E501

        The grade that is assigned for the product rate plan. The value of this field must be a positive integer. The greater the value, the higher the grade.  A product rate plan to be added to a Grading catalog group must have one grade. You can specify a grade for a product rate plan in this request or update the product rate plan individually.   # noqa: E501

        :return: The grade of this CreateOrUpdateCatalogGroupProductRatePlan.  # noqa: E501
        :rtype: float
        """
        return self._grade

    @grade.setter
    def grade(self, grade):
        """Sets the grade of this CreateOrUpdateCatalogGroupProductRatePlan.

        The grade that is assigned for the product rate plan. The value of this field must be a positive integer. The greater the value, the higher the grade.  A product rate plan to be added to a Grading catalog group must have one grade. You can specify a grade for a product rate plan in this request or update the product rate plan individually.   # noqa: E501

        :param grade: The grade of this CreateOrUpdateCatalogGroupProductRatePlan.  # noqa: E501
        :type: float
        """

        self._grade = grade

    @property
    def id(self):
        """Gets the id of this CreateOrUpdateCatalogGroupProductRatePlan.  # noqa: E501

        The unique ID of the product rate plan.   # noqa: E501

        :return: The id of this CreateOrUpdateCatalogGroupProductRatePlan.  # noqa: E501
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this CreateOrUpdateCatalogGroupProductRatePlan.

        The unique ID of the product rate plan.   # noqa: E501

        :param id: The id of this CreateOrUpdateCatalogGroupProductRatePlan.  # noqa: E501
        :type: str
        """

        self._id = id

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(CreateOrUpdateCatalogGroupProductRatePlan, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, CreateOrUpdateCatalogGroupProductRatePlan):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
