# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).  # noqa: E501

    OpenAPI spec version: 2024-05-20
    Contact: docs@zuora.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class CreateOrderAsyncRequest(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'category': 'OrderCategory',
        'custom_fields': 'dict(str, object)',
        'description': 'str',
        'existing_account_number': 'str',
        'externally_managed_by': 'ExternallyManagedBy',
        'new_account': 'OrderCreateAccount',
        'order_date': 'date',
        'order_line_items': 'list[CreateOrderOrderLineItem]',
        'order_number': 'str',
        'processing_options': 'AsyncOrderProcessingOptions',
        'reason_code': 'str',
        'subscriptions': 'list[CreateOrderSubscription]'
    }

    attribute_map = {
        'category': 'category',
        'custom_fields': 'customFields',
        'description': 'description',
        'existing_account_number': 'existingAccountNumber',
        'externally_managed_by': 'externallyManagedBy',
        'new_account': 'newAccount',
        'order_date': 'orderDate',
        'order_line_items': 'orderLineItems',
        'order_number': 'orderNumber',
        'processing_options': 'processingOptions',
        'reason_code': 'reasonCode',
        'subscriptions': 'subscriptions'
    }

    def __init__(self, category=None, custom_fields=None, description=None, existing_account_number=None, externally_managed_by=None, new_account=None, order_date=None, order_line_items=None, order_number=None, processing_options=None, reason_code=None, subscriptions=None):  # noqa: E501
        """CreateOrderAsyncRequest - a model defined in Swagger"""  # noqa: E501
        self._category = None
        self._custom_fields = None
        self._description = None
        self._existing_account_number = None
        self._externally_managed_by = None
        self._new_account = None
        self._order_date = None
        self._order_line_items = None
        self._order_number = None
        self._processing_options = None
        self._reason_code = None
        self._subscriptions = None
        self.discriminator = None
        if category is not None:
            self.category = category
        if custom_fields is not None:
            self.custom_fields = custom_fields
        if description is not None:
            self.description = description
        if existing_account_number is not None:
            self.existing_account_number = existing_account_number
        if externally_managed_by is not None:
            self.externally_managed_by = externally_managed_by
        if new_account is not None:
            self.new_account = new_account
        self.order_date = order_date
        if order_line_items is not None:
            self.order_line_items = order_line_items
        if order_number is not None:
            self.order_number = order_number
        if processing_options is not None:
            self.processing_options = processing_options
        if reason_code is not None:
            self.reason_code = reason_code
        if subscriptions is not None:
            self.subscriptions = subscriptions

    @property
    def category(self):
        """Gets the category of this CreateOrderAsyncRequest.  # noqa: E501


        :return: The category of this CreateOrderAsyncRequest.  # noqa: E501
        :rtype: OrderCategory
        """
        return self._category

    @category.setter
    def category(self, category):
        """Sets the category of this CreateOrderAsyncRequest.


        :param category: The category of this CreateOrderAsyncRequest.  # noqa: E501
        :type: OrderCategory
        """

        self._category = category

    @property
    def custom_fields(self):
        """Gets the custom_fields of this CreateOrderAsyncRequest.  # noqa: E501

        Container for custom fields of an Order object.   # noqa: E501

        :return: The custom_fields of this CreateOrderAsyncRequest.  # noqa: E501
        :rtype: dict(str, object)
        """
        return self._custom_fields

    @custom_fields.setter
    def custom_fields(self, custom_fields):
        """Sets the custom_fields of this CreateOrderAsyncRequest.

        Container for custom fields of an Order object.   # noqa: E501

        :param custom_fields: The custom_fields of this CreateOrderAsyncRequest.  # noqa: E501
        :type: dict(str, object)
        """

        self._custom_fields = custom_fields

    @property
    def description(self):
        """Gets the description of this CreateOrderAsyncRequest.  # noqa: E501

        A description of the order.  # noqa: E501

        :return: The description of this CreateOrderAsyncRequest.  # noqa: E501
        :rtype: str
        """
        return self._description

    @description.setter
    def description(self, description):
        """Sets the description of this CreateOrderAsyncRequest.

        A description of the order.  # noqa: E501

        :param description: The description of this CreateOrderAsyncRequest.  # noqa: E501
        :type: str
        """

        self._description = description

    @property
    def existing_account_number(self):
        """Gets the existing_account_number of this CreateOrderAsyncRequest.  # noqa: E501

        The account number that this order will be created under. It can be either the accountNumber or the account info provided. It will return an error if both are specified. Note that this actually specifies the invoice owner account of the subscriptions included in this order.   # noqa: E501

        :return: The existing_account_number of this CreateOrderAsyncRequest.  # noqa: E501
        :rtype: str
        """
        return self._existing_account_number

    @existing_account_number.setter
    def existing_account_number(self, existing_account_number):
        """Sets the existing_account_number of this CreateOrderAsyncRequest.

        The account number that this order will be created under. It can be either the accountNumber or the account info provided. It will return an error if both are specified. Note that this actually specifies the invoice owner account of the subscriptions included in this order.   # noqa: E501

        :param existing_account_number: The existing_account_number of this CreateOrderAsyncRequest.  # noqa: E501
        :type: str
        """

        self._existing_account_number = existing_account_number

    @property
    def externally_managed_by(self):
        """Gets the externally_managed_by of this CreateOrderAsyncRequest.  # noqa: E501


        :return: The externally_managed_by of this CreateOrderAsyncRequest.  # noqa: E501
        :rtype: ExternallyManagedBy
        """
        return self._externally_managed_by

    @externally_managed_by.setter
    def externally_managed_by(self, externally_managed_by):
        """Sets the externally_managed_by of this CreateOrderAsyncRequest.


        :param externally_managed_by: The externally_managed_by of this CreateOrderAsyncRequest.  # noqa: E501
        :type: ExternallyManagedBy
        """

        self._externally_managed_by = externally_managed_by

    @property
    def new_account(self):
        """Gets the new_account of this CreateOrderAsyncRequest.  # noqa: E501


        :return: The new_account of this CreateOrderAsyncRequest.  # noqa: E501
        :rtype: OrderCreateAccount
        """
        return self._new_account

    @new_account.setter
    def new_account(self, new_account):
        """Sets the new_account of this CreateOrderAsyncRequest.


        :param new_account: The new_account of this CreateOrderAsyncRequest.  # noqa: E501
        :type: OrderCreateAccount
        """

        self._new_account = new_account

    @property
    def order_date(self):
        """Gets the order_date of this CreateOrderAsyncRequest.  # noqa: E501

        The date when the order is signed. All the order actions under this order will use this order date as the contract effective date if the contract effective date field is skipped or its value is left as null.  # noqa: E501

        :return: The order_date of this CreateOrderAsyncRequest.  # noqa: E501
        :rtype: date
        """
        return self._order_date

    @order_date.setter
    def order_date(self, order_date):
        """Sets the order_date of this CreateOrderAsyncRequest.

        The date when the order is signed. All the order actions under this order will use this order date as the contract effective date if the contract effective date field is skipped or its value is left as null.  # noqa: E501

        :param order_date: The order_date of this CreateOrderAsyncRequest.  # noqa: E501
        :type: date
        """
        if order_date is None:
            raise ValueError("Invalid value for `order_date`, must not be `None`")  # noqa: E501

        self._order_date = order_date

    @property
    def order_line_items(self):
        """Gets the order_line_items of this CreateOrderAsyncRequest.  # noqa: E501

        [Order Line Items](https://knowledgecenter.zuora.com/Billing/Subscriptions/Orders/Order_Line_Items/AA_Overview_of_Order_Line_Items) are non subscription based items created by an Order, representing transactional charges such as one-time fees, physical goods, or professional service charges that are not sold as subscription services.   With the Order Line Items feature enabled, you can now launch non-subscription and unified monetization business models in Zuora, in addition to subscription business models.  **Note:** The [Order Line Items](https://knowledgecenter.zuora.com/Billing/Subscriptions/Orders/Order_Line_Items/AA_Overview_of_Order_Line_Items) feature is now generally available to all Zuora customers. You need to enable the [Orders](https://knowledgecenter.zuora.com/BC_Subscription_Management/Orders/AA_Overview_of_Orders#Orders) feature to access the [Order Line Items](https://knowledgecenter.zuora.com/Billing/Subscriptions/Orders/Order_Line_Items/AA_Overview_of_Order_Line_Items) feature. As of Zuora Billing Release 313 (November 2021), new customers who onboard on [Orders](https://knowledgecenter.zuora.com/Billing/Subscriptions/Orders/AA_Overview_of_Orders) will have the [Order Line Items](https://knowledgecenter.zuora.com/Billing/Subscriptions/Orders/Order_Line_Items) feature enabled by default.           # noqa: E501

        :return: The order_line_items of this CreateOrderAsyncRequest.  # noqa: E501
        :rtype: list[CreateOrderOrderLineItem]
        """
        return self._order_line_items

    @order_line_items.setter
    def order_line_items(self, order_line_items):
        """Sets the order_line_items of this CreateOrderAsyncRequest.

        [Order Line Items](https://knowledgecenter.zuora.com/Billing/Subscriptions/Orders/Order_Line_Items/AA_Overview_of_Order_Line_Items) are non subscription based items created by an Order, representing transactional charges such as one-time fees, physical goods, or professional service charges that are not sold as subscription services.   With the Order Line Items feature enabled, you can now launch non-subscription and unified monetization business models in Zuora, in addition to subscription business models.  **Note:** The [Order Line Items](https://knowledgecenter.zuora.com/Billing/Subscriptions/Orders/Order_Line_Items/AA_Overview_of_Order_Line_Items) feature is now generally available to all Zuora customers. You need to enable the [Orders](https://knowledgecenter.zuora.com/BC_Subscription_Management/Orders/AA_Overview_of_Orders#Orders) feature to access the [Order Line Items](https://knowledgecenter.zuora.com/Billing/Subscriptions/Orders/Order_Line_Items/AA_Overview_of_Order_Line_Items) feature. As of Zuora Billing Release 313 (November 2021), new customers who onboard on [Orders](https://knowledgecenter.zuora.com/Billing/Subscriptions/Orders/AA_Overview_of_Orders) will have the [Order Line Items](https://knowledgecenter.zuora.com/Billing/Subscriptions/Orders/Order_Line_Items) feature enabled by default.           # noqa: E501

        :param order_line_items: The order_line_items of this CreateOrderAsyncRequest.  # noqa: E501
        :type: list[CreateOrderOrderLineItem]
        """

        self._order_line_items = order_line_items

    @property
    def order_number(self):
        """Gets the order_number of this CreateOrderAsyncRequest.  # noqa: E501

        The order number of the new order. If not provided, system will auto-generate a number for this order.    **Note:** Make sure the order number does not contain a slash.   # noqa: E501

        :return: The order_number of this CreateOrderAsyncRequest.  # noqa: E501
        :rtype: str
        """
        return self._order_number

    @order_number.setter
    def order_number(self, order_number):
        """Sets the order_number of this CreateOrderAsyncRequest.

        The order number of the new order. If not provided, system will auto-generate a number for this order.    **Note:** Make sure the order number does not contain a slash.   # noqa: E501

        :param order_number: The order_number of this CreateOrderAsyncRequest.  # noqa: E501
        :type: str
        """

        self._order_number = order_number

    @property
    def processing_options(self):
        """Gets the processing_options of this CreateOrderAsyncRequest.  # noqa: E501


        :return: The processing_options of this CreateOrderAsyncRequest.  # noqa: E501
        :rtype: AsyncOrderProcessingOptions
        """
        return self._processing_options

    @processing_options.setter
    def processing_options(self, processing_options):
        """Sets the processing_options of this CreateOrderAsyncRequest.


        :param processing_options: The processing_options of this CreateOrderAsyncRequest.  # noqa: E501
        :type: AsyncOrderProcessingOptions
        """

        self._processing_options = processing_options

    @property
    def reason_code(self):
        """Gets the reason_code of this CreateOrderAsyncRequest.  # noqa: E501

        Values of reason code configured in **Billing Settings** > **Configure Reason Codes** through Zuora UI. Indicates the reason when a return order line item occurs.   # noqa: E501

        :return: The reason_code of this CreateOrderAsyncRequest.  # noqa: E501
        :rtype: str
        """
        return self._reason_code

    @reason_code.setter
    def reason_code(self, reason_code):
        """Sets the reason_code of this CreateOrderAsyncRequest.

        Values of reason code configured in **Billing Settings** > **Configure Reason Codes** through Zuora UI. Indicates the reason when a return order line item occurs.   # noqa: E501

        :param reason_code: The reason_code of this CreateOrderAsyncRequest.  # noqa: E501
        :type: str
        """

        self._reason_code = reason_code

    @property
    def subscriptions(self):
        """Gets the subscriptions of this CreateOrderAsyncRequest.  # noqa: E501

        Each item includes a set of order actions, which will be applied to the same base subscription.  # noqa: E501

        :return: The subscriptions of this CreateOrderAsyncRequest.  # noqa: E501
        :rtype: list[CreateOrderSubscription]
        """
        return self._subscriptions

    @subscriptions.setter
    def subscriptions(self, subscriptions):
        """Sets the subscriptions of this CreateOrderAsyncRequest.

        Each item includes a set of order actions, which will be applied to the same base subscription.  # noqa: E501

        :param subscriptions: The subscriptions of this CreateOrderAsyncRequest.  # noqa: E501
        :type: list[CreateOrderSubscription]
        """

        self._subscriptions = subscriptions

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(CreateOrderAsyncRequest, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, CreateOrderAsyncRequest):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
