# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).  # noqa: E501

    OpenAPI spec version: 2024-05-20
    Contact: docs@zuora.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class CreateOrderResponseOrderAction(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'id': 'str',
        'type': 'OrderActionType',
        'order_metrics': 'list[CreateOrderResponseOrderMetric]'
    }

    attribute_map = {
        'id': 'id',
        'type': 'type',
        'order_metrics': 'orderMetrics'
    }

    def __init__(self, id=None, type=None, order_metrics=None):  # noqa: E501
        """CreateOrderResponseOrderAction - a model defined in Swagger"""  # noqa: E501
        self._id = None
        self._type = None
        self._order_metrics = None
        self.discriminator = None
        if id is not None:
            self.id = id
        if type is not None:
            self.type = type
        if order_metrics is not None:
            self.order_metrics = order_metrics

    @property
    def id(self):
        """Gets the id of this CreateOrderResponseOrderAction.  # noqa: E501

        The Id of the order action processed in the order.  # noqa: E501

        :return: The id of this CreateOrderResponseOrderAction.  # noqa: E501
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this CreateOrderResponseOrderAction.

        The Id of the order action processed in the order.  # noqa: E501

        :param id: The id of this CreateOrderResponseOrderAction.  # noqa: E501
        :type: str
        """

        self._id = id

    @property
    def type(self):
        """Gets the type of this CreateOrderResponseOrderAction.  # noqa: E501


        :return: The type of this CreateOrderResponseOrderAction.  # noqa: E501
        :rtype: OrderActionType
        """
        return self._type

    @type.setter
    def type(self, type):
        """Sets the type of this CreateOrderResponseOrderAction.


        :param type: The type of this CreateOrderResponseOrderAction.  # noqa: E501
        :type: OrderActionType
        """

        self._type = type

    @property
    def order_metrics(self):
        """Gets the order_metrics of this CreateOrderResponseOrderAction.  # noqa: E501

        subscription order metrics  # noqa: E501

        :return: The order_metrics of this CreateOrderResponseOrderAction.  # noqa: E501
        :rtype: list[CreateOrderResponseOrderMetric]
        """
        return self._order_metrics

    @order_metrics.setter
    def order_metrics(self, order_metrics):
        """Sets the order_metrics of this CreateOrderResponseOrderAction.

        subscription order metrics  # noqa: E501

        :param order_metrics: The order_metrics of this CreateOrderResponseOrderAction.  # noqa: E501
        :type: list[CreateOrderResponseOrderMetric]
        """

        self._order_metrics = order_metrics

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(CreateOrderResponseOrderAction, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, CreateOrderResponseOrderAction):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
