# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).  # noqa: E501

    OpenAPI spec version: 2024-05-20
    Contact: docs@zuora.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class CreateOrderResponseOrderMetric(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'charge_number': 'str',
        'mrr': 'list[TimeSlicedNetMetrics]',
        'quantity': 'list[TimeSlicedMetrics]',
        'tcb': 'list[TimeSlicedTcbNetMetrics]',
        'tcv': 'list[TimeSlicedNetMetrics]'
    }

    attribute_map = {
        'charge_number': 'chargeNumber',
        'mrr': 'mrr',
        'quantity': 'quantity',
        'tcb': 'tcb',
        'tcv': 'tcv'
    }

    def __init__(self, charge_number=None, mrr=None, quantity=None, tcb=None, tcv=None):  # noqa: E501
        """CreateOrderResponseOrderMetric - a model defined in Swagger"""  # noqa: E501
        self._charge_number = None
        self._mrr = None
        self._quantity = None
        self._tcb = None
        self._tcv = None
        self.discriminator = None
        if charge_number is not None:
            self.charge_number = charge_number
        if mrr is not None:
            self.mrr = mrr
        if quantity is not None:
            self.quantity = quantity
        if tcb is not None:
            self.tcb = tcb
        if tcv is not None:
            self.tcv = tcv

    @property
    def charge_number(self):
        """Gets the charge_number of this CreateOrderResponseOrderMetric.  # noqa: E501


        :return: The charge_number of this CreateOrderResponseOrderMetric.  # noqa: E501
        :rtype: str
        """
        return self._charge_number

    @charge_number.setter
    def charge_number(self, charge_number):
        """Sets the charge_number of this CreateOrderResponseOrderMetric.


        :param charge_number: The charge_number of this CreateOrderResponseOrderMetric.  # noqa: E501
        :type: str
        """

        self._charge_number = charge_number

    @property
    def mrr(self):
        """Gets the mrr of this CreateOrderResponseOrderMetric.  # noqa: E501


        :return: The mrr of this CreateOrderResponseOrderMetric.  # noqa: E501
        :rtype: list[TimeSlicedNetMetrics]
        """
        return self._mrr

    @mrr.setter
    def mrr(self, mrr):
        """Sets the mrr of this CreateOrderResponseOrderMetric.


        :param mrr: The mrr of this CreateOrderResponseOrderMetric.  # noqa: E501
        :type: list[TimeSlicedNetMetrics]
        """

        self._mrr = mrr

    @property
    def quantity(self):
        """Gets the quantity of this CreateOrderResponseOrderMetric.  # noqa: E501


        :return: The quantity of this CreateOrderResponseOrderMetric.  # noqa: E501
        :rtype: list[TimeSlicedMetrics]
        """
        return self._quantity

    @quantity.setter
    def quantity(self, quantity):
        """Sets the quantity of this CreateOrderResponseOrderMetric.


        :param quantity: The quantity of this CreateOrderResponseOrderMetric.  # noqa: E501
        :type: list[TimeSlicedMetrics]
        """

        self._quantity = quantity

    @property
    def tcb(self):
        """Gets the tcb of this CreateOrderResponseOrderMetric.  # noqa: E501

        Total contracted billing which is the forecast value for the total invoice amount.  # noqa: E501

        :return: The tcb of this CreateOrderResponseOrderMetric.  # noqa: E501
        :rtype: list[TimeSlicedTcbNetMetrics]
        """
        return self._tcb

    @tcb.setter
    def tcb(self, tcb):
        """Sets the tcb of this CreateOrderResponseOrderMetric.

        Total contracted billing which is the forecast value for the total invoice amount.  # noqa: E501

        :param tcb: The tcb of this CreateOrderResponseOrderMetric.  # noqa: E501
        :type: list[TimeSlicedTcbNetMetrics]
        """

        self._tcb = tcb

    @property
    def tcv(self):
        """Gets the tcv of this CreateOrderResponseOrderMetric.  # noqa: E501

        Total contracted value.  # noqa: E501

        :return: The tcv of this CreateOrderResponseOrderMetric.  # noqa: E501
        :rtype: list[TimeSlicedNetMetrics]
        """
        return self._tcv

    @tcv.setter
    def tcv(self, tcv):
        """Sets the tcv of this CreateOrderResponseOrderMetric.

        Total contracted value.  # noqa: E501

        :param tcv: The tcv of this CreateOrderResponseOrderMetric.  # noqa: E501
        :type: list[TimeSlicedNetMetrics]
        """

        self._tcv = tcv

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(CreateOrderResponseOrderMetric, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, CreateOrderResponseOrderMetric):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
