# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).  # noqa: E501

    OpenAPI spec version: 2024-05-20
    Contact: docs@zuora.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class CreateOrderResponseRefunds(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'number': 'str',
        'refund_invoice_numbers': 'list[str]',
        'status': 'CreateOrderResponseRefundStatus'
    }

    attribute_map = {
        'number': 'number',
        'refund_invoice_numbers': 'refundInvoiceNumbers',
        'status': 'status'
    }

    def __init__(self, number=None, refund_invoice_numbers=None, status=None):  # noqa: E501
        """CreateOrderResponseRefunds - a model defined in Swagger"""  # noqa: E501
        self._number = None
        self._refund_invoice_numbers = None
        self._status = None
        self.discriminator = None
        if number is not None:
            self.number = number
        if refund_invoice_numbers is not None:
            self.refund_invoice_numbers = refund_invoice_numbers
        if status is not None:
            self.status = status

    @property
    def number(self):
        """Gets the number of this CreateOrderResponseRefunds.  # noqa: E501

        The refund number. For example, `R-00009564`.  # noqa: E501

        :return: The number of this CreateOrderResponseRefunds.  # noqa: E501
        :rtype: str
        """
        return self._number

    @number.setter
    def number(self, number):
        """Sets the number of this CreateOrderResponseRefunds.

        The refund number. For example, `R-00009564`.  # noqa: E501

        :param number: The number of this CreateOrderResponseRefunds.  # noqa: E501
        :type: str
        """

        self._number = number

    @property
    def refund_invoice_numbers(self):
        """Gets the refund_invoice_numbers of this CreateOrderResponseRefunds.  # noqa: E501

        An array of the refunded invoice numbers generated in this order request.  # noqa: E501

        :return: The refund_invoice_numbers of this CreateOrderResponseRefunds.  # noqa: E501
        :rtype: list[str]
        """
        return self._refund_invoice_numbers

    @refund_invoice_numbers.setter
    def refund_invoice_numbers(self, refund_invoice_numbers):
        """Sets the refund_invoice_numbers of this CreateOrderResponseRefunds.

        An array of the refunded invoice numbers generated in this order request.  # noqa: E501

        :param refund_invoice_numbers: The refund_invoice_numbers of this CreateOrderResponseRefunds.  # noqa: E501
        :type: list[str]
        """

        self._refund_invoice_numbers = refund_invoice_numbers

    @property
    def status(self):
        """Gets the status of this CreateOrderResponseRefunds.  # noqa: E501


        :return: The status of this CreateOrderResponseRefunds.  # noqa: E501
        :rtype: CreateOrderResponseRefundStatus
        """
        return self._status

    @status.setter
    def status(self, status):
        """Sets the status of this CreateOrderResponseRefunds.


        :param status: The status of this CreateOrderResponseRefunds.  # noqa: E501
        :type: CreateOrderResponseRefundStatus
        """

        self._status = status

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(CreateOrderResponseRefunds, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, CreateOrderResponseRefunds):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
