# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).  # noqa: E501

    OpenAPI spec version: 2024-05-20
    Contact: docs@zuora.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class CreateOrderTermsAndConditions(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'auto_renew': 'bool',
        'bill_to_contact_id': 'str',
        'clearing_existing_bill_to_contact': 'bool',
        'clearing_existing_invoice_template': 'bool',
        'clearing_existing_payment_term': 'bool',
        'clearing_existing_sequence_set': 'bool',
        'clearing_existing_sold_to_contact': 'bool',
        'invoice_separately': 'bool',
        'invoice_template_id': 'str',
        'last_term': 'LastTerm',
        'term_increase_to_new_contract_line': 'bool',
        'payment_term': 'str',
        'renewal_setting': 'RenewalSetting',
        'renewal_terms': 'list[RenewalTerm]',
        'sequence_set_id': 'str',
        'sold_to_contact_id': 'str'
    }

    attribute_map = {
        'auto_renew': 'autoRenew',
        'bill_to_contact_id': 'billToContactId',
        'clearing_existing_bill_to_contact': 'clearingExistingBillToContact',
        'clearing_existing_invoice_template': 'clearingExistingInvoiceTemplate',
        'clearing_existing_payment_term': 'clearingExistingPaymentTerm',
        'clearing_existing_sequence_set': 'clearingExistingSequenceSet',
        'clearing_existing_sold_to_contact': 'clearingExistingSoldToContact',
        'invoice_separately': 'invoiceSeparately',
        'invoice_template_id': 'invoiceTemplateId',
        'last_term': 'lastTerm',
        'term_increase_to_new_contract_line': 'termIncreaseToNewContractLine',
        'payment_term': 'paymentTerm',
        'renewal_setting': 'renewalSetting',
        'renewal_terms': 'renewalTerms',
        'sequence_set_id': 'sequenceSetId',
        'sold_to_contact_id': 'soldToContactId'
    }

    def __init__(self, auto_renew=None, bill_to_contact_id=None, clearing_existing_bill_to_contact=False, clearing_existing_invoice_template=False, clearing_existing_payment_term=False, clearing_existing_sequence_set=False, clearing_existing_sold_to_contact=False, invoice_separately=None, invoice_template_id=None, last_term=None, term_increase_to_new_contract_line=None, payment_term=None, renewal_setting=None, renewal_terms=None, sequence_set_id=None, sold_to_contact_id=None):  # noqa: E501
        """CreateOrderTermsAndConditions - a model defined in Swagger"""  # noqa: E501
        self._auto_renew = None
        self._bill_to_contact_id = None
        self._clearing_existing_bill_to_contact = None
        self._clearing_existing_invoice_template = None
        self._clearing_existing_payment_term = None
        self._clearing_existing_sequence_set = None
        self._clearing_existing_sold_to_contact = None
        self._invoice_separately = None
        self._invoice_template_id = None
        self._last_term = None
        self._term_increase_to_new_contract_line = None
        self._payment_term = None
        self._renewal_setting = None
        self._renewal_terms = None
        self._sequence_set_id = None
        self._sold_to_contact_id = None
        self.discriminator = None
        if auto_renew is not None:
            self.auto_renew = auto_renew
        if bill_to_contact_id is not None:
            self.bill_to_contact_id = bill_to_contact_id
        if clearing_existing_bill_to_contact is not None:
            self.clearing_existing_bill_to_contact = clearing_existing_bill_to_contact
        if clearing_existing_invoice_template is not None:
            self.clearing_existing_invoice_template = clearing_existing_invoice_template
        if clearing_existing_payment_term is not None:
            self.clearing_existing_payment_term = clearing_existing_payment_term
        if clearing_existing_sequence_set is not None:
            self.clearing_existing_sequence_set = clearing_existing_sequence_set
        if clearing_existing_sold_to_contact is not None:
            self.clearing_existing_sold_to_contact = clearing_existing_sold_to_contact
        if invoice_separately is not None:
            self.invoice_separately = invoice_separately
        if invoice_template_id is not None:
            self.invoice_template_id = invoice_template_id
        if last_term is not None:
            self.last_term = last_term
        if term_increase_to_new_contract_line is not None:
            self.term_increase_to_new_contract_line = term_increase_to_new_contract_line
        if payment_term is not None:
            self.payment_term = payment_term
        if renewal_setting is not None:
            self.renewal_setting = renewal_setting
        if renewal_terms is not None:
            self.renewal_terms = renewal_terms
        if sequence_set_id is not None:
            self.sequence_set_id = sequence_set_id
        if sold_to_contact_id is not None:
            self.sold_to_contact_id = sold_to_contact_id

    @property
    def auto_renew(self):
        """Gets the auto_renew of this CreateOrderTermsAndConditions.  # noqa: E501


        :return: The auto_renew of this CreateOrderTermsAndConditions.  # noqa: E501
        :rtype: bool
        """
        return self._auto_renew

    @auto_renew.setter
    def auto_renew(self, auto_renew):
        """Sets the auto_renew of this CreateOrderTermsAndConditions.


        :param auto_renew: The auto_renew of this CreateOrderTermsAndConditions.  # noqa: E501
        :type: bool
        """

        self._auto_renew = auto_renew

    @property
    def bill_to_contact_id(self):
        """Gets the bill_to_contact_id of this CreateOrderTermsAndConditions.  # noqa: E501

        The ID of the bill-to contact associated with the subscription.  **Note**:    - If you have the <a href=\"https://knowledgecenter.zuora.com/Zuora_Billing/Bill_your_customers/Bill_customers_at_subscription_level/Flexible_Billing_Attributes\" target=\"_blank\">Flexible Billing Attributes</a> feature disabled, this field is unavailable in the request body and the value of this field is `null` in the response body.    - If you have the Flexible Billing Attributes feature enabled, and you do not specify this field in the request or you select **Default Contact from Account** for this field during subscription creation, the value of this field is automatically set to `null` in the response body.   # noqa: E501

        :return: The bill_to_contact_id of this CreateOrderTermsAndConditions.  # noqa: E501
        :rtype: str
        """
        return self._bill_to_contact_id

    @bill_to_contact_id.setter
    def bill_to_contact_id(self, bill_to_contact_id):
        """Sets the bill_to_contact_id of this CreateOrderTermsAndConditions.

        The ID of the bill-to contact associated with the subscription.  **Note**:    - If you have the <a href=\"https://knowledgecenter.zuora.com/Zuora_Billing/Bill_your_customers/Bill_customers_at_subscription_level/Flexible_Billing_Attributes\" target=\"_blank\">Flexible Billing Attributes</a> feature disabled, this field is unavailable in the request body and the value of this field is `null` in the response body.    - If you have the Flexible Billing Attributes feature enabled, and you do not specify this field in the request or you select **Default Contact from Account** for this field during subscription creation, the value of this field is automatically set to `null` in the response body.   # noqa: E501

        :param bill_to_contact_id: The bill_to_contact_id of this CreateOrderTermsAndConditions.  # noqa: E501
        :type: str
        """

        self._bill_to_contact_id = bill_to_contact_id

    @property
    def clearing_existing_bill_to_contact(self):
        """Gets the clearing_existing_bill_to_contact of this CreateOrderTermsAndConditions.  # noqa: E501

        Whether to clear the existing bill-to contact ID at the subscription level. This field is mutually exclusive with the `billToContactId` field.  **Note**: If you have the [Flexible Billing Attributes](https://knowledgecenter.zuora.com/Billing/Subscriptions/Flexible_Billing_Attributes) feature disabled, this field is unavailable in the request body and the value of this field is `null` in the response body.   # noqa: E501

        :return: The clearing_existing_bill_to_contact of this CreateOrderTermsAndConditions.  # noqa: E501
        :rtype: bool
        """
        return self._clearing_existing_bill_to_contact

    @clearing_existing_bill_to_contact.setter
    def clearing_existing_bill_to_contact(self, clearing_existing_bill_to_contact):
        """Sets the clearing_existing_bill_to_contact of this CreateOrderTermsAndConditions.

        Whether to clear the existing bill-to contact ID at the subscription level. This field is mutually exclusive with the `billToContactId` field.  **Note**: If you have the [Flexible Billing Attributes](https://knowledgecenter.zuora.com/Billing/Subscriptions/Flexible_Billing_Attributes) feature disabled, this field is unavailable in the request body and the value of this field is `null` in the response body.   # noqa: E501

        :param clearing_existing_bill_to_contact: The clearing_existing_bill_to_contact of this CreateOrderTermsAndConditions.  # noqa: E501
        :type: bool
        """

        self._clearing_existing_bill_to_contact = clearing_existing_bill_to_contact

    @property
    def clearing_existing_invoice_template(self):
        """Gets the clearing_existing_invoice_template of this CreateOrderTermsAndConditions.  # noqa: E501

        Whether to clear the existing invoice template ID at the subscription level. This field is mutually exclusive with the `invoiceTemplateId` field.  **Note**: If you have the [Flexible Billing Attributes](https://knowledgecenter.zuora.com/Billing/Subscriptions/Flexible_Billing_Attributes) feature disabled, this field is unavailable in the request body and the value of this field is `null` in the response body.   # noqa: E501

        :return: The clearing_existing_invoice_template of this CreateOrderTermsAndConditions.  # noqa: E501
        :rtype: bool
        """
        return self._clearing_existing_invoice_template

    @clearing_existing_invoice_template.setter
    def clearing_existing_invoice_template(self, clearing_existing_invoice_template):
        """Sets the clearing_existing_invoice_template of this CreateOrderTermsAndConditions.

        Whether to clear the existing invoice template ID at the subscription level. This field is mutually exclusive with the `invoiceTemplateId` field.  **Note**: If you have the [Flexible Billing Attributes](https://knowledgecenter.zuora.com/Billing/Subscriptions/Flexible_Billing_Attributes) feature disabled, this field is unavailable in the request body and the value of this field is `null` in the response body.   # noqa: E501

        :param clearing_existing_invoice_template: The clearing_existing_invoice_template of this CreateOrderTermsAndConditions.  # noqa: E501
        :type: bool
        """

        self._clearing_existing_invoice_template = clearing_existing_invoice_template

    @property
    def clearing_existing_payment_term(self):
        """Gets the clearing_existing_payment_term of this CreateOrderTermsAndConditions.  # noqa: E501

        Whether to clear the existing payment term at the subscription level. This field is mutually exclusive with the `paymentTerm` field.  **Note**: If you have the [Flexible Billing Attributes](https://knowledgecenter.zuora.com/Billing/Subscriptions/Flexible_Billing_Attributes) feature disabled, this field is unavailable in the request body and the value of this field is `null` in the response body.   # noqa: E501

        :return: The clearing_existing_payment_term of this CreateOrderTermsAndConditions.  # noqa: E501
        :rtype: bool
        """
        return self._clearing_existing_payment_term

    @clearing_existing_payment_term.setter
    def clearing_existing_payment_term(self, clearing_existing_payment_term):
        """Sets the clearing_existing_payment_term of this CreateOrderTermsAndConditions.

        Whether to clear the existing payment term at the subscription level. This field is mutually exclusive with the `paymentTerm` field.  **Note**: If you have the [Flexible Billing Attributes](https://knowledgecenter.zuora.com/Billing/Subscriptions/Flexible_Billing_Attributes) feature disabled, this field is unavailable in the request body and the value of this field is `null` in the response body.   # noqa: E501

        :param clearing_existing_payment_term: The clearing_existing_payment_term of this CreateOrderTermsAndConditions.  # noqa: E501
        :type: bool
        """

        self._clearing_existing_payment_term = clearing_existing_payment_term

    @property
    def clearing_existing_sequence_set(self):
        """Gets the clearing_existing_sequence_set of this CreateOrderTermsAndConditions.  # noqa: E501

        Whether to clear the existing sequence set ID at the subscription level. This field is mutually exclusive with the `sequenceSetId` field.  **Note**: If you have the [Flexible Billing Attributes](https://knowledgecenter.zuora.com/Billing/Subscriptions/Flexible_Billing_Attributes) feature disabled, this field is unavailable in the request body and the value of this field is `null` in the response body.   # noqa: E501

        :return: The clearing_existing_sequence_set of this CreateOrderTermsAndConditions.  # noqa: E501
        :rtype: bool
        """
        return self._clearing_existing_sequence_set

    @clearing_existing_sequence_set.setter
    def clearing_existing_sequence_set(self, clearing_existing_sequence_set):
        """Sets the clearing_existing_sequence_set of this CreateOrderTermsAndConditions.

        Whether to clear the existing sequence set ID at the subscription level. This field is mutually exclusive with the `sequenceSetId` field.  **Note**: If you have the [Flexible Billing Attributes](https://knowledgecenter.zuora.com/Billing/Subscriptions/Flexible_Billing_Attributes) feature disabled, this field is unavailable in the request body and the value of this field is `null` in the response body.   # noqa: E501

        :param clearing_existing_sequence_set: The clearing_existing_sequence_set of this CreateOrderTermsAndConditions.  # noqa: E501
        :type: bool
        """

        self._clearing_existing_sequence_set = clearing_existing_sequence_set

    @property
    def clearing_existing_sold_to_contact(self):
        """Gets the clearing_existing_sold_to_contact of this CreateOrderTermsAndConditions.  # noqa: E501

        Whether to clear the existing sold-to contact ID at the subscription level. This field is mutually exclusive with the `soldToContactId` field.  **Note**: If you have the [Flexible Billing Attributes](https://knowledgecenter.zuora.com/Billing/Subscriptions/Flexible_Billing_Attributes) feature disabled, this field is unavailable in the request body and the value of this field is `null` in the response body.   # noqa: E501

        :return: The clearing_existing_sold_to_contact of this CreateOrderTermsAndConditions.  # noqa: E501
        :rtype: bool
        """
        return self._clearing_existing_sold_to_contact

    @clearing_existing_sold_to_contact.setter
    def clearing_existing_sold_to_contact(self, clearing_existing_sold_to_contact):
        """Sets the clearing_existing_sold_to_contact of this CreateOrderTermsAndConditions.

        Whether to clear the existing sold-to contact ID at the subscription level. This field is mutually exclusive with the `soldToContactId` field.  **Note**: If you have the [Flexible Billing Attributes](https://knowledgecenter.zuora.com/Billing/Subscriptions/Flexible_Billing_Attributes) feature disabled, this field is unavailable in the request body and the value of this field is `null` in the response body.   # noqa: E501

        :param clearing_existing_sold_to_contact: The clearing_existing_sold_to_contact of this CreateOrderTermsAndConditions.  # noqa: E501
        :type: bool
        """

        self._clearing_existing_sold_to_contact = clearing_existing_sold_to_contact

    @property
    def invoice_separately(self):
        """Gets the invoice_separately of this CreateOrderTermsAndConditions.  # noqa: E501

        Specifies whether the subscription appears on a separate invoice when generates invoices.  # noqa: E501

        :return: The invoice_separately of this CreateOrderTermsAndConditions.  # noqa: E501
        :rtype: bool
        """
        return self._invoice_separately

    @invoice_separately.setter
    def invoice_separately(self, invoice_separately):
        """Sets the invoice_separately of this CreateOrderTermsAndConditions.

        Specifies whether the subscription appears on a separate invoice when generates invoices.  # noqa: E501

        :param invoice_separately: The invoice_separately of this CreateOrderTermsAndConditions.  # noqa: E501
        :type: bool
        """

        self._invoice_separately = invoice_separately

    @property
    def invoice_template_id(self):
        """Gets the invoice_template_id of this CreateOrderTermsAndConditions.  # noqa: E501

        The ID of the invoice template associated with the subscription.  **Note**:    - If you have the <a href=\"https://knowledgecenter.zuora.com/Zuora_Billing/Bill_your_customers/Bill_customers_at_subscription_level/Flexible_Billing_Attributes\" target=\"_blank\">Flexible Billing Attributes</a> feature disabled, this field is unavailable in the request body and the value of this field is `null` in the response body.    - If you have the Flexible Billing Attributes feature enabled, and you do not specify this field in the request or you select **Default Template from Account** for this field during subscription creation, the value of this field is automatically set to `null` in the response body.   # noqa: E501

        :return: The invoice_template_id of this CreateOrderTermsAndConditions.  # noqa: E501
        :rtype: str
        """
        return self._invoice_template_id

    @invoice_template_id.setter
    def invoice_template_id(self, invoice_template_id):
        """Sets the invoice_template_id of this CreateOrderTermsAndConditions.

        The ID of the invoice template associated with the subscription.  **Note**:    - If you have the <a href=\"https://knowledgecenter.zuora.com/Zuora_Billing/Bill_your_customers/Bill_customers_at_subscription_level/Flexible_Billing_Attributes\" target=\"_blank\">Flexible Billing Attributes</a> feature disabled, this field is unavailable in the request body and the value of this field is `null` in the response body.    - If you have the Flexible Billing Attributes feature enabled, and you do not specify this field in the request or you select **Default Template from Account** for this field during subscription creation, the value of this field is automatically set to `null` in the response body.   # noqa: E501

        :param invoice_template_id: The invoice_template_id of this CreateOrderTermsAndConditions.  # noqa: E501
        :type: str
        """

        self._invoice_template_id = invoice_template_id

    @property
    def last_term(self):
        """Gets the last_term of this CreateOrderTermsAndConditions.  # noqa: E501


        :return: The last_term of this CreateOrderTermsAndConditions.  # noqa: E501
        :rtype: LastTerm
        """
        return self._last_term

    @last_term.setter
    def last_term(self, last_term):
        """Sets the last_term of this CreateOrderTermsAndConditions.


        :param last_term: The last_term of this CreateOrderTermsAndConditions.  # noqa: E501
        :type: LastTerm
        """

        self._last_term = last_term

    @property
    def term_increase_to_new_contract_line(self):
        """Gets the term_increase_to_new_contract_line of this CreateOrderTermsAndConditions.  # noqa: E501

        Reflect the term increase to a new contract line when term increased or converts from Term to Evergreen  # noqa: E501

        :return: The term_increase_to_new_contract_line of this CreateOrderTermsAndConditions.  # noqa: E501
        :rtype: bool
        """
        return self._term_increase_to_new_contract_line

    @term_increase_to_new_contract_line.setter
    def term_increase_to_new_contract_line(self, term_increase_to_new_contract_line):
        """Sets the term_increase_to_new_contract_line of this CreateOrderTermsAndConditions.

        Reflect the term increase to a new contract line when term increased or converts from Term to Evergreen  # noqa: E501

        :param term_increase_to_new_contract_line: The term_increase_to_new_contract_line of this CreateOrderTermsAndConditions.  # noqa: E501
        :type: bool
        """

        self._term_increase_to_new_contract_line = term_increase_to_new_contract_line

    @property
    def payment_term(self):
        """Gets the payment_term of this CreateOrderTermsAndConditions.  # noqa: E501

        The name of the payment term associated with the subscription. For example, `Net 30`. The payment term determines the due dates of invoices.  **Note**:    - If you have the <a href=\"https://knowledgecenter.zuora.com/Zuora_Billing/Bill_your_customers/Bill_customers_at_subscription_level/Flexible_Billing_Attributes\" target=\"_blank\">Flexible Billing Attributes</a> feature disabled, this field is unavailable in the request body and the value of this field is `null` in the response body.    - If you have the Flexible Billing Attributes feature enabled, and you do not specify this field in the request or you select **Default Term from Account** for this field during subscription creation, the value of this field is automatically set to `null` in the response body.   # noqa: E501

        :return: The payment_term of this CreateOrderTermsAndConditions.  # noqa: E501
        :rtype: str
        """
        return self._payment_term

    @payment_term.setter
    def payment_term(self, payment_term):
        """Sets the payment_term of this CreateOrderTermsAndConditions.

        The name of the payment term associated with the subscription. For example, `Net 30`. The payment term determines the due dates of invoices.  **Note**:    - If you have the <a href=\"https://knowledgecenter.zuora.com/Zuora_Billing/Bill_your_customers/Bill_customers_at_subscription_level/Flexible_Billing_Attributes\" target=\"_blank\">Flexible Billing Attributes</a> feature disabled, this field is unavailable in the request body and the value of this field is `null` in the response body.    - If you have the Flexible Billing Attributes feature enabled, and you do not specify this field in the request or you select **Default Term from Account** for this field during subscription creation, the value of this field is automatically set to `null` in the response body.   # noqa: E501

        :param payment_term: The payment_term of this CreateOrderTermsAndConditions.  # noqa: E501
        :type: str
        """

        self._payment_term = payment_term

    @property
    def renewal_setting(self):
        """Gets the renewal_setting of this CreateOrderTermsAndConditions.  # noqa: E501


        :return: The renewal_setting of this CreateOrderTermsAndConditions.  # noqa: E501
        :rtype: RenewalSetting
        """
        return self._renewal_setting

    @renewal_setting.setter
    def renewal_setting(self, renewal_setting):
        """Sets the renewal_setting of this CreateOrderTermsAndConditions.


        :param renewal_setting: The renewal_setting of this CreateOrderTermsAndConditions.  # noqa: E501
        :type: RenewalSetting
        """

        self._renewal_setting = renewal_setting

    @property
    def renewal_terms(self):
        """Gets the renewal_terms of this CreateOrderTermsAndConditions.  # noqa: E501


        :return: The renewal_terms of this CreateOrderTermsAndConditions.  # noqa: E501
        :rtype: list[RenewalTerm]
        """
        return self._renewal_terms

    @renewal_terms.setter
    def renewal_terms(self, renewal_terms):
        """Sets the renewal_terms of this CreateOrderTermsAndConditions.


        :param renewal_terms: The renewal_terms of this CreateOrderTermsAndConditions.  # noqa: E501
        :type: list[RenewalTerm]
        """

        self._renewal_terms = renewal_terms

    @property
    def sequence_set_id(self):
        """Gets the sequence_set_id of this CreateOrderTermsAndConditions.  # noqa: E501

        The ID of the sequence set associated with the subscription.  **Note**:    - If you have the <a href=\"https://knowledgecenter.zuora.com/Zuora_Billing/Bill_your_customers/Bill_customers_at_subscription_level/Flexible_Billing_Attributes\" target=\"_blank\">Flexible Billing Attributes</a> feature disabled, this field is unavailable in the request body and the value of this field is `null` in the response body.    - If you have the Flexible Billing Attributes feature enabled, and you do not specify this field in the request or you select **Default Set from Account** for this field during subscription creation, the value of this field is automatically set to `null` in the response body.   # noqa: E501

        :return: The sequence_set_id of this CreateOrderTermsAndConditions.  # noqa: E501
        :rtype: str
        """
        return self._sequence_set_id

    @sequence_set_id.setter
    def sequence_set_id(self, sequence_set_id):
        """Sets the sequence_set_id of this CreateOrderTermsAndConditions.

        The ID of the sequence set associated with the subscription.  **Note**:    - If you have the <a href=\"https://knowledgecenter.zuora.com/Zuora_Billing/Bill_your_customers/Bill_customers_at_subscription_level/Flexible_Billing_Attributes\" target=\"_blank\">Flexible Billing Attributes</a> feature disabled, this field is unavailable in the request body and the value of this field is `null` in the response body.    - If you have the Flexible Billing Attributes feature enabled, and you do not specify this field in the request or you select **Default Set from Account** for this field during subscription creation, the value of this field is automatically set to `null` in the response body.   # noqa: E501

        :param sequence_set_id: The sequence_set_id of this CreateOrderTermsAndConditions.  # noqa: E501
        :type: str
        """

        self._sequence_set_id = sequence_set_id

    @property
    def sold_to_contact_id(self):
        """Gets the sold_to_contact_id of this CreateOrderTermsAndConditions.  # noqa: E501

        The ID of the sold-to contact associated with the subscription.  **Note**:    - If you have the <a href=\"https://knowledgecenter.zuora.com/Zuora_Billing/Bill_your_customers/Bill_customers_at_subscription_level/Flexible_Billing_Attributes\" target=\"_blank\">Flexible Billing Attributes</a> feature disabled, this field is unavailable in the request body and the value of this field is `null` in the response body.    - If you have the Flexible Billing Attributes feature enabled, and you do not specify this field in the request or you select **Default Contact from Account** for this field during subscription creation, the value of this field is automatically set to `null` in the response body.   # noqa: E501

        :return: The sold_to_contact_id of this CreateOrderTermsAndConditions.  # noqa: E501
        :rtype: str
        """
        return self._sold_to_contact_id

    @sold_to_contact_id.setter
    def sold_to_contact_id(self, sold_to_contact_id):
        """Sets the sold_to_contact_id of this CreateOrderTermsAndConditions.

        The ID of the sold-to contact associated with the subscription.  **Note**:    - If you have the <a href=\"https://knowledgecenter.zuora.com/Zuora_Billing/Bill_your_customers/Bill_customers_at_subscription_level/Flexible_Billing_Attributes\" target=\"_blank\">Flexible Billing Attributes</a> feature disabled, this field is unavailable in the request body and the value of this field is `null` in the response body.    - If you have the Flexible Billing Attributes feature enabled, and you do not specify this field in the request or you select **Default Contact from Account** for this field during subscription creation, the value of this field is automatically set to `null` in the response body.   # noqa: E501

        :param sold_to_contact_id: The sold_to_contact_id of this CreateOrderTermsAndConditions.  # noqa: E501
        :type: str
        """

        self._sold_to_contact_id = sold_to_contact_id

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(CreateOrderTermsAndConditions, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, CreateOrderTermsAndConditions):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
