# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).  # noqa: E501

    OpenAPI spec version: 2024-05-20
    Contact: docs@zuora.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class CreatePaymentMethodDecryptionResponse(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'amount': 'str',
        'payment_id': 'str',
        'payment_method_id': 'str',
        'success': 'bool'
    }

    attribute_map = {
        'amount': 'amount',
        'payment_id': 'paymentId',
        'payment_method_id': 'paymentMethodId',
        'success': 'success'
    }

    def __init__(self, amount=None, payment_id=None, payment_method_id=None, success=None):  # noqa: E501
        """CreatePaymentMethodDecryptionResponse - a model defined in Swagger"""  # noqa: E501
        self._amount = None
        self._payment_id = None
        self._payment_method_id = None
        self._success = None
        self.discriminator = None
        if amount is not None:
            self.amount = amount
        if payment_id is not None:
            self.payment_id = payment_id
        if payment_method_id is not None:
            self.payment_method_id = payment_method_id
        if success is not None:
            self.success = success

    @property
    def amount(self):
        """Gets the amount of this CreatePaymentMethodDecryptionResponse.  # noqa: E501

        The payment amount contained within the encrypted token.   # noqa: E501

        :return: The amount of this CreatePaymentMethodDecryptionResponse.  # noqa: E501
        :rtype: str
        """
        return self._amount

    @amount.setter
    def amount(self, amount):
        """Sets the amount of this CreatePaymentMethodDecryptionResponse.

        The payment amount contained within the encrypted token.   # noqa: E501

        :param amount: The amount of this CreatePaymentMethodDecryptionResponse.  # noqa: E501
        :type: str
        """

        self._amount = amount

    @property
    def payment_id(self):
        """Gets the payment_id of this CreatePaymentMethodDecryptionResponse.  # noqa: E501

        The ID of newly processed payment,   # noqa: E501

        :return: The payment_id of this CreatePaymentMethodDecryptionResponse.  # noqa: E501
        :rtype: str
        """
        return self._payment_id

    @payment_id.setter
    def payment_id(self, payment_id):
        """Sets the payment_id of this CreatePaymentMethodDecryptionResponse.

        The ID of newly processed payment,   # noqa: E501

        :param payment_id: The payment_id of this CreatePaymentMethodDecryptionResponse.  # noqa: E501
        :type: str
        """

        self._payment_id = payment_id

    @property
    def payment_method_id(self):
        """Gets the payment_method_id of this CreatePaymentMethodDecryptionResponse.  # noqa: E501

        ID of the newly-created payment method.   # noqa: E501

        :return: The payment_method_id of this CreatePaymentMethodDecryptionResponse.  # noqa: E501
        :rtype: str
        """
        return self._payment_method_id

    @payment_method_id.setter
    def payment_method_id(self, payment_method_id):
        """Sets the payment_method_id of this CreatePaymentMethodDecryptionResponse.

        ID of the newly-created payment method.   # noqa: E501

        :param payment_method_id: The payment_method_id of this CreatePaymentMethodDecryptionResponse.  # noqa: E501
        :type: str
        """

        self._payment_method_id = payment_method_id

    @property
    def success(self):
        """Gets the success of this CreatePaymentMethodDecryptionResponse.  # noqa: E501

        Returns `true` if the request was processed successfully.   # noqa: E501

        :return: The success of this CreatePaymentMethodDecryptionResponse.  # noqa: E501
        :rtype: bool
        """
        return self._success

    @success.setter
    def success(self, success):
        """Sets the success of this CreatePaymentMethodDecryptionResponse.

        Returns `true` if the request was processed successfully.   # noqa: E501

        :param success: The success of this CreatePaymentMethodDecryptionResponse.  # noqa: E501
        :type: bool
        """

        self._success = success

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(CreatePaymentMethodDecryptionResponse, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, CreatePaymentMethodDecryptionResponse):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
