# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).  # noqa: E501

    OpenAPI spec version: 2024-05-20
    Contact: docs@zuora.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six
from zuora_sdk.models.common_response import CommonResponse  # noqa: F401,E501

class CreatePaymentMethodResponse(CommonResponse):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'id': 'str',
        'reasons': 'list[CreatePaymentMethodResponseReason]'
    }
    if hasattr(CommonResponse, "swagger_types"):
        swagger_types.update(CommonResponse.swagger_types)

    attribute_map = {
        'id': 'id',
        'reasons': 'reasons'
    }
    if hasattr(CommonResponse, "attribute_map"):
        attribute_map.update(CommonResponse.attribute_map)

    def __init__(self, id=None, reasons=None, *args, **kwargs):  # noqa: E501
        """CreatePaymentMethodResponse - a model defined in Swagger"""  # noqa: E501
        self._id = None
        self._reasons = None
        self.discriminator = None
        if id is not None:
            self.id = id
        if reasons is not None:
            self.reasons = reasons
        CommonResponse.__init__(self, *args, **kwargs)

    @property
    def id(self):
        """Gets the id of this CreatePaymentMethodResponse.  # noqa: E501

        Internal ID of the payment method that was created.   # noqa: E501

        :return: The id of this CreatePaymentMethodResponse.  # noqa: E501
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this CreatePaymentMethodResponse.

        Internal ID of the payment method that was created.   # noqa: E501

        :param id: The id of this CreatePaymentMethodResponse.  # noqa: E501
        :type: str
        """

        self._id = id

    @property
    def reasons(self):
        """Gets the reasons of this CreatePaymentMethodResponse.  # noqa: E501


        :return: The reasons of this CreatePaymentMethodResponse.  # noqa: E501
        :rtype: list[CreatePaymentMethodResponseReason]
        """
        return self._reasons

    @reasons.setter
    def reasons(self, reasons):
        """Sets the reasons of this CreatePaymentMethodResponse.


        :param reasons: The reasons of this CreatePaymentMethodResponse.  # noqa: E501
        :type: list[CreatePaymentMethodResponseReason]
        """

        self._reasons = reasons

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(CreatePaymentMethodResponse, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, CreatePaymentMethodResponse):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
