# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).  # noqa: E501

    OpenAPI spec version: 2024-05-20
    Contact: docs@zuora.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class CreatePaymentSchedulesResponse(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'payment_schedules': 'list[CreatePaymentSchedulesResponseItems]',
        'success': 'bool'
    }

    attribute_map = {
        'payment_schedules': 'paymentSchedules',
        'success': 'success'
    }

    def __init__(self, payment_schedules=None, success=None):  # noqa: E501
        """CreatePaymentSchedulesResponse - a model defined in Swagger"""  # noqa: E501
        self._payment_schedules = None
        self._success = None
        self.discriminator = None
        if payment_schedules is not None:
            self.payment_schedules = payment_schedules
        if success is not None:
            self.success = success

    @property
    def payment_schedules(self):
        """Gets the payment_schedules of this CreatePaymentSchedulesResponse.  # noqa: E501

        Container for payment parts.   # noqa: E501

        :return: The payment_schedules of this CreatePaymentSchedulesResponse.  # noqa: E501
        :rtype: list[CreatePaymentSchedulesResponseItems]
        """
        return self._payment_schedules

    @payment_schedules.setter
    def payment_schedules(self, payment_schedules):
        """Sets the payment_schedules of this CreatePaymentSchedulesResponse.

        Container for payment parts.   # noqa: E501

        :param payment_schedules: The payment_schedules of this CreatePaymentSchedulesResponse.  # noqa: E501
        :type: list[CreatePaymentSchedulesResponseItems]
        """

        self._payment_schedules = payment_schedules

    @property
    def success(self):
        """Gets the success of this CreatePaymentSchedulesResponse.  # noqa: E501

        Returns `true` if the request was processed successfully.  # noqa: E501

        :return: The success of this CreatePaymentSchedulesResponse.  # noqa: E501
        :rtype: bool
        """
        return self._success

    @success.setter
    def success(self, success):
        """Sets the success of this CreatePaymentSchedulesResponse.

        Returns `true` if the request was processed successfully.  # noqa: E501

        :param success: The success of this CreatePaymentSchedulesResponse.  # noqa: E501
        :type: bool
        """

        self._success = success

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(CreatePaymentSchedulesResponse, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, CreatePaymentSchedulesResponse):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
