# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).  # noqa: E501

    OpenAPI spec version: 2024-05-20
    Contact: docs@zuora.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class CreateUpdateOpenPaymentMethodTypeResponse(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'payment_method_type': 'str',
        'publish_date': 'str',
        'revision': 'int',
        'status': 'str'
    }

    attribute_map = {
        'payment_method_type': 'paymentMethodType',
        'publish_date': 'publishDate',
        'revision': 'revision',
        'status': 'status'
    }

    def __init__(self, payment_method_type=None, publish_date=None, revision=None, status=None):  # noqa: E501
        """CreateUpdateOpenPaymentMethodTypeResponse - a model defined in Swagger"""  # noqa: E501
        self._payment_method_type = None
        self._publish_date = None
        self._revision = None
        self._status = None
        self.discriminator = None
        if payment_method_type is not None:
            self.payment_method_type = payment_method_type
        if publish_date is not None:
            self.publish_date = publish_date
        if revision is not None:
            self.revision = revision
        if status is not None:
            self.status = status

    @property
    def payment_method_type(self):
        """Gets the payment_method_type of this CreateUpdateOpenPaymentMethodTypeResponse.  # noqa: E501

        The API name of the custom payment method type.   # noqa: E501

        :return: The payment_method_type of this CreateUpdateOpenPaymentMethodTypeResponse.  # noqa: E501
        :rtype: str
        """
        return self._payment_method_type

    @payment_method_type.setter
    def payment_method_type(self, payment_method_type):
        """Sets the payment_method_type of this CreateUpdateOpenPaymentMethodTypeResponse.

        The API name of the custom payment method type.   # noqa: E501

        :param payment_method_type: The payment_method_type of this CreateUpdateOpenPaymentMethodTypeResponse.  # noqa: E501
        :type: str
        """

        self._payment_method_type = payment_method_type

    @property
    def publish_date(self):
        """Gets the publish_date of this CreateUpdateOpenPaymentMethodTypeResponse.  # noqa: E501

        The date when the custom payment method type was published. It is empty if the custom payment method type has not been published yet.   # noqa: E501

        :return: The publish_date of this CreateUpdateOpenPaymentMethodTypeResponse.  # noqa: E501
        :rtype: str
        """
        return self._publish_date

    @publish_date.setter
    def publish_date(self, publish_date):
        """Sets the publish_date of this CreateUpdateOpenPaymentMethodTypeResponse.

        The date when the custom payment method type was published. It is empty if the custom payment method type has not been published yet.   # noqa: E501

        :param publish_date: The publish_date of this CreateUpdateOpenPaymentMethodTypeResponse.  # noqa: E501
        :type: str
        """

        self._publish_date = publish_date

    @property
    def revision(self):
        """Gets the revision of this CreateUpdateOpenPaymentMethodTypeResponse.  # noqa: E501

        The revision number of the custom payment method type, which starts from 1 and increases by 1 when you update a published revision for the first time.   # noqa: E501

        :return: The revision of this CreateUpdateOpenPaymentMethodTypeResponse.  # noqa: E501
        :rtype: int
        """
        return self._revision

    @revision.setter
    def revision(self, revision):
        """Sets the revision of this CreateUpdateOpenPaymentMethodTypeResponse.

        The revision number of the custom payment method type, which starts from 1 and increases by 1 when you update a published revision for the first time.   # noqa: E501

        :param revision: The revision of this CreateUpdateOpenPaymentMethodTypeResponse.  # noqa: E501
        :type: int
        """

        self._revision = revision

    @property
    def status(self):
        """Gets the status of this CreateUpdateOpenPaymentMethodTypeResponse.  # noqa: E501

        The status of the custom payment method type.   # noqa: E501

        :return: The status of this CreateUpdateOpenPaymentMethodTypeResponse.  # noqa: E501
        :rtype: str
        """
        return self._status

    @status.setter
    def status(self, status):
        """Sets the status of this CreateUpdateOpenPaymentMethodTypeResponse.

        The status of the custom payment method type.   # noqa: E501

        :param status: The status of this CreateUpdateOpenPaymentMethodTypeResponse.  # noqa: E501
        :type: str
        """

        self._status = status

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(CreateUpdateOpenPaymentMethodTypeResponse, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, CreateUpdateOpenPaymentMethodTypeResponse):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
