# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).  # noqa: E501

    OpenAPI spec version: 2024-05-20
    Contact: docs@zuora.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class CreateUpdateStoredCredentialProfileResponse(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'number': 'int',
        'payment_method_id': 'str',
        'success': 'bool'
    }

    attribute_map = {
        'number': 'number',
        'payment_method_id': 'paymentMethodId',
        'success': 'success'
    }

    def __init__(self, number=None, payment_method_id=None, success=None):  # noqa: E501
        """CreateUpdateStoredCredentialProfileResponse - a model defined in Swagger"""  # noqa: E501
        self._number = None
        self._payment_method_id = None
        self._success = None
        self.discriminator = None
        if number is not None:
            self.number = number
        if payment_method_id is not None:
            self.payment_method_id = payment_method_id
        if success is not None:
            self.success = success

    @property
    def number(self):
        """Gets the number of this CreateUpdateStoredCredentialProfileResponse.  # noqa: E501

        The number that identifies the stored credential profile within the payment method.   # noqa: E501

        :return: The number of this CreateUpdateStoredCredentialProfileResponse.  # noqa: E501
        :rtype: int
        """
        return self._number

    @number.setter
    def number(self, number):
        """Sets the number of this CreateUpdateStoredCredentialProfileResponse.

        The number that identifies the stored credential profile within the payment method.   # noqa: E501

        :param number: The number of this CreateUpdateStoredCredentialProfileResponse.  # noqa: E501
        :type: int
        """

        self._number = number

    @property
    def payment_method_id(self):
        """Gets the payment_method_id of this CreateUpdateStoredCredentialProfileResponse.  # noqa: E501

        ID of the payment method.   # noqa: E501

        :return: The payment_method_id of this CreateUpdateStoredCredentialProfileResponse.  # noqa: E501
        :rtype: str
        """
        return self._payment_method_id

    @payment_method_id.setter
    def payment_method_id(self, payment_method_id):
        """Sets the payment_method_id of this CreateUpdateStoredCredentialProfileResponse.

        ID of the payment method.   # noqa: E501

        :param payment_method_id: The payment_method_id of this CreateUpdateStoredCredentialProfileResponse.  # noqa: E501
        :type: str
        """

        self._payment_method_id = payment_method_id

    @property
    def success(self):
        """Gets the success of this CreateUpdateStoredCredentialProfileResponse.  # noqa: E501


        :return: The success of this CreateUpdateStoredCredentialProfileResponse.  # noqa: E501
        :rtype: bool
        """
        return self._success

    @success.setter
    def success(self, success):
        """Sets the success of this CreateUpdateStoredCredentialProfileResponse.


        :param success: The success of this CreateUpdateStoredCredentialProfileResponse.  # noqa: E501
        :type: bool
        """

        self._success = success

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(CreateUpdateStoredCredentialProfileResponse, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, CreateUpdateStoredCredentialProfileResponse):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
