# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).  # noqa: E501

    OpenAPI spec version: 2024-05-20
    Contact: docs@zuora.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class CustomObjectBulkDeleteFilterCondition(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'field': 'str',
        'operator': 'CustomObjectBulkDeleteFilterConditionOperator',
        'value': 'object'
    }

    attribute_map = {
        'field': 'field',
        'operator': 'operator',
        'value': 'value'
    }

    def __init__(self, field=None, operator=None, value=None):  # noqa: E501
        """CustomObjectBulkDeleteFilterCondition - a model defined in Swagger"""  # noqa: E501
        self._field = None
        self._operator = None
        self._value = None
        self.discriminator = None
        self.field = field
        self.operator = operator
        self.value = value

    @property
    def field(self):
        """Gets the field of this CustomObjectBulkDeleteFilterCondition.  # noqa: E501

        The object field that is evaluated. Only filterable fields can be evaluated in the filter.  # noqa: E501

        :return: The field of this CustomObjectBulkDeleteFilterCondition.  # noqa: E501
        :rtype: str
        """
        return self._field

    @field.setter
    def field(self, field):
        """Sets the field of this CustomObjectBulkDeleteFilterCondition.

        The object field that is evaluated. Only filterable fields can be evaluated in the filter.  # noqa: E501

        :param field: The field of this CustomObjectBulkDeleteFilterCondition.  # noqa: E501
        :type: str
        """
        if field is None:
            raise ValueError("Invalid value for `field`, must not be `None`")  # noqa: E501

        self._field = field

    @property
    def operator(self):
        """Gets the operator of this CustomObjectBulkDeleteFilterCondition.  # noqa: E501


        :return: The operator of this CustomObjectBulkDeleteFilterCondition.  # noqa: E501
        :rtype: CustomObjectBulkDeleteFilterConditionOperator
        """
        return self._operator

    @operator.setter
    def operator(self, operator):
        """Sets the operator of this CustomObjectBulkDeleteFilterCondition.


        :param operator: The operator of this CustomObjectBulkDeleteFilterCondition.  # noqa: E501
        :type: CustomObjectBulkDeleteFilterConditionOperator
        """
        if operator is None:
            raise ValueError("Invalid value for `operator`, must not be `None`")  # noqa: E501

        self._operator = operator

    @property
    def value(self):
        """Gets the value of this CustomObjectBulkDeleteFilterCondition.  # noqa: E501

        The value that the filterable `field` is evaluated against in the filter. The data type of `value` is consistent with that of the `field`.  # noqa: E501

        :return: The value of this CustomObjectBulkDeleteFilterCondition.  # noqa: E501
        :rtype: object
        """
        return self._value

    @value.setter
    def value(self, value):
        """Sets the value of this CustomObjectBulkDeleteFilterCondition.

        The value that the filterable `field` is evaluated against in the filter. The data type of `value` is consistent with that of the `field`.  # noqa: E501

        :param value: The value of this CustomObjectBulkDeleteFilterCondition.  # noqa: E501
        :type: object
        """
        if value is None:
            raise ValueError("Invalid value for `value`, must not be `None`")  # noqa: E501

        self._value = value

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(CustomObjectBulkDeleteFilterCondition, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, CustomObjectBulkDeleteFilterCondition):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
