# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).  # noqa: E501

    OpenAPI spec version: 2024-05-20
    Contact: docs@zuora.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class CustomObjectBulkJobResponseCollection(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'count': 'int',
        'cursor': 'str',
        'jobs': 'list[CustomObjectBulkJobResponse]'
    }

    attribute_map = {
        'count': 'count',
        'cursor': 'cursor',
        'jobs': 'jobs'
    }

    def __init__(self, count=None, cursor=None, jobs=None):  # noqa: E501
        """CustomObjectBulkJobResponseCollection - a model defined in Swagger"""  # noqa: E501
        self._count = None
        self._cursor = None
        self._jobs = None
        self.discriminator = None
        if count is not None:
            self.count = count
        if cursor is not None:
            self.cursor = cursor
        self.jobs = jobs

    @property
    def count(self):
        """Gets the count of this CustomObjectBulkJobResponseCollection.  # noqa: E501

        The number of custom object bulk jobs returned in the result page set.  # noqa: E501

        :return: The count of this CustomObjectBulkJobResponseCollection.  # noqa: E501
        :rtype: int
        """
        return self._count

    @count.setter
    def count(self, count):
        """Sets the count of this CustomObjectBulkJobResponseCollection.

        The number of custom object bulk jobs returned in the result page set.  # noqa: E501

        :param count: The count of this CustomObjectBulkJobResponseCollection.  # noqa: E501
        :type: int
        """

        self._count = count

    @property
    def cursor(self):
        """Gets the cursor of this CustomObjectBulkJobResponseCollection.  # noqa: E501

        The `cursor` points to the last job record of the current page.  # noqa: E501

        :return: The cursor of this CustomObjectBulkJobResponseCollection.  # noqa: E501
        :rtype: str
        """
        return self._cursor

    @cursor.setter
    def cursor(self, cursor):
        """Sets the cursor of this CustomObjectBulkJobResponseCollection.

        The `cursor` points to the last job record of the current page.  # noqa: E501

        :param cursor: The cursor of this CustomObjectBulkJobResponseCollection.  # noqa: E501
        :type: str
        """

        self._cursor = cursor

    @property
    def jobs(self):
        """Gets the jobs of this CustomObjectBulkJobResponseCollection.  # noqa: E501

        All custom object bulk jobs returned in the result page set.  # noqa: E501

        :return: The jobs of this CustomObjectBulkJobResponseCollection.  # noqa: E501
        :rtype: list[CustomObjectBulkJobResponse]
        """
        return self._jobs

    @jobs.setter
    def jobs(self, jobs):
        """Sets the jobs of this CustomObjectBulkJobResponseCollection.

        All custom object bulk jobs returned in the result page set.  # noqa: E501

        :param jobs: The jobs of this CustomObjectBulkJobResponseCollection.  # noqa: E501
        :type: list[CustomObjectBulkJobResponse]
        """
        if jobs is None:
            raise ValueError("Invalid value for `jobs`, must not be `None`")  # noqa: E501

        self._jobs = jobs

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(CustomObjectBulkJobResponseCollection, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, CustomObjectBulkJobResponseCollection):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
