# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).  # noqa: E501

    OpenAPI spec version: 2024-05-20
    Contact: docs@zuora.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class CustomObjectCustomFieldDefinitionUpdate(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'default': 'str',
        'description': 'str',
        'display_name': 'bool',
        'format': 'str',
        'label': 'str',
        'max_length': 'int',
        'multiselect': 'bool',
        'origin': 'CustomObjectCustomFieldDefinitionUpdateOrigin',
        'type': 'str'
    }

    attribute_map = {
        'default': 'default',
        'description': 'description',
        'display_name': 'displayName',
        'format': 'format',
        'label': 'label',
        'max_length': 'maxLength',
        'multiselect': 'multiselect',
        'origin': 'origin',
        'type': 'type'
    }

    def __init__(self, default=None, description=None, display_name=None, format=None, label=None, max_length=None, multiselect=None, origin=None, type=None):  # noqa: E501
        """CustomObjectCustomFieldDefinitionUpdate - a model defined in Swagger"""  # noqa: E501
        self._default = None
        self._description = None
        self._display_name = None
        self._format = None
        self._label = None
        self._max_length = None
        self._multiselect = None
        self._origin = None
        self._type = None
        self.discriminator = None
        if default is not None:
            self.default = default
        if description is not None:
            self.description = description
        if display_name is not None:
            self.display_name = display_name
        if format is not None:
            self.format = format
        if label is not None:
            self.label = label
        if max_length is not None:
            self.max_length = max_length
        if multiselect is not None:
            self.multiselect = multiselect
        if origin is not None:
            self.origin = origin
        if type is not None:
            self.type = type

    @property
    def default(self):
        """Gets the default of this CustomObjectCustomFieldDefinitionUpdate.  # noqa: E501

        Applicable if the `type` of the action is  `updateField`  # noqa: E501

        :return: The default of this CustomObjectCustomFieldDefinitionUpdate.  # noqa: E501
        :rtype: str
        """
        return self._default

    @default.setter
    def default(self, default):
        """Sets the default of this CustomObjectCustomFieldDefinitionUpdate.

        Applicable if the `type` of the action is  `updateField`  # noqa: E501

        :param default: The default of this CustomObjectCustomFieldDefinitionUpdate.  # noqa: E501
        :type: str
        """

        self._default = default

    @property
    def description(self):
        """Gets the description of this CustomObjectCustomFieldDefinitionUpdate.  # noqa: E501

        Applicable if the `type` of the action is  `updateField`  # noqa: E501

        :return: The description of this CustomObjectCustomFieldDefinitionUpdate.  # noqa: E501
        :rtype: str
        """
        return self._description

    @description.setter
    def description(self, description):
        """Sets the description of this CustomObjectCustomFieldDefinitionUpdate.

        Applicable if the `type` of the action is  `updateField`  # noqa: E501

        :param description: The description of this CustomObjectCustomFieldDefinitionUpdate.  # noqa: E501
        :type: str
        """

        self._description = description

    @property
    def display_name(self):
        """Gets the display_name of this CustomObjectCustomFieldDefinitionUpdate.  # noqa: E501

        Indicates whether to use this field as the display name of the custom object when being linked to another custom object.  This field applies only to the Text custom field type:  - The `type` field is `string`. - The `enum` field is not specified.   # noqa: E501

        :return: The display_name of this CustomObjectCustomFieldDefinitionUpdate.  # noqa: E501
        :rtype: bool
        """
        return self._display_name

    @display_name.setter
    def display_name(self, display_name):
        """Sets the display_name of this CustomObjectCustomFieldDefinitionUpdate.

        Indicates whether to use this field as the display name of the custom object when being linked to another custom object.  This field applies only to the Text custom field type:  - The `type` field is `string`. - The `enum` field is not specified.   # noqa: E501

        :param display_name: The display_name of this CustomObjectCustomFieldDefinitionUpdate.  # noqa: E501
        :type: bool
        """

        self._display_name = display_name

    @property
    def format(self):
        """Gets the format of this CustomObjectCustomFieldDefinitionUpdate.  # noqa: E501

        The data format of the custom field  # noqa: E501

        :return: The format of this CustomObjectCustomFieldDefinitionUpdate.  # noqa: E501
        :rtype: str
        """
        return self._format

    @format.setter
    def format(self, format):
        """Sets the format of this CustomObjectCustomFieldDefinitionUpdate.

        The data format of the custom field  # noqa: E501

        :param format: The format of this CustomObjectCustomFieldDefinitionUpdate.  # noqa: E501
        :type: str
        """

        self._format = format

    @property
    def label(self):
        """Gets the label of this CustomObjectCustomFieldDefinitionUpdate.  # noqa: E501

        The UI label of the custom field  # noqa: E501

        :return: The label of this CustomObjectCustomFieldDefinitionUpdate.  # noqa: E501
        :rtype: str
        """
        return self._label

    @label.setter
    def label(self, label):
        """Sets the label of this CustomObjectCustomFieldDefinitionUpdate.

        The UI label of the custom field  # noqa: E501

        :param label: The label of this CustomObjectCustomFieldDefinitionUpdate.  # noqa: E501
        :type: str
        """

        self._label = label

    @property
    def max_length(self):
        """Gets the max_length of this CustomObjectCustomFieldDefinitionUpdate.  # noqa: E501

        The maximum length of string that can be stored in the custom field.  This field applies only to the following custom field types:  - Text:   - The `type` field is `string`.   - The `format` field is not specified or is `url`.   - The `enum` field is not specified. - Picklist:   - The `type` field is `string`.   - The `enum` field is specified.   - The `multiselect` field is not specified or is `false`. - Multiselect:   - The `type` field is `string`.   - The `enum` field is specified.   - The `multiselect` field is `true`.  If the custom field is filterable, the value of `maxLength` must be 512 or less.   # noqa: E501

        :return: The max_length of this CustomObjectCustomFieldDefinitionUpdate.  # noqa: E501
        :rtype: int
        """
        return self._max_length

    @max_length.setter
    def max_length(self, max_length):
        """Sets the max_length of this CustomObjectCustomFieldDefinitionUpdate.

        The maximum length of string that can be stored in the custom field.  This field applies only to the following custom field types:  - Text:   - The `type` field is `string`.   - The `format` field is not specified or is `url`.   - The `enum` field is not specified. - Picklist:   - The `type` field is `string`.   - The `enum` field is specified.   - The `multiselect` field is not specified or is `false`. - Multiselect:   - The `type` field is `string`.   - The `enum` field is specified.   - The `multiselect` field is `true`.  If the custom field is filterable, the value of `maxLength` must be 512 or less.   # noqa: E501

        :param max_length: The max_length of this CustomObjectCustomFieldDefinitionUpdate.  # noqa: E501
        :type: int
        """

        self._max_length = max_length

    @property
    def multiselect(self):
        """Gets the multiselect of this CustomObjectCustomFieldDefinitionUpdate.  # noqa: E501

        Indicates whether this is a multiselect custom field.  This field applies only to the creation of Picklist or Multiselect custom fields:  - The action `type` field is `addField`. - The definition `type` field is `string`. - The `maxLength` field is specified. - The `enum` field is specified.   # noqa: E501

        :return: The multiselect of this CustomObjectCustomFieldDefinitionUpdate.  # noqa: E501
        :rtype: bool
        """
        return self._multiselect

    @multiselect.setter
    def multiselect(self, multiselect):
        """Sets the multiselect of this CustomObjectCustomFieldDefinitionUpdate.

        Indicates whether this is a multiselect custom field.  This field applies only to the creation of Picklist or Multiselect custom fields:  - The action `type` field is `addField`. - The definition `type` field is `string`. - The `maxLength` field is specified. - The `enum` field is specified.   # noqa: E501

        :param multiselect: The multiselect of this CustomObjectCustomFieldDefinitionUpdate.  # noqa: E501
        :type: bool
        """

        self._multiselect = multiselect

    @property
    def origin(self):
        """Gets the origin of this CustomObjectCustomFieldDefinitionUpdate.  # noqa: E501


        :return: The origin of this CustomObjectCustomFieldDefinitionUpdate.  # noqa: E501
        :rtype: CustomObjectCustomFieldDefinitionUpdateOrigin
        """
        return self._origin

    @origin.setter
    def origin(self, origin):
        """Sets the origin of this CustomObjectCustomFieldDefinitionUpdate.


        :param origin: The origin of this CustomObjectCustomFieldDefinitionUpdate.  # noqa: E501
        :type: CustomObjectCustomFieldDefinitionUpdateOrigin
        """

        self._origin = origin

    @property
    def type(self):
        """Gets the type of this CustomObjectCustomFieldDefinitionUpdate.  # noqa: E501

        The data type of the custom field  # noqa: E501

        :return: The type of this CustomObjectCustomFieldDefinitionUpdate.  # noqa: E501
        :rtype: str
        """
        return self._type

    @type.setter
    def type(self, type):
        """Sets the type of this CustomObjectCustomFieldDefinitionUpdate.

        The data type of the custom field  # noqa: E501

        :param type: The type of this CustomObjectCustomFieldDefinitionUpdate.  # noqa: E501
        :type: str
        """

        self._type = type

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(CustomObjectCustomFieldDefinitionUpdate, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, CustomObjectCustomFieldDefinitionUpdate):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
