# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).  # noqa: E501

    OpenAPI spec version: 2024-05-20
    Contact: docs@zuora.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class DailyConsumptionRevRecRequest(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'original_charge_id': 'str',
        'charge_segment_number': 'str',
        'fund_id': 'str'
    }

    attribute_map = {
        'original_charge_id': 'originalChargeId',
        'charge_segment_number': 'chargeSegmentNumber',
        'fund_id': 'fundId'
    }

    def __init__(self, original_charge_id=None, charge_segment_number=None, fund_id=None):  # noqa: E501
        """DailyConsumptionRevRecRequest - a model defined in Swagger"""  # noqa: E501
        self._original_charge_id = None
        self._charge_segment_number = None
        self._fund_id = None
        self.discriminator = None
        self.original_charge_id = original_charge_id
        if charge_segment_number is not None:
            self.charge_segment_number = charge_segment_number
        if fund_id is not None:
            self.fund_id = fund_id

    @property
    def original_charge_id(self):
        """Gets the original_charge_id of this DailyConsumptionRevRecRequest.  # noqa: E501

        Original RPC ID   # noqa: E501

        :return: The original_charge_id of this DailyConsumptionRevRecRequest.  # noqa: E501
        :rtype: str
        """
        return self._original_charge_id

    @original_charge_id.setter
    def original_charge_id(self, original_charge_id):
        """Sets the original_charge_id of this DailyConsumptionRevRecRequest.

        Original RPC ID   # noqa: E501

        :param original_charge_id: The original_charge_id of this DailyConsumptionRevRecRequest.  # noqa: E501
        :type: str
        """
        if original_charge_id is None:
            raise ValueError("Invalid value for `original_charge_id`, must not be `None`")  # noqa: E501

        self._original_charge_id = original_charge_id

    @property
    def charge_segment_number(self):
        """Gets the charge_segment_number of this DailyConsumptionRevRecRequest.  # noqa: E501

        RPC number   # noqa: E501

        :return: The charge_segment_number of this DailyConsumptionRevRecRequest.  # noqa: E501
        :rtype: str
        """
        return self._charge_segment_number

    @charge_segment_number.setter
    def charge_segment_number(self, charge_segment_number):
        """Sets the charge_segment_number of this DailyConsumptionRevRecRequest.

        RPC number   # noqa: E501

        :param charge_segment_number: The charge_segment_number of this DailyConsumptionRevRecRequest.  # noqa: E501
        :type: str
        """

        self._charge_segment_number = charge_segment_number

    @property
    def fund_id(self):
        """Gets the fund_id of this DailyConsumptionRevRecRequest.  # noqa: E501


        :return: The fund_id of this DailyConsumptionRevRecRequest.  # noqa: E501
        :rtype: str
        """
        return self._fund_id

    @fund_id.setter
    def fund_id(self, fund_id):
        """Sets the fund_id of this DailyConsumptionRevRecRequest.


        :param fund_id: The fund_id of this DailyConsumptionRevRecRequest.  # noqa: E501
        :type: str
        """

        self._fund_id = fund_id

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(DailyConsumptionRevRecRequest, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, DailyConsumptionRevRecRequest):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
