# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).  # noqa: E501

    OpenAPI spec version: 2024-05-20
    Contact: docs@zuora.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six
from zuora_sdk.models.data_query_job_common import DataQueryJobCommon  # noqa: F401,E501

class DataQueryJobCancelled(DataQueryJobCommon):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'query_status': 'str'
    }
    if hasattr(DataQueryJobCommon, "swagger_types"):
        swagger_types.update(DataQueryJobCommon.swagger_types)

    attribute_map = {
        'query_status': 'queryStatus'
    }
    if hasattr(DataQueryJobCommon, "attribute_map"):
        attribute_map.update(DataQueryJobCommon.attribute_map)

    def __init__(self, query_status=None, *args, **kwargs):  # noqa: E501
        """DataQueryJobCancelled - a model defined in Swagger"""  # noqa: E501
        self._query_status = None
        self.discriminator = None
        if query_status is not None:
            self.query_status = query_status
        DataQueryJobCommon.__init__(self, *args, **kwargs)

    @property
    def query_status(self):
        """Gets the query_status of this DataQueryJobCancelled.  # noqa: E501

        Status of the query job.   # noqa: E501

        :return: The query_status of this DataQueryJobCancelled.  # noqa: E501
        :rtype: str
        """
        return self._query_status

    @query_status.setter
    def query_status(self, query_status):
        """Sets the query_status of this DataQueryJobCancelled.

        Status of the query job.   # noqa: E501

        :param query_status: The query_status of this DataQueryJobCancelled.  # noqa: E501
        :type: str
        """
        allowed_values = ["cancelled"]  # noqa: E501
        if query_status not in allowed_values:
            raise ValueError(
                "Invalid value for `query_status` ({0}), must be one of {1}"  # noqa: E501
                .format(query_status, allowed_values)
            )

        self._query_status = query_status

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(DataQueryJobCancelled, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, DataQueryJobCancelled):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
