# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).  # noqa: E501

    OpenAPI spec version: 2024-05-20
    Contact: docs@zuora.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class DebitMemoDueDate(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'due_date': 'date',
        'id': 'str',
        'memo_key': 'str'
    }

    attribute_map = {
        'due_date': 'dueDate',
        'id': 'id',
        'memo_key': 'memoKey'
    }

    def __init__(self, due_date=None, id=None, memo_key=None):  # noqa: E501
        """DebitMemoDueDate - a model defined in Swagger"""  # noqa: E501
        self._due_date = None
        self._id = None
        self._memo_key = None
        self.discriminator = None
        if due_date is not None:
            self.due_date = due_date
        if id is not None:
            self.id = id
        if memo_key is not None:
            self.memo_key = memo_key

    @property
    def due_date(self):
        """Gets the due_date of this DebitMemoDueDate.  # noqa: E501

        The date by which the payment for the debit memo is due, in `yyyy-mm-dd` format.   # noqa: E501

        :return: The due_date of this DebitMemoDueDate.  # noqa: E501
        :rtype: date
        """
        return self._due_date

    @due_date.setter
    def due_date(self, due_date):
        """Sets the due_date of this DebitMemoDueDate.

        The date by which the payment for the debit memo is due, in `yyyy-mm-dd` format.   # noqa: E501

        :param due_date: The due_date of this DebitMemoDueDate.  # noqa: E501
        :type: date
        """

        self._due_date = due_date

    @property
    def id(self):
        """Gets the id of this DebitMemoDueDate.  # noqa: E501

        The unique ID or number of the debit memo to be updated. For example, 402890555a87d7f5015a892f2ba10057 or or DM00000001.   # noqa: E501

        :return: The id of this DebitMemoDueDate.  # noqa: E501
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this DebitMemoDueDate.

        The unique ID or number of the debit memo to be updated. For example, 402890555a87d7f5015a892f2ba10057 or or DM00000001.   # noqa: E501

        :param id: The id of this DebitMemoDueDate.  # noqa: E501
        :type: str
        """

        self._id = id

    @property
    def memo_key(self):
        """Gets the memo_key of this DebitMemoDueDate.  # noqa: E501

        The unique ID or number of the debit memo to be updated. For example, 402890555a87d7f5015a892f2ba10057 or or DM00000001. If `memoKey` is set, `id` will be ignored.   # noqa: E501

        :return: The memo_key of this DebitMemoDueDate.  # noqa: E501
        :rtype: str
        """
        return self._memo_key

    @memo_key.setter
    def memo_key(self, memo_key):
        """Sets the memo_key of this DebitMemoDueDate.

        The unique ID or number of the debit memo to be updated. For example, 402890555a87d7f5015a892f2ba10057 or or DM00000001. If `memoKey` is set, `id` will be ignored.   # noqa: E501

        :param memo_key: The memo_key of this DebitMemoDueDate.  # noqa: E501
        :type: str
        """

        self._memo_key = memo_key

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(DebitMemoDueDate, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, DebitMemoDueDate):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
