# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).  # noqa: E501

    OpenAPI spec version: 2024-05-20
    Contact: docs@zuora.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class DebitMemoItemFromInvoiceItemRequest(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'amount': 'float',
        'comment': 'str',
        'description': 'str',
        'finance_information': 'DebitMemoItemFromInvoiceItemFinanceInformation',
        'invoice_item_id': 'str',
        'quantity': 'float',
        'service_end_date': 'date',
        'service_start_date': 'date',
        'sku_name': 'str',
        'tax_items': 'list[DebitMemoTaxItemFromInvoiceTaxItemRequest]',
        'tax_mode': 'TaxMode',
        'unit_of_measure': 'str',
        'exclude_item_billing_from_revenue_accounting': 'bool'
    }

    attribute_map = {
        'amount': 'amount',
        'comment': 'comment',
        'description': 'description',
        'finance_information': 'financeInformation',
        'invoice_item_id': 'invoiceItemId',
        'quantity': 'quantity',
        'service_end_date': 'serviceEndDate',
        'service_start_date': 'serviceStartDate',
        'sku_name': 'skuName',
        'tax_items': 'taxItems',
        'tax_mode': 'taxMode',
        'unit_of_measure': 'unitOfMeasure',
        'exclude_item_billing_from_revenue_accounting': 'excludeItemBillingFromRevenueAccounting'
    }

    def __init__(self, amount=None, comment=None, description=None, finance_information=None, invoice_item_id=None, quantity=None, service_end_date=None, service_start_date=None, sku_name=None, tax_items=None, tax_mode=None, unit_of_measure=None, exclude_item_billing_from_revenue_accounting=None):  # noqa: E501
        """DebitMemoItemFromInvoiceItemRequest - a model defined in Swagger"""  # noqa: E501
        self._amount = None
        self._comment = None
        self._description = None
        self._finance_information = None
        self._invoice_item_id = None
        self._quantity = None
        self._service_end_date = None
        self._service_start_date = None
        self._sku_name = None
        self._tax_items = None
        self._tax_mode = None
        self._unit_of_measure = None
        self._exclude_item_billing_from_revenue_accounting = None
        self.discriminator = None
        self.amount = amount
        if comment is not None:
            self.comment = comment
        if description is not None:
            self.description = description
        if finance_information is not None:
            self.finance_information = finance_information
        if invoice_item_id is not None:
            self.invoice_item_id = invoice_item_id
        if quantity is not None:
            self.quantity = quantity
        if service_end_date is not None:
            self.service_end_date = service_end_date
        if service_start_date is not None:
            self.service_start_date = service_start_date
        self.sku_name = sku_name
        if tax_items is not None:
            self.tax_items = tax_items
        if tax_mode is not None:
            self.tax_mode = tax_mode
        if unit_of_measure is not None:
            self.unit_of_measure = unit_of_measure
        if exclude_item_billing_from_revenue_accounting is not None:
            self.exclude_item_billing_from_revenue_accounting = exclude_item_billing_from_revenue_accounting

    @property
    def amount(self):
        """Gets the amount of this DebitMemoItemFromInvoiceItemRequest.  # noqa: E501

        The amount of the debit memo item.  # noqa: E501

        :return: The amount of this DebitMemoItemFromInvoiceItemRequest.  # noqa: E501
        :rtype: float
        """
        return self._amount

    @amount.setter
    def amount(self, amount):
        """Sets the amount of this DebitMemoItemFromInvoiceItemRequest.

        The amount of the debit memo item.  # noqa: E501

        :param amount: The amount of this DebitMemoItemFromInvoiceItemRequest.  # noqa: E501
        :type: float
        """
        if amount is None:
            raise ValueError("Invalid value for `amount`, must not be `None`")  # noqa: E501

        self._amount = amount

    @property
    def comment(self):
        """Gets the comment of this DebitMemoItemFromInvoiceItemRequest.  # noqa: E501

        Comments about the debit memo item. **Note**: This field is not available if you set the `zuora-version` request header to `257.0` or later.  # noqa: E501

        :return: The comment of this DebitMemoItemFromInvoiceItemRequest.  # noqa: E501
        :rtype: str
        """
        return self._comment

    @comment.setter
    def comment(self, comment):
        """Sets the comment of this DebitMemoItemFromInvoiceItemRequest.

        Comments about the debit memo item. **Note**: This field is not available if you set the `zuora-version` request header to `257.0` or later.  # noqa: E501

        :param comment: The comment of this DebitMemoItemFromInvoiceItemRequest.  # noqa: E501
        :type: str
        """

        self._comment = comment

    @property
    def description(self):
        """Gets the description of this DebitMemoItemFromInvoiceItemRequest.  # noqa: E501

        The description of the debit memo item. **Note**: This field is only available if you set the `zuora-version` request header to `257.0` or later.  # noqa: E501

        :return: The description of this DebitMemoItemFromInvoiceItemRequest.  # noqa: E501
        :rtype: str
        """
        return self._description

    @description.setter
    def description(self, description):
        """Sets the description of this DebitMemoItemFromInvoiceItemRequest.

        The description of the debit memo item. **Note**: This field is only available if you set the `zuora-version` request header to `257.0` or later.  # noqa: E501

        :param description: The description of this DebitMemoItemFromInvoiceItemRequest.  # noqa: E501
        :type: str
        """

        self._description = description

    @property
    def finance_information(self):
        """Gets the finance_information of this DebitMemoItemFromInvoiceItemRequest.  # noqa: E501


        :return: The finance_information of this DebitMemoItemFromInvoiceItemRequest.  # noqa: E501
        :rtype: DebitMemoItemFromInvoiceItemFinanceInformation
        """
        return self._finance_information

    @finance_information.setter
    def finance_information(self, finance_information):
        """Sets the finance_information of this DebitMemoItemFromInvoiceItemRequest.


        :param finance_information: The finance_information of this DebitMemoItemFromInvoiceItemRequest.  # noqa: E501
        :type: DebitMemoItemFromInvoiceItemFinanceInformation
        """

        self._finance_information = finance_information

    @property
    def invoice_item_id(self):
        """Gets the invoice_item_id of this DebitMemoItemFromInvoiceItemRequest.  # noqa: E501

        The ID of the invoice item.  # noqa: E501

        :return: The invoice_item_id of this DebitMemoItemFromInvoiceItemRequest.  # noqa: E501
        :rtype: str
        """
        return self._invoice_item_id

    @invoice_item_id.setter
    def invoice_item_id(self, invoice_item_id):
        """Sets the invoice_item_id of this DebitMemoItemFromInvoiceItemRequest.

        The ID of the invoice item.  # noqa: E501

        :param invoice_item_id: The invoice_item_id of this DebitMemoItemFromInvoiceItemRequest.  # noqa: E501
        :type: str
        """

        self._invoice_item_id = invoice_item_id

    @property
    def quantity(self):
        """Gets the quantity of this DebitMemoItemFromInvoiceItemRequest.  # noqa: E501

        The number of units for the debit memo item.  # noqa: E501

        :return: The quantity of this DebitMemoItemFromInvoiceItemRequest.  # noqa: E501
        :rtype: float
        """
        return self._quantity

    @quantity.setter
    def quantity(self, quantity):
        """Sets the quantity of this DebitMemoItemFromInvoiceItemRequest.

        The number of units for the debit memo item.  # noqa: E501

        :param quantity: The quantity of this DebitMemoItemFromInvoiceItemRequest.  # noqa: E501
        :type: float
        """

        self._quantity = quantity

    @property
    def service_end_date(self):
        """Gets the service_end_date of this DebitMemoItemFromInvoiceItemRequest.  # noqa: E501

        The service end date of the debit memo item.  # noqa: E501

        :return: The service_end_date of this DebitMemoItemFromInvoiceItemRequest.  # noqa: E501
        :rtype: date
        """
        return self._service_end_date

    @service_end_date.setter
    def service_end_date(self, service_end_date):
        """Sets the service_end_date of this DebitMemoItemFromInvoiceItemRequest.

        The service end date of the debit memo item.  # noqa: E501

        :param service_end_date: The service_end_date of this DebitMemoItemFromInvoiceItemRequest.  # noqa: E501
        :type: date
        """

        self._service_end_date = service_end_date

    @property
    def service_start_date(self):
        """Gets the service_start_date of this DebitMemoItemFromInvoiceItemRequest.  # noqa: E501

        The service start date of the debit memo item.    # noqa: E501

        :return: The service_start_date of this DebitMemoItemFromInvoiceItemRequest.  # noqa: E501
        :rtype: date
        """
        return self._service_start_date

    @service_start_date.setter
    def service_start_date(self, service_start_date):
        """Sets the service_start_date of this DebitMemoItemFromInvoiceItemRequest.

        The service start date of the debit memo item.    # noqa: E501

        :param service_start_date: The service_start_date of this DebitMemoItemFromInvoiceItemRequest.  # noqa: E501
        :type: date
        """

        self._service_start_date = service_start_date

    @property
    def sku_name(self):
        """Gets the sku_name of this DebitMemoItemFromInvoiceItemRequest.  # noqa: E501

        The name of the charge associated with the invoice.  # noqa: E501

        :return: The sku_name of this DebitMemoItemFromInvoiceItemRequest.  # noqa: E501
        :rtype: str
        """
        return self._sku_name

    @sku_name.setter
    def sku_name(self, sku_name):
        """Sets the sku_name of this DebitMemoItemFromInvoiceItemRequest.

        The name of the charge associated with the invoice.  # noqa: E501

        :param sku_name: The sku_name of this DebitMemoItemFromInvoiceItemRequest.  # noqa: E501
        :type: str
        """
        if sku_name is None:
            raise ValueError("Invalid value for `sku_name`, must not be `None`")  # noqa: E501

        self._sku_name = sku_name

    @property
    def tax_items(self):
        """Gets the tax_items of this DebitMemoItemFromInvoiceItemRequest.  # noqa: E501

        Container for taxation items.  # noqa: E501

        :return: The tax_items of this DebitMemoItemFromInvoiceItemRequest.  # noqa: E501
        :rtype: list[DebitMemoTaxItemFromInvoiceTaxItemRequest]
        """
        return self._tax_items

    @tax_items.setter
    def tax_items(self, tax_items):
        """Sets the tax_items of this DebitMemoItemFromInvoiceItemRequest.

        Container for taxation items.  # noqa: E501

        :param tax_items: The tax_items of this DebitMemoItemFromInvoiceItemRequest.  # noqa: E501
        :type: list[DebitMemoTaxItemFromInvoiceTaxItemRequest]
        """

        self._tax_items = tax_items

    @property
    def tax_mode(self):
        """Gets the tax_mode of this DebitMemoItemFromInvoiceItemRequest.  # noqa: E501


        :return: The tax_mode of this DebitMemoItemFromInvoiceItemRequest.  # noqa: E501
        :rtype: TaxMode
        """
        return self._tax_mode

    @tax_mode.setter
    def tax_mode(self, tax_mode):
        """Sets the tax_mode of this DebitMemoItemFromInvoiceItemRequest.


        :param tax_mode: The tax_mode of this DebitMemoItemFromInvoiceItemRequest.  # noqa: E501
        :type: TaxMode
        """

        self._tax_mode = tax_mode

    @property
    def unit_of_measure(self):
        """Gets the unit_of_measure of this DebitMemoItemFromInvoiceItemRequest.  # noqa: E501

        The definable unit that you measure when determining charges.  # noqa: E501

        :return: The unit_of_measure of this DebitMemoItemFromInvoiceItemRequest.  # noqa: E501
        :rtype: str
        """
        return self._unit_of_measure

    @unit_of_measure.setter
    def unit_of_measure(self, unit_of_measure):
        """Sets the unit_of_measure of this DebitMemoItemFromInvoiceItemRequest.

        The definable unit that you measure when determining charges.  # noqa: E501

        :param unit_of_measure: The unit_of_measure of this DebitMemoItemFromInvoiceItemRequest.  # noqa: E501
        :type: str
        """

        self._unit_of_measure = unit_of_measure

    @property
    def exclude_item_billing_from_revenue_accounting(self):
        """Gets the exclude_item_billing_from_revenue_accounting of this DebitMemoItemFromInvoiceItemRequest.  # noqa: E501

        The flag to exclude the debit memo item from revenue accounting.  **Note**: This field is only available if you have the Billing - Revenue Integration feature enabled.   # noqa: E501

        :return: The exclude_item_billing_from_revenue_accounting of this DebitMemoItemFromInvoiceItemRequest.  # noqa: E501
        :rtype: bool
        """
        return self._exclude_item_billing_from_revenue_accounting

    @exclude_item_billing_from_revenue_accounting.setter
    def exclude_item_billing_from_revenue_accounting(self, exclude_item_billing_from_revenue_accounting):
        """Sets the exclude_item_billing_from_revenue_accounting of this DebitMemoItemFromInvoiceItemRequest.

        The flag to exclude the debit memo item from revenue accounting.  **Note**: This field is only available if you have the Billing - Revenue Integration feature enabled.   # noqa: E501

        :param exclude_item_billing_from_revenue_accounting: The exclude_item_billing_from_revenue_accounting of this DebitMemoItemFromInvoiceItemRequest.  # noqa: E501
        :type: bool
        """

        self._exclude_item_billing_from_revenue_accounting = exclude_item_billing_from_revenue_accounting

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(DebitMemoItemFromInvoiceItemRequest, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, DebitMemoItemFromInvoiceItemRequest):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
