# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).  # noqa: E501

    OpenAPI spec version: 2024-05-20
    Contact: docs@zuora.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class DecryptRSASignatureRequest(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'method': 'str',
        'public_key': 'str',
        'signature': 'str'
    }

    attribute_map = {
        'method': 'method',
        'public_key': 'publicKey',
        'signature': 'signature'
    }

    def __init__(self, method=None, public_key=None, signature=None):  # noqa: E501
        """DecryptRSASignatureRequest - a model defined in Swagger"""  # noqa: E501
        self._method = None
        self._public_key = None
        self._signature = None
        self.discriminator = None
        self.method = method
        self.public_key = public_key
        self.signature = signature

    @property
    def method(self):
        """Gets the method of this DecryptRSASignatureRequest.  # noqa: E501

        The type of the request. Set it to Post.   # noqa: E501

        :return: The method of this DecryptRSASignatureRequest.  # noqa: E501
        :rtype: str
        """
        return self._method

    @method.setter
    def method(self, method):
        """Sets the method of this DecryptRSASignatureRequest.

        The type of the request. Set it to Post.   # noqa: E501

        :param method: The method of this DecryptRSASignatureRequest.  # noqa: E501
        :type: str
        """
        if method is None:
            raise ValueError("Invalid value for `method`, must not be `None`")  # noqa: E501

        self._method = method

    @property
    def public_key(self):
        """Gets the public_key of this DecryptRSASignatureRequest.  # noqa: E501

        The public key generated by Zuora.   # noqa: E501

        :return: The public_key of this DecryptRSASignatureRequest.  # noqa: E501
        :rtype: str
        """
        return self._public_key

    @public_key.setter
    def public_key(self, public_key):
        """Sets the public_key of this DecryptRSASignatureRequest.

        The public key generated by Zuora.   # noqa: E501

        :param public_key: The public_key of this DecryptRSASignatureRequest.  # noqa: E501
        :type: str
        """
        if public_key is None:
            raise ValueError("Invalid value for `public_key`, must not be `None`")  # noqa: E501

        self._public_key = public_key

    @property
    def signature(self):
        """Gets the signature of this DecryptRSASignatureRequest.  # noqa: E501

        The signature generated by Zuora.   # noqa: E501

        :return: The signature of this DecryptRSASignatureRequest.  # noqa: E501
        :rtype: str
        """
        return self._signature

    @signature.setter
    def signature(self, signature):
        """Sets the signature of this DecryptRSASignatureRequest.

        The signature generated by Zuora.   # noqa: E501

        :param signature: The signature of this DecryptRSASignatureRequest.  # noqa: E501
        :type: str
        """
        if signature is None:
            raise ValueError("Invalid value for `signature`, must not be `None`")  # noqa: E501

        self._signature = signature

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(DecryptRSASignatureRequest, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, DecryptRSASignatureRequest):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
