# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).  # noqa: E501

    OpenAPI spec version: 2024-05-20
    Contact: docs@zuora.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class DeliverySchedule(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'frequency': 'DeliveryFrequency',
        'monday': 'bool',
        'tuesday': 'bool',
        'wednesday': 'bool',
        'thursday': 'bool',
        'friday': 'bool',
        'saturday': 'bool',
        'sunday': 'bool'
    }

    attribute_map = {
        'frequency': 'frequency',
        'monday': 'monday',
        'tuesday': 'tuesday',
        'wednesday': 'wednesday',
        'thursday': 'thursday',
        'friday': 'friday',
        'saturday': 'saturday',
        'sunday': 'sunday'
    }

    def __init__(self, frequency=None, monday=None, tuesday=None, wednesday=None, thursday=None, friday=None, saturday=None, sunday=None):  # noqa: E501
        """DeliverySchedule - a model defined in Swagger"""  # noqa: E501
        self._frequency = None
        self._monday = None
        self._tuesday = None
        self._wednesday = None
        self._thursday = None
        self._friday = None
        self._saturday = None
        self._sunday = None
        self.discriminator = None
        if frequency is not None:
            self.frequency = frequency
        if monday is not None:
            self.monday = monday
        if tuesday is not None:
            self.tuesday = tuesday
        if wednesday is not None:
            self.wednesday = wednesday
        if thursday is not None:
            self.thursday = thursday
        if friday is not None:
            self.friday = friday
        if saturday is not None:
            self.saturday = saturday
        if sunday is not None:
            self.sunday = sunday

    @property
    def frequency(self):
        """Gets the frequency of this DeliverySchedule.  # noqa: E501


        :return: The frequency of this DeliverySchedule.  # noqa: E501
        :rtype: DeliveryFrequency
        """
        return self._frequency

    @frequency.setter
    def frequency(self, frequency):
        """Sets the frequency of this DeliverySchedule.


        :param frequency: The frequency of this DeliverySchedule.  # noqa: E501
        :type: DeliveryFrequency
        """

        self._frequency = frequency

    @property
    def monday(self):
        """Gets the monday of this DeliverySchedule.  # noqa: E501

        Indicates whether delivery occurs on Monday.  # noqa: E501

        :return: The monday of this DeliverySchedule.  # noqa: E501
        :rtype: bool
        """
        return self._monday

    @monday.setter
    def monday(self, monday):
        """Sets the monday of this DeliverySchedule.

        Indicates whether delivery occurs on Monday.  # noqa: E501

        :param monday: The monday of this DeliverySchedule.  # noqa: E501
        :type: bool
        """

        self._monday = monday

    @property
    def tuesday(self):
        """Gets the tuesday of this DeliverySchedule.  # noqa: E501

        Indicates whether delivery occurs on Tuesday.  # noqa: E501

        :return: The tuesday of this DeliverySchedule.  # noqa: E501
        :rtype: bool
        """
        return self._tuesday

    @tuesday.setter
    def tuesday(self, tuesday):
        """Sets the tuesday of this DeliverySchedule.

        Indicates whether delivery occurs on Tuesday.  # noqa: E501

        :param tuesday: The tuesday of this DeliverySchedule.  # noqa: E501
        :type: bool
        """

        self._tuesday = tuesday

    @property
    def wednesday(self):
        """Gets the wednesday of this DeliverySchedule.  # noqa: E501

        Indicates whether delivery occurs on Wednesday.  # noqa: E501

        :return: The wednesday of this DeliverySchedule.  # noqa: E501
        :rtype: bool
        """
        return self._wednesday

    @wednesday.setter
    def wednesday(self, wednesday):
        """Sets the wednesday of this DeliverySchedule.

        Indicates whether delivery occurs on Wednesday.  # noqa: E501

        :param wednesday: The wednesday of this DeliverySchedule.  # noqa: E501
        :type: bool
        """

        self._wednesday = wednesday

    @property
    def thursday(self):
        """Gets the thursday of this DeliverySchedule.  # noqa: E501

        Indicates whether delivery occurs on Thursday.  # noqa: E501

        :return: The thursday of this DeliverySchedule.  # noqa: E501
        :rtype: bool
        """
        return self._thursday

    @thursday.setter
    def thursday(self, thursday):
        """Sets the thursday of this DeliverySchedule.

        Indicates whether delivery occurs on Thursday.  # noqa: E501

        :param thursday: The thursday of this DeliverySchedule.  # noqa: E501
        :type: bool
        """

        self._thursday = thursday

    @property
    def friday(self):
        """Gets the friday of this DeliverySchedule.  # noqa: E501

        Indicates whether delivery occurs on Friday.  # noqa: E501

        :return: The friday of this DeliverySchedule.  # noqa: E501
        :rtype: bool
        """
        return self._friday

    @friday.setter
    def friday(self, friday):
        """Sets the friday of this DeliverySchedule.

        Indicates whether delivery occurs on Friday.  # noqa: E501

        :param friday: The friday of this DeliverySchedule.  # noqa: E501
        :type: bool
        """

        self._friday = friday

    @property
    def saturday(self):
        """Gets the saturday of this DeliverySchedule.  # noqa: E501

        Indicates whether delivery occurs on Saturday.  # noqa: E501

        :return: The saturday of this DeliverySchedule.  # noqa: E501
        :rtype: bool
        """
        return self._saturday

    @saturday.setter
    def saturday(self, saturday):
        """Sets the saturday of this DeliverySchedule.

        Indicates whether delivery occurs on Saturday.  # noqa: E501

        :param saturday: The saturday of this DeliverySchedule.  # noqa: E501
        :type: bool
        """

        self._saturday = saturday

    @property
    def sunday(self):
        """Gets the sunday of this DeliverySchedule.  # noqa: E501

        Indicates whether delivery occurs on Sunday.  # noqa: E501

        :return: The sunday of this DeliverySchedule.  # noqa: E501
        :rtype: bool
        """
        return self._sunday

    @sunday.setter
    def sunday(self, sunday):
        """Sets the sunday of this DeliverySchedule.

        Indicates whether delivery occurs on Sunday.  # noqa: E501

        :param sunday: The sunday of this DeliverySchedule.  # noqa: E501
        :type: bool
        """

        self._sunday = sunday

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(DeliverySchedule, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, DeliverySchedule):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
