# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).  # noqa: E501

    OpenAPI spec version: 2024-05-20
    Contact: docs@zuora.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class DetailedWorkflow(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'call_type': 'str',
        'callout_trigger': 'bool',
        'created_at': 'str',
        'description': 'str',
        'finished_at': 'str',
        'id': 'int',
        'interval': 'str',
        'name': 'str',
        'ondemand_trigger': 'bool',
        'original_workflow_id': 'int',
        'priority': 'str',
        'scheduled_trigger': 'bool',
        'started_at': 'str',
        'status': 'int',
        'sync_trigger': 'bool',
        'timezone': 'str',
        'type': 'DetailedWorkflowType',
        'updated_at': 'str',
        'version': 'str'
    }

    attribute_map = {
        'call_type': 'call_type',
        'callout_trigger': 'calloutTrigger',
        'created_at': 'createdAt',
        'description': 'description',
        'finished_at': 'finished_at',
        'id': 'id',
        'interval': 'interval',
        'name': 'name',
        'ondemand_trigger': 'ondemandTrigger',
        'original_workflow_id': 'original_workflow_id',
        'priority': 'priority',
        'scheduled_trigger': 'scheduledTrigger',
        'started_at': 'started_at',
        'status': 'status',
        'sync_trigger': 'sync_trigger',
        'timezone': 'timezone',
        'type': 'type',
        'updated_at': 'updatedAt',
        'version': 'version'
    }

    def __init__(self, call_type=None, callout_trigger=None, created_at=None, description=None, finished_at=None, id=None, interval=None, name=None, ondemand_trigger=None, original_workflow_id=None, priority=None, scheduled_trigger=None, started_at=None, status=None, sync_trigger=None, timezone=None, type=None, updated_at=None, version=None):  # noqa: E501
        """DetailedWorkflow - a model defined in Swagger"""  # noqa: E501
        self._call_type = None
        self._callout_trigger = None
        self._created_at = None
        self._description = None
        self._finished_at = None
        self._id = None
        self._interval = None
        self._name = None
        self._ondemand_trigger = None
        self._original_workflow_id = None
        self._priority = None
        self._scheduled_trigger = None
        self._started_at = None
        self._status = None
        self._sync_trigger = None
        self._timezone = None
        self._type = None
        self._updated_at = None
        self._version = None
        self.discriminator = None
        if call_type is not None:
            self.call_type = call_type
        if callout_trigger is not None:
            self.callout_trigger = callout_trigger
        if created_at is not None:
            self.created_at = created_at
        if description is not None:
            self.description = description
        if finished_at is not None:
            self.finished_at = finished_at
        if id is not None:
            self.id = id
        if interval is not None:
            self.interval = interval
        if name is not None:
            self.name = name
        if ondemand_trigger is not None:
            self.ondemand_trigger = ondemand_trigger
        if original_workflow_id is not None:
            self.original_workflow_id = original_workflow_id
        if priority is not None:
            self.priority = priority
        if scheduled_trigger is not None:
            self.scheduled_trigger = scheduled_trigger
        if started_at is not None:
            self.started_at = started_at
        if status is not None:
            self.status = status
        if sync_trigger is not None:
            self.sync_trigger = sync_trigger
        if timezone is not None:
            self.timezone = timezone
        if type is not None:
            self.type = type
        if updated_at is not None:
            self.updated_at = updated_at
        if version is not None:
            self.version = version

    @property
    def call_type(self):
        """Gets the call_type of this DetailedWorkflow.  # noqa: E501

        The call type of the active workflow version.   # noqa: E501

        :return: The call_type of this DetailedWorkflow.  # noqa: E501
        :rtype: str
        """
        return self._call_type

    @call_type.setter
    def call_type(self, call_type):
        """Sets the call_type of this DetailedWorkflow.

        The call type of the active workflow version.   # noqa: E501

        :param call_type: The call_type of this DetailedWorkflow.  # noqa: E501
        :type: str
        """

        self._call_type = call_type

    @property
    def callout_trigger(self):
        """Gets the callout_trigger of this DetailedWorkflow.  # noqa: E501

        Indicates whether the callout trigger is enabled for the retrieved workflow.   # noqa: E501

        :return: The callout_trigger of this DetailedWorkflow.  # noqa: E501
        :rtype: bool
        """
        return self._callout_trigger

    @callout_trigger.setter
    def callout_trigger(self, callout_trigger):
        """Sets the callout_trigger of this DetailedWorkflow.

        Indicates whether the callout trigger is enabled for the retrieved workflow.   # noqa: E501

        :param callout_trigger: The callout_trigger of this DetailedWorkflow.  # noqa: E501
        :type: bool
        """

        self._callout_trigger = callout_trigger

    @property
    def created_at(self):
        """Gets the created_at of this DetailedWorkflow.  # noqa: E501

        The date and time when the workflow is created, in the `YYYY-MM-DD HH:MM:SS` format.   # noqa: E501

        :return: The created_at of this DetailedWorkflow.  # noqa: E501
        :rtype: str
        """
        return self._created_at

    @created_at.setter
    def created_at(self, created_at):
        """Sets the created_at of this DetailedWorkflow.

        The date and time when the workflow is created, in the `YYYY-MM-DD HH:MM:SS` format.   # noqa: E501

        :param created_at: The created_at of this DetailedWorkflow.  # noqa: E501
        :type: str
        """

        self._created_at = created_at

    @property
    def description(self):
        """Gets the description of this DetailedWorkflow.  # noqa: E501

        The description of the workflow.   # noqa: E501

        :return: The description of this DetailedWorkflow.  # noqa: E501
        :rtype: str
        """
        return self._description

    @description.setter
    def description(self, description):
        """Sets the description of this DetailedWorkflow.

        The description of the workflow.   # noqa: E501

        :param description: The description of this DetailedWorkflow.  # noqa: E501
        :type: str
        """

        self._description = description

    @property
    def finished_at(self):
        """Gets the finished_at of this DetailedWorkflow.  # noqa: E501

        The date and time when the instance of the workflow version finished at.   # noqa: E501

        :return: The finished_at of this DetailedWorkflow.  # noqa: E501
        :rtype: str
        """
        return self._finished_at

    @finished_at.setter
    def finished_at(self, finished_at):
        """Sets the finished_at of this DetailedWorkflow.

        The date and time when the instance of the workflow version finished at.   # noqa: E501

        :param finished_at: The finished_at of this DetailedWorkflow.  # noqa: E501
        :type: str
        """

        self._finished_at = finished_at

    @property
    def id(self):
        """Gets the id of this DetailedWorkflow.  # noqa: E501

        The unique ID of the workflow.   # noqa: E501

        :return: The id of this DetailedWorkflow.  # noqa: E501
        :rtype: int
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this DetailedWorkflow.

        The unique ID of the workflow.   # noqa: E501

        :param id: The id of this DetailedWorkflow.  # noqa: E501
        :type: int
        """

        self._id = id

    @property
    def interval(self):
        """Gets the interval of this DetailedWorkflow.  # noqa: E501

        The schedule of the workflow, in a CRON expression. Returns null if the schedued trigger is disabled.   # noqa: E501

        :return: The interval of this DetailedWorkflow.  # noqa: E501
        :rtype: str
        """
        return self._interval

    @interval.setter
    def interval(self, interval):
        """Sets the interval of this DetailedWorkflow.

        The schedule of the workflow, in a CRON expression. Returns null if the schedued trigger is disabled.   # noqa: E501

        :param interval: The interval of this DetailedWorkflow.  # noqa: E501
        :type: str
        """

        self._interval = interval

    @property
    def name(self):
        """Gets the name of this DetailedWorkflow.  # noqa: E501

        The name of the workflow.   # noqa: E501

        :return: The name of this DetailedWorkflow.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this DetailedWorkflow.

        The name of the workflow.   # noqa: E501

        :param name: The name of this DetailedWorkflow.  # noqa: E501
        :type: str
        """

        self._name = name

    @property
    def ondemand_trigger(self):
        """Gets the ondemand_trigger of this DetailedWorkflow.  # noqa: E501

        Indicates whether the ondemand trigger is enabled for the workflow.   # noqa: E501

        :return: The ondemand_trigger of this DetailedWorkflow.  # noqa: E501
        :rtype: bool
        """
        return self._ondemand_trigger

    @ondemand_trigger.setter
    def ondemand_trigger(self, ondemand_trigger):
        """Sets the ondemand_trigger of this DetailedWorkflow.

        Indicates whether the ondemand trigger is enabled for the workflow.   # noqa: E501

        :param ondemand_trigger: The ondemand_trigger of this DetailedWorkflow.  # noqa: E501
        :type: bool
        """

        self._ondemand_trigger = ondemand_trigger

    @property
    def original_workflow_id(self):
        """Gets the original_workflow_id of this DetailedWorkflow.  # noqa: E501

        The unique ID of the original workflow version.   # noqa: E501

        :return: The original_workflow_id of this DetailedWorkflow.  # noqa: E501
        :rtype: int
        """
        return self._original_workflow_id

    @original_workflow_id.setter
    def original_workflow_id(self, original_workflow_id):
        """Sets the original_workflow_id of this DetailedWorkflow.

        The unique ID of the original workflow version.   # noqa: E501

        :param original_workflow_id: The original_workflow_id of this DetailedWorkflow.  # noqa: E501
        :type: int
        """

        self._original_workflow_id = original_workflow_id

    @property
    def priority(self):
        """Gets the priority of this DetailedWorkflow.  # noqa: E501

        The priority of the active workflow version.    # noqa: E501

        :return: The priority of this DetailedWorkflow.  # noqa: E501
        :rtype: str
        """
        return self._priority

    @priority.setter
    def priority(self, priority):
        """Sets the priority of this DetailedWorkflow.

        The priority of the active workflow version.    # noqa: E501

        :param priority: The priority of this DetailedWorkflow.  # noqa: E501
        :type: str
        """

        self._priority = priority

    @property
    def scheduled_trigger(self):
        """Gets the scheduled_trigger of this DetailedWorkflow.  # noqa: E501

        Indicates whether the scheduled trigger is enabled for the workflow.   # noqa: E501

        :return: The scheduled_trigger of this DetailedWorkflow.  # noqa: E501
        :rtype: bool
        """
        return self._scheduled_trigger

    @scheduled_trigger.setter
    def scheduled_trigger(self, scheduled_trigger):
        """Sets the scheduled_trigger of this DetailedWorkflow.

        Indicates whether the scheduled trigger is enabled for the workflow.   # noqa: E501

        :param scheduled_trigger: The scheduled_trigger of this DetailedWorkflow.  # noqa: E501
        :type: bool
        """

        self._scheduled_trigger = scheduled_trigger

    @property
    def started_at(self):
        """Gets the started_at of this DetailedWorkflow.  # noqa: E501

        The date and time when the instance of the workflow version started at.   # noqa: E501

        :return: The started_at of this DetailedWorkflow.  # noqa: E501
        :rtype: str
        """
        return self._started_at

    @started_at.setter
    def started_at(self, started_at):
        """Sets the started_at of this DetailedWorkflow.

        The date and time when the instance of the workflow version started at.   # noqa: E501

        :param started_at: The started_at of this DetailedWorkflow.  # noqa: E501
        :type: str
        """

        self._started_at = started_at

    @property
    def status(self):
        """Gets the status of this DetailedWorkflow.  # noqa: E501

        The status of the active workflow version.   # noqa: E501

        :return: The status of this DetailedWorkflow.  # noqa: E501
        :rtype: int
        """
        return self._status

    @status.setter
    def status(self, status):
        """Sets the status of this DetailedWorkflow.

        The status of the active workflow version.   # noqa: E501

        :param status: The status of this DetailedWorkflow.  # noqa: E501
        :type: int
        """

        self._status = status

    @property
    def sync_trigger(self):
        """Gets the sync_trigger of this DetailedWorkflow.  # noqa: E501

        Indicates whether the workflow version is enabled for the sync mode.   # noqa: E501

        :return: The sync_trigger of this DetailedWorkflow.  # noqa: E501
        :rtype: bool
        """
        return self._sync_trigger

    @sync_trigger.setter
    def sync_trigger(self, sync_trigger):
        """Sets the sync_trigger of this DetailedWorkflow.

        Indicates whether the workflow version is enabled for the sync mode.   # noqa: E501

        :param sync_trigger: The sync_trigger of this DetailedWorkflow.  # noqa: E501
        :type: bool
        """

        self._sync_trigger = sync_trigger

    @property
    def timezone(self):
        """Gets the timezone of this DetailedWorkflow.  # noqa: E501

        The timezone that is configured for the scheduler of the workflow. Returns null if the scheduled trigger is disabled.   # noqa: E501

        :return: The timezone of this DetailedWorkflow.  # noqa: E501
        :rtype: str
        """
        return self._timezone

    @timezone.setter
    def timezone(self, timezone):
        """Sets the timezone of this DetailedWorkflow.

        The timezone that is configured for the scheduler of the workflow. Returns null if the scheduled trigger is disabled.   # noqa: E501

        :param timezone: The timezone of this DetailedWorkflow.  # noqa: E501
        :type: str
        """

        self._timezone = timezone

    @property
    def type(self):
        """Gets the type of this DetailedWorkflow.  # noqa: E501


        :return: The type of this DetailedWorkflow.  # noqa: E501
        :rtype: DetailedWorkflowType
        """
        return self._type

    @type.setter
    def type(self, type):
        """Sets the type of this DetailedWorkflow.


        :param type: The type of this DetailedWorkflow.  # noqa: E501
        :type: DetailedWorkflowType
        """

        self._type = type

    @property
    def updated_at(self):
        """Gets the updated_at of this DetailedWorkflow.  # noqa: E501

        The date and time when the workflow is updated the last time, in the `YYYY-MM-DD HH:MM:SS` format.   # noqa: E501

        :return: The updated_at of this DetailedWorkflow.  # noqa: E501
        :rtype: str
        """
        return self._updated_at

    @updated_at.setter
    def updated_at(self, updated_at):
        """Sets the updated_at of this DetailedWorkflow.

        The date and time when the workflow is updated the last time, in the `YYYY-MM-DD HH:MM:SS` format.   # noqa: E501

        :param updated_at: The updated_at of this DetailedWorkflow.  # noqa: E501
        :type: str
        """

        self._updated_at = updated_at

    @property
    def version(self):
        """Gets the version of this DetailedWorkflow.  # noqa: E501

        The version number of the active workflow version.               # noqa: E501

        :return: The version of this DetailedWorkflow.  # noqa: E501
        :rtype: str
        """
        return self._version

    @version.setter
    def version(self, version):
        """Sets the version of this DetailedWorkflow.

        The version number of the active workflow version.               # noqa: E501

        :param version: The version of this DetailedWorkflow.  # noqa: E501
        :type: str
        """

        self._version = version

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(DetailedWorkflow, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, DetailedWorkflow):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
