# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).  # noqa: E501

    OpenAPI spec version: 2024-05-20
    Contact: docs@zuora.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class DiscountApplyDetail(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'applied_product_rate_plan_id': 'str',
        'applied_product_rate_plan_charge_id': 'str',
        'applied_product_name': 'str',
        'applied_product_rate_plan_name': 'str',
        'applied_product_rate_plan_charge_name': 'str'
    }

    attribute_map = {
        'applied_product_rate_plan_id': 'appliedProductRatePlanId',
        'applied_product_rate_plan_charge_id': 'appliedProductRatePlanChargeId',
        'applied_product_name': 'appliedProductName',
        'applied_product_rate_plan_name': 'appliedProductRatePlanName',
        'applied_product_rate_plan_charge_name': 'appliedProductRatePlanChargeName'
    }

    def __init__(self, applied_product_rate_plan_id=None, applied_product_rate_plan_charge_id=None, applied_product_name=None, applied_product_rate_plan_name=None, applied_product_rate_plan_charge_name=None):  # noqa: E501
        """DiscountApplyDetail - a model defined in Swagger"""  # noqa: E501
        self._applied_product_rate_plan_id = None
        self._applied_product_rate_plan_charge_id = None
        self._applied_product_name = None
        self._applied_product_rate_plan_name = None
        self._applied_product_rate_plan_charge_name = None
        self.discriminator = None
        if applied_product_rate_plan_id is not None:
            self.applied_product_rate_plan_id = applied_product_rate_plan_id
        if applied_product_rate_plan_charge_id is not None:
            self.applied_product_rate_plan_charge_id = applied_product_rate_plan_charge_id
        if applied_product_name is not None:
            self.applied_product_name = applied_product_name
        if applied_product_rate_plan_name is not None:
            self.applied_product_rate_plan_name = applied_product_rate_plan_name
        if applied_product_rate_plan_charge_name is not None:
            self.applied_product_rate_plan_charge_name = applied_product_rate_plan_charge_name

    @property
    def applied_product_rate_plan_id(self):
        """Gets the applied_product_rate_plan_id of this DiscountApplyDetail.  # noqa: E501

        The ID of the product rate plan that the discount rate plan charge applies to.   # noqa: E501

        :return: The applied_product_rate_plan_id of this DiscountApplyDetail.  # noqa: E501
        :rtype: str
        """
        return self._applied_product_rate_plan_id

    @applied_product_rate_plan_id.setter
    def applied_product_rate_plan_id(self, applied_product_rate_plan_id):
        """Sets the applied_product_rate_plan_id of this DiscountApplyDetail.

        The ID of the product rate plan that the discount rate plan charge applies to.   # noqa: E501

        :param applied_product_rate_plan_id: The applied_product_rate_plan_id of this DiscountApplyDetail.  # noqa: E501
        :type: str
        """

        self._applied_product_rate_plan_id = applied_product_rate_plan_id

    @property
    def applied_product_rate_plan_charge_id(self):
        """Gets the applied_product_rate_plan_charge_id of this DiscountApplyDetail.  # noqa: E501

        The ID of the product rate plan charge that the discount rate plan charge applies to.   # noqa: E501

        :return: The applied_product_rate_plan_charge_id of this DiscountApplyDetail.  # noqa: E501
        :rtype: str
        """
        return self._applied_product_rate_plan_charge_id

    @applied_product_rate_plan_charge_id.setter
    def applied_product_rate_plan_charge_id(self, applied_product_rate_plan_charge_id):
        """Sets the applied_product_rate_plan_charge_id of this DiscountApplyDetail.

        The ID of the product rate plan charge that the discount rate plan charge applies to.   # noqa: E501

        :param applied_product_rate_plan_charge_id: The applied_product_rate_plan_charge_id of this DiscountApplyDetail.  # noqa: E501
        :type: str
        """

        self._applied_product_rate_plan_charge_id = applied_product_rate_plan_charge_id

    @property
    def applied_product_name(self):
        """Gets the applied_product_name of this DiscountApplyDetail.  # noqa: E501

        The name of the product that the discount rate plan charge applies to.   # noqa: E501

        :return: The applied_product_name of this DiscountApplyDetail.  # noqa: E501
        :rtype: str
        """
        return self._applied_product_name

    @applied_product_name.setter
    def applied_product_name(self, applied_product_name):
        """Sets the applied_product_name of this DiscountApplyDetail.

        The name of the product that the discount rate plan charge applies to.   # noqa: E501

        :param applied_product_name: The applied_product_name of this DiscountApplyDetail.  # noqa: E501
        :type: str
        """

        self._applied_product_name = applied_product_name

    @property
    def applied_product_rate_plan_name(self):
        """Gets the applied_product_rate_plan_name of this DiscountApplyDetail.  # noqa: E501

        The name of the product rate plan that the discount rate plan charge applies to.   # noqa: E501

        :return: The applied_product_rate_plan_name of this DiscountApplyDetail.  # noqa: E501
        :rtype: str
        """
        return self._applied_product_rate_plan_name

    @applied_product_rate_plan_name.setter
    def applied_product_rate_plan_name(self, applied_product_rate_plan_name):
        """Sets the applied_product_rate_plan_name of this DiscountApplyDetail.

        The name of the product rate plan that the discount rate plan charge applies to.   # noqa: E501

        :param applied_product_rate_plan_name: The applied_product_rate_plan_name of this DiscountApplyDetail.  # noqa: E501
        :type: str
        """

        self._applied_product_rate_plan_name = applied_product_rate_plan_name

    @property
    def applied_product_rate_plan_charge_name(self):
        """Gets the applied_product_rate_plan_charge_name of this DiscountApplyDetail.  # noqa: E501

        The name of the product rate plan charge that the discount rate plan charge applies to.   # noqa: E501

        :return: The applied_product_rate_plan_charge_name of this DiscountApplyDetail.  # noqa: E501
        :rtype: str
        """
        return self._applied_product_rate_plan_charge_name

    @applied_product_rate_plan_charge_name.setter
    def applied_product_rate_plan_charge_name(self, applied_product_rate_plan_charge_name):
        """Sets the applied_product_rate_plan_charge_name of this DiscountApplyDetail.

        The name of the product rate plan charge that the discount rate plan charge applies to.   # noqa: E501

        :param applied_product_rate_plan_charge_name: The applied_product_rate_plan_charge_name of this DiscountApplyDetail.  # noqa: E501
        :type: str
        """

        self._applied_product_rate_plan_charge_name = applied_product_rate_plan_charge_name

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(DiscountApplyDetail, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, DiscountApplyDetail):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
