# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).  # noqa: E501

    OpenAPI spec version: 2024-05-20
    Contact: docs@zuora.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class DiscountPricingUpdate(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'apply_discount_to': 'ApplyDiscountTo',
        'discount_level': 'DiscountLevel',
        'discount_percentage': 'float',
        'price_change_option': 'PriceChangeOption'
    }

    attribute_map = {
        'apply_discount_to': 'applyDiscountTo',
        'discount_level': 'discountLevel',
        'discount_percentage': 'discountPercentage',
        'price_change_option': 'priceChangeOption'
    }

    def __init__(self, apply_discount_to=None, discount_level=None, discount_percentage=None, price_change_option=None):  # noqa: E501
        """DiscountPricingUpdate - a model defined in Swagger"""  # noqa: E501
        self._apply_discount_to = None
        self._discount_level = None
        self._discount_percentage = None
        self._price_change_option = None
        self.discriminator = None
        if apply_discount_to is not None:
            self.apply_discount_to = apply_discount_to
        if discount_level is not None:
            self.discount_level = discount_level
        if discount_percentage is not None:
            self.discount_percentage = discount_percentage
        if price_change_option is not None:
            self.price_change_option = price_change_option

    @property
    def apply_discount_to(self):
        """Gets the apply_discount_to of this DiscountPricingUpdate.  # noqa: E501


        :return: The apply_discount_to of this DiscountPricingUpdate.  # noqa: E501
        :rtype: ApplyDiscountTo
        """
        return self._apply_discount_to

    @apply_discount_to.setter
    def apply_discount_to(self, apply_discount_to):
        """Sets the apply_discount_to of this DiscountPricingUpdate.


        :param apply_discount_to: The apply_discount_to of this DiscountPricingUpdate.  # noqa: E501
        :type: ApplyDiscountTo
        """

        self._apply_discount_to = apply_discount_to

    @property
    def discount_level(self):
        """Gets the discount_level of this DiscountPricingUpdate.  # noqa: E501


        :return: The discount_level of this DiscountPricingUpdate.  # noqa: E501
        :rtype: DiscountLevel
        """
        return self._discount_level

    @discount_level.setter
    def discount_level(self, discount_level):
        """Sets the discount_level of this DiscountPricingUpdate.


        :param discount_level: The discount_level of this DiscountPricingUpdate.  # noqa: E501
        :type: DiscountLevel
        """

        self._discount_level = discount_level

    @property
    def discount_percentage(self):
        """Gets the discount_percentage of this DiscountPricingUpdate.  # noqa: E501

        The amount of the discount as a percentage. This field is only used for percentage discounts.   # noqa: E501

        :return: The discount_percentage of this DiscountPricingUpdate.  # noqa: E501
        :rtype: float
        """
        return self._discount_percentage

    @discount_percentage.setter
    def discount_percentage(self, discount_percentage):
        """Sets the discount_percentage of this DiscountPricingUpdate.

        The amount of the discount as a percentage. This field is only used for percentage discounts.   # noqa: E501

        :param discount_percentage: The discount_percentage of this DiscountPricingUpdate.  # noqa: E501
        :type: float
        """

        self._discount_percentage = discount_percentage

    @property
    def price_change_option(self):
        """Gets the price_change_option of this DiscountPricingUpdate.  # noqa: E501


        :return: The price_change_option of this DiscountPricingUpdate.  # noqa: E501
        :rtype: PriceChangeOption
        """
        return self._price_change_option

    @price_change_option.setter
    def price_change_option(self, price_change_option):
        """Sets the price_change_option of this DiscountPricingUpdate.


        :param price_change_option: The price_change_option of this DiscountPricingUpdate.  # noqa: E501
        :type: PriceChangeOption
        """

        self._price_change_option = price_change_option

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(DiscountPricingUpdate, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, DiscountPricingUpdate):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
