# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).  # noqa: E501

    OpenAPI spec version: 2024-05-20
    Contact: docs@zuora.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class GetAllCustomObjectDefinitionsInNamespaceResponse(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'count': 'int',
        'definitions': 'dict(str, CustomObjectDefinition)'
    }

    attribute_map = {
        'count': 'count',
        'definitions': 'definitions'
    }

    def __init__(self, count=None, definitions=None):  # noqa: E501
        """GetAllCustomObjectDefinitionsInNamespaceResponse - a model defined in Swagger"""  # noqa: E501
        self._count = None
        self._definitions = None
        self.discriminator = None
        if count is not None:
            self.count = count
        if definitions is not None:
            self.definitions = definitions

    @property
    def count(self):
        """Gets the count of this GetAllCustomObjectDefinitionsInNamespaceResponse.  # noqa: E501

        The number of objects in the `definitions` object. The value of this field is the number of custom object definitions in the namespace.  # noqa: E501

        :return: The count of this GetAllCustomObjectDefinitionsInNamespaceResponse.  # noqa: E501
        :rtype: int
        """
        return self._count

    @count.setter
    def count(self, count):
        """Sets the count of this GetAllCustomObjectDefinitionsInNamespaceResponse.

        The number of objects in the `definitions` object. The value of this field is the number of custom object definitions in the namespace.  # noqa: E501

        :param count: The count of this GetAllCustomObjectDefinitionsInNamespaceResponse.  # noqa: E501
        :type: int
        """

        self._count = count

    @property
    def definitions(self):
        """Gets the definitions of this GetAllCustomObjectDefinitionsInNamespaceResponse.  # noqa: E501

        The custom object definitions. This object maps types to custom object definitions.  # noqa: E501

        :return: The definitions of this GetAllCustomObjectDefinitionsInNamespaceResponse.  # noqa: E501
        :rtype: dict(str, CustomObjectDefinition)
        """
        return self._definitions

    @definitions.setter
    def definitions(self, definitions):
        """Sets the definitions of this GetAllCustomObjectDefinitionsInNamespaceResponse.

        The custom object definitions. This object maps types to custom object definitions.  # noqa: E501

        :param definitions: The definitions of this GetAllCustomObjectDefinitionsInNamespaceResponse.  # noqa: E501
        :type: dict(str, CustomObjectDefinition)
        """

        self._definitions = definitions

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(GetAllCustomObjectDefinitionsInNamespaceResponse, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, GetAllCustomObjectDefinitionsInNamespaceResponse):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
