# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).  # noqa: E501

    OpenAPI spec version: 2024-05-20
    Contact: docs@zuora.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six
from zuora_sdk.models.common_response import CommonResponse  # noqa: F401,E501

class GetBillingAdjustmentsBySubscriptionNumberResponse(CommonResponse):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'adjustments': 'list[BillingAdjustment]'
    }
    if hasattr(CommonResponse, "swagger_types"):
        swagger_types.update(CommonResponse.swagger_types)

    attribute_map = {
        'adjustments': 'adjustments'
    }
    if hasattr(CommonResponse, "attribute_map"):
        attribute_map.update(CommonResponse.attribute_map)

    def __init__(self, adjustments=None, *args, **kwargs):  # noqa: E501
        """GetBillingAdjustmentsBySubscriptionNumberResponse - a model defined in Swagger"""  # noqa: E501
        self._adjustments = None
        self.discriminator = None
        if adjustments is not None:
            self.adjustments = adjustments
        CommonResponse.__init__(self, *args, **kwargs)

    @property
    def adjustments(self):
        """Gets the adjustments of this GetBillingAdjustmentsBySubscriptionNumberResponse.  # noqa: E501

        Container for all the adjustments of a subscription.   # noqa: E501

        :return: The adjustments of this GetBillingAdjustmentsBySubscriptionNumberResponse.  # noqa: E501
        :rtype: list[BillingAdjustment]
        """
        return self._adjustments

    @adjustments.setter
    def adjustments(self, adjustments):
        """Sets the adjustments of this GetBillingAdjustmentsBySubscriptionNumberResponse.

        Container for all the adjustments of a subscription.   # noqa: E501

        :param adjustments: The adjustments of this GetBillingAdjustmentsBySubscriptionNumberResponse.  # noqa: E501
        :type: list[BillingAdjustment]
        """

        self._adjustments = adjustments

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(GetBillingAdjustmentsBySubscriptionNumberResponse, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, GetBillingAdjustmentsBySubscriptionNumberResponse):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
