# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).  # noqa: E501

    OpenAPI spec version: 2024-05-20
    Contact: docs@zuora.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class GetCatalogGroupsResponse(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'catalog_groups': 'list[CatalogGroup]',
        'next_page': 'str'
    }

    attribute_map = {
        'catalog_groups': 'catalogGroups',
        'next_page': 'nextPage'
    }

    def __init__(self, catalog_groups=None, next_page=None):  # noqa: E501
        """GetCatalogGroupsResponse - a model defined in Swagger"""  # noqa: E501
        self._catalog_groups = None
        self._next_page = None
        self.discriminator = None
        if catalog_groups is not None:
            self.catalog_groups = catalog_groups
        if next_page is not None:
            self.next_page = next_page

    @property
    def catalog_groups(self):
        """Gets the catalog_groups of this GetCatalogGroupsResponse.  # noqa: E501

        The list of catalog groups that are retrieved..   # noqa: E501

        :return: The catalog_groups of this GetCatalogGroupsResponse.  # noqa: E501
        :rtype: list[CatalogGroup]
        """
        return self._catalog_groups

    @catalog_groups.setter
    def catalog_groups(self, catalog_groups):
        """Sets the catalog_groups of this GetCatalogGroupsResponse.

        The list of catalog groups that are retrieved..   # noqa: E501

        :param catalog_groups: The catalog_groups of this GetCatalogGroupsResponse.  # noqa: E501
        :type: list[CatalogGroup]
        """

        self._catalog_groups = catalog_groups

    @property
    def next_page(self):
        """Gets the next_page of this GetCatalogGroupsResponse.  # noqa: E501

        URL to retrieve the next page of the response if it exists; otherwise absent.   # noqa: E501

        :return: The next_page of this GetCatalogGroupsResponse.  # noqa: E501
        :rtype: str
        """
        return self._next_page

    @next_page.setter
    def next_page(self, next_page):
        """Sets the next_page of this GetCatalogGroupsResponse.

        URL to retrieve the next page of the response if it exists; otherwise absent.   # noqa: E501

        :param next_page: The next_page of this GetCatalogGroupsResponse.  # noqa: E501
        :type: str
        """

        self._next_page = next_page

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(GetCatalogGroupsResponse, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, GetCatalogGroupsResponse):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
