# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).  # noqa: E501

    OpenAPI spec version: 2024-05-20
    Contact: docs@zuora.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class GetCustomExchangeRatesType(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'inverse': 'bool',
        'rates': 'list[GetCustomExchangeRatesDataType]',
        'success': 'bool'
    }

    attribute_map = {
        'inverse': 'inverse',
        'rates': 'rates',
        'success': 'success'
    }

    def __init__(self, inverse=None, rates=None, success=None):  # noqa: E501
        """GetCustomExchangeRatesType - a model defined in Swagger"""  # noqa: E501
        self._inverse = None
        self._rates = None
        self._success = None
        self.discriminator = None
        if inverse is not None:
            self.inverse = inverse
        if rates is not None:
            self.rates = rates
        if success is not None:
            self.success = success

    @property
    def inverse(self):
        """Gets the inverse of this GetCustomExchangeRatesType.  # noqa: E501

        - If `true`, the exchange rate in the response is an inverse exchange rate. - If `false`, the exchange rate in the response is not an inverse exchange rate. The value is determined by the **Use inverse rate** checkbox in your Zuora Finance Manage Currency Conversion settings.   # noqa: E501

        :return: The inverse of this GetCustomExchangeRatesType.  # noqa: E501
        :rtype: bool
        """
        return self._inverse

    @inverse.setter
    def inverse(self, inverse):
        """Sets the inverse of this GetCustomExchangeRatesType.

        - If `true`, the exchange rate in the response is an inverse exchange rate. - If `false`, the exchange rate in the response is not an inverse exchange rate. The value is determined by the **Use inverse rate** checkbox in your Zuora Finance Manage Currency Conversion settings.   # noqa: E501

        :param inverse: The inverse of this GetCustomExchangeRatesType.  # noqa: E501
        :type: bool
        """

        self._inverse = inverse

    @property
    def rates(self):
        """Gets the rates of this GetCustomExchangeRatesType.  # noqa: E501

        Container for exchange rate data. Contains a set of fields that provide exchange rate data for each day between the specified `startDate` and `endDate` (inclusive).    # noqa: E501

        :return: The rates of this GetCustomExchangeRatesType.  # noqa: E501
        :rtype: list[GetCustomExchangeRatesDataType]
        """
        return self._rates

    @rates.setter
    def rates(self, rates):
        """Sets the rates of this GetCustomExchangeRatesType.

        Container for exchange rate data. Contains a set of fields that provide exchange rate data for each day between the specified `startDate` and `endDate` (inclusive).    # noqa: E501

        :param rates: The rates of this GetCustomExchangeRatesType.  # noqa: E501
        :type: list[GetCustomExchangeRatesDataType]
        """

        self._rates = rates

    @property
    def success(self):
        """Gets the success of this GetCustomExchangeRatesType.  # noqa: E501

        Returns `true` if the request was processed successfully.   # noqa: E501

        :return: The success of this GetCustomExchangeRatesType.  # noqa: E501
        :rtype: bool
        """
        return self._success

    @success.setter
    def success(self, success):
        """Sets the success of this GetCustomExchangeRatesType.

        Returns `true` if the request was processed successfully.   # noqa: E501

        :param success: The success of this GetCustomExchangeRatesType.  # noqa: E501
        :type: bool
        """

        self._success = success

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(GetCustomExchangeRatesType, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, GetCustomExchangeRatesType):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
