# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).  # noqa: E501

    OpenAPI spec version: 2024-05-20
    Contact: docs@zuora.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class GetDebitMemoItemFinanceInformation(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'deferred_revenue_accounting_code': 'str',
        'deferred_revenue_accounting_code_type': 'str',
        'recognized_revenue_accounting_code': 'str',
        'recognized_revenue_accounting_code_type': 'str',
        'revenue_recognition_rule_name': 'str',
        'revenue_schedule_number': 'str'
    }

    attribute_map = {
        'deferred_revenue_accounting_code': 'deferredRevenueAccountingCode',
        'deferred_revenue_accounting_code_type': 'deferredRevenueAccountingCodeType',
        'recognized_revenue_accounting_code': 'recognizedRevenueAccountingCode',
        'recognized_revenue_accounting_code_type': 'recognizedRevenueAccountingCodeType',
        'revenue_recognition_rule_name': 'revenueRecognitionRuleName',
        'revenue_schedule_number': 'revenueScheduleNumber'
    }

    def __init__(self, deferred_revenue_accounting_code=None, deferred_revenue_accounting_code_type=None, recognized_revenue_accounting_code=None, recognized_revenue_accounting_code_type=None, revenue_recognition_rule_name=None, revenue_schedule_number=None):  # noqa: E501
        """GetDebitMemoItemFinanceInformation - a model defined in Swagger"""  # noqa: E501
        self._deferred_revenue_accounting_code = None
        self._deferred_revenue_accounting_code_type = None
        self._recognized_revenue_accounting_code = None
        self._recognized_revenue_accounting_code_type = None
        self._revenue_recognition_rule_name = None
        self._revenue_schedule_number = None
        self.discriminator = None
        if deferred_revenue_accounting_code is not None:
            self.deferred_revenue_accounting_code = deferred_revenue_accounting_code
        if deferred_revenue_accounting_code_type is not None:
            self.deferred_revenue_accounting_code_type = deferred_revenue_accounting_code_type
        if recognized_revenue_accounting_code is not None:
            self.recognized_revenue_accounting_code = recognized_revenue_accounting_code
        if recognized_revenue_accounting_code_type is not None:
            self.recognized_revenue_accounting_code_type = recognized_revenue_accounting_code_type
        if revenue_recognition_rule_name is not None:
            self.revenue_recognition_rule_name = revenue_recognition_rule_name
        if revenue_schedule_number is not None:
            self.revenue_schedule_number = revenue_schedule_number

    @property
    def deferred_revenue_accounting_code(self):
        """Gets the deferred_revenue_accounting_code of this GetDebitMemoItemFinanceInformation.  # noqa: E501

        The accounting code for the deferred revenue, such as Monthly Recurring Liability.   # noqa: E501

        :return: The deferred_revenue_accounting_code of this GetDebitMemoItemFinanceInformation.  # noqa: E501
        :rtype: str
        """
        return self._deferred_revenue_accounting_code

    @deferred_revenue_accounting_code.setter
    def deferred_revenue_accounting_code(self, deferred_revenue_accounting_code):
        """Sets the deferred_revenue_accounting_code of this GetDebitMemoItemFinanceInformation.

        The accounting code for the deferred revenue, such as Monthly Recurring Liability.   # noqa: E501

        :param deferred_revenue_accounting_code: The deferred_revenue_accounting_code of this GetDebitMemoItemFinanceInformation.  # noqa: E501
        :type: str
        """

        self._deferred_revenue_accounting_code = deferred_revenue_accounting_code

    @property
    def deferred_revenue_accounting_code_type(self):
        """Gets the deferred_revenue_accounting_code_type of this GetDebitMemoItemFinanceInformation.  # noqa: E501

        The type of the deferred revenue accounting code, such as Deferred Revenue.   # noqa: E501

        :return: The deferred_revenue_accounting_code_type of this GetDebitMemoItemFinanceInformation.  # noqa: E501
        :rtype: str
        """
        return self._deferred_revenue_accounting_code_type

    @deferred_revenue_accounting_code_type.setter
    def deferred_revenue_accounting_code_type(self, deferred_revenue_accounting_code_type):
        """Sets the deferred_revenue_accounting_code_type of this GetDebitMemoItemFinanceInformation.

        The type of the deferred revenue accounting code, such as Deferred Revenue.   # noqa: E501

        :param deferred_revenue_accounting_code_type: The deferred_revenue_accounting_code_type of this GetDebitMemoItemFinanceInformation.  # noqa: E501
        :type: str
        """

        self._deferred_revenue_accounting_code_type = deferred_revenue_accounting_code_type

    @property
    def recognized_revenue_accounting_code(self):
        """Gets the recognized_revenue_accounting_code of this GetDebitMemoItemFinanceInformation.  # noqa: E501

        The accounting code for the recognized revenue, such as Monthly Recurring Charges or Overage Charges.   # noqa: E501

        :return: The recognized_revenue_accounting_code of this GetDebitMemoItemFinanceInformation.  # noqa: E501
        :rtype: str
        """
        return self._recognized_revenue_accounting_code

    @recognized_revenue_accounting_code.setter
    def recognized_revenue_accounting_code(self, recognized_revenue_accounting_code):
        """Sets the recognized_revenue_accounting_code of this GetDebitMemoItemFinanceInformation.

        The accounting code for the recognized revenue, such as Monthly Recurring Charges or Overage Charges.   # noqa: E501

        :param recognized_revenue_accounting_code: The recognized_revenue_accounting_code of this GetDebitMemoItemFinanceInformation.  # noqa: E501
        :type: str
        """

        self._recognized_revenue_accounting_code = recognized_revenue_accounting_code

    @property
    def recognized_revenue_accounting_code_type(self):
        """Gets the recognized_revenue_accounting_code_type of this GetDebitMemoItemFinanceInformation.  # noqa: E501

        The type of the recognized revenue accounting code, such as Sales Revenue or Sales Discount.   # noqa: E501

        :return: The recognized_revenue_accounting_code_type of this GetDebitMemoItemFinanceInformation.  # noqa: E501
        :rtype: str
        """
        return self._recognized_revenue_accounting_code_type

    @recognized_revenue_accounting_code_type.setter
    def recognized_revenue_accounting_code_type(self, recognized_revenue_accounting_code_type):
        """Sets the recognized_revenue_accounting_code_type of this GetDebitMemoItemFinanceInformation.

        The type of the recognized revenue accounting code, such as Sales Revenue or Sales Discount.   # noqa: E501

        :param recognized_revenue_accounting_code_type: The recognized_revenue_accounting_code_type of this GetDebitMemoItemFinanceInformation.  # noqa: E501
        :type: str
        """

        self._recognized_revenue_accounting_code_type = recognized_revenue_accounting_code_type

    @property
    def revenue_recognition_rule_name(self):
        """Gets the revenue_recognition_rule_name of this GetDebitMemoItemFinanceInformation.  # noqa: E501

        The name of the revenue recognition rule governing the revenue schedule.   # noqa: E501

        :return: The revenue_recognition_rule_name of this GetDebitMemoItemFinanceInformation.  # noqa: E501
        :rtype: str
        """
        return self._revenue_recognition_rule_name

    @revenue_recognition_rule_name.setter
    def revenue_recognition_rule_name(self, revenue_recognition_rule_name):
        """Sets the revenue_recognition_rule_name of this GetDebitMemoItemFinanceInformation.

        The name of the revenue recognition rule governing the revenue schedule.   # noqa: E501

        :param revenue_recognition_rule_name: The revenue_recognition_rule_name of this GetDebitMemoItemFinanceInformation.  # noqa: E501
        :type: str
        """

        self._revenue_recognition_rule_name = revenue_recognition_rule_name

    @property
    def revenue_schedule_number(self):
        """Gets the revenue_schedule_number of this GetDebitMemoItemFinanceInformation.  # noqa: E501

        The revenue schedule number. The revenue schedule number is always prefixed with \"RS\", for example, RS-00000001.   # noqa: E501

        :return: The revenue_schedule_number of this GetDebitMemoItemFinanceInformation.  # noqa: E501
        :rtype: str
        """
        return self._revenue_schedule_number

    @revenue_schedule_number.setter
    def revenue_schedule_number(self, revenue_schedule_number):
        """Sets the revenue_schedule_number of this GetDebitMemoItemFinanceInformation.

        The revenue schedule number. The revenue schedule number is always prefixed with \"RS\", for example, RS-00000001.   # noqa: E501

        :param revenue_schedule_number: The revenue_schedule_number of this GetDebitMemoItemFinanceInformation.  # noqa: E501
        :type: str
        """

        self._revenue_schedule_number = revenue_schedule_number

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(GetDebitMemoItemFinanceInformation, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, GetDebitMemoItemFinanceInformation):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
