# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).  # noqa: E501

    OpenAPI spec version: 2024-05-20
    Contact: docs@zuora.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class GetInvoicePdfStatusBatchResponse(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'invoice_files': 'list[GetInvoicePdfStatusResponse]',
        'success': 'bool'
    }

    attribute_map = {
        'invoice_files': 'invoiceFiles',
        'success': 'success'
    }

    def __init__(self, invoice_files=None, success=None):  # noqa: E501
        """GetInvoicePdfStatusBatchResponse - a model defined in Swagger"""  # noqa: E501
        self._invoice_files = None
        self._success = None
        self.discriminator = None
        if invoice_files is not None:
            self.invoice_files = invoice_files
        if success is not None:
            self.success = success

    @property
    def invoice_files(self):
        """Gets the invoice_files of this GetInvoicePdfStatusBatchResponse.  # noqa: E501

        Array of invoice PDF statuses requested.   # noqa: E501

        :return: The invoice_files of this GetInvoicePdfStatusBatchResponse.  # noqa: E501
        :rtype: list[GetInvoicePdfStatusResponse]
        """
        return self._invoice_files

    @invoice_files.setter
    def invoice_files(self, invoice_files):
        """Sets the invoice_files of this GetInvoicePdfStatusBatchResponse.

        Array of invoice PDF statuses requested.   # noqa: E501

        :param invoice_files: The invoice_files of this GetInvoicePdfStatusBatchResponse.  # noqa: E501
        :type: list[GetInvoicePdfStatusResponse]
        """

        self._invoice_files = invoice_files

    @property
    def success(self):
        """Gets the success of this GetInvoicePdfStatusBatchResponse.  # noqa: E501

        Indicates whether the call succeeded.   # noqa: E501

        :return: The success of this GetInvoicePdfStatusBatchResponse.  # noqa: E501
        :rtype: bool
        """
        return self._success

    @success.setter
    def success(self, success):
        """Sets the success of this GetInvoicePdfStatusBatchResponse.

        Indicates whether the call succeeded.   # noqa: E501

        :param success: The success of this GetInvoicePdfStatusBatchResponse.  # noqa: E501
        :type: bool
        """

        self._success = success

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(GetInvoicePdfStatusBatchResponse, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, GetInvoicePdfStatusBatchResponse):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
