# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).  # noqa: E501

    OpenAPI spec version: 2024-05-20
    Contact: docs@zuora.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six
from zuora_sdk.models.common_response import CommonResponse  # noqa: F401,E501

class GetMetricsBySubscriptionNumbersResponse(CommonResponse):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'subscription_metrics': 'list[SubscriptionMetrics]'
    }
    if hasattr(CommonResponse, "swagger_types"):
        swagger_types.update(CommonResponse.swagger_types)

    attribute_map = {
        'subscription_metrics': 'subscriptionMetrics'
    }
    if hasattr(CommonResponse, "attribute_map"):
        attribute_map.update(CommonResponse.attribute_map)

    def __init__(self, subscription_metrics=None, *args, **kwargs):  # noqa: E501
        """GetMetricsBySubscriptionNumbersResponse - a model defined in Swagger"""  # noqa: E501
        self._subscription_metrics = None
        self.discriminator = None
        if subscription_metrics is not None:
            self.subscription_metrics = subscription_metrics
        CommonResponse.__init__(self, *args, **kwargs)

    @property
    def subscription_metrics(self):
        """Gets the subscription_metrics of this GetMetricsBySubscriptionNumbersResponse.  # noqa: E501


        :return: The subscription_metrics of this GetMetricsBySubscriptionNumbersResponse.  # noqa: E501
        :rtype: list[SubscriptionMetrics]
        """
        return self._subscription_metrics

    @subscription_metrics.setter
    def subscription_metrics(self, subscription_metrics):
        """Sets the subscription_metrics of this GetMetricsBySubscriptionNumbersResponse.


        :param subscription_metrics: The subscription_metrics of this GetMetricsBySubscriptionNumbersResponse.  # noqa: E501
        :type: list[SubscriptionMetrics]
        """

        self._subscription_metrics = subscription_metrics

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(GetMetricsBySubscriptionNumbersResponse, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, GetMetricsBySubscriptionNumbersResponse):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
