# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).  # noqa: E501

    OpenAPI spec version: 2024-05-20
    Contact: docs@zuora.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class GetPMAccountHolderInfo(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'account_holder_name': 'str',
        'address_line1': 'str',
        'address_line2': 'str',
        'city': 'str',
        'country': 'str',
        'email': 'str',
        'phone': 'str',
        'state': 'str',
        'zip_code': 'str'
    }

    attribute_map = {
        'account_holder_name': 'accountHolderName',
        'address_line1': 'addressLine1',
        'address_line2': 'addressLine2',
        'city': 'city',
        'country': 'country',
        'email': 'email',
        'phone': 'phone',
        'state': 'state',
        'zip_code': 'zipCode'
    }

    def __init__(self, account_holder_name=None, address_line1=None, address_line2=None, city=None, country=None, email=None, phone=None, state=None, zip_code=None):  # noqa: E501
        """GetPMAccountHolderInfo - a model defined in Swagger"""  # noqa: E501
        self._account_holder_name = None
        self._address_line1 = None
        self._address_line2 = None
        self._city = None
        self._country = None
        self._email = None
        self._phone = None
        self._state = None
        self._zip_code = None
        self.discriminator = None
        if account_holder_name is not None:
            self.account_holder_name = account_holder_name
        if address_line1 is not None:
            self.address_line1 = address_line1
        if address_line2 is not None:
            self.address_line2 = address_line2
        if city is not None:
            self.city = city
        if country is not None:
            self.country = country
        if email is not None:
            self.email = email
        if phone is not None:
            self.phone = phone
        if state is not None:
            self.state = state
        if zip_code is not None:
            self.zip_code = zip_code

    @property
    def account_holder_name(self):
        """Gets the account_holder_name of this GetPMAccountHolderInfo.  # noqa: E501

        The full name of the account holder.   # noqa: E501

        :return: The account_holder_name of this GetPMAccountHolderInfo.  # noqa: E501
        :rtype: str
        """
        return self._account_holder_name

    @account_holder_name.setter
    def account_holder_name(self, account_holder_name):
        """Sets the account_holder_name of this GetPMAccountHolderInfo.

        The full name of the account holder.   # noqa: E501

        :param account_holder_name: The account_holder_name of this GetPMAccountHolderInfo.  # noqa: E501
        :type: str
        """

        self._account_holder_name = account_holder_name

    @property
    def address_line1(self):
        """Gets the address_line1 of this GetPMAccountHolderInfo.  # noqa: E501

        The first line of the address for the account holder.   # noqa: E501

        :return: The address_line1 of this GetPMAccountHolderInfo.  # noqa: E501
        :rtype: str
        """
        return self._address_line1

    @address_line1.setter
    def address_line1(self, address_line1):
        """Sets the address_line1 of this GetPMAccountHolderInfo.

        The first line of the address for the account holder.   # noqa: E501

        :param address_line1: The address_line1 of this GetPMAccountHolderInfo.  # noqa: E501
        :type: str
        """

        self._address_line1 = address_line1

    @property
    def address_line2(self):
        """Gets the address_line2 of this GetPMAccountHolderInfo.  # noqa: E501

        The second line of the address for the account holder.    # noqa: E501

        :return: The address_line2 of this GetPMAccountHolderInfo.  # noqa: E501
        :rtype: str
        """
        return self._address_line2

    @address_line2.setter
    def address_line2(self, address_line2):
        """Sets the address_line2 of this GetPMAccountHolderInfo.

        The second line of the address for the account holder.    # noqa: E501

        :param address_line2: The address_line2 of this GetPMAccountHolderInfo.  # noqa: E501
        :type: str
        """

        self._address_line2 = address_line2

    @property
    def city(self):
        """Gets the city of this GetPMAccountHolderInfo.  # noqa: E501

        The city where the account holder stays.   # noqa: E501

        :return: The city of this GetPMAccountHolderInfo.  # noqa: E501
        :rtype: str
        """
        return self._city

    @city.setter
    def city(self, city):
        """Sets the city of this GetPMAccountHolderInfo.

        The city where the account holder stays.   # noqa: E501

        :param city: The city of this GetPMAccountHolderInfo.  # noqa: E501
        :type: str
        """

        self._city = city

    @property
    def country(self):
        """Gets the country of this GetPMAccountHolderInfo.  # noqa: E501

        The country where the account holder stays.  When creating a payment method through a translated UI or Payment Page, a country name in a translated language might be selected. Regardless of the country texts selected when creating the payment method, only the country name listed in [Country Names and Their ISO Standard 2- and 3-Digit Codes](https://knowledgecenter.zuora.com/BB_Introducing_Z_Business/D_Country%2C_State%2C_and_Province_Codes/A_Country_Names_and_Their_ISO_Codes) returns in this field. Internationalization is not supported for the API field value.   # noqa: E501

        :return: The country of this GetPMAccountHolderInfo.  # noqa: E501
        :rtype: str
        """
        return self._country

    @country.setter
    def country(self, country):
        """Sets the country of this GetPMAccountHolderInfo.

        The country where the account holder stays.  When creating a payment method through a translated UI or Payment Page, a country name in a translated language might be selected. Regardless of the country texts selected when creating the payment method, only the country name listed in [Country Names and Their ISO Standard 2- and 3-Digit Codes](https://knowledgecenter.zuora.com/BB_Introducing_Z_Business/D_Country%2C_State%2C_and_Province_Codes/A_Country_Names_and_Their_ISO_Codes) returns in this field. Internationalization is not supported for the API field value.   # noqa: E501

        :param country: The country of this GetPMAccountHolderInfo.  # noqa: E501
        :type: str
        """

        self._country = country

    @property
    def email(self):
        """Gets the email of this GetPMAccountHolderInfo.  # noqa: E501

        The email address of the account holder.   # noqa: E501

        :return: The email of this GetPMAccountHolderInfo.  # noqa: E501
        :rtype: str
        """
        return self._email

    @email.setter
    def email(self, email):
        """Sets the email of this GetPMAccountHolderInfo.

        The email address of the account holder.   # noqa: E501

        :param email: The email of this GetPMAccountHolderInfo.  # noqa: E501
        :type: str
        """

        self._email = email

    @property
    def phone(self):
        """Gets the phone of this GetPMAccountHolderInfo.  # noqa: E501

        The phone number of the account holder.   # noqa: E501

        :return: The phone of this GetPMAccountHolderInfo.  # noqa: E501
        :rtype: str
        """
        return self._phone

    @phone.setter
    def phone(self, phone):
        """Sets the phone of this GetPMAccountHolderInfo.

        The phone number of the account holder.   # noqa: E501

        :param phone: The phone of this GetPMAccountHolderInfo.  # noqa: E501
        :type: str
        """

        self._phone = phone

    @property
    def state(self):
        """Gets the state of this GetPMAccountHolderInfo.  # noqa: E501

        The state where the account holder stays.   # noqa: E501

        :return: The state of this GetPMAccountHolderInfo.  # noqa: E501
        :rtype: str
        """
        return self._state

    @state.setter
    def state(self, state):
        """Sets the state of this GetPMAccountHolderInfo.

        The state where the account holder stays.   # noqa: E501

        :param state: The state of this GetPMAccountHolderInfo.  # noqa: E501
        :type: str
        """

        self._state = state

    @property
    def zip_code(self):
        """Gets the zip_code of this GetPMAccountHolderInfo.  # noqa: E501

        The zip code for the address of the account holder.   # noqa: E501

        :return: The zip_code of this GetPMAccountHolderInfo.  # noqa: E501
        :rtype: str
        """
        return self._zip_code

    @zip_code.setter
    def zip_code(self, zip_code):
        """Sets the zip_code of this GetPMAccountHolderInfo.

        The zip code for the address of the account holder.   # noqa: E501

        :param zip_code: The zip_code of this GetPMAccountHolderInfo.  # noqa: E501
        :type: str
        """

        self._zip_code = zip_code

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(GetPMAccountHolderInfo, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, GetPMAccountHolderInfo):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
