# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).  # noqa: E501

    OpenAPI spec version: 2024-05-20
    Contact: docs@zuora.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class GetPublicNotificationDefinitionResponse(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'active': 'bool',
        'associated_account': 'str',
        'callout': 'GetPublicNotificationDefinitionResponseCallout',
        'callout_active': 'bool',
        'communication_profile_id': 'str',
        'created_by': 'str',
        'created_on': 'str',
        'description': 'str',
        'email_active': 'bool',
        'email_template_id': 'str',
        'event_type_name': 'str',
        'event_type_namespace': 'str',
        'filter_rule': 'GetPublicNotificationDefinitionResponseFilterRule',
        'filter_rule_params': 'dict(str, str)',
        'id': 'str',
        'name': 'str',
        'updated_by': 'str',
        'updated_on': 'str'
    }

    attribute_map = {
        'active': 'active',
        'associated_account': 'associatedAccount',
        'callout': 'callout',
        'callout_active': 'calloutActive',
        'communication_profile_id': 'communicationProfileId',
        'created_by': 'createdBy',
        'created_on': 'createdOn',
        'description': 'description',
        'email_active': 'emailActive',
        'email_template_id': 'emailTemplateId',
        'event_type_name': 'eventTypeName',
        'event_type_namespace': 'eventTypeNamespace',
        'filter_rule': 'filterRule',
        'filter_rule_params': 'filterRuleParams',
        'id': 'id',
        'name': 'name',
        'updated_by': 'updatedBy',
        'updated_on': 'updatedOn'
    }

    def __init__(self, active=None, associated_account=None, callout=None, callout_active=None, communication_profile_id=None, created_by=None, created_on=None, description=None, email_active=None, email_template_id=None, event_type_name=None, event_type_namespace=None, filter_rule=None, filter_rule_params=None, id=None, name=None, updated_by=None, updated_on=None):  # noqa: E501
        """GetPublicNotificationDefinitionResponse - a model defined in Swagger"""  # noqa: E501
        self._active = None
        self._associated_account = None
        self._callout = None
        self._callout_active = None
        self._communication_profile_id = None
        self._created_by = None
        self._created_on = None
        self._description = None
        self._email_active = None
        self._email_template_id = None
        self._event_type_name = None
        self._event_type_namespace = None
        self._filter_rule = None
        self._filter_rule_params = None
        self._id = None
        self._name = None
        self._updated_by = None
        self._updated_on = None
        self.discriminator = None
        if active is not None:
            self.active = active
        if associated_account is not None:
            self.associated_account = associated_account
        if callout is not None:
            self.callout = callout
        if callout_active is not None:
            self.callout_active = callout_active
        if communication_profile_id is not None:
            self.communication_profile_id = communication_profile_id
        if created_by is not None:
            self.created_by = created_by
        if created_on is not None:
            self.created_on = created_on
        if description is not None:
            self.description = description
        if email_active is not None:
            self.email_active = email_active
        if email_template_id is not None:
            self.email_template_id = email_template_id
        if event_type_name is not None:
            self.event_type_name = event_type_name
        if event_type_namespace is not None:
            self.event_type_namespace = event_type_namespace
        if filter_rule is not None:
            self.filter_rule = filter_rule
        if filter_rule_params is not None:
            self.filter_rule_params = filter_rule_params
        if id is not None:
            self.id = id
        if name is not None:
            self.name = name
        if updated_by is not None:
            self.updated_by = updated_by
        if updated_on is not None:
            self.updated_on = updated_on

    @property
    def active(self):
        """Gets the active of this GetPublicNotificationDefinitionResponse.  # noqa: E501

        The status of the notification definition. The default value is `true`.  # noqa: E501

        :return: The active of this GetPublicNotificationDefinitionResponse.  # noqa: E501
        :rtype: bool
        """
        return self._active

    @active.setter
    def active(self, active):
        """Sets the active of this GetPublicNotificationDefinitionResponse.

        The status of the notification definition. The default value is `true`.  # noqa: E501

        :param active: The active of this GetPublicNotificationDefinitionResponse.  # noqa: E501
        :type: bool
        """

        self._active = active

    @property
    def associated_account(self):
        """Gets the associated_account of this GetPublicNotificationDefinitionResponse.  # noqa: E501

        Indicates with which type of account this notification is associated.   # noqa: E501

        :return: The associated_account of this GetPublicNotificationDefinitionResponse.  # noqa: E501
        :rtype: str
        """
        return self._associated_account

    @associated_account.setter
    def associated_account(self, associated_account):
        """Sets the associated_account of this GetPublicNotificationDefinitionResponse.

        Indicates with which type of account this notification is associated.   # noqa: E501

        :param associated_account: The associated_account of this GetPublicNotificationDefinitionResponse.  # noqa: E501
        :type: str
        """

        self._associated_account = associated_account

    @property
    def callout(self):
        """Gets the callout of this GetPublicNotificationDefinitionResponse.  # noqa: E501


        :return: The callout of this GetPublicNotificationDefinitionResponse.  # noqa: E501
        :rtype: GetPublicNotificationDefinitionResponseCallout
        """
        return self._callout

    @callout.setter
    def callout(self, callout):
        """Sets the callout of this GetPublicNotificationDefinitionResponse.


        :param callout: The callout of this GetPublicNotificationDefinitionResponse.  # noqa: E501
        :type: GetPublicNotificationDefinitionResponseCallout
        """

        self._callout = callout

    @property
    def callout_active(self):
        """Gets the callout_active of this GetPublicNotificationDefinitionResponse.  # noqa: E501

        The status of the callout action. The default value is `false`.  # noqa: E501

        :return: The callout_active of this GetPublicNotificationDefinitionResponse.  # noqa: E501
        :rtype: bool
        """
        return self._callout_active

    @callout_active.setter
    def callout_active(self, callout_active):
        """Sets the callout_active of this GetPublicNotificationDefinitionResponse.

        The status of the callout action. The default value is `false`.  # noqa: E501

        :param callout_active: The callout_active of this GetPublicNotificationDefinitionResponse.  # noqa: E501
        :type: bool
        """

        self._callout_active = callout_active

    @property
    def communication_profile_id(self):
        """Gets the communication_profile_id of this GetPublicNotificationDefinitionResponse.  # noqa: E501

        The profile that the notification definition belongs to.  # noqa: E501

        :return: The communication_profile_id of this GetPublicNotificationDefinitionResponse.  # noqa: E501
        :rtype: str
        """
        return self._communication_profile_id

    @communication_profile_id.setter
    def communication_profile_id(self, communication_profile_id):
        """Sets the communication_profile_id of this GetPublicNotificationDefinitionResponse.

        The profile that the notification definition belongs to.  # noqa: E501

        :param communication_profile_id: The communication_profile_id of this GetPublicNotificationDefinitionResponse.  # noqa: E501
        :type: str
        """

        self._communication_profile_id = communication_profile_id

    @property
    def created_by(self):
        """Gets the created_by of this GetPublicNotificationDefinitionResponse.  # noqa: E501

        The ID of the user who created the notification definition.  # noqa: E501

        :return: The created_by of this GetPublicNotificationDefinitionResponse.  # noqa: E501
        :rtype: str
        """
        return self._created_by

    @created_by.setter
    def created_by(self, created_by):
        """Sets the created_by of this GetPublicNotificationDefinitionResponse.

        The ID of the user who created the notification definition.  # noqa: E501

        :param created_by: The created_by of this GetPublicNotificationDefinitionResponse.  # noqa: E501
        :type: str
        """

        self._created_by = created_by

    @property
    def created_on(self):
        """Gets the created_on of this GetPublicNotificationDefinitionResponse.  # noqa: E501

        The time when the notification definition was created. Specified in the UTC timezone in the ISO860 format (YYYY-MM-DDThh:mm:ss.sTZD). E.g. 1997-07-16T19:20:30.45+00:00  # noqa: E501

        :return: The created_on of this GetPublicNotificationDefinitionResponse.  # noqa: E501
        :rtype: str
        """
        return self._created_on

    @created_on.setter
    def created_on(self, created_on):
        """Sets the created_on of this GetPublicNotificationDefinitionResponse.

        The time when the notification definition was created. Specified in the UTC timezone in the ISO860 format (YYYY-MM-DDThh:mm:ss.sTZD). E.g. 1997-07-16T19:20:30.45+00:00  # noqa: E501

        :param created_on: The created_on of this GetPublicNotificationDefinitionResponse.  # noqa: E501
        :type: str
        """

        self._created_on = created_on

    @property
    def description(self):
        """Gets the description of this GetPublicNotificationDefinitionResponse.  # noqa: E501

        Description of the notification definition  # noqa: E501

        :return: The description of this GetPublicNotificationDefinitionResponse.  # noqa: E501
        :rtype: str
        """
        return self._description

    @description.setter
    def description(self, description):
        """Sets the description of this GetPublicNotificationDefinitionResponse.

        Description of the notification definition  # noqa: E501

        :param description: The description of this GetPublicNotificationDefinitionResponse.  # noqa: E501
        :type: str
        """

        self._description = description

    @property
    def email_active(self):
        """Gets the email_active of this GetPublicNotificationDefinitionResponse.  # noqa: E501

        The status of the email action. The default value is `false`.  # noqa: E501

        :return: The email_active of this GetPublicNotificationDefinitionResponse.  # noqa: E501
        :rtype: bool
        """
        return self._email_active

    @email_active.setter
    def email_active(self, email_active):
        """Sets the email_active of this GetPublicNotificationDefinitionResponse.

        The status of the email action. The default value is `false`.  # noqa: E501

        :param email_active: The email_active of this GetPublicNotificationDefinitionResponse.  # noqa: E501
        :type: bool
        """

        self._email_active = email_active

    @property
    def email_template_id(self):
        """Gets the email_template_id of this GetPublicNotificationDefinitionResponse.  # noqa: E501

        The ID of the email template. In the request, there should be at least one email template or callout.  # noqa: E501

        :return: The email_template_id of this GetPublicNotificationDefinitionResponse.  # noqa: E501
        :rtype: str
        """
        return self._email_template_id

    @email_template_id.setter
    def email_template_id(self, email_template_id):
        """Sets the email_template_id of this GetPublicNotificationDefinitionResponse.

        The ID of the email template. In the request, there should be at least one email template or callout.  # noqa: E501

        :param email_template_id: The email_template_id of this GetPublicNotificationDefinitionResponse.  # noqa: E501
        :type: str
        """

        self._email_template_id = email_template_id

    @property
    def event_type_name(self):
        """Gets the event_type_name of this GetPublicNotificationDefinitionResponse.  # noqa: E501

        The name of the event type.  # noqa: E501

        :return: The event_type_name of this GetPublicNotificationDefinitionResponse.  # noqa: E501
        :rtype: str
        """
        return self._event_type_name

    @event_type_name.setter
    def event_type_name(self, event_type_name):
        """Sets the event_type_name of this GetPublicNotificationDefinitionResponse.

        The name of the event type.  # noqa: E501

        :param event_type_name: The event_type_name of this GetPublicNotificationDefinitionResponse.  # noqa: E501
        :type: str
        """

        self._event_type_name = event_type_name

    @property
    def event_type_namespace(self):
        """Gets the event_type_namespace of this GetPublicNotificationDefinitionResponse.  # noqa: E501

        The namespace of the `eventTypeName` field.    # noqa: E501

        :return: The event_type_namespace of this GetPublicNotificationDefinitionResponse.  # noqa: E501
        :rtype: str
        """
        return self._event_type_namespace

    @event_type_namespace.setter
    def event_type_namespace(self, event_type_namespace):
        """Sets the event_type_namespace of this GetPublicNotificationDefinitionResponse.

        The namespace of the `eventTypeName` field.    # noqa: E501

        :param event_type_namespace: The event_type_namespace of this GetPublicNotificationDefinitionResponse.  # noqa: E501
        :type: str
        """

        self._event_type_namespace = event_type_namespace

    @property
    def filter_rule(self):
        """Gets the filter_rule of this GetPublicNotificationDefinitionResponse.  # noqa: E501


        :return: The filter_rule of this GetPublicNotificationDefinitionResponse.  # noqa: E501
        :rtype: GetPublicNotificationDefinitionResponseFilterRule
        """
        return self._filter_rule

    @filter_rule.setter
    def filter_rule(self, filter_rule):
        """Sets the filter_rule of this GetPublicNotificationDefinitionResponse.


        :param filter_rule: The filter_rule of this GetPublicNotificationDefinitionResponse.  # noqa: E501
        :type: GetPublicNotificationDefinitionResponseFilterRule
        """

        self._filter_rule = filter_rule

    @property
    def filter_rule_params(self):
        """Gets the filter_rule_params of this GetPublicNotificationDefinitionResponse.  # noqa: E501

        The parameter values used to configure the filter rule.   # noqa: E501

        :return: The filter_rule_params of this GetPublicNotificationDefinitionResponse.  # noqa: E501
        :rtype: dict(str, str)
        """
        return self._filter_rule_params

    @filter_rule_params.setter
    def filter_rule_params(self, filter_rule_params):
        """Sets the filter_rule_params of this GetPublicNotificationDefinitionResponse.

        The parameter values used to configure the filter rule.   # noqa: E501

        :param filter_rule_params: The filter_rule_params of this GetPublicNotificationDefinitionResponse.  # noqa: E501
        :type: dict(str, str)
        """

        self._filter_rule_params = filter_rule_params

    @property
    def id(self):
        """Gets the id of this GetPublicNotificationDefinitionResponse.  # noqa: E501

        The ID associated with this notification definition.  # noqa: E501

        :return: The id of this GetPublicNotificationDefinitionResponse.  # noqa: E501
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this GetPublicNotificationDefinitionResponse.

        The ID associated with this notification definition.  # noqa: E501

        :param id: The id of this GetPublicNotificationDefinitionResponse.  # noqa: E501
        :type: str
        """

        self._id = id

    @property
    def name(self):
        """Gets the name of this GetPublicNotificationDefinitionResponse.  # noqa: E501

        The name of the notification definition.  # noqa: E501

        :return: The name of this GetPublicNotificationDefinitionResponse.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this GetPublicNotificationDefinitionResponse.

        The name of the notification definition.  # noqa: E501

        :param name: The name of this GetPublicNotificationDefinitionResponse.  # noqa: E501
        :type: str
        """

        self._name = name

    @property
    def updated_by(self):
        """Gets the updated_by of this GetPublicNotificationDefinitionResponse.  # noqa: E501

        The ID of the user who updated the notification definition.  # noqa: E501

        :return: The updated_by of this GetPublicNotificationDefinitionResponse.  # noqa: E501
        :rtype: str
        """
        return self._updated_by

    @updated_by.setter
    def updated_by(self, updated_by):
        """Sets the updated_by of this GetPublicNotificationDefinitionResponse.

        The ID of the user who updated the notification definition.  # noqa: E501

        :param updated_by: The updated_by of this GetPublicNotificationDefinitionResponse.  # noqa: E501
        :type: str
        """

        self._updated_by = updated_by

    @property
    def updated_on(self):
        """Gets the updated_on of this GetPublicNotificationDefinitionResponse.  # noqa: E501

        The time when the notification was updated. Specified in the UTC timezone in the ISO860 format (YYYY-MM-DDThh:mm:ss.sTZD). E.g. 1997-07-16T19:20:30.45+00:00  # noqa: E501

        :return: The updated_on of this GetPublicNotificationDefinitionResponse.  # noqa: E501
        :rtype: str
        """
        return self._updated_on

    @updated_on.setter
    def updated_on(self, updated_on):
        """Sets the updated_on of this GetPublicNotificationDefinitionResponse.

        The time when the notification was updated. Specified in the UTC timezone in the ISO860 format (YYYY-MM-DDThh:mm:ss.sTZD). E.g. 1997-07-16T19:20:30.45+00:00  # noqa: E501

        :param updated_on: The updated_on of this GetPublicNotificationDefinitionResponse.  # noqa: E501
        :type: str
        """

        self._updated_on = updated_on

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(GetPublicNotificationDefinitionResponse, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, GetPublicNotificationDefinitionResponse):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
