# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).  # noqa: E501

    OpenAPI spec version: 2024-05-20
    Contact: docs@zuora.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class GetSubscriptionRatePlan(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'id': 'str',
        'subscription_rate_plan_number': 'str',
        'is_from_external_catalog': 'bool',
        'last_change_type': 'str',
        'product_id': 'str',
        'product_name': 'str',
        'product_sku': 'str',
        'product_rate_plan_id': 'str',
        'product_rate_plan_number': 'str',
        'rate_plan_name': 'str',
        'subscription_product_features': 'list[SubscriptionProductFeature]',
        'externally_managed_plan_id': 'str',
        'contracted_mrr': 'float',
        'contracted_net_mrr': 'float',
        'as_of_day_gross_mrr': 'float',
        'as_of_day_net_mrr': 'float',
        'rate_plan_charges': 'list[GetSubscriptionRatePlanChargesWithAllSegments]'
    }

    attribute_map = {
        'id': 'id',
        'subscription_rate_plan_number': 'subscriptionRatePlanNumber',
        'is_from_external_catalog': 'isFromExternalCatalog',
        'last_change_type': 'lastChangeType',
        'product_id': 'productId',
        'product_name': 'productName',
        'product_sku': 'productSku',
        'product_rate_plan_id': 'productRatePlanId',
        'product_rate_plan_number': 'productRatePlanNumber',
        'rate_plan_name': 'ratePlanName',
        'subscription_product_features': 'subscriptionProductFeatures',
        'externally_managed_plan_id': 'externallyManagedPlanId',
        'contracted_mrr': 'contractedMrr',
        'contracted_net_mrr': 'contractedNetMrr',
        'as_of_day_gross_mrr': 'asOfDayGrossMrr',
        'as_of_day_net_mrr': 'asOfDayNetMrr',
        'rate_plan_charges': 'ratePlanCharges'
    }

    def __init__(self, id=None, subscription_rate_plan_number=None, is_from_external_catalog=None, last_change_type=None, product_id=None, product_name=None, product_sku=None, product_rate_plan_id=None, product_rate_plan_number=None, rate_plan_name=None, subscription_product_features=None, externally_managed_plan_id=None, contracted_mrr=None, contracted_net_mrr=None, as_of_day_gross_mrr=None, as_of_day_net_mrr=None, rate_plan_charges=None):  # noqa: E501
        """GetSubscriptionRatePlan - a model defined in Swagger"""  # noqa: E501
        self._id = None
        self._subscription_rate_plan_number = None
        self._is_from_external_catalog = None
        self._last_change_type = None
        self._product_id = None
        self._product_name = None
        self._product_sku = None
        self._product_rate_plan_id = None
        self._product_rate_plan_number = None
        self._rate_plan_name = None
        self._subscription_product_features = None
        self._externally_managed_plan_id = None
        self._contracted_mrr = None
        self._contracted_net_mrr = None
        self._as_of_day_gross_mrr = None
        self._as_of_day_net_mrr = None
        self._rate_plan_charges = None
        self.discriminator = None
        if id is not None:
            self.id = id
        if subscription_rate_plan_number is not None:
            self.subscription_rate_plan_number = subscription_rate_plan_number
        if is_from_external_catalog is not None:
            self.is_from_external_catalog = is_from_external_catalog
        if last_change_type is not None:
            self.last_change_type = last_change_type
        if product_id is not None:
            self.product_id = product_id
        if product_name is not None:
            self.product_name = product_name
        if product_sku is not None:
            self.product_sku = product_sku
        if product_rate_plan_id is not None:
            self.product_rate_plan_id = product_rate_plan_id
        if product_rate_plan_number is not None:
            self.product_rate_plan_number = product_rate_plan_number
        if rate_plan_name is not None:
            self.rate_plan_name = rate_plan_name
        if subscription_product_features is not None:
            self.subscription_product_features = subscription_product_features
        if externally_managed_plan_id is not None:
            self.externally_managed_plan_id = externally_managed_plan_id
        if contracted_mrr is not None:
            self.contracted_mrr = contracted_mrr
        if contracted_net_mrr is not None:
            self.contracted_net_mrr = contracted_net_mrr
        if as_of_day_gross_mrr is not None:
            self.as_of_day_gross_mrr = as_of_day_gross_mrr
        if as_of_day_net_mrr is not None:
            self.as_of_day_net_mrr = as_of_day_net_mrr
        if rate_plan_charges is not None:
            self.rate_plan_charges = rate_plan_charges

    @property
    def id(self):
        """Gets the id of this GetSubscriptionRatePlan.  # noqa: E501

        Rate plan ID.   # noqa: E501

        :return: The id of this GetSubscriptionRatePlan.  # noqa: E501
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this GetSubscriptionRatePlan.

        Rate plan ID.   # noqa: E501

        :param id: The id of this GetSubscriptionRatePlan.  # noqa: E501
        :type: str
        """

        self._id = id

    @property
    def subscription_rate_plan_number(self):
        """Gets the subscription_rate_plan_number of this GetSubscriptionRatePlan.  # noqa: E501


        :return: The subscription_rate_plan_number of this GetSubscriptionRatePlan.  # noqa: E501
        :rtype: str
        """
        return self._subscription_rate_plan_number

    @subscription_rate_plan_number.setter
    def subscription_rate_plan_number(self, subscription_rate_plan_number):
        """Sets the subscription_rate_plan_number of this GetSubscriptionRatePlan.


        :param subscription_rate_plan_number: The subscription_rate_plan_number of this GetSubscriptionRatePlan.  # noqa: E501
        :type: str
        """

        self._subscription_rate_plan_number = subscription_rate_plan_number

    @property
    def is_from_external_catalog(self):
        """Gets the is_from_external_catalog of this GetSubscriptionRatePlan.  # noqa: E501


        :return: The is_from_external_catalog of this GetSubscriptionRatePlan.  # noqa: E501
        :rtype: bool
        """
        return self._is_from_external_catalog

    @is_from_external_catalog.setter
    def is_from_external_catalog(self, is_from_external_catalog):
        """Sets the is_from_external_catalog of this GetSubscriptionRatePlan.


        :param is_from_external_catalog: The is_from_external_catalog of this GetSubscriptionRatePlan.  # noqa: E501
        :type: bool
        """

        self._is_from_external_catalog = is_from_external_catalog

    @property
    def last_change_type(self):
        """Gets the last_change_type of this GetSubscriptionRatePlan.  # noqa: E501

        The last amendment on the rate plan.    **Note:** If a subscription is created through an order, this field is only available if multiple orders are created on the subscription.   Possible Values:   * `Add`   * `Update`   * `Remove`   # noqa: E501

        :return: The last_change_type of this GetSubscriptionRatePlan.  # noqa: E501
        :rtype: str
        """
        return self._last_change_type

    @last_change_type.setter
    def last_change_type(self, last_change_type):
        """Sets the last_change_type of this GetSubscriptionRatePlan.

        The last amendment on the rate plan.    **Note:** If a subscription is created through an order, this field is only available if multiple orders are created on the subscription.   Possible Values:   * `Add`   * `Update`   * `Remove`   # noqa: E501

        :param last_change_type: The last_change_type of this GetSubscriptionRatePlan.  # noqa: E501
        :type: str
        """
        allowed_values = ["Add", "Update", "Remove"]  # noqa: E501
        if last_change_type not in allowed_values:
            raise ValueError(
                "Invalid value for `last_change_type` ({0}), must be one of {1}"  # noqa: E501
                .format(last_change_type, allowed_values)
            )

        self._last_change_type = last_change_type

    @property
    def product_id(self):
        """Gets the product_id of this GetSubscriptionRatePlan.  # noqa: E501


        :return: The product_id of this GetSubscriptionRatePlan.  # noqa: E501
        :rtype: str
        """
        return self._product_id

    @product_id.setter
    def product_id(self, product_id):
        """Sets the product_id of this GetSubscriptionRatePlan.


        :param product_id: The product_id of this GetSubscriptionRatePlan.  # noqa: E501
        :type: str
        """

        self._product_id = product_id

    @property
    def product_name(self):
        """Gets the product_name of this GetSubscriptionRatePlan.  # noqa: E501


        :return: The product_name of this GetSubscriptionRatePlan.  # noqa: E501
        :rtype: str
        """
        return self._product_name

    @product_name.setter
    def product_name(self, product_name):
        """Sets the product_name of this GetSubscriptionRatePlan.


        :param product_name: The product_name of this GetSubscriptionRatePlan.  # noqa: E501
        :type: str
        """

        self._product_name = product_name

    @property
    def product_sku(self):
        """Gets the product_sku of this GetSubscriptionRatePlan.  # noqa: E501

        The unique SKU for the product.  # noqa: E501

        :return: The product_sku of this GetSubscriptionRatePlan.  # noqa: E501
        :rtype: str
        """
        return self._product_sku

    @product_sku.setter
    def product_sku(self, product_sku):
        """Sets the product_sku of this GetSubscriptionRatePlan.

        The unique SKU for the product.  # noqa: E501

        :param product_sku: The product_sku of this GetSubscriptionRatePlan.  # noqa: E501
        :type: str
        """

        self._product_sku = product_sku

    @property
    def product_rate_plan_id(self):
        """Gets the product_rate_plan_id of this GetSubscriptionRatePlan.  # noqa: E501


        :return: The product_rate_plan_id of this GetSubscriptionRatePlan.  # noqa: E501
        :rtype: str
        """
        return self._product_rate_plan_id

    @product_rate_plan_id.setter
    def product_rate_plan_id(self, product_rate_plan_id):
        """Sets the product_rate_plan_id of this GetSubscriptionRatePlan.


        :param product_rate_plan_id: The product_rate_plan_id of this GetSubscriptionRatePlan.  # noqa: E501
        :type: str
        """

        self._product_rate_plan_id = product_rate_plan_id

    @property
    def product_rate_plan_number(self):
        """Gets the product_rate_plan_number of this GetSubscriptionRatePlan.  # noqa: E501


        :return: The product_rate_plan_number of this GetSubscriptionRatePlan.  # noqa: E501
        :rtype: str
        """
        return self._product_rate_plan_number

    @product_rate_plan_number.setter
    def product_rate_plan_number(self, product_rate_plan_number):
        """Sets the product_rate_plan_number of this GetSubscriptionRatePlan.


        :param product_rate_plan_number: The product_rate_plan_number of this GetSubscriptionRatePlan.  # noqa: E501
        :type: str
        """

        self._product_rate_plan_number = product_rate_plan_number

    @property
    def rate_plan_name(self):
        """Gets the rate_plan_name of this GetSubscriptionRatePlan.  # noqa: E501

        Name of the rate plan.  # noqa: E501

        :return: The rate_plan_name of this GetSubscriptionRatePlan.  # noqa: E501
        :rtype: str
        """
        return self._rate_plan_name

    @rate_plan_name.setter
    def rate_plan_name(self, rate_plan_name):
        """Sets the rate_plan_name of this GetSubscriptionRatePlan.

        Name of the rate plan.  # noqa: E501

        :param rate_plan_name: The rate_plan_name of this GetSubscriptionRatePlan.  # noqa: E501
        :type: str
        """

        self._rate_plan_name = rate_plan_name

    @property
    def subscription_product_features(self):
        """Gets the subscription_product_features of this GetSubscriptionRatePlan.  # noqa: E501

        Container for one or more features.   Only available when the following settings are enabled:  * The Entitlements feature in your tenant.  * The Enable Feature Specification in Product and Subscriptions setting in Zuora Billing Settings  # noqa: E501

        :return: The subscription_product_features of this GetSubscriptionRatePlan.  # noqa: E501
        :rtype: list[SubscriptionProductFeature]
        """
        return self._subscription_product_features

    @subscription_product_features.setter
    def subscription_product_features(self, subscription_product_features):
        """Sets the subscription_product_features of this GetSubscriptionRatePlan.

        Container for one or more features.   Only available when the following settings are enabled:  * The Entitlements feature in your tenant.  * The Enable Feature Specification in Product and Subscriptions setting in Zuora Billing Settings  # noqa: E501

        :param subscription_product_features: The subscription_product_features of this GetSubscriptionRatePlan.  # noqa: E501
        :type: list[SubscriptionProductFeature]
        """

        self._subscription_product_features = subscription_product_features

    @property
    def externally_managed_plan_id(self):
        """Gets the externally_managed_plan_id of this GetSubscriptionRatePlan.  # noqa: E501

        Indicates the unique identifier for the rate plan purchased on a third-party store. This field is used to represent a subscription rate plan created through third-party stores.   # noqa: E501

        :return: The externally_managed_plan_id of this GetSubscriptionRatePlan.  # noqa: E501
        :rtype: str
        """
        return self._externally_managed_plan_id

    @externally_managed_plan_id.setter
    def externally_managed_plan_id(self, externally_managed_plan_id):
        """Sets the externally_managed_plan_id of this GetSubscriptionRatePlan.

        Indicates the unique identifier for the rate plan purchased on a third-party store. This field is used to represent a subscription rate plan created through third-party stores.   # noqa: E501

        :param externally_managed_plan_id: The externally_managed_plan_id of this GetSubscriptionRatePlan.  # noqa: E501
        :type: str
        """

        self._externally_managed_plan_id = externally_managed_plan_id

    @property
    def contracted_mrr(self):
        """Gets the contracted_mrr of this GetSubscriptionRatePlan.  # noqa: E501

        Monthly recurring revenue of the subscription rate plan exclusive of all the discounts applicable.   # noqa: E501

        :return: The contracted_mrr of this GetSubscriptionRatePlan.  # noqa: E501
        :rtype: float
        """
        return self._contracted_mrr

    @contracted_mrr.setter
    def contracted_mrr(self, contracted_mrr):
        """Sets the contracted_mrr of this GetSubscriptionRatePlan.

        Monthly recurring revenue of the subscription rate plan exclusive of all the discounts applicable.   # noqa: E501

        :param contracted_mrr: The contracted_mrr of this GetSubscriptionRatePlan.  # noqa: E501
        :type: float
        """

        self._contracted_mrr = contracted_mrr

    @property
    def contracted_net_mrr(self):
        """Gets the contracted_net_mrr of this GetSubscriptionRatePlan.  # noqa: E501

        Monthly recurring revenue of the subscription rate plan inclusive of all the discounts applicable, including the fixed-amount discounts and percentage discounts.   # noqa: E501

        :return: The contracted_net_mrr of this GetSubscriptionRatePlan.  # noqa: E501
        :rtype: float
        """
        return self._contracted_net_mrr

    @contracted_net_mrr.setter
    def contracted_net_mrr(self, contracted_net_mrr):
        """Sets the contracted_net_mrr of this GetSubscriptionRatePlan.

        Monthly recurring revenue of the subscription rate plan inclusive of all the discounts applicable, including the fixed-amount discounts and percentage discounts.   # noqa: E501

        :param contracted_net_mrr: The contracted_net_mrr of this GetSubscriptionRatePlan.  # noqa: E501
        :type: float
        """

        self._contracted_net_mrr = contracted_net_mrr

    @property
    def as_of_day_gross_mrr(self):
        """Gets the as_of_day_gross_mrr of this GetSubscriptionRatePlan.  # noqa: E501

        Monthly recurring revenue of the subscription rate plan exclusive of any discounts applicable as of specified day.   # noqa: E501

        :return: The as_of_day_gross_mrr of this GetSubscriptionRatePlan.  # noqa: E501
        :rtype: float
        """
        return self._as_of_day_gross_mrr

    @as_of_day_gross_mrr.setter
    def as_of_day_gross_mrr(self, as_of_day_gross_mrr):
        """Sets the as_of_day_gross_mrr of this GetSubscriptionRatePlan.

        Monthly recurring revenue of the subscription rate plan exclusive of any discounts applicable as of specified day.   # noqa: E501

        :param as_of_day_gross_mrr: The as_of_day_gross_mrr of this GetSubscriptionRatePlan.  # noqa: E501
        :type: float
        """

        self._as_of_day_gross_mrr = as_of_day_gross_mrr

    @property
    def as_of_day_net_mrr(self):
        """Gets the as_of_day_net_mrr of this GetSubscriptionRatePlan.  # noqa: E501

        Monthly recurring revenue of the subscription rate plan inclusive of all the discounts applicable, including the fixed-amount discounts and percentage discounts as of specified day.   # noqa: E501

        :return: The as_of_day_net_mrr of this GetSubscriptionRatePlan.  # noqa: E501
        :rtype: float
        """
        return self._as_of_day_net_mrr

    @as_of_day_net_mrr.setter
    def as_of_day_net_mrr(self, as_of_day_net_mrr):
        """Sets the as_of_day_net_mrr of this GetSubscriptionRatePlan.

        Monthly recurring revenue of the subscription rate plan inclusive of all the discounts applicable, including the fixed-amount discounts and percentage discounts as of specified day.   # noqa: E501

        :param as_of_day_net_mrr: The as_of_day_net_mrr of this GetSubscriptionRatePlan.  # noqa: E501
        :type: float
        """

        self._as_of_day_net_mrr = as_of_day_net_mrr

    @property
    def rate_plan_charges(self):
        """Gets the rate_plan_charges of this GetSubscriptionRatePlan.  # noqa: E501

        Container for one or more charges.  # noqa: E501

        :return: The rate_plan_charges of this GetSubscriptionRatePlan.  # noqa: E501
        :rtype: list[GetSubscriptionRatePlanChargesWithAllSegments]
        """
        return self._rate_plan_charges

    @rate_plan_charges.setter
    def rate_plan_charges(self, rate_plan_charges):
        """Sets the rate_plan_charges of this GetSubscriptionRatePlan.

        Container for one or more charges.  # noqa: E501

        :param rate_plan_charges: The rate_plan_charges of this GetSubscriptionRatePlan.  # noqa: E501
        :type: list[GetSubscriptionRatePlanChargesWithAllSegments]
        """

        self._rate_plan_charges = rate_plan_charges

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(GetSubscriptionRatePlan, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, GetSubscriptionRatePlan):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
