# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).  # noqa: E501

    OpenAPI spec version: 2024-05-20
    Contact: docs@zuora.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class InvoiceScheduleSubscription(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'order_key': 'str',
        'subscription_key': 'str',
        'charge_numbers': 'list[str]'
    }

    attribute_map = {
        'order_key': 'orderKey',
        'subscription_key': 'subscriptionKey',
        'charge_numbers': 'chargeNumbers'
    }

    def __init__(self, order_key=None, subscription_key=None, charge_numbers=None):  # noqa: E501
        """InvoiceScheduleSubscription - a model defined in Swagger"""  # noqa: E501
        self._order_key = None
        self._subscription_key = None
        self._charge_numbers = None
        self.discriminator = None
        if order_key is not None:
            self.order_key = order_key
        if subscription_key is not None:
            self.subscription_key = subscription_key
        if charge_numbers is not None:
            self.charge_numbers = charge_numbers

    @property
    def order_key(self):
        """Gets the order_key of this InvoiceScheduleSubscription.  # noqa: E501

        The unique ID or number of the order associated with the invoice schedule.   # noqa: E501

        :return: The order_key of this InvoiceScheduleSubscription.  # noqa: E501
        :rtype: str
        """
        return self._order_key

    @order_key.setter
    def order_key(self, order_key):
        """Sets the order_key of this InvoiceScheduleSubscription.

        The unique ID or number of the order associated with the invoice schedule.   # noqa: E501

        :param order_key: The order_key of this InvoiceScheduleSubscription.  # noqa: E501
        :type: str
        """

        self._order_key = order_key

    @property
    def subscription_key(self):
        """Gets the subscription_key of this InvoiceScheduleSubscription.  # noqa: E501

        The unique number of the subscription contained in the order associated with the invoice schedule.   # noqa: E501

        :return: The subscription_key of this InvoiceScheduleSubscription.  # noqa: E501
        :rtype: str
        """
        return self._subscription_key

    @subscription_key.setter
    def subscription_key(self, subscription_key):
        """Sets the subscription_key of this InvoiceScheduleSubscription.

        The unique number of the subscription contained in the order associated with the invoice schedule.   # noqa: E501

        :param subscription_key: The subscription_key of this InvoiceScheduleSubscription.  # noqa: E501
        :type: str
        """

        self._subscription_key = subscription_key

    @property
    def charge_numbers(self):
        """Gets the charge_numbers of this InvoiceScheduleSubscription.  # noqa: E501

        A list of the numbers of charges contained in the subscription\"   # noqa: E501

        :return: The charge_numbers of this InvoiceScheduleSubscription.  # noqa: E501
        :rtype: list[str]
        """
        return self._charge_numbers

    @charge_numbers.setter
    def charge_numbers(self, charge_numbers):
        """Sets the charge_numbers of this InvoiceScheduleSubscription.

        A list of the numbers of charges contained in the subscription\"   # noqa: E501

        :param charge_numbers: The charge_numbers of this InvoiceScheduleSubscription.  # noqa: E501
        :type: list[str]
        """

        self._charge_numbers = charge_numbers

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(InvoiceScheduleSubscription, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, InvoiceScheduleSubscription):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
