# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).  # noqa: E501

    OpenAPI spec version: 2024-05-20
    Contact: docs@zuora.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class ListOfExchangeRates(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'currency': 'str',
        'provider_exchange_rate_date': 'date'
    }

    attribute_map = {
        'currency': 'CURRENCY',
        'provider_exchange_rate_date': 'providerExchangeRateDate'
    }

    def __init__(self, currency=None, provider_exchange_rate_date=None):  # noqa: E501
        """ListOfExchangeRates - a model defined in Swagger"""  # noqa: E501
        self._currency = None
        self._provider_exchange_rate_date = None
        self.discriminator = None
        if currency is not None:
            self.currency = currency
        if provider_exchange_rate_date is not None:
            self.provider_exchange_rate_date = provider_exchange_rate_date

    @property
    def currency(self):
        """Gets the currency of this ListOfExchangeRates.  # noqa: E501

        The exchange rate on the **providerExchangeRateDate**. The field name is the ISO currency code of the currency, for example, `EUR`.  There may be more than one currency returned for a given **providerExchangeRateDate**. If the rate for a certain currency is not available on the **providerExchangeRateDate**, the currency is not returned in the response.   # noqa: E501

        :return: The currency of this ListOfExchangeRates.  # noqa: E501
        :rtype: str
        """
        return self._currency

    @currency.setter
    def currency(self, currency):
        """Sets the currency of this ListOfExchangeRates.

        The exchange rate on the **providerExchangeRateDate**. The field name is the ISO currency code of the currency, for example, `EUR`.  There may be more than one currency returned for a given **providerExchangeRateDate**. If the rate for a certain currency is not available on the **providerExchangeRateDate**, the currency is not returned in the response.   # noqa: E501

        :param currency: The currency of this ListOfExchangeRates.  # noqa: E501
        :type: str
        """

        self._currency = currency

    @property
    def provider_exchange_rate_date(self):
        """Gets the provider_exchange_rate_date of this ListOfExchangeRates.  # noqa: E501

        The date of the exchange rate used. The date is in `yyyy-mm-dd` format.  Corresponds to the value specified in the Provider Exchange Rate Date column in the Import Foreign Exchange Rates template when you uploaded the rates through the Mass Updater.   # noqa: E501

        :return: The provider_exchange_rate_date of this ListOfExchangeRates.  # noqa: E501
        :rtype: date
        """
        return self._provider_exchange_rate_date

    @provider_exchange_rate_date.setter
    def provider_exchange_rate_date(self, provider_exchange_rate_date):
        """Sets the provider_exchange_rate_date of this ListOfExchangeRates.

        The date of the exchange rate used. The date is in `yyyy-mm-dd` format.  Corresponds to the value specified in the Provider Exchange Rate Date column in the Import Foreign Exchange Rates template when you uploaded the rates through the Mass Updater.   # noqa: E501

        :param provider_exchange_rate_date: The provider_exchange_rate_date of this ListOfExchangeRates.  # noqa: E501
        :type: date
        """

        self._provider_exchange_rate_date = provider_exchange_rate_date

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(ListOfExchangeRates, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ListOfExchangeRates):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
