# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).  # noqa: E501

    OpenAPI spec version: 2024-05-20
    Contact: docs@zuora.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class MigrationUpdateCustomObjectDefinitionsResponse(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'actions': 'list[CustomObjectDefinitionUpdateActionResponse]'
    }

    attribute_map = {
        'actions': 'actions'
    }

    def __init__(self, actions=None):  # noqa: E501
        """MigrationUpdateCustomObjectDefinitionsResponse - a model defined in Swagger"""  # noqa: E501
        self._actions = None
        self.discriminator = None
        if actions is not None:
            self.actions = actions

    @property
    def actions(self):
        """Gets the actions of this MigrationUpdateCustomObjectDefinitionsResponse.  # noqa: E501

        The actions of updating custom object definitions, to be performed as parts of the migration.  Currently only one action per migration is supported.  # noqa: E501

        :return: The actions of this MigrationUpdateCustomObjectDefinitionsResponse.  # noqa: E501
        :rtype: list[CustomObjectDefinitionUpdateActionResponse]
        """
        return self._actions

    @actions.setter
    def actions(self, actions):
        """Sets the actions of this MigrationUpdateCustomObjectDefinitionsResponse.

        The actions of updating custom object definitions, to be performed as parts of the migration.  Currently only one action per migration is supported.  # noqa: E501

        :param actions: The actions of this MigrationUpdateCustomObjectDefinitionsResponse.  # noqa: E501
        :type: list[CustomObjectDefinitionUpdateActionResponse]
        """

        self._actions = actions

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(MigrationUpdateCustomObjectDefinitionsResponse, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, MigrationUpdateCustomObjectDefinitionsResponse):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
