# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).  # noqa: E501

    OpenAPI spec version: 2024-05-20
    Contact: docs@zuora.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class ObjectPostImportRequest(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'file': 'str',
        'import_type': 'ObjectPostImportRequestImportType',
        'name': 'str'
    }

    attribute_map = {
        'file': 'File',
        'import_type': 'ImportType',
        'name': 'Name'
    }

    def __init__(self, file=None, import_type=None, name=None):  # noqa: E501
        """ObjectPostImportRequest - a model defined in Swagger"""  # noqa: E501
        self._file = None
        self._import_type = None
        self._name = None
        self.discriminator = None
        self.file = file
        self.import_type = import_type
        self.name = name

    @property
    def file(self):
        """Gets the file of this ObjectPostImportRequest.  # noqa: E501

        The data to import.   # noqa: E501

        :return: The file of this ObjectPostImportRequest.  # noqa: E501
        :rtype: str
        """
        return self._file

    @file.setter
    def file(self, file):
        """Sets the file of this ObjectPostImportRequest.

        The data to import.   # noqa: E501

        :param file: The file of this ObjectPostImportRequest.  # noqa: E501
        :type: str
        """
        if file is None:
            raise ValueError("Invalid value for `file`, must not be `None`")  # noqa: E501

        self._file = file

    @property
    def import_type(self):
        """Gets the import_type of this ObjectPostImportRequest.  # noqa: E501


        :return: The import_type of this ObjectPostImportRequest.  # noqa: E501
        :rtype: ObjectPostImportRequestImportType
        """
        return self._import_type

    @import_type.setter
    def import_type(self, import_type):
        """Sets the import_type of this ObjectPostImportRequest.


        :param import_type: The import_type of this ObjectPostImportRequest.  # noqa: E501
        :type: ObjectPostImportRequestImportType
        """
        if import_type is None:
            raise ValueError("Invalid value for `import_type`, must not be `None`")  # noqa: E501

        self._import_type = import_type

    @property
    def name(self):
        """Gets the name of this ObjectPostImportRequest.  # noqa: E501

        A descriptive name for the import.   # noqa: E501

        :return: The name of this ObjectPostImportRequest.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this ObjectPostImportRequest.

        A descriptive name for the import.   # noqa: E501

        :param name: The name of this ObjectPostImportRequest.  # noqa: E501
        :type: str
        """
        if name is None:
            raise ValueError("Invalid value for `name`, must not be `None`")  # noqa: E501

        self._name = name

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(ObjectPostImportRequest, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ObjectPostImportRequest):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
