# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).  # noqa: E501

    OpenAPI spec version: 2024-05-20
    Contact: docs@zuora.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class OrderActionRatePlanChargeRemove(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'charge_number': 'str',
        'product_rate_plan_charge_id': 'str',
        'product_rate_plan_number': 'str',
        'unique_token': 'str',
        'custom_fields': 'dict(str, object)'
    }

    attribute_map = {
        'charge_number': 'chargeNumber',
        'product_rate_plan_charge_id': 'productRatePlanChargeId',
        'product_rate_plan_number': 'productRatePlanNumber',
        'unique_token': 'uniqueToken',
        'custom_fields': 'customFields'
    }

    def __init__(self, charge_number=None, product_rate_plan_charge_id=None, product_rate_plan_number=None, unique_token=None, custom_fields=None):  # noqa: E501
        """OrderActionRatePlanChargeRemove - a model defined in Swagger"""  # noqa: E501
        self._charge_number = None
        self._product_rate_plan_charge_id = None
        self._product_rate_plan_number = None
        self._unique_token = None
        self._custom_fields = None
        self.discriminator = None
        if charge_number is not None:
            self.charge_number = charge_number
        if product_rate_plan_charge_id is not None:
            self.product_rate_plan_charge_id = product_rate_plan_charge_id
        if product_rate_plan_number is not None:
            self.product_rate_plan_number = product_rate_plan_number
        if unique_token is not None:
            self.unique_token = unique_token
        if custom_fields is not None:
            self.custom_fields = custom_fields

    @property
    def charge_number(self):
        """Gets the charge_number of this OrderActionRatePlanChargeRemove.  # noqa: E501

        Read only. Identifies the charge to be updated.   # noqa: E501

        :return: The charge_number of this OrderActionRatePlanChargeRemove.  # noqa: E501
        :rtype: str
        """
        return self._charge_number

    @charge_number.setter
    def charge_number(self, charge_number):
        """Sets the charge_number of this OrderActionRatePlanChargeRemove.

        Read only. Identifies the charge to be updated.   # noqa: E501

        :param charge_number: The charge_number of this OrderActionRatePlanChargeRemove.  # noqa: E501
        :type: str
        """

        self._charge_number = charge_number

    @property
    def product_rate_plan_charge_id(self):
        """Gets the product_rate_plan_charge_id of this OrderActionRatePlanChargeRemove.  # noqa: E501

        Identifier of the rate plan that was updated.   # noqa: E501

        :return: The product_rate_plan_charge_id of this OrderActionRatePlanChargeRemove.  # noqa: E501
        :rtype: str
        """
        return self._product_rate_plan_charge_id

    @product_rate_plan_charge_id.setter
    def product_rate_plan_charge_id(self, product_rate_plan_charge_id):
        """Sets the product_rate_plan_charge_id of this OrderActionRatePlanChargeRemove.

        Identifier of the rate plan that was updated.   # noqa: E501

        :param product_rate_plan_charge_id: The product_rate_plan_charge_id of this OrderActionRatePlanChargeRemove.  # noqa: E501
        :type: str
        """

        self._product_rate_plan_charge_id = product_rate_plan_charge_id

    @property
    def product_rate_plan_number(self):
        """Gets the product_rate_plan_number of this OrderActionRatePlanChargeRemove.  # noqa: E501

        Number of a product rate plan for this subscription.   # noqa: E501

        :return: The product_rate_plan_number of this OrderActionRatePlanChargeRemove.  # noqa: E501
        :rtype: str
        """
        return self._product_rate_plan_number

    @product_rate_plan_number.setter
    def product_rate_plan_number(self, product_rate_plan_number):
        """Sets the product_rate_plan_number of this OrderActionRatePlanChargeRemove.

        Number of a product rate plan for this subscription.   # noqa: E501

        :param product_rate_plan_number: The product_rate_plan_number of this OrderActionRatePlanChargeRemove.  # noqa: E501
        :type: str
        """

        self._product_rate_plan_number = product_rate_plan_number

    @property
    def unique_token(self):
        """Gets the unique_token of this OrderActionRatePlanChargeRemove.  # noqa: E501

        A unique string to represent the rate plan charge in the order. The unique token is used to perform multiple actions against a newly added rate plan. For example, if you want to add and update a product in the same order, you would assign a unique token to the product rate plan when added and use that token in future order actions.   # noqa: E501

        :return: The unique_token of this OrderActionRatePlanChargeRemove.  # noqa: E501
        :rtype: str
        """
        return self._unique_token

    @unique_token.setter
    def unique_token(self, unique_token):
        """Sets the unique_token of this OrderActionRatePlanChargeRemove.

        A unique string to represent the rate plan charge in the order. The unique token is used to perform multiple actions against a newly added rate plan. For example, if you want to add and update a product in the same order, you would assign a unique token to the product rate plan when added and use that token in future order actions.   # noqa: E501

        :param unique_token: The unique_token of this OrderActionRatePlanChargeRemove.  # noqa: E501
        :type: str
        """

        self._unique_token = unique_token

    @property
    def custom_fields(self):
        """Gets the custom_fields of this OrderActionRatePlanChargeRemove.  # noqa: E501

        Container for custom fields of a Rate Plan Charge object.   # noqa: E501

        :return: The custom_fields of this OrderActionRatePlanChargeRemove.  # noqa: E501
        :rtype: dict(str, object)
        """
        return self._custom_fields

    @custom_fields.setter
    def custom_fields(self, custom_fields):
        """Sets the custom_fields of this OrderActionRatePlanChargeRemove.

        Container for custom fields of a Rate Plan Charge object.   # noqa: E501

        :param custom_fields: The custom_fields of this OrderActionRatePlanChargeRemove.  # noqa: E501
        :type: dict(str, object)
        """

        self._custom_fields = custom_fields

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(OrderActionRatePlanChargeRemove, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, OrderActionRatePlanChargeRemove):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
