# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).  # noqa: E501

    OpenAPI spec version: 2024-05-20
    Contact: docs@zuora.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six
from zuora_sdk.models.price_change_params import PriceChangeParams  # noqa: F401,E501

class OrderActionRatePlanRecurringDeliveryPricingUpdate(PriceChangeParams):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'delivery_schedule': 'DeliveryScheduleParams',
        'list_price': 'float'
    }
    if hasattr(PriceChangeParams, "swagger_types"):
        swagger_types.update(PriceChangeParams.swagger_types)

    attribute_map = {
        'delivery_schedule': 'deliverySchedule',
        'list_price': 'listPrice'
    }
    if hasattr(PriceChangeParams, "attribute_map"):
        attribute_map.update(PriceChangeParams.attribute_map)

    def __init__(self, delivery_schedule=None, list_price=None, *args, **kwargs):  # noqa: E501
        """OrderActionRatePlanRecurringDeliveryPricingUpdate - a model defined in Swagger"""  # noqa: E501
        self._delivery_schedule = None
        self._list_price = None
        self.discriminator = None
        if delivery_schedule is not None:
            self.delivery_schedule = delivery_schedule
        if list_price is not None:
            self.list_price = list_price
        PriceChangeParams.__init__(self, *args, **kwargs)

    @property
    def delivery_schedule(self):
        """Gets the delivery_schedule of this OrderActionRatePlanRecurringDeliveryPricingUpdate.  # noqa: E501


        :return: The delivery_schedule of this OrderActionRatePlanRecurringDeliveryPricingUpdate.  # noqa: E501
        :rtype: DeliveryScheduleParams
        """
        return self._delivery_schedule

    @delivery_schedule.setter
    def delivery_schedule(self, delivery_schedule):
        """Sets the delivery_schedule of this OrderActionRatePlanRecurringDeliveryPricingUpdate.


        :param delivery_schedule: The delivery_schedule of this OrderActionRatePlanRecurringDeliveryPricingUpdate.  # noqa: E501
        :type: DeliveryScheduleParams
        """

        self._delivery_schedule = delivery_schedule

    @property
    def list_price(self):
        """Gets the list_price of this OrderActionRatePlanRecurringDeliveryPricingUpdate.  # noqa: E501


        :return: The list_price of this OrderActionRatePlanRecurringDeliveryPricingUpdate.  # noqa: E501
        :rtype: float
        """
        return self._list_price

    @list_price.setter
    def list_price(self, list_price):
        """Sets the list_price of this OrderActionRatePlanRecurringDeliveryPricingUpdate.


        :param list_price: The list_price of this OrderActionRatePlanRecurringDeliveryPricingUpdate.  # noqa: E501
        :type: float
        """

        self._list_price = list_price

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(OrderActionRatePlanRecurringDeliveryPricingUpdate, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, OrderActionRatePlanRecurringDeliveryPricingUpdate):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
