# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).  # noqa: E501

    OpenAPI spec version: 2024-05-20
    Contact: docs@zuora.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class OrderSchedulingOptions(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'scheduled_date': 'date',
        'scheduled_date_policy': 'OrderScheduledDatePolicy'
    }

    attribute_map = {
        'scheduled_date': 'scheduledDate',
        'scheduled_date_policy': 'scheduledDatePolicy'
    }

    def __init__(self, scheduled_date=None, scheduled_date_policy=None):  # noqa: E501
        """OrderSchedulingOptions - a model defined in Swagger"""  # noqa: E501
        self._scheduled_date = None
        self._scheduled_date_policy = None
        self.discriminator = None
        if scheduled_date is not None:
            self.scheduled_date = scheduled_date
        if scheduled_date_policy is not None:
            self.scheduled_date_policy = scheduled_date_policy

    @property
    def scheduled_date(self):
        """Gets the scheduled_date of this OrderSchedulingOptions.  # noqa: E501

        The date for the order scheduled.   # noqa: E501

        :return: The scheduled_date of this OrderSchedulingOptions.  # noqa: E501
        :rtype: date
        """
        return self._scheduled_date

    @scheduled_date.setter
    def scheduled_date(self, scheduled_date):
        """Sets the scheduled_date of this OrderSchedulingOptions.

        The date for the order scheduled.   # noqa: E501

        :param scheduled_date: The scheduled_date of this OrderSchedulingOptions.  # noqa: E501
        :type: date
        """

        self._scheduled_date = scheduled_date

    @property
    def scheduled_date_policy(self):
        """Gets the scheduled_date_policy of this OrderSchedulingOptions.  # noqa: E501


        :return: The scheduled_date_policy of this OrderSchedulingOptions.  # noqa: E501
        :rtype: OrderScheduledDatePolicy
        """
        return self._scheduled_date_policy

    @scheduled_date_policy.setter
    def scheduled_date_policy(self, scheduled_date_policy):
        """Sets the scheduled_date_policy of this OrderSchedulingOptions.


        :param scheduled_date_policy: The scheduled_date_policy of this OrderSchedulingOptions.  # noqa: E501
        :type: OrderScheduledDatePolicy
        """

        self._scheduled_date_policy = scheduled_date_policy

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(OrderSchedulingOptions, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, OrderSchedulingOptions):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
