# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).  # noqa: E501

    OpenAPI spec version: 2024-05-20
    Contact: docs@zuora.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class PATCHUpdateWorkflowRequest(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'name': 'str',
        'description': 'str',
        'active_workflow_version_id': 'int',
        'status': 'str'
    }

    attribute_map = {
        'name': 'name',
        'description': 'description',
        'active_workflow_version_id': 'active_workflow_version_id',
        'status': 'status'
    }

    def __init__(self, name=None, description=None, active_workflow_version_id=None, status=None):  # noqa: E501
        """PATCHUpdateWorkflowRequest - a model defined in Swagger"""  # noqa: E501
        self._name = None
        self._description = None
        self._active_workflow_version_id = None
        self._status = None
        self.discriminator = None
        if name is not None:
            self.name = name
        if description is not None:
            self.description = description
        if active_workflow_version_id is not None:
            self.active_workflow_version_id = active_workflow_version_id
        if status is not None:
            self.status = status

    @property
    def name(self):
        """Gets the name of this PATCHUpdateWorkflowRequest.  # noqa: E501

        The name of the workflow definition   # noqa: E501

        :return: The name of this PATCHUpdateWorkflowRequest.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this PATCHUpdateWorkflowRequest.

        The name of the workflow definition   # noqa: E501

        :param name: The name of this PATCHUpdateWorkflowRequest.  # noqa: E501
        :type: str
        """

        self._name = name

    @property
    def description(self):
        """Gets the description of this PATCHUpdateWorkflowRequest.  # noqa: E501

        The description of the workflow defintion   # noqa: E501

        :return: The description of this PATCHUpdateWorkflowRequest.  # noqa: E501
        :rtype: str
        """
        return self._description

    @description.setter
    def description(self, description):
        """Sets the description of this PATCHUpdateWorkflowRequest.

        The description of the workflow defintion   # noqa: E501

        :param description: The description of this PATCHUpdateWorkflowRequest.  # noqa: E501
        :type: str
        """

        self._description = description

    @property
    def active_workflow_version_id(self):
        """Gets the active_workflow_version_id of this PATCHUpdateWorkflowRequest.  # noqa: E501

        The id of a version. This version will then be set to the active version of the workflow definition.   # noqa: E501

        :return: The active_workflow_version_id of this PATCHUpdateWorkflowRequest.  # noqa: E501
        :rtype: int
        """
        return self._active_workflow_version_id

    @active_workflow_version_id.setter
    def active_workflow_version_id(self, active_workflow_version_id):
        """Sets the active_workflow_version_id of this PATCHUpdateWorkflowRequest.

        The id of a version. This version will then be set to the active version of the workflow definition.   # noqa: E501

        :param active_workflow_version_id: The active_workflow_version_id of this PATCHUpdateWorkflowRequest.  # noqa: E501
        :type: int
        """

        self._active_workflow_version_id = active_workflow_version_id

    @property
    def status(self):
        """Gets the status of this PATCHUpdateWorkflowRequest.  # noqa: E501

        Can be `Active` or `Inactive`. Active workfow definitions run like normal. Inactive workflow definitions cannot be run.   # noqa: E501

        :return: The status of this PATCHUpdateWorkflowRequest.  # noqa: E501
        :rtype: str
        """
        return self._status

    @status.setter
    def status(self, status):
        """Sets the status of this PATCHUpdateWorkflowRequest.

        Can be `Active` or `Inactive`. Active workfow definitions run like normal. Inactive workflow definitions cannot be run.   # noqa: E501

        :param status: The status of this PATCHUpdateWorkflowRequest.  # noqa: E501
        :type: str
        """

        self._status = status

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(PATCHUpdateWorkflowRequest, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, PATCHUpdateWorkflowRequest):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
