# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).  # noqa: E501

    OpenAPI spec version: 2024-05-20
    Contact: docs@zuora.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class PaymentGatwayResponse(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'id': 'str',
        'is_active': 'bool',
        'is_default': 'bool',
        'name': 'str',
        'number': 'str',
        'type': 'str'
    }

    attribute_map = {
        'id': 'id',
        'is_active': 'isActive',
        'is_default': 'isDefault',
        'name': 'name',
        'number': 'number',
        'type': 'type'
    }

    def __init__(self, id=None, is_active=None, is_default=None, name=None, number=None, type=None):  # noqa: E501
        """PaymentGatwayResponse - a model defined in Swagger"""  # noqa: E501
        self._id = None
        self._is_active = None
        self._is_default = None
        self._name = None
        self._number = None
        self._type = None
        self.discriminator = None
        if id is not None:
            self.id = id
        if is_active is not None:
            self.is_active = is_active
        if is_default is not None:
            self.is_default = is_default
        if name is not None:
            self.name = name
        if number is not None:
            self.number = number
        if type is not None:
            self.type = type

    @property
    def id(self):
        """Gets the id of this PaymentGatwayResponse.  # noqa: E501

        The ID of the payment gateway.  # noqa: E501

        :return: The id of this PaymentGatwayResponse.  # noqa: E501
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this PaymentGatwayResponse.

        The ID of the payment gateway.  # noqa: E501

        :param id: The id of this PaymentGatwayResponse.  # noqa: E501
        :type: str
        """

        self._id = id

    @property
    def is_active(self):
        """Gets the is_active of this PaymentGatwayResponse.  # noqa: E501

        Specifies if this payment gateway is in active status.  # noqa: E501

        :return: The is_active of this PaymentGatwayResponse.  # noqa: E501
        :rtype: bool
        """
        return self._is_active

    @is_active.setter
    def is_active(self, is_active):
        """Sets the is_active of this PaymentGatwayResponse.

        Specifies if this payment gateway is in active status.  # noqa: E501

        :param is_active: The is_active of this PaymentGatwayResponse.  # noqa: E501
        :type: bool
        """

        self._is_active = is_active

    @property
    def is_default(self):
        """Gets the is_default of this PaymentGatwayResponse.  # noqa: E501

        Specifies if this is the default payment gateway to process payments for your customer accounts.  # noqa: E501

        :return: The is_default of this PaymentGatwayResponse.  # noqa: E501
        :rtype: bool
        """
        return self._is_default

    @is_default.setter
    def is_default(self, is_default):
        """Sets the is_default of this PaymentGatwayResponse.

        Specifies if this is the default payment gateway to process payments for your customer accounts.  # noqa: E501

        :param is_default: The is_default of this PaymentGatwayResponse.  # noqa: E501
        :type: bool
        """

        self._is_default = is_default

    @property
    def name(self):
        """Gets the name of this PaymentGatwayResponse.  # noqa: E501

        The name of the payment gateway.  # noqa: E501

        :return: The name of this PaymentGatwayResponse.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this PaymentGatwayResponse.

        The name of the payment gateway.  # noqa: E501

        :param name: The name of this PaymentGatwayResponse.  # noqa: E501
        :type: str
        """

        self._name = name

    @property
    def number(self):
        """Gets the number of this PaymentGatwayResponse.  # noqa: E501

        The number of the payment gateway.  # noqa: E501

        :return: The number of this PaymentGatwayResponse.  # noqa: E501
        :rtype: str
        """
        return self._number

    @number.setter
    def number(self, number):
        """Sets the number of this PaymentGatwayResponse.

        The number of the payment gateway.  # noqa: E501

        :param number: The number of this PaymentGatwayResponse.  # noqa: E501
        :type: str
        """

        self._number = number

    @property
    def type(self):
        """Gets the type of this PaymentGatwayResponse.  # noqa: E501

        The type of the payment gateway  # noqa: E501

        :return: The type of this PaymentGatwayResponse.  # noqa: E501
        :rtype: str
        """
        return self._type

    @type.setter
    def type(self, type):
        """Sets the type of this PaymentGatwayResponse.

        The type of the payment gateway  # noqa: E501

        :param type: The type of this PaymentGatwayResponse.  # noqa: E501
        :type: str
        """

        self._type = type

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(PaymentGatwayResponse, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, PaymentGatwayResponse):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
