# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).  # noqa: E501

    OpenAPI spec version: 2024-05-20
    Contact: docs@zuora.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class PaymentMethodRequestMandateInfo(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'mandate_id': 'str',
        'mandate_reason': 'str',
        'mandate_status': 'str'
    }

    attribute_map = {
        'mandate_id': 'mandateId',
        'mandate_reason': 'mandateReason',
        'mandate_status': 'mandateStatus'
    }

    def __init__(self, mandate_id=None, mandate_reason=None, mandate_status=None):  # noqa: E501
        """PaymentMethodRequestMandateInfo - a model defined in Swagger"""  # noqa: E501
        self._mandate_id = None
        self._mandate_reason = None
        self._mandate_status = None
        self.discriminator = None
        if mandate_id is not None:
            self.mandate_id = mandate_id
        if mandate_reason is not None:
            self.mandate_reason = mandate_reason
        if mandate_status is not None:
            self.mandate_status = mandate_status

    @property
    def mandate_id(self):
        """Gets the mandate_id of this PaymentMethodRequestMandateInfo.  # noqa: E501

        The mandate ID.  When creating an ACH payment method, if you need to pass in tokenized information, use the `mandateId` instead of `tokenId` field.   # noqa: E501

        :return: The mandate_id of this PaymentMethodRequestMandateInfo.  # noqa: E501
        :rtype: str
        """
        return self._mandate_id

    @mandate_id.setter
    def mandate_id(self, mandate_id):
        """Sets the mandate_id of this PaymentMethodRequestMandateInfo.

        The mandate ID.  When creating an ACH payment method, if you need to pass in tokenized information, use the `mandateId` instead of `tokenId` field.   # noqa: E501

        :param mandate_id: The mandate_id of this PaymentMethodRequestMandateInfo.  # noqa: E501
        :type: str
        """

        self._mandate_id = mandate_id

    @property
    def mandate_reason(self):
        """Gets the mandate_reason of this PaymentMethodRequestMandateInfo.  # noqa: E501

        The reason of the mandate from the gateway side.   # noqa: E501

        :return: The mandate_reason of this PaymentMethodRequestMandateInfo.  # noqa: E501
        :rtype: str
        """
        return self._mandate_reason

    @mandate_reason.setter
    def mandate_reason(self, mandate_reason):
        """Sets the mandate_reason of this PaymentMethodRequestMandateInfo.

        The reason of the mandate from the gateway side.   # noqa: E501

        :param mandate_reason: The mandate_reason of this PaymentMethodRequestMandateInfo.  # noqa: E501
        :type: str
        """

        self._mandate_reason = mandate_reason

    @property
    def mandate_status(self):
        """Gets the mandate_status of this PaymentMethodRequestMandateInfo.  # noqa: E501

        The status of the mandate from the gateway side.   # noqa: E501

        :return: The mandate_status of this PaymentMethodRequestMandateInfo.  # noqa: E501
        :rtype: str
        """
        return self._mandate_status

    @mandate_status.setter
    def mandate_status(self, mandate_status):
        """Sets the mandate_status of this PaymentMethodRequestMandateInfo.

        The status of the mandate from the gateway side.   # noqa: E501

        :param mandate_status: The mandate_status of this PaymentMethodRequestMandateInfo.  # noqa: E501
        :type: str
        """

        self._mandate_status = mandate_status

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(PaymentMethodRequestMandateInfo, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, PaymentMethodRequestMandateInfo):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
