# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).  # noqa: E501

    OpenAPI spec version: 2024-05-20
    Contact: docs@zuora.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class PaymentMethodResponsePayPal(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'baid': 'str',
        'email': 'str',
        'preapproval_key': 'str'
    }

    attribute_map = {
        'baid': 'BAID',
        'email': 'email',
        'preapproval_key': 'preapprovalKey'
    }

    def __init__(self, baid=None, email=None, preapproval_key=None):  # noqa: E501
        """PaymentMethodResponsePayPal - a model defined in Swagger"""  # noqa: E501
        self._baid = None
        self._email = None
        self._preapproval_key = None
        self.discriminator = None
        if baid is not None:
            self.baid = baid
        if email is not None:
            self.email = email
        if preapproval_key is not None:
            self.preapproval_key = preapproval_key

    @property
    def baid(self):
        """Gets the baid of this PaymentMethodResponsePayPal.  # noqa: E501

        ID of a PayPal billing agreement. For example, I-1TJ3GAGG82Y9.   # noqa: E501

        :return: The baid of this PaymentMethodResponsePayPal.  # noqa: E501
        :rtype: str
        """
        return self._baid

    @baid.setter
    def baid(self, baid):
        """Sets the baid of this PaymentMethodResponsePayPal.

        ID of a PayPal billing agreement. For example, I-1TJ3GAGG82Y9.   # noqa: E501

        :param baid: The baid of this PaymentMethodResponsePayPal.  # noqa: E501
        :type: str
        """

        self._baid = baid

    @property
    def email(self):
        """Gets the email of this PaymentMethodResponsePayPal.  # noqa: E501

        Email address associated with the PayPal payment method.    # noqa: E501

        :return: The email of this PaymentMethodResponsePayPal.  # noqa: E501
        :rtype: str
        """
        return self._email

    @email.setter
    def email(self, email):
        """Sets the email of this PaymentMethodResponsePayPal.

        Email address associated with the PayPal payment method.    # noqa: E501

        :param email: The email of this PaymentMethodResponsePayPal.  # noqa: E501
        :type: str
        """

        self._email = email

    @property
    def preapproval_key(self):
        """Gets the preapproval_key of this PaymentMethodResponsePayPal.  # noqa: E501

        The PayPal preapproval key.   # noqa: E501

        :return: The preapproval_key of this PaymentMethodResponsePayPal.  # noqa: E501
        :rtype: str
        """
        return self._preapproval_key

    @preapproval_key.setter
    def preapproval_key(self, preapproval_key):
        """Sets the preapproval_key of this PaymentMethodResponsePayPal.

        The PayPal preapproval key.   # noqa: E501

        :param preapproval_key: The preapproval_key of this PaymentMethodResponsePayPal.  # noqa: E501
        :type: str
        """

        self._preapproval_key = preapproval_key

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(PaymentMethodResponsePayPal, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, PaymentMethodResponsePayPal):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
