# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).  # noqa: E501

    OpenAPI spec version: 2024-05-20
    Contact: docs@zuora.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class PaymentMethodTransactionLogResponse(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'gateway': 'str',
        'gateway_reason_code': 'str',
        'gateway_reason_code_description': 'str',
        'gateway_transaction_type': 'str',
        'id': 'str',
        'payment_method_id': 'str',
        'payment_method_type': 'str',
        'request_string': 'str',
        'response_string': 'str',
        'transaction_date': 'datetime',
        'transaction_id': 'str'
    }

    attribute_map = {
        'gateway': 'Gateway',
        'gateway_reason_code': 'GatewayReasonCode',
        'gateway_reason_code_description': 'GatewayReasonCodeDescription',
        'gateway_transaction_type': 'GatewayTransactionType',
        'id': 'Id',
        'payment_method_id': 'PaymentMethodId',
        'payment_method_type': 'PaymentMethodType',
        'request_string': 'RequestString',
        'response_string': 'ResponseString',
        'transaction_date': 'TransactionDate',
        'transaction_id': 'TransactionId'
    }

    def __init__(self, gateway=None, gateway_reason_code=None, gateway_reason_code_description=None, gateway_transaction_type=None, id=None, payment_method_id=None, payment_method_type=None, request_string=None, response_string=None, transaction_date=None, transaction_id=None):  # noqa: E501
        """PaymentMethodTransactionLogResponse - a model defined in Swagger"""  # noqa: E501
        self._gateway = None
        self._gateway_reason_code = None
        self._gateway_reason_code_description = None
        self._gateway_transaction_type = None
        self._id = None
        self._payment_method_id = None
        self._payment_method_type = None
        self._request_string = None
        self._response_string = None
        self._transaction_date = None
        self._transaction_id = None
        self.discriminator = None
        if gateway is not None:
            self.gateway = gateway
        if gateway_reason_code is not None:
            self.gateway_reason_code = gateway_reason_code
        if gateway_reason_code_description is not None:
            self.gateway_reason_code_description = gateway_reason_code_description
        if gateway_transaction_type is not None:
            self.gateway_transaction_type = gateway_transaction_type
        if id is not None:
            self.id = id
        if payment_method_id is not None:
            self.payment_method_id = payment_method_id
        if payment_method_type is not None:
            self.payment_method_type = payment_method_type
        if request_string is not None:
            self.request_string = request_string
        if response_string is not None:
            self.response_string = response_string
        if transaction_date is not None:
            self.transaction_date = transaction_date
        if transaction_id is not None:
            self.transaction_id = transaction_id

    @property
    def gateway(self):
        """Gets the gateway of this PaymentMethodTransactionLogResponse.  # noqa: E501


        :return: The gateway of this PaymentMethodTransactionLogResponse.  # noqa: E501
        :rtype: str
        """
        return self._gateway

    @gateway.setter
    def gateway(self, gateway):
        """Sets the gateway of this PaymentMethodTransactionLogResponse.


        :param gateway: The gateway of this PaymentMethodTransactionLogResponse.  # noqa: E501
        :type: str
        """

        self._gateway = gateway

    @property
    def gateway_reason_code(self):
        """Gets the gateway_reason_code of this PaymentMethodTransactionLogResponse.  # noqa: E501


        :return: The gateway_reason_code of this PaymentMethodTransactionLogResponse.  # noqa: E501
        :rtype: str
        """
        return self._gateway_reason_code

    @gateway_reason_code.setter
    def gateway_reason_code(self, gateway_reason_code):
        """Sets the gateway_reason_code of this PaymentMethodTransactionLogResponse.


        :param gateway_reason_code: The gateway_reason_code of this PaymentMethodTransactionLogResponse.  # noqa: E501
        :type: str
        """

        self._gateway_reason_code = gateway_reason_code

    @property
    def gateway_reason_code_description(self):
        """Gets the gateway_reason_code_description of this PaymentMethodTransactionLogResponse.  # noqa: E501


        :return: The gateway_reason_code_description of this PaymentMethodTransactionLogResponse.  # noqa: E501
        :rtype: str
        """
        return self._gateway_reason_code_description

    @gateway_reason_code_description.setter
    def gateway_reason_code_description(self, gateway_reason_code_description):
        """Sets the gateway_reason_code_description of this PaymentMethodTransactionLogResponse.


        :param gateway_reason_code_description: The gateway_reason_code_description of this PaymentMethodTransactionLogResponse.  # noqa: E501
        :type: str
        """

        self._gateway_reason_code_description = gateway_reason_code_description

    @property
    def gateway_transaction_type(self):
        """Gets the gateway_transaction_type of this PaymentMethodTransactionLogResponse.  # noqa: E501


        :return: The gateway_transaction_type of this PaymentMethodTransactionLogResponse.  # noqa: E501
        :rtype: str
        """
        return self._gateway_transaction_type

    @gateway_transaction_type.setter
    def gateway_transaction_type(self, gateway_transaction_type):
        """Sets the gateway_transaction_type of this PaymentMethodTransactionLogResponse.


        :param gateway_transaction_type: The gateway_transaction_type of this PaymentMethodTransactionLogResponse.  # noqa: E501
        :type: str
        """

        self._gateway_transaction_type = gateway_transaction_type

    @property
    def id(self):
        """Gets the id of this PaymentMethodTransactionLogResponse.  # noqa: E501

        Object identifier.  # noqa: E501

        :return: The id of this PaymentMethodTransactionLogResponse.  # noqa: E501
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this PaymentMethodTransactionLogResponse.

        Object identifier.  # noqa: E501

        :param id: The id of this PaymentMethodTransactionLogResponse.  # noqa: E501
        :type: str
        """

        self._id = id

    @property
    def payment_method_id(self):
        """Gets the payment_method_id of this PaymentMethodTransactionLogResponse.  # noqa: E501


        :return: The payment_method_id of this PaymentMethodTransactionLogResponse.  # noqa: E501
        :rtype: str
        """
        return self._payment_method_id

    @payment_method_id.setter
    def payment_method_id(self, payment_method_id):
        """Sets the payment_method_id of this PaymentMethodTransactionLogResponse.


        :param payment_method_id: The payment_method_id of this PaymentMethodTransactionLogResponse.  # noqa: E501
        :type: str
        """

        self._payment_method_id = payment_method_id

    @property
    def payment_method_type(self):
        """Gets the payment_method_type of this PaymentMethodTransactionLogResponse.  # noqa: E501


        :return: The payment_method_type of this PaymentMethodTransactionLogResponse.  # noqa: E501
        :rtype: str
        """
        return self._payment_method_type

    @payment_method_type.setter
    def payment_method_type(self, payment_method_type):
        """Sets the payment_method_type of this PaymentMethodTransactionLogResponse.


        :param payment_method_type: The payment_method_type of this PaymentMethodTransactionLogResponse.  # noqa: E501
        :type: str
        """

        self._payment_method_type = payment_method_type

    @property
    def request_string(self):
        """Gets the request_string of this PaymentMethodTransactionLogResponse.  # noqa: E501


        :return: The request_string of this PaymentMethodTransactionLogResponse.  # noqa: E501
        :rtype: str
        """
        return self._request_string

    @request_string.setter
    def request_string(self, request_string):
        """Sets the request_string of this PaymentMethodTransactionLogResponse.


        :param request_string: The request_string of this PaymentMethodTransactionLogResponse.  # noqa: E501
        :type: str
        """

        self._request_string = request_string

    @property
    def response_string(self):
        """Gets the response_string of this PaymentMethodTransactionLogResponse.  # noqa: E501


        :return: The response_string of this PaymentMethodTransactionLogResponse.  # noqa: E501
        :rtype: str
        """
        return self._response_string

    @response_string.setter
    def response_string(self, response_string):
        """Sets the response_string of this PaymentMethodTransactionLogResponse.


        :param response_string: The response_string of this PaymentMethodTransactionLogResponse.  # noqa: E501
        :type: str
        """

        self._response_string = response_string

    @property
    def transaction_date(self):
        """Gets the transaction_date of this PaymentMethodTransactionLogResponse.  # noqa: E501


        :return: The transaction_date of this PaymentMethodTransactionLogResponse.  # noqa: E501
        :rtype: datetime
        """
        return self._transaction_date

    @transaction_date.setter
    def transaction_date(self, transaction_date):
        """Sets the transaction_date of this PaymentMethodTransactionLogResponse.


        :param transaction_date: The transaction_date of this PaymentMethodTransactionLogResponse.  # noqa: E501
        :type: datetime
        """

        self._transaction_date = transaction_date

    @property
    def transaction_id(self):
        """Gets the transaction_id of this PaymentMethodTransactionLogResponse.  # noqa: E501


        :return: The transaction_id of this PaymentMethodTransactionLogResponse.  # noqa: E501
        :rtype: str
        """
        return self._transaction_id

    @transaction_id.setter
    def transaction_id(self, transaction_id):
        """Sets the transaction_id of this PaymentMethodTransactionLogResponse.


        :param transaction_id: The transaction_id of this PaymentMethodTransactionLogResponse.  # noqa: E501
        :type: str
        """

        self._transaction_id = transaction_id

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(PaymentMethodTransactionLogResponse, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, PaymentMethodTransactionLogResponse):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
