# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).  # noqa: E501

    OpenAPI spec version: 2024-05-20
    Contact: docs@zuora.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class PaymentScheduleBillingDocument(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'id': 'str',
        'number': 'str',
        'type': 'PostPaymentScheduleRequestAllOfBillingDocumentType'
    }

    attribute_map = {
        'id': 'id',
        'number': 'number',
        'type': 'type'
    }

    def __init__(self, id=None, number=None, type=None):  # noqa: E501
        """PaymentScheduleBillingDocument - a model defined in Swagger"""  # noqa: E501
        self._id = None
        self._number = None
        self._type = None
        self.discriminator = None
        if id is not None:
            self.id = id
        if number is not None:
            self.number = number
        self.type = type

    @property
    def id(self):
        """Gets the id of this PaymentScheduleBillingDocument.  # noqa: E501

        ID of the billing document.  **Note:**  If a billing document is specified, either `id` or `number` of the billing document must be specified. You cannot specify both of them or skip both.   # noqa: E501

        :return: The id of this PaymentScheduleBillingDocument.  # noqa: E501
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this PaymentScheduleBillingDocument.

        ID of the billing document.  **Note:**  If a billing document is specified, either `id` or `number` of the billing document must be specified. You cannot specify both of them or skip both.   # noqa: E501

        :param id: The id of this PaymentScheduleBillingDocument.  # noqa: E501
        :type: str
        """

        self._id = id

    @property
    def number(self):
        """Gets the number of this PaymentScheduleBillingDocument.  # noqa: E501

        ID of the billing document.  **Note:**  If a billing document is specified, either `id` or `number` of the billing document must be specified. You cannot specify both of them or skip both.   # noqa: E501

        :return: The number of this PaymentScheduleBillingDocument.  # noqa: E501
        :rtype: str
        """
        return self._number

    @number.setter
    def number(self, number):
        """Sets the number of this PaymentScheduleBillingDocument.

        ID of the billing document.  **Note:**  If a billing document is specified, either `id` or `number` of the billing document must be specified. You cannot specify both of them or skip both.   # noqa: E501

        :param number: The number of this PaymentScheduleBillingDocument.  # noqa: E501
        :type: str
        """

        self._number = number

    @property
    def type(self):
        """Gets the type of this PaymentScheduleBillingDocument.  # noqa: E501


        :return: The type of this PaymentScheduleBillingDocument.  # noqa: E501
        :rtype: PostPaymentScheduleRequestAllOfBillingDocumentType
        """
        return self._type

    @type.setter
    def type(self, type):
        """Sets the type of this PaymentScheduleBillingDocument.


        :param type: The type of this PaymentScheduleBillingDocument.  # noqa: E501
        :type: PostPaymentScheduleRequestAllOfBillingDocumentType
        """
        if type is None:
            raise ValueError("Invalid value for `type`, must not be `None`")  # noqa: E501

        self._type = type

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(PaymentScheduleBillingDocument, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, PaymentScheduleBillingDocument):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
