# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).  # noqa: E501

    OpenAPI spec version: 2024-05-20
    Contact: docs@zuora.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class PaymentVolumeSummaryRecord(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'error': 'int',
        'payment_gateway_type': 'str',
        'payment_method_type': 'str',
        'success': 'int',
        'total': 'int'
    }

    attribute_map = {
        'error': 'error',
        'payment_gateway_type': 'paymentGatewayType',
        'payment_method_type': 'paymentMethodType',
        'success': 'success',
        'total': 'total'
    }

    def __init__(self, error=None, payment_gateway_type=None, payment_method_type=None, success=None, total=None):  # noqa: E501
        """PaymentVolumeSummaryRecord - a model defined in Swagger"""  # noqa: E501
        self._error = None
        self._payment_gateway_type = None
        self._payment_method_type = None
        self._success = None
        self._total = None
        self.discriminator = None
        if error is not None:
            self.error = error
        if payment_gateway_type is not None:
            self.payment_gateway_type = payment_gateway_type
        if payment_method_type is not None:
            self.payment_method_type = payment_method_type
        if success is not None:
            self.success = success
        if total is not None:
            self.total = total

    @property
    def error(self):
        """Gets the error of this PaymentVolumeSummaryRecord.  # noqa: E501

        The count of failed payments of above `paymentGatewayType` and `paymentMethodType`.   # noqa: E501

        :return: The error of this PaymentVolumeSummaryRecord.  # noqa: E501
        :rtype: int
        """
        return self._error

    @error.setter
    def error(self, error):
        """Sets the error of this PaymentVolumeSummaryRecord.

        The count of failed payments of above `paymentGatewayType` and `paymentMethodType`.   # noqa: E501

        :param error: The error of this PaymentVolumeSummaryRecord.  # noqa: E501
        :type: int
        """

        self._error = error

    @property
    def payment_gateway_type(self):
        """Gets the payment_gateway_type of this PaymentVolumeSummaryRecord.  # noqa: E501

        The payment gateway type.   # noqa: E501

        :return: The payment_gateway_type of this PaymentVolumeSummaryRecord.  # noqa: E501
        :rtype: str
        """
        return self._payment_gateway_type

    @payment_gateway_type.setter
    def payment_gateway_type(self, payment_gateway_type):
        """Sets the payment_gateway_type of this PaymentVolumeSummaryRecord.

        The payment gateway type.   # noqa: E501

        :param payment_gateway_type: The payment_gateway_type of this PaymentVolumeSummaryRecord.  # noqa: E501
        :type: str
        """

        self._payment_gateway_type = payment_gateway_type

    @property
    def payment_method_type(self):
        """Gets the payment_method_type of this PaymentVolumeSummaryRecord.  # noqa: E501

        The payment method type.   # noqa: E501

        :return: The payment_method_type of this PaymentVolumeSummaryRecord.  # noqa: E501
        :rtype: str
        """
        return self._payment_method_type

    @payment_method_type.setter
    def payment_method_type(self, payment_method_type):
        """Sets the payment_method_type of this PaymentVolumeSummaryRecord.

        The payment method type.   # noqa: E501

        :param payment_method_type: The payment_method_type of this PaymentVolumeSummaryRecord.  # noqa: E501
        :type: str
        """

        self._payment_method_type = payment_method_type

    @property
    def success(self):
        """Gets the success of this PaymentVolumeSummaryRecord.  # noqa: E501

        The count of successful payments of above `paymentGatewayType` and `paymentMethodType`.   # noqa: E501

        :return: The success of this PaymentVolumeSummaryRecord.  # noqa: E501
        :rtype: int
        """
        return self._success

    @success.setter
    def success(self, success):
        """Sets the success of this PaymentVolumeSummaryRecord.

        The count of successful payments of above `paymentGatewayType` and `paymentMethodType`.   # noqa: E501

        :param success: The success of this PaymentVolumeSummaryRecord.  # noqa: E501
        :type: int
        """

        self._success = success

    @property
    def total(self):
        """Gets the total of this PaymentVolumeSummaryRecord.  # noqa: E501

        The count of total payments of above `paymentGatewayType` and `paymentMethodType`.        # noqa: E501

        :return: The total of this PaymentVolumeSummaryRecord.  # noqa: E501
        :rtype: int
        """
        return self._total

    @total.setter
    def total(self, total):
        """Sets the total of this PaymentVolumeSummaryRecord.

        The count of total payments of above `paymentGatewayType` and `paymentMethodType`.        # noqa: E501

        :param total: The total of this PaymentVolumeSummaryRecord.  # noqa: E501
        :type: int
        """

        self._total = total

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(PaymentVolumeSummaryRecord, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, PaymentVolumeSummaryRecord):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
