# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).  # noqa: E501

    OpenAPI spec version: 2024-05-20
    Contact: docs@zuora.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six
from zuora_sdk.models.common_response import CommonResponse  # noqa: F401,E501

class PostAttachmentResponse(CommonResponse):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'request_id': 'str',
        'file_id': 'str',
        'id': 'str',
        'success': 'bool'
    }
    if hasattr(CommonResponse, "swagger_types"):
        swagger_types.update(CommonResponse.swagger_types)

    attribute_map = {
        'request_id': 'requestId',
        'file_id': 'fileId',
        'id': 'id',
        'success': 'success'
    }
    if hasattr(CommonResponse, "attribute_map"):
        attribute_map.update(CommonResponse.attribute_map)

    def __init__(self, request_id=None, file_id=None, id=None, success=None, *args, **kwargs):  # noqa: E501
        """PostAttachmentResponse - a model defined in Swagger"""  # noqa: E501
        self._request_id = None
        self._file_id = None
        self._id = None
        self._success = None
        self.discriminator = None
        if request_id is not None:
            self.request_id = request_id
        if file_id is not None:
            self.file_id = file_id
        if id is not None:
            self.id = id
        if success is not None:
            self.success = success
        CommonResponse.__init__(self, *args, **kwargs)

    @property
    def request_id(self):
        """Gets the request_id of this PostAttachmentResponse.  # noqa: E501

        The request ID of this process.   # noqa: E501

        :return: The request_id of this PostAttachmentResponse.  # noqa: E501
        :rtype: str
        """
        return self._request_id

    @request_id.setter
    def request_id(self, request_id):
        """Sets the request_id of this PostAttachmentResponse.

        The request ID of this process.   # noqa: E501

        :param request_id: The request_id of this PostAttachmentResponse.  # noqa: E501
        :type: str
        """

        self._request_id = request_id

    @property
    def file_id(self):
        """Gets the file_id of this PostAttachmentResponse.  # noqa: E501

        ID to identify the attached file. Use this file ID with [Get files](https://www.zuora.com/developer/api-references/api/operation/Get_Files) to download the file.   # noqa: E501

        :return: The file_id of this PostAttachmentResponse.  # noqa: E501
        :rtype: str
        """
        return self._file_id

    @file_id.setter
    def file_id(self, file_id):
        """Sets the file_id of this PostAttachmentResponse.

        ID to identify the attached file. Use this file ID with [Get files](https://www.zuora.com/developer/api-references/api/operation/Get_Files) to download the file.   # noqa: E501

        :param file_id: The file_id of this PostAttachmentResponse.  # noqa: E501
        :type: str
        """

        self._file_id = file_id

    @property
    def id(self):
        """Gets the id of this PostAttachmentResponse.  # noqa: E501

        Attachment id.   # noqa: E501

        :return: The id of this PostAttachmentResponse.  # noqa: E501
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this PostAttachmentResponse.

        Attachment id.   # noqa: E501

        :param id: The id of this PostAttachmentResponse.  # noqa: E501
        :type: str
        """

        self._id = id

    @property
    def success(self):
        """Gets the success of this PostAttachmentResponse.  # noqa: E501

        Returns `true` if the request was processed successfully.   # noqa: E501

        :return: The success of this PostAttachmentResponse.  # noqa: E501
        :rtype: bool
        """
        return self._success

    @success.setter
    def success(self, success):
        """Sets the success of this PostAttachmentResponse.

        Returns `true` if the request was processed successfully.   # noqa: E501

        :param success: The success of this PostAttachmentResponse.  # noqa: E501
        :type: bool
        """

        self._success = success

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(PostAttachmentResponse, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, PostAttachmentResponse):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
