# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).  # noqa: E501

    OpenAPI spec version: 2024-05-20
    Contact: docs@zuora.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class PostCreateOrUpdateEmailTemplateRequest(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'allow_partial_success': 'bool',
        'email_templates': 'list[PostCreateOrUpdateEmailTemplateRequestFormat]'
    }

    attribute_map = {
        'allow_partial_success': 'allowPartialSuccess',
        'email_templates': 'emailTemplates'
    }

    def __init__(self, allow_partial_success=None, email_templates=None):  # noqa: E501
        """PostCreateOrUpdateEmailTemplateRequest - a model defined in Swagger"""  # noqa: E501
        self._allow_partial_success = None
        self._email_templates = None
        self.discriminator = None
        if allow_partial_success is not None:
            self.allow_partial_success = allow_partial_success
        if email_templates is not None:
            self.email_templates = email_templates

    @property
    def allow_partial_success(self):
        """Gets the allow_partial_success of this PostCreateOrUpdateEmailTemplateRequest.  # noqa: E501

        When set to `false`, the call will fail if one or multiple instances fail to import, and a `200` response is returned if all email templates have been successfully updated. When set to `true`, a success (`200`) response is returned if one or more instances have imported successfully. All failed instances are also returned in the response.   # noqa: E501

        :return: The allow_partial_success of this PostCreateOrUpdateEmailTemplateRequest.  # noqa: E501
        :rtype: bool
        """
        return self._allow_partial_success

    @allow_partial_success.setter
    def allow_partial_success(self, allow_partial_success):
        """Sets the allow_partial_success of this PostCreateOrUpdateEmailTemplateRequest.

        When set to `false`, the call will fail if one or multiple instances fail to import, and a `200` response is returned if all email templates have been successfully updated. When set to `true`, a success (`200`) response is returned if one or more instances have imported successfully. All failed instances are also returned in the response.   # noqa: E501

        :param allow_partial_success: The allow_partial_success of this PostCreateOrUpdateEmailTemplateRequest.  # noqa: E501
        :type: bool
        """

        self._allow_partial_success = allow_partial_success

    @property
    def email_templates(self):
        """Gets the email_templates of this PostCreateOrUpdateEmailTemplateRequest.  # noqa: E501

        A container for email templates.   # noqa: E501

        :return: The email_templates of this PostCreateOrUpdateEmailTemplateRequest.  # noqa: E501
        :rtype: list[PostCreateOrUpdateEmailTemplateRequestFormat]
        """
        return self._email_templates

    @email_templates.setter
    def email_templates(self, email_templates):
        """Sets the email_templates of this PostCreateOrUpdateEmailTemplateRequest.

        A container for email templates.   # noqa: E501

        :param email_templates: The email_templates of this PostCreateOrUpdateEmailTemplateRequest.  # noqa: E501
        :type: list[PostCreateOrUpdateEmailTemplateRequestFormat]
        """

        self._email_templates = email_templates

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(PostCreateOrUpdateEmailTemplateRequest, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, PostCreateOrUpdateEmailTemplateRequest):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
