# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).  # noqa: E501

    OpenAPI spec version: 2024-05-20
    Contact: docs@zuora.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class PostCreditMemoRequest(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'credit_memo_date': 'date'
    }

    attribute_map = {
        'credit_memo_date': 'creditMemoDate'
    }

    def __init__(self, credit_memo_date=None):  # noqa: E501
        """PostCreditMemoRequest - a model defined in Swagger"""  # noqa: E501
        self._credit_memo_date = None
        self.discriminator = None
        if credit_memo_date is not None:
            self.credit_memo_date = credit_memo_date

    @property
    def credit_memo_date(self):
        """Gets the credit_memo_date of this PostCreditMemoRequest.  # noqa: E501

        The new memo date when posting the credit memo. By default, it will use current memo date of the credit memo.   # noqa: E501

        :return: The credit_memo_date of this PostCreditMemoRequest.  # noqa: E501
        :rtype: date
        """
        return self._credit_memo_date

    @credit_memo_date.setter
    def credit_memo_date(self, credit_memo_date):
        """Sets the credit_memo_date of this PostCreditMemoRequest.

        The new memo date when posting the credit memo. By default, it will use current memo date of the credit memo.   # noqa: E501

        :param credit_memo_date: The credit_memo_date of this PostCreditMemoRequest.  # noqa: E501
        :type: date
        """

        self._credit_memo_date = credit_memo_date

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(PostCreditMemoRequest, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, PostCreditMemoRequest):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
