# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).  # noqa: E501

    OpenAPI spec version: 2024-05-20
    Contact: docs@zuora.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class PostCustomObjectRecordsRequest(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'allow_partial_success': 'bool',
        'records': 'list[CustomObjectRecordWithOnlyCustomFields]'
    }

    attribute_map = {
        'allow_partial_success': 'allowPartialSuccess',
        'records': 'records'
    }

    def __init__(self, allow_partial_success=False, records=None):  # noqa: E501
        """PostCustomObjectRecordsRequest - a model defined in Swagger"""  # noqa: E501
        self._allow_partial_success = None
        self._records = None
        self.discriminator = None
        if allow_partial_success is not None:
            self.allow_partial_success = allow_partial_success
        self.records = records

    @property
    def allow_partial_success(self):
        """Gets the allow_partial_success of this PostCustomObjectRecordsRequest.  # noqa: E501

        Indicates whether the records that pass the schema validation should be created when not all records in the request pass the schema validation.  # noqa: E501

        :return: The allow_partial_success of this PostCustomObjectRecordsRequest.  # noqa: E501
        :rtype: bool
        """
        return self._allow_partial_success

    @allow_partial_success.setter
    def allow_partial_success(self, allow_partial_success):
        """Sets the allow_partial_success of this PostCustomObjectRecordsRequest.

        Indicates whether the records that pass the schema validation should be created when not all records in the request pass the schema validation.  # noqa: E501

        :param allow_partial_success: The allow_partial_success of this PostCustomObjectRecordsRequest.  # noqa: E501
        :type: bool
        """

        self._allow_partial_success = allow_partial_success

    @property
    def records(self):
        """Gets the records of this PostCustomObjectRecordsRequest.  # noqa: E501

        A list of custom object records to be created  # noqa: E501

        :return: The records of this PostCustomObjectRecordsRequest.  # noqa: E501
        :rtype: list[CustomObjectRecordWithOnlyCustomFields]
        """
        return self._records

    @records.setter
    def records(self, records):
        """Sets the records of this PostCustomObjectRecordsRequest.

        A list of custom object records to be created  # noqa: E501

        :param records: The records of this PostCustomObjectRecordsRequest.  # noqa: E501
        :type: list[CustomObjectRecordWithOnlyCustomFields]
        """
        if records is None:
            raise ValueError("Invalid value for `records`, must not be `None`")  # noqa: E501

        self._records = records

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(PostCustomObjectRecordsRequest, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, PostCustomObjectRecordsRequest):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
