# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).  # noqa: E501

    OpenAPI spec version: 2024-05-20
    Contact: docs@zuora.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class PostCustomObjectRecordsResponse(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'error': 'CustomObjectRecordsErrorResponse',
        'records': 'list[CustomObjectRecordWithAllFields]'
    }

    attribute_map = {
        'error': 'error',
        'records': 'records'
    }

    def __init__(self, error=None, records=None):  # noqa: E501
        """PostCustomObjectRecordsResponse - a model defined in Swagger"""  # noqa: E501
        self._error = None
        self._records = None
        self.discriminator = None
        if error is not None:
            self.error = error
        if records is not None:
            self.records = records

    @property
    def error(self):
        """Gets the error of this PostCustomObjectRecordsResponse.  # noqa: E501


        :return: The error of this PostCustomObjectRecordsResponse.  # noqa: E501
        :rtype: CustomObjectRecordsErrorResponse
        """
        return self._error

    @error.setter
    def error(self, error):
        """Sets the error of this PostCustomObjectRecordsResponse.


        :param error: The error of this PostCustomObjectRecordsResponse.  # noqa: E501
        :type: CustomObjectRecordsErrorResponse
        """

        self._error = error

    @property
    def records(self):
        """Gets the records of this PostCustomObjectRecordsResponse.  # noqa: E501

        The custom object records that are succesfully created and stored  # noqa: E501

        :return: The records of this PostCustomObjectRecordsResponse.  # noqa: E501
        :rtype: list[CustomObjectRecordWithAllFields]
        """
        return self._records

    @records.setter
    def records(self, records):
        """Sets the records of this PostCustomObjectRecordsResponse.

        The custom object records that are succesfully created and stored  # noqa: E501

        :param records: The records of this PostCustomObjectRecordsResponse.  # noqa: E501
        :type: list[CustomObjectRecordWithAllFields]
        """

        self._records = records

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(PostCustomObjectRecordsResponse, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, PostCustomObjectRecordsResponse):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
