# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).  # noqa: E501

    OpenAPI spec version: 2024-05-20
    Contact: docs@zuora.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class PreviewExistingSubscriptionCreditMemoItemResult(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'service_start_date': 'date',
        'service_end_date': 'date',
        'amount_without_tax': 'float',
        'tax_amount': 'float',
        'charge_description': 'str',
        'charge_name': 'str',
        'charge_number': 'str',
        'product_name': 'str',
        'product_rate_plan_charge_id': 'str',
        'processing_type': 'InvoiceItemPreviewResultProcessingType',
        'unit_price': 'float',
        'quantity': 'float',
        'unit_of_measure': 'str',
        'discount_details': 'list[PreviewExistingSubscriptionDiscountDetails]'
    }

    attribute_map = {
        'service_start_date': 'serviceStartDate',
        'service_end_date': 'serviceEndDate',
        'amount_without_tax': 'amountWithoutTax',
        'tax_amount': 'taxAmount',
        'charge_description': 'chargeDescription',
        'charge_name': 'chargeName',
        'charge_number': 'chargeNumber',
        'product_name': 'productName',
        'product_rate_plan_charge_id': 'productRatePlanChargeId',
        'processing_type': 'processingType',
        'unit_price': 'unitPrice',
        'quantity': 'quantity',
        'unit_of_measure': 'unitOfMeasure',
        'discount_details': 'discountDetails'
    }

    def __init__(self, service_start_date=None, service_end_date=None, amount_without_tax=None, tax_amount=None, charge_description=None, charge_name=None, charge_number=None, product_name=None, product_rate_plan_charge_id=None, processing_type=None, unit_price=None, quantity=None, unit_of_measure=None, discount_details=None):  # noqa: E501
        """PreviewExistingSubscriptionCreditMemoItemResult - a model defined in Swagger"""  # noqa: E501
        self._service_start_date = None
        self._service_end_date = None
        self._amount_without_tax = None
        self._tax_amount = None
        self._charge_description = None
        self._charge_name = None
        self._charge_number = None
        self._product_name = None
        self._product_rate_plan_charge_id = None
        self._processing_type = None
        self._unit_price = None
        self._quantity = None
        self._unit_of_measure = None
        self._discount_details = None
        self.discriminator = None
        if service_start_date is not None:
            self.service_start_date = service_start_date
        if service_end_date is not None:
            self.service_end_date = service_end_date
        if amount_without_tax is not None:
            self.amount_without_tax = amount_without_tax
        if tax_amount is not None:
            self.tax_amount = tax_amount
        if charge_description is not None:
            self.charge_description = charge_description
        if charge_name is not None:
            self.charge_name = charge_name
        if charge_number is not None:
            self.charge_number = charge_number
        if product_name is not None:
            self.product_name = product_name
        if product_rate_plan_charge_id is not None:
            self.product_rate_plan_charge_id = product_rate_plan_charge_id
        if processing_type is not None:
            self.processing_type = processing_type
        if unit_price is not None:
            self.unit_price = unit_price
        if quantity is not None:
            self.quantity = quantity
        if unit_of_measure is not None:
            self.unit_of_measure = unit_of_measure
        if discount_details is not None:
            self.discount_details = discount_details

    @property
    def service_start_date(self):
        """Gets the service_start_date of this PreviewExistingSubscriptionCreditMemoItemResult.  # noqa: E501

        Service start date as yyyy-mm-dd. If the charge is a one-time fee, this is the date of that charge.  # noqa: E501

        :return: The service_start_date of this PreviewExistingSubscriptionCreditMemoItemResult.  # noqa: E501
        :rtype: date
        """
        return self._service_start_date

    @service_start_date.setter
    def service_start_date(self, service_start_date):
        """Sets the service_start_date of this PreviewExistingSubscriptionCreditMemoItemResult.

        Service start date as yyyy-mm-dd. If the charge is a one-time fee, this is the date of that charge.  # noqa: E501

        :param service_start_date: The service_start_date of this PreviewExistingSubscriptionCreditMemoItemResult.  # noqa: E501
        :type: date
        """

        self._service_start_date = service_start_date

    @property
    def service_end_date(self):
        """Gets the service_end_date of this PreviewExistingSubscriptionCreditMemoItemResult.  # noqa: E501

        End date of the service period for this item, i.e., the last day of the period, as yyyy-mm-dd.  # noqa: E501

        :return: The service_end_date of this PreviewExistingSubscriptionCreditMemoItemResult.  # noqa: E501
        :rtype: date
        """
        return self._service_end_date

    @service_end_date.setter
    def service_end_date(self, service_end_date):
        """Sets the service_end_date of this PreviewExistingSubscriptionCreditMemoItemResult.

        End date of the service period for this item, i.e., the last day of the period, as yyyy-mm-dd.  # noqa: E501

        :param service_end_date: The service_end_date of this PreviewExistingSubscriptionCreditMemoItemResult.  # noqa: E501
        :type: date
        """

        self._service_end_date = service_end_date

    @property
    def amount_without_tax(self):
        """Gets the amount_without_tax of this PreviewExistingSubscriptionCreditMemoItemResult.  # noqa: E501

        Credit memo amount minus tax.  # noqa: E501

        :return: The amount_without_tax of this PreviewExistingSubscriptionCreditMemoItemResult.  # noqa: E501
        :rtype: float
        """
        return self._amount_without_tax

    @amount_without_tax.setter
    def amount_without_tax(self, amount_without_tax):
        """Sets the amount_without_tax of this PreviewExistingSubscriptionCreditMemoItemResult.

        Credit memo amount minus tax.  # noqa: E501

        :param amount_without_tax: The amount_without_tax of this PreviewExistingSubscriptionCreditMemoItemResult.  # noqa: E501
        :type: float
        """

        self._amount_without_tax = amount_without_tax

    @property
    def tax_amount(self):
        """Gets the tax_amount of this PreviewExistingSubscriptionCreditMemoItemResult.  # noqa: E501

        The tax amount of the credit memo item.  # noqa: E501

        :return: The tax_amount of this PreviewExistingSubscriptionCreditMemoItemResult.  # noqa: E501
        :rtype: float
        """
        return self._tax_amount

    @tax_amount.setter
    def tax_amount(self, tax_amount):
        """Sets the tax_amount of this PreviewExistingSubscriptionCreditMemoItemResult.

        The tax amount of the credit memo item.  # noqa: E501

        :param tax_amount: The tax_amount of this PreviewExistingSubscriptionCreditMemoItemResult.  # noqa: E501
        :type: float
        """

        self._tax_amount = tax_amount

    @property
    def charge_description(self):
        """Gets the charge_description of this PreviewExistingSubscriptionCreditMemoItemResult.  # noqa: E501

        Description of the charge.  # noqa: E501

        :return: The charge_description of this PreviewExistingSubscriptionCreditMemoItemResult.  # noqa: E501
        :rtype: str
        """
        return self._charge_description

    @charge_description.setter
    def charge_description(self, charge_description):
        """Sets the charge_description of this PreviewExistingSubscriptionCreditMemoItemResult.

        Description of the charge.  # noqa: E501

        :param charge_description: The charge_description of this PreviewExistingSubscriptionCreditMemoItemResult.  # noqa: E501
        :type: str
        """

        self._charge_description = charge_description

    @property
    def charge_name(self):
        """Gets the charge_name of this PreviewExistingSubscriptionCreditMemoItemResult.  # noqa: E501

        Name of the charge.  # noqa: E501

        :return: The charge_name of this PreviewExistingSubscriptionCreditMemoItemResult.  # noqa: E501
        :rtype: str
        """
        return self._charge_name

    @charge_name.setter
    def charge_name(self, charge_name):
        """Sets the charge_name of this PreviewExistingSubscriptionCreditMemoItemResult.

        Name of the charge.  # noqa: E501

        :param charge_name: The charge_name of this PreviewExistingSubscriptionCreditMemoItemResult.  # noqa: E501
        :type: str
        """

        self._charge_name = charge_name

    @property
    def charge_number(self):
        """Gets the charge_number of this PreviewExistingSubscriptionCreditMemoItemResult.  # noqa: E501

        Available when the chargeNumber was specified in the request or when the order is amending an existing subscription.  # noqa: E501

        :return: The charge_number of this PreviewExistingSubscriptionCreditMemoItemResult.  # noqa: E501
        :rtype: str
        """
        return self._charge_number

    @charge_number.setter
    def charge_number(self, charge_number):
        """Sets the charge_number of this PreviewExistingSubscriptionCreditMemoItemResult.

        Available when the chargeNumber was specified in the request or when the order is amending an existing subscription.  # noqa: E501

        :param charge_number: The charge_number of this PreviewExistingSubscriptionCreditMemoItemResult.  # noqa: E501
        :type: str
        """

        self._charge_number = charge_number

    @property
    def product_name(self):
        """Gets the product_name of this PreviewExistingSubscriptionCreditMemoItemResult.  # noqa: E501

        Name of the product.  # noqa: E501

        :return: The product_name of this PreviewExistingSubscriptionCreditMemoItemResult.  # noqa: E501
        :rtype: str
        """
        return self._product_name

    @product_name.setter
    def product_name(self, product_name):
        """Sets the product_name of this PreviewExistingSubscriptionCreditMemoItemResult.

        Name of the product.  # noqa: E501

        :param product_name: The product_name of this PreviewExistingSubscriptionCreditMemoItemResult.  # noqa: E501
        :type: str
        """

        self._product_name = product_name

    @property
    def product_rate_plan_charge_id(self):
        """Gets the product_rate_plan_charge_id of this PreviewExistingSubscriptionCreditMemoItemResult.  # noqa: E501

        The ID of the product rate plan charge.  # noqa: E501

        :return: The product_rate_plan_charge_id of this PreviewExistingSubscriptionCreditMemoItemResult.  # noqa: E501
        :rtype: str
        """
        return self._product_rate_plan_charge_id

    @product_rate_plan_charge_id.setter
    def product_rate_plan_charge_id(self, product_rate_plan_charge_id):
        """Sets the product_rate_plan_charge_id of this PreviewExistingSubscriptionCreditMemoItemResult.

        The ID of the product rate plan charge.  # noqa: E501

        :param product_rate_plan_charge_id: The product_rate_plan_charge_id of this PreviewExistingSubscriptionCreditMemoItemResult.  # noqa: E501
        :type: str
        """

        self._product_rate_plan_charge_id = product_rate_plan_charge_id

    @property
    def processing_type(self):
        """Gets the processing_type of this PreviewExistingSubscriptionCreditMemoItemResult.  # noqa: E501


        :return: The processing_type of this PreviewExistingSubscriptionCreditMemoItemResult.  # noqa: E501
        :rtype: InvoiceItemPreviewResultProcessingType
        """
        return self._processing_type

    @processing_type.setter
    def processing_type(self, processing_type):
        """Sets the processing_type of this PreviewExistingSubscriptionCreditMemoItemResult.


        :param processing_type: The processing_type of this PreviewExistingSubscriptionCreditMemoItemResult.  # noqa: E501
        :type: InvoiceItemPreviewResultProcessingType
        """

        self._processing_type = processing_type

    @property
    def unit_price(self):
        """Gets the unit_price of this PreviewExistingSubscriptionCreditMemoItemResult.  # noqa: E501

        The unit price of the charge.  # noqa: E501

        :return: The unit_price of this PreviewExistingSubscriptionCreditMemoItemResult.  # noqa: E501
        :rtype: float
        """
        return self._unit_price

    @unit_price.setter
    def unit_price(self, unit_price):
        """Sets the unit_price of this PreviewExistingSubscriptionCreditMemoItemResult.

        The unit price of the charge.  # noqa: E501

        :param unit_price: The unit_price of this PreviewExistingSubscriptionCreditMemoItemResult.  # noqa: E501
        :type: float
        """

        self._unit_price = unit_price

    @property
    def quantity(self):
        """Gets the quantity of this PreviewExistingSubscriptionCreditMemoItemResult.  # noqa: E501

        The quantity of the charge.  # noqa: E501

        :return: The quantity of this PreviewExistingSubscriptionCreditMemoItemResult.  # noqa: E501
        :rtype: float
        """
        return self._quantity

    @quantity.setter
    def quantity(self, quantity):
        """Sets the quantity of this PreviewExistingSubscriptionCreditMemoItemResult.

        The quantity of the charge.  # noqa: E501

        :param quantity: The quantity of this PreviewExistingSubscriptionCreditMemoItemResult.  # noqa: E501
        :type: float
        """

        self._quantity = quantity

    @property
    def unit_of_measure(self):
        """Gets the unit_of_measure of this PreviewExistingSubscriptionCreditMemoItemResult.  # noqa: E501

        The unit of measure of the charge.  # noqa: E501

        :return: The unit_of_measure of this PreviewExistingSubscriptionCreditMemoItemResult.  # noqa: E501
        :rtype: str
        """
        return self._unit_of_measure

    @unit_of_measure.setter
    def unit_of_measure(self, unit_of_measure):
        """Sets the unit_of_measure of this PreviewExistingSubscriptionCreditMemoItemResult.

        The unit of measure of the charge.  # noqa: E501

        :param unit_of_measure: The unit_of_measure of this PreviewExistingSubscriptionCreditMemoItemResult.  # noqa: E501
        :type: str
        """

        self._unit_of_measure = unit_of_measure

    @property
    def discount_details(self):
        """Gets the discount_details of this PreviewExistingSubscriptionCreditMemoItemResult.  # noqa: E501

        Container for discount details.  # noqa: E501

        :return: The discount_details of this PreviewExistingSubscriptionCreditMemoItemResult.  # noqa: E501
        :rtype: list[PreviewExistingSubscriptionDiscountDetails]
        """
        return self._discount_details

    @discount_details.setter
    def discount_details(self, discount_details):
        """Sets the discount_details of this PreviewExistingSubscriptionCreditMemoItemResult.

        Container for discount details.  # noqa: E501

        :param discount_details: The discount_details of this PreviewExistingSubscriptionCreditMemoItemResult.  # noqa: E501
        :type: list[PreviewExistingSubscriptionDiscountDetails]
        """

        self._discount_details = discount_details

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(PreviewExistingSubscriptionCreditMemoItemResult, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, PreviewExistingSubscriptionCreditMemoItemResult):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
