# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).  # noqa: E501

    OpenAPI spec version: 2024-05-20
    Contact: docs@zuora.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class PreviewExistingSubscriptionResultCreditMemos(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'credit_memo_number': 'str',
        'amount': 'float',
        'amount_without_tax': 'float',
        'tax_amount': 'float',
        'target_date': 'date',
        'credit_memo_items': 'list[PreviewExistingSubscriptionCreditMemoItemResult]',
        'status': 'str',
        'is_from_existing_credit_memo': 'bool'
    }

    attribute_map = {
        'credit_memo_number': 'creditMemoNumber',
        'amount': 'amount',
        'amount_without_tax': 'amountWithoutTax',
        'tax_amount': 'taxAmount',
        'target_date': 'targetDate',
        'credit_memo_items': 'creditMemoItems',
        'status': 'status',
        'is_from_existing_credit_memo': 'isFromExistingCreditMemo'
    }

    def __init__(self, credit_memo_number=None, amount=None, amount_without_tax=None, tax_amount=None, target_date=None, credit_memo_items=None, status=None, is_from_existing_credit_memo=None):  # noqa: E501
        """PreviewExistingSubscriptionResultCreditMemos - a model defined in Swagger"""  # noqa: E501
        self._credit_memo_number = None
        self._amount = None
        self._amount_without_tax = None
        self._tax_amount = None
        self._target_date = None
        self._credit_memo_items = None
        self._status = None
        self._is_from_existing_credit_memo = None
        self.discriminator = None
        if credit_memo_number is not None:
            self.credit_memo_number = credit_memo_number
        if amount is not None:
            self.amount = amount
        if amount_without_tax is not None:
            self.amount_without_tax = amount_without_tax
        if tax_amount is not None:
            self.tax_amount = tax_amount
        if target_date is not None:
            self.target_date = target_date
        if credit_memo_items is not None:
            self.credit_memo_items = credit_memo_items
        if status is not None:
            self.status = status
        if is_from_existing_credit_memo is not None:
            self.is_from_existing_credit_memo = is_from_existing_credit_memo

    @property
    def credit_memo_number(self):
        """Gets the credit_memo_number of this PreviewExistingSubscriptionResultCreditMemos.  # noqa: E501

        The credit memo number.  # noqa: E501

        :return: The credit_memo_number of this PreviewExistingSubscriptionResultCreditMemos.  # noqa: E501
        :rtype: str
        """
        return self._credit_memo_number

    @credit_memo_number.setter
    def credit_memo_number(self, credit_memo_number):
        """Sets the credit_memo_number of this PreviewExistingSubscriptionResultCreditMemos.

        The credit memo number.  # noqa: E501

        :param credit_memo_number: The credit_memo_number of this PreviewExistingSubscriptionResultCreditMemos.  # noqa: E501
        :type: str
        """

        self._credit_memo_number = credit_memo_number

    @property
    def amount(self):
        """Gets the amount of this PreviewExistingSubscriptionResultCreditMemos.  # noqa: E501

        Credit memo amount.  # noqa: E501

        :return: The amount of this PreviewExistingSubscriptionResultCreditMemos.  # noqa: E501
        :rtype: float
        """
        return self._amount

    @amount.setter
    def amount(self, amount):
        """Sets the amount of this PreviewExistingSubscriptionResultCreditMemos.

        Credit memo amount.  # noqa: E501

        :param amount: The amount of this PreviewExistingSubscriptionResultCreditMemos.  # noqa: E501
        :type: float
        """

        self._amount = amount

    @property
    def amount_without_tax(self):
        """Gets the amount_without_tax of this PreviewExistingSubscriptionResultCreditMemos.  # noqa: E501

        Credit memo amount minus tax.  # noqa: E501

        :return: The amount_without_tax of this PreviewExistingSubscriptionResultCreditMemos.  # noqa: E501
        :rtype: float
        """
        return self._amount_without_tax

    @amount_without_tax.setter
    def amount_without_tax(self, amount_without_tax):
        """Sets the amount_without_tax of this PreviewExistingSubscriptionResultCreditMemos.

        Credit memo amount minus tax.  # noqa: E501

        :param amount_without_tax: The amount_without_tax of this PreviewExistingSubscriptionResultCreditMemos.  # noqa: E501
        :type: float
        """

        self._amount_without_tax = amount_without_tax

    @property
    def tax_amount(self):
        """Gets the tax_amount of this PreviewExistingSubscriptionResultCreditMemos.  # noqa: E501

        The tax amount of the credit memo.  # noqa: E501

        :return: The tax_amount of this PreviewExistingSubscriptionResultCreditMemos.  # noqa: E501
        :rtype: float
        """
        return self._tax_amount

    @tax_amount.setter
    def tax_amount(self, tax_amount):
        """Sets the tax_amount of this PreviewExistingSubscriptionResultCreditMemos.

        The tax amount of the credit memo.  # noqa: E501

        :param tax_amount: The tax_amount of this PreviewExistingSubscriptionResultCreditMemos.  # noqa: E501
        :type: float
        """

        self._tax_amount = tax_amount

    @property
    def target_date(self):
        """Gets the target_date of this PreviewExistingSubscriptionResultCreditMemos.  # noqa: E501

        Date through which to calculate charges if a credit memo is generated, as yyyy-mm-dd.  # noqa: E501

        :return: The target_date of this PreviewExistingSubscriptionResultCreditMemos.  # noqa: E501
        :rtype: date
        """
        return self._target_date

    @target_date.setter
    def target_date(self, target_date):
        """Sets the target_date of this PreviewExistingSubscriptionResultCreditMemos.

        Date through which to calculate charges if a credit memo is generated, as yyyy-mm-dd.  # noqa: E501

        :param target_date: The target_date of this PreviewExistingSubscriptionResultCreditMemos.  # noqa: E501
        :type: date
        """

        self._target_date = target_date

    @property
    def credit_memo_items(self):
        """Gets the credit_memo_items of this PreviewExistingSubscriptionResultCreditMemos.  # noqa: E501

        Container for credit memo items.  # noqa: E501

        :return: The credit_memo_items of this PreviewExistingSubscriptionResultCreditMemos.  # noqa: E501
        :rtype: list[PreviewExistingSubscriptionCreditMemoItemResult]
        """
        return self._credit_memo_items

    @credit_memo_items.setter
    def credit_memo_items(self, credit_memo_items):
        """Sets the credit_memo_items of this PreviewExistingSubscriptionResultCreditMemos.

        Container for credit memo items.  # noqa: E501

        :param credit_memo_items: The credit_memo_items of this PreviewExistingSubscriptionResultCreditMemos.  # noqa: E501
        :type: list[PreviewExistingSubscriptionCreditMemoItemResult]
        """

        self._credit_memo_items = credit_memo_items

    @property
    def status(self):
        """Gets the status of this PreviewExistingSubscriptionResultCreditMemos.  # noqa: E501

        The status of the credit memo.  # noqa: E501

        :return: The status of this PreviewExistingSubscriptionResultCreditMemos.  # noqa: E501
        :rtype: str
        """
        return self._status

    @status.setter
    def status(self, status):
        """Sets the status of this PreviewExistingSubscriptionResultCreditMemos.

        The status of the credit memo.  # noqa: E501

        :param status: The status of this PreviewExistingSubscriptionResultCreditMemos.  # noqa: E501
        :type: str
        """

        self._status = status

    @property
    def is_from_existing_credit_memo(self):
        """Gets the is_from_existing_credit_memo of this PreviewExistingSubscriptionResultCreditMemos.  # noqa: E501

        Indicates whether the credit memo information is from an existing credit memo.  # noqa: E501

        :return: The is_from_existing_credit_memo of this PreviewExistingSubscriptionResultCreditMemos.  # noqa: E501
        :rtype: bool
        """
        return self._is_from_existing_credit_memo

    @is_from_existing_credit_memo.setter
    def is_from_existing_credit_memo(self, is_from_existing_credit_memo):
        """Sets the is_from_existing_credit_memo of this PreviewExistingSubscriptionResultCreditMemos.

        Indicates whether the credit memo information is from an existing credit memo.  # noqa: E501

        :param is_from_existing_credit_memo: The is_from_existing_credit_memo of this PreviewExistingSubscriptionResultCreditMemos.  # noqa: E501
        :type: bool
        """

        self._is_from_existing_credit_memo = is_from_existing_credit_memo

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(PreviewExistingSubscriptionResultCreditMemos, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, PreviewExistingSubscriptionResultCreditMemos):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
