# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).  # noqa: E501

    OpenAPI spec version: 2024-05-20
    Contact: docs@zuora.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class PreviewOrderOrderAction(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'add_product': 'PreviewOrderRatePlanOverride',
        'cancel_subscription': 'OrderActionCancelSubscription',
        'change_plan': 'CreateOrderChangePlan',
        'change_reason': 'str',
        'create_subscription': 'PreviewOrderCreateSubscription',
        'custom_fields': 'dict(str, object)',
        'owner_transfer': 'OrderActionOwnerTransfer',
        'remove_product': 'OrderActionRemoveProduct',
        'renew_subscription': 'OrderActionRenewSubscription',
        'resume': 'CreateOrderResume',
        'suspend': 'CreateOrderSuspend',
        'terms_and_conditions': 'CreateOrderTermsAndConditions',
        'trigger_dates': 'list[TriggerDate]',
        'type': 'OrderActionType',
        'update_product': 'PreviewOrderRatePlanUpdate'
    }

    attribute_map = {
        'add_product': 'addProduct',
        'cancel_subscription': 'cancelSubscription',
        'change_plan': 'changePlan',
        'change_reason': 'changeReason',
        'create_subscription': 'createSubscription',
        'custom_fields': 'customFields',
        'owner_transfer': 'ownerTransfer',
        'remove_product': 'removeProduct',
        'renew_subscription': 'renewSubscription',
        'resume': 'resume',
        'suspend': 'suspend',
        'terms_and_conditions': 'termsAndConditions',
        'trigger_dates': 'triggerDates',
        'type': 'type',
        'update_product': 'updateProduct'
    }

    def __init__(self, add_product=None, cancel_subscription=None, change_plan=None, change_reason=None, create_subscription=None, custom_fields=None, owner_transfer=None, remove_product=None, renew_subscription=None, resume=None, suspend=None, terms_and_conditions=None, trigger_dates=None, type=None, update_product=None):  # noqa: E501
        """PreviewOrderOrderAction - a model defined in Swagger"""  # noqa: E501
        self._add_product = None
        self._cancel_subscription = None
        self._change_plan = None
        self._change_reason = None
        self._create_subscription = None
        self._custom_fields = None
        self._owner_transfer = None
        self._remove_product = None
        self._renew_subscription = None
        self._resume = None
        self._suspend = None
        self._terms_and_conditions = None
        self._trigger_dates = None
        self._type = None
        self._update_product = None
        self.discriminator = None
        if add_product is not None:
            self.add_product = add_product
        if cancel_subscription is not None:
            self.cancel_subscription = cancel_subscription
        if change_plan is not None:
            self.change_plan = change_plan
        if change_reason is not None:
            self.change_reason = change_reason
        if create_subscription is not None:
            self.create_subscription = create_subscription
        if custom_fields is not None:
            self.custom_fields = custom_fields
        if owner_transfer is not None:
            self.owner_transfer = owner_transfer
        if remove_product is not None:
            self.remove_product = remove_product
        if renew_subscription is not None:
            self.renew_subscription = renew_subscription
        if resume is not None:
            self.resume = resume
        if suspend is not None:
            self.suspend = suspend
        if terms_and_conditions is not None:
            self.terms_and_conditions = terms_and_conditions
        if trigger_dates is not None:
            self.trigger_dates = trigger_dates
        self.type = type
        if update_product is not None:
            self.update_product = update_product

    @property
    def add_product(self):
        """Gets the add_product of this PreviewOrderOrderAction.  # noqa: E501


        :return: The add_product of this PreviewOrderOrderAction.  # noqa: E501
        :rtype: PreviewOrderRatePlanOverride
        """
        return self._add_product

    @add_product.setter
    def add_product(self, add_product):
        """Sets the add_product of this PreviewOrderOrderAction.


        :param add_product: The add_product of this PreviewOrderOrderAction.  # noqa: E501
        :type: PreviewOrderRatePlanOverride
        """

        self._add_product = add_product

    @property
    def cancel_subscription(self):
        """Gets the cancel_subscription of this PreviewOrderOrderAction.  # noqa: E501


        :return: The cancel_subscription of this PreviewOrderOrderAction.  # noqa: E501
        :rtype: OrderActionCancelSubscription
        """
        return self._cancel_subscription

    @cancel_subscription.setter
    def cancel_subscription(self, cancel_subscription):
        """Sets the cancel_subscription of this PreviewOrderOrderAction.


        :param cancel_subscription: The cancel_subscription of this PreviewOrderOrderAction.  # noqa: E501
        :type: OrderActionCancelSubscription
        """

        self._cancel_subscription = cancel_subscription

    @property
    def change_plan(self):
        """Gets the change_plan of this PreviewOrderOrderAction.  # noqa: E501


        :return: The change_plan of this PreviewOrderOrderAction.  # noqa: E501
        :rtype: CreateOrderChangePlan
        """
        return self._change_plan

    @change_plan.setter
    def change_plan(self, change_plan):
        """Sets the change_plan of this PreviewOrderOrderAction.


        :param change_plan: The change_plan of this PreviewOrderOrderAction.  # noqa: E501
        :type: CreateOrderChangePlan
        """

        self._change_plan = change_plan

    @property
    def change_reason(self):
        """Gets the change_reason of this PreviewOrderOrderAction.  # noqa: E501

        The change reason set for an order action when an order is created.   # noqa: E501

        :return: The change_reason of this PreviewOrderOrderAction.  # noqa: E501
        :rtype: str
        """
        return self._change_reason

    @change_reason.setter
    def change_reason(self, change_reason):
        """Sets the change_reason of this PreviewOrderOrderAction.

        The change reason set for an order action when an order is created.   # noqa: E501

        :param change_reason: The change_reason of this PreviewOrderOrderAction.  # noqa: E501
        :type: str
        """

        self._change_reason = change_reason

    @property
    def create_subscription(self):
        """Gets the create_subscription of this PreviewOrderOrderAction.  # noqa: E501


        :return: The create_subscription of this PreviewOrderOrderAction.  # noqa: E501
        :rtype: PreviewOrderCreateSubscription
        """
        return self._create_subscription

    @create_subscription.setter
    def create_subscription(self, create_subscription):
        """Sets the create_subscription of this PreviewOrderOrderAction.


        :param create_subscription: The create_subscription of this PreviewOrderOrderAction.  # noqa: E501
        :type: PreviewOrderCreateSubscription
        """

        self._create_subscription = create_subscription

    @property
    def custom_fields(self):
        """Gets the custom_fields of this PreviewOrderOrderAction.  # noqa: E501

        Container for custom fields of an Order Action object.   # noqa: E501

        :return: The custom_fields of this PreviewOrderOrderAction.  # noqa: E501
        :rtype: dict(str, object)
        """
        return self._custom_fields

    @custom_fields.setter
    def custom_fields(self, custom_fields):
        """Sets the custom_fields of this PreviewOrderOrderAction.

        Container for custom fields of an Order Action object.   # noqa: E501

        :param custom_fields: The custom_fields of this PreviewOrderOrderAction.  # noqa: E501
        :type: dict(str, object)
        """

        self._custom_fields = custom_fields

    @property
    def owner_transfer(self):
        """Gets the owner_transfer of this PreviewOrderOrderAction.  # noqa: E501


        :return: The owner_transfer of this PreviewOrderOrderAction.  # noqa: E501
        :rtype: OrderActionOwnerTransfer
        """
        return self._owner_transfer

    @owner_transfer.setter
    def owner_transfer(self, owner_transfer):
        """Sets the owner_transfer of this PreviewOrderOrderAction.


        :param owner_transfer: The owner_transfer of this PreviewOrderOrderAction.  # noqa: E501
        :type: OrderActionOwnerTransfer
        """

        self._owner_transfer = owner_transfer

    @property
    def remove_product(self):
        """Gets the remove_product of this PreviewOrderOrderAction.  # noqa: E501


        :return: The remove_product of this PreviewOrderOrderAction.  # noqa: E501
        :rtype: OrderActionRemoveProduct
        """
        return self._remove_product

    @remove_product.setter
    def remove_product(self, remove_product):
        """Sets the remove_product of this PreviewOrderOrderAction.


        :param remove_product: The remove_product of this PreviewOrderOrderAction.  # noqa: E501
        :type: OrderActionRemoveProduct
        """

        self._remove_product = remove_product

    @property
    def renew_subscription(self):
        """Gets the renew_subscription of this PreviewOrderOrderAction.  # noqa: E501


        :return: The renew_subscription of this PreviewOrderOrderAction.  # noqa: E501
        :rtype: OrderActionRenewSubscription
        """
        return self._renew_subscription

    @renew_subscription.setter
    def renew_subscription(self, renew_subscription):
        """Sets the renew_subscription of this PreviewOrderOrderAction.


        :param renew_subscription: The renew_subscription of this PreviewOrderOrderAction.  # noqa: E501
        :type: OrderActionRenewSubscription
        """

        self._renew_subscription = renew_subscription

    @property
    def resume(self):
        """Gets the resume of this PreviewOrderOrderAction.  # noqa: E501


        :return: The resume of this PreviewOrderOrderAction.  # noqa: E501
        :rtype: CreateOrderResume
        """
        return self._resume

    @resume.setter
    def resume(self, resume):
        """Sets the resume of this PreviewOrderOrderAction.


        :param resume: The resume of this PreviewOrderOrderAction.  # noqa: E501
        :type: CreateOrderResume
        """

        self._resume = resume

    @property
    def suspend(self):
        """Gets the suspend of this PreviewOrderOrderAction.  # noqa: E501


        :return: The suspend of this PreviewOrderOrderAction.  # noqa: E501
        :rtype: CreateOrderSuspend
        """
        return self._suspend

    @suspend.setter
    def suspend(self, suspend):
        """Sets the suspend of this PreviewOrderOrderAction.


        :param suspend: The suspend of this PreviewOrderOrderAction.  # noqa: E501
        :type: CreateOrderSuspend
        """

        self._suspend = suspend

    @property
    def terms_and_conditions(self):
        """Gets the terms_and_conditions of this PreviewOrderOrderAction.  # noqa: E501


        :return: The terms_and_conditions of this PreviewOrderOrderAction.  # noqa: E501
        :rtype: CreateOrderTermsAndConditions
        """
        return self._terms_and_conditions

    @terms_and_conditions.setter
    def terms_and_conditions(self, terms_and_conditions):
        """Sets the terms_and_conditions of this PreviewOrderOrderAction.


        :param terms_and_conditions: The terms_and_conditions of this PreviewOrderOrderAction.  # noqa: E501
        :type: CreateOrderTermsAndConditions
        """

        self._terms_and_conditions = terms_and_conditions

    @property
    def trigger_dates(self):
        """Gets the trigger_dates of this PreviewOrderOrderAction.  # noqa: E501

        Container for the contract effective, service activation, and customer acceptance dates of the order action.   If the service activation date is set as a required field in Default Subscription Settings, skipping this field in a `CreateSubscription` order action of your JSON request will result in a `Pending` order and a `Pending Activation` subscription.  If the customer acceptance date is set as a required field in Default Subscription Settings, skipping this field in a `CreateSubscription` order action of your JSON request will result in a `Pending` order and a `Pending Acceptance` subscription. If the service activation date field is at the same time required and skipped (or set as null), it will be a `Pending Activation` subscription.   # noqa: E501

        :return: The trigger_dates of this PreviewOrderOrderAction.  # noqa: E501
        :rtype: list[TriggerDate]
        """
        return self._trigger_dates

    @trigger_dates.setter
    def trigger_dates(self, trigger_dates):
        """Sets the trigger_dates of this PreviewOrderOrderAction.

        Container for the contract effective, service activation, and customer acceptance dates of the order action.   If the service activation date is set as a required field in Default Subscription Settings, skipping this field in a `CreateSubscription` order action of your JSON request will result in a `Pending` order and a `Pending Activation` subscription.  If the customer acceptance date is set as a required field in Default Subscription Settings, skipping this field in a `CreateSubscription` order action of your JSON request will result in a `Pending` order and a `Pending Acceptance` subscription. If the service activation date field is at the same time required and skipped (or set as null), it will be a `Pending Activation` subscription.   # noqa: E501

        :param trigger_dates: The trigger_dates of this PreviewOrderOrderAction.  # noqa: E501
        :type: list[TriggerDate]
        """

        self._trigger_dates = trigger_dates

    @property
    def type(self):
        """Gets the type of this PreviewOrderOrderAction.  # noqa: E501


        :return: The type of this PreviewOrderOrderAction.  # noqa: E501
        :rtype: OrderActionType
        """
        return self._type

    @type.setter
    def type(self, type):
        """Sets the type of this PreviewOrderOrderAction.


        :param type: The type of this PreviewOrderOrderAction.  # noqa: E501
        :type: OrderActionType
        """
        if type is None:
            raise ValueError("Invalid value for `type`, must not be `None`")  # noqa: E501

        self._type = type

    @property
    def update_product(self):
        """Gets the update_product of this PreviewOrderOrderAction.  # noqa: E501


        :return: The update_product of this PreviewOrderOrderAction.  # noqa: E501
        :rtype: PreviewOrderRatePlanUpdate
        """
        return self._update_product

    @update_product.setter
    def update_product(self, update_product):
        """Sets the update_product of this PreviewOrderOrderAction.


        :param update_product: The update_product of this PreviewOrderOrderAction.  # noqa: E501
        :type: PreviewOrderRatePlanUpdate
        """

        self._update_product = update_product

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(PreviewOrderOrderAction, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, PreviewOrderOrderAction):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
