# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).  # noqa: E501

    OpenAPI spec version: 2024-05-20
    Contact: docs@zuora.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six
from zuora_sdk.models.preview_order_subscriptions import PreviewOrderSubscriptions  # noqa: F401,E501

class PreviewOrderSubscriptionsAsync(PreviewOrderSubscriptions):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'custom_fields': 'dict(str, object)',
        'order_actions': 'list[PreviewOrderOrderAction]',
        'quote': 'QuoteObjectFields',
        'ramp': 'CreateRamp',
        'subscription_number': 'str'
    }
    if hasattr(PreviewOrderSubscriptions, "swagger_types"):
        swagger_types.update(PreviewOrderSubscriptions.swagger_types)

    attribute_map = {
        'custom_fields': 'customFields',
        'order_actions': 'orderActions',
        'quote': 'quote',
        'ramp': 'ramp',
        'subscription_number': 'subscriptionNumber'
    }
    if hasattr(PreviewOrderSubscriptions, "attribute_map"):
        attribute_map.update(PreviewOrderSubscriptions.attribute_map)

    def __init__(self, custom_fields=None, order_actions=None, quote=None, ramp=None, subscription_number=None, *args, **kwargs):  # noqa: E501
        """PreviewOrderSubscriptionsAsync - a model defined in Swagger"""  # noqa: E501
        self._custom_fields = None
        self._order_actions = None
        self._quote = None
        self._ramp = None
        self._subscription_number = None
        self.discriminator = None
        if custom_fields is not None:
            self.custom_fields = custom_fields
        if order_actions is not None:
            self.order_actions = order_actions
        if quote is not None:
            self.quote = quote
        if ramp is not None:
            self.ramp = ramp
        if subscription_number is not None:
            self.subscription_number = subscription_number
        PreviewOrderSubscriptions.__init__(self, *args, **kwargs)

    @property
    def custom_fields(self):
        """Gets the custom_fields of this PreviewOrderSubscriptionsAsync.  # noqa: E501

        Container for custom fields of a Subscription object.   # noqa: E501

        :return: The custom_fields of this PreviewOrderSubscriptionsAsync.  # noqa: E501
        :rtype: dict(str, object)
        """
        return self._custom_fields

    @custom_fields.setter
    def custom_fields(self, custom_fields):
        """Sets the custom_fields of this PreviewOrderSubscriptionsAsync.

        Container for custom fields of a Subscription object.   # noqa: E501

        :param custom_fields: The custom_fields of this PreviewOrderSubscriptionsAsync.  # noqa: E501
        :type: dict(str, object)
        """

        self._custom_fields = custom_fields

    @property
    def order_actions(self):
        """Gets the order_actions of this PreviewOrderSubscriptionsAsync.  # noqa: E501

        The actions to be applied to the subscription. Order actions will be stored with the sequence when it was provided in the request.  # noqa: E501

        :return: The order_actions of this PreviewOrderSubscriptionsAsync.  # noqa: E501
        :rtype: list[PreviewOrderOrderAction]
        """
        return self._order_actions

    @order_actions.setter
    def order_actions(self, order_actions):
        """Sets the order_actions of this PreviewOrderSubscriptionsAsync.

        The actions to be applied to the subscription. Order actions will be stored with the sequence when it was provided in the request.  # noqa: E501

        :param order_actions: The order_actions of this PreviewOrderSubscriptionsAsync.  # noqa: E501
        :type: list[PreviewOrderOrderAction]
        """

        self._order_actions = order_actions

    @property
    def quote(self):
        """Gets the quote of this PreviewOrderSubscriptionsAsync.  # noqa: E501


        :return: The quote of this PreviewOrderSubscriptionsAsync.  # noqa: E501
        :rtype: QuoteObjectFields
        """
        return self._quote

    @quote.setter
    def quote(self, quote):
        """Sets the quote of this PreviewOrderSubscriptionsAsync.


        :param quote: The quote of this PreviewOrderSubscriptionsAsync.  # noqa: E501
        :type: QuoteObjectFields
        """

        self._quote = quote

    @property
    def ramp(self):
        """Gets the ramp of this PreviewOrderSubscriptionsAsync.  # noqa: E501


        :return: The ramp of this PreviewOrderSubscriptionsAsync.  # noqa: E501
        :rtype: CreateRamp
        """
        return self._ramp

    @ramp.setter
    def ramp(self, ramp):
        """Sets the ramp of this PreviewOrderSubscriptionsAsync.


        :param ramp: The ramp of this PreviewOrderSubscriptionsAsync.  # noqa: E501
        :type: CreateRamp
        """

        self._ramp = ramp

    @property
    def subscription_number(self):
        """Gets the subscription_number of this PreviewOrderSubscriptionsAsync.  # noqa: E501

        Leave this field empty to represent new subscription creation, or specify a subscription number to update an existing subscription.   # noqa: E501

        :return: The subscription_number of this PreviewOrderSubscriptionsAsync.  # noqa: E501
        :rtype: str
        """
        return self._subscription_number

    @subscription_number.setter
    def subscription_number(self, subscription_number):
        """Sets the subscription_number of this PreviewOrderSubscriptionsAsync.

        Leave this field empty to represent new subscription creation, or specify a subscription number to update an existing subscription.   # noqa: E501

        :param subscription_number: The subscription_number of this PreviewOrderSubscriptionsAsync.  # noqa: E501
        :type: str
        """

        self._subscription_number = subscription_number

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(PreviewOrderSubscriptionsAsync, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, PreviewOrderSubscriptionsAsync):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
