# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).  # noqa: E501

    OpenAPI spec version: 2024-05-20
    Contact: docs@zuora.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class PreviewSubscriptionInvoice(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'amount': 'float',
        'amount_without_tax': 'float',
        'invoice_items': 'list[PreviewSubscriptionInvoiceItem]',
        'target_date': 'str',
        'tax_amount': 'float'
    }

    attribute_map = {
        'amount': 'amount',
        'amount_without_tax': 'amountWithoutTax',
        'invoice_items': 'invoiceItems',
        'target_date': 'targetDate',
        'tax_amount': 'taxAmount'
    }

    def __init__(self, amount=None, amount_without_tax=None, invoice_items=None, target_date=None, tax_amount=None):  # noqa: E501
        """PreviewSubscriptionInvoice - a model defined in Swagger"""  # noqa: E501
        self._amount = None
        self._amount_without_tax = None
        self._invoice_items = None
        self._target_date = None
        self._tax_amount = None
        self.discriminator = None
        if amount is not None:
            self.amount = amount
        if amount_without_tax is not None:
            self.amount_without_tax = amount_without_tax
        if invoice_items is not None:
            self.invoice_items = invoice_items
        if target_date is not None:
            self.target_date = target_date
        if tax_amount is not None:
            self.tax_amount = tax_amount

    @property
    def amount(self):
        """Gets the amount of this PreviewSubscriptionInvoice.  # noqa: E501

        Invoice amount.  # noqa: E501

        :return: The amount of this PreviewSubscriptionInvoice.  # noqa: E501
        :rtype: float
        """
        return self._amount

    @amount.setter
    def amount(self, amount):
        """Sets the amount of this PreviewSubscriptionInvoice.

        Invoice amount.  # noqa: E501

        :param amount: The amount of this PreviewSubscriptionInvoice.  # noqa: E501
        :type: float
        """

        self._amount = amount

    @property
    def amount_without_tax(self):
        """Gets the amount_without_tax of this PreviewSubscriptionInvoice.  # noqa: E501

        Invoice amount minus tax.   # noqa: E501

        :return: The amount_without_tax of this PreviewSubscriptionInvoice.  # noqa: E501
        :rtype: float
        """
        return self._amount_without_tax

    @amount_without_tax.setter
    def amount_without_tax(self, amount_without_tax):
        """Sets the amount_without_tax of this PreviewSubscriptionInvoice.

        Invoice amount minus tax.   # noqa: E501

        :param amount_without_tax: The amount_without_tax of this PreviewSubscriptionInvoice.  # noqa: E501
        :type: float
        """

        self._amount_without_tax = amount_without_tax

    @property
    def invoice_items(self):
        """Gets the invoice_items of this PreviewSubscriptionInvoice.  # noqa: E501

        Container for invoice items.   # noqa: E501

        :return: The invoice_items of this PreviewSubscriptionInvoice.  # noqa: E501
        :rtype: list[PreviewSubscriptionInvoiceItem]
        """
        return self._invoice_items

    @invoice_items.setter
    def invoice_items(self, invoice_items):
        """Sets the invoice_items of this PreviewSubscriptionInvoice.

        Container for invoice items.   # noqa: E501

        :param invoice_items: The invoice_items of this PreviewSubscriptionInvoice.  # noqa: E501
        :type: list[PreviewSubscriptionInvoiceItem]
        """

        self._invoice_items = invoice_items

    @property
    def target_date(self):
        """Gets the target_date of this PreviewSubscriptionInvoice.  # noqa: E501

        Date through which to calculate charges if an invoice is generated, as yyyy-mm-dd. Default is current date.  **Note:** This field is only available if you set the Zuora REST API minor version to 207.0 or later in the request header. See [Zuora REST API Versions](https://www.zuora.com/developer/api-references/api/overview/#section/API-Versions) for more information.   # noqa: E501

        :return: The target_date of this PreviewSubscriptionInvoice.  # noqa: E501
        :rtype: str
        """
        return self._target_date

    @target_date.setter
    def target_date(self, target_date):
        """Sets the target_date of this PreviewSubscriptionInvoice.

        Date through which to calculate charges if an invoice is generated, as yyyy-mm-dd. Default is current date.  **Note:** This field is only available if you set the Zuora REST API minor version to 207.0 or later in the request header. See [Zuora REST API Versions](https://www.zuora.com/developer/api-references/api/overview/#section/API-Versions) for more information.   # noqa: E501

        :param target_date: The target_date of this PreviewSubscriptionInvoice.  # noqa: E501
        :type: str
        """

        self._target_date = target_date

    @property
    def tax_amount(self):
        """Gets the tax_amount of this PreviewSubscriptionInvoice.  # noqa: E501

        The tax amount of the invoice.   # noqa: E501

        :return: The tax_amount of this PreviewSubscriptionInvoice.  # noqa: E501
        :rtype: float
        """
        return self._tax_amount

    @tax_amount.setter
    def tax_amount(self, tax_amount):
        """Sets the tax_amount of this PreviewSubscriptionInvoice.

        The tax amount of the invoice.   # noqa: E501

        :param tax_amount: The tax_amount of this PreviewSubscriptionInvoice.  # noqa: E501
        :type: float
        """

        self._tax_amount = tax_amount

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(PreviewSubscriptionInvoice, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, PreviewSubscriptionInvoice):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
