# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).  # noqa: E501

    OpenAPI spec version: 2024-05-20
    Contact: docs@zuora.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class PreviewThroughDate(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'preview_thru_date_policy': 'PreviewThruDatePolicy',
        'next_billing_periods': 'float',
        'specific_date': 'str'
    }

    attribute_map = {
        'preview_thru_date_policy': 'previewThruDatePolicy',
        'next_billing_periods': 'nextBillingPeriods',
        'specific_date': 'specificDate'
    }

    def __init__(self, preview_thru_date_policy=None, next_billing_periods=None, specific_date=None):  # noqa: E501
        """PreviewThroughDate - a model defined in Swagger"""  # noqa: E501
        self._preview_thru_date_policy = None
        self._next_billing_periods = None
        self._specific_date = None
        self.discriminator = None
        if preview_thru_date_policy is not None:
            self.preview_thru_date_policy = preview_thru_date_policy
        if next_billing_periods is not None:
            self.next_billing_periods = next_billing_periods
        if specific_date is not None:
            self.specific_date = specific_date

    @property
    def preview_thru_date_policy(self):
        """Gets the preview_thru_date_policy of this PreviewThroughDate.  # noqa: E501


        :return: The preview_thru_date_policy of this PreviewThroughDate.  # noqa: E501
        :rtype: PreviewThruDatePolicy
        """
        return self._preview_thru_date_policy

    @preview_thru_date_policy.setter
    def preview_thru_date_policy(self, preview_thru_date_policy):
        """Sets the preview_thru_date_policy of this PreviewThroughDate.


        :param preview_thru_date_policy: The preview_thru_date_policy of this PreviewThroughDate.  # noqa: E501
        :type: PreviewThruDatePolicy
        """

        self._preview_thru_date_policy = preview_thru_date_policy

    @property
    def next_billing_periods(self):
        """Gets the next_billing_periods of this PreviewThroughDate.  # noqa: E501

        The number of billing periods to preview. Required if `previewThruDatePolicy` is `nextBillingPeriods`.   # noqa: E501

        :return: The next_billing_periods of this PreviewThroughDate.  # noqa: E501
        :rtype: float
        """
        return self._next_billing_periods

    @next_billing_periods.setter
    def next_billing_periods(self, next_billing_periods):
        """Sets the next_billing_periods of this PreviewThroughDate.

        The number of billing periods to preview. Required if `previewThruDatePolicy` is `nextBillingPeriods`.   # noqa: E501

        :param next_billing_periods: The next_billing_periods of this PreviewThroughDate.  # noqa: E501
        :type: float
        """

        self._next_billing_periods = next_billing_periods

    @property
    def specific_date(self):
        """Gets the specific_date of this PreviewThroughDate.  # noqa: E501

        The specific date for the preview start date. Required if `previewThruDatePolicy` is `specificDate`.   # noqa: E501

        :return: The specific_date of this PreviewThroughDate.  # noqa: E501
        :rtype: str
        """
        return self._specific_date

    @specific_date.setter
    def specific_date(self, specific_date):
        """Sets the specific_date of this PreviewThroughDate.

        The specific date for the preview start date. Required if `previewThruDatePolicy` is `specificDate`.   # noqa: E501

        :param specific_date: The specific_date of this PreviewThroughDate.  # noqa: E501
        :type: str
        """

        self._specific_date = specific_date

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(PreviewThroughDate, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, PreviewThroughDate):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
