# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).  # noqa: E501

    OpenAPI spec version: 2024-05-20
    Contact: docs@zuora.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class RampIntervalRequest(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'description': 'str',
        'end_date': 'date',
        'name': 'str',
        'start_date': 'date'
    }

    attribute_map = {
        'description': 'description',
        'end_date': 'endDate',
        'name': 'name',
        'start_date': 'startDate'
    }

    def __init__(self, description=None, end_date=None, name=None, start_date=None):  # noqa: E501
        """RampIntervalRequest - a model defined in Swagger"""  # noqa: E501
        self._description = None
        self._end_date = None
        self._name = None
        self._start_date = None
        self.discriminator = None
        if description is not None:
            self.description = description
        self.end_date = end_date
        if name is not None:
            self.name = name
        self.start_date = start_date

    @property
    def description(self):
        """Gets the description of this RampIntervalRequest.  # noqa: E501

        The short description of the interval.  # noqa: E501

        :return: The description of this RampIntervalRequest.  # noqa: E501
        :rtype: str
        """
        return self._description

    @description.setter
    def description(self, description):
        """Sets the description of this RampIntervalRequest.

        The short description of the interval.  # noqa: E501

        :param description: The description of this RampIntervalRequest.  # noqa: E501
        :type: str
        """

        self._description = description

    @property
    def end_date(self):
        """Gets the end_date of this RampIntervalRequest.  # noqa: E501

        The end date of the interval.  # noqa: E501

        :return: The end_date of this RampIntervalRequest.  # noqa: E501
        :rtype: date
        """
        return self._end_date

    @end_date.setter
    def end_date(self, end_date):
        """Sets the end_date of this RampIntervalRequest.

        The end date of the interval.  # noqa: E501

        :param end_date: The end_date of this RampIntervalRequest.  # noqa: E501
        :type: date
        """
        if end_date is None:
            raise ValueError("Invalid value for `end_date`, must not be `None`")  # noqa: E501

        self._end_date = end_date

    @property
    def name(self):
        """Gets the name of this RampIntervalRequest.  # noqa: E501

        The name of the interval.  # noqa: E501

        :return: The name of this RampIntervalRequest.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this RampIntervalRequest.

        The name of the interval.  # noqa: E501

        :param name: The name of this RampIntervalRequest.  # noqa: E501
        :type: str
        """

        self._name = name

    @property
    def start_date(self):
        """Gets the start_date of this RampIntervalRequest.  # noqa: E501

        The start date of the interval.  # noqa: E501

        :return: The start_date of this RampIntervalRequest.  # noqa: E501
        :rtype: date
        """
        return self._start_date

    @start_date.setter
    def start_date(self, start_date):
        """Sets the start_date of this RampIntervalRequest.

        The start date of the interval.  # noqa: E501

        :param start_date: The start_date of this RampIntervalRequest.  # noqa: E501
        :type: date
        """
        if start_date is None:
            raise ValueError("Invalid value for `start_date`, must not be `None`")  # noqa: E501

        self._start_date = start_date

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(RampIntervalRequest, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, RampIntervalRequest):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
