# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).  # noqa: E501

    OpenAPI spec version: 2024-05-20
    Contact: docs@zuora.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class RampMetrics(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'description': 'str',
        'discount_tcb': 'float',
        'discount_tcv': 'float',
        'gross_tcb': 'float',
        'gross_tcv': 'float',
        'intervals': 'list[RampIntervalMetrics]',
        'name': 'str',
        'net_tcb': 'float',
        'net_tcv': 'float',
        'number': 'str'
    }

    attribute_map = {
        'description': 'description',
        'discount_tcb': 'discountTcb',
        'discount_tcv': 'discountTcv',
        'gross_tcb': 'grossTcb',
        'gross_tcv': 'grossTcv',
        'intervals': 'intervals',
        'name': 'name',
        'net_tcb': 'netTcb',
        'net_tcv': 'netTcv',
        'number': 'number'
    }

    def __init__(self, description=None, discount_tcb=None, discount_tcv=None, gross_tcb=None, gross_tcv=None, intervals=None, name=None, net_tcb=None, net_tcv=None, number=None):  # noqa: E501
        """RampMetrics - a model defined in Swagger"""  # noqa: E501
        self._description = None
        self._discount_tcb = None
        self._discount_tcv = None
        self._gross_tcb = None
        self._gross_tcv = None
        self._intervals = None
        self._name = None
        self._net_tcb = None
        self._net_tcv = None
        self._number = None
        self.discriminator = None
        if description is not None:
            self.description = description
        if discount_tcb is not None:
            self.discount_tcb = discount_tcb
        if discount_tcv is not None:
            self.discount_tcv = discount_tcv
        if gross_tcb is not None:
            self.gross_tcb = gross_tcb
        if gross_tcv is not None:
            self.gross_tcv = gross_tcv
        if intervals is not None:
            self.intervals = intervals
        if name is not None:
            self.name = name
        if net_tcb is not None:
            self.net_tcb = net_tcb
        if net_tcv is not None:
            self.net_tcv = net_tcv
        if number is not None:
            self.number = number

    @property
    def description(self):
        """Gets the description of this RampMetrics.  # noqa: E501

        The short description of the ramp.  # noqa: E501

        :return: The description of this RampMetrics.  # noqa: E501
        :rtype: str
        """
        return self._description

    @description.setter
    def description(self, description):
        """Sets the description of this RampMetrics.

        The short description of the ramp.  # noqa: E501

        :param description: The description of this RampMetrics.  # noqa: E501
        :type: str
        """

        self._description = description

    @property
    def discount_tcb(self):
        """Gets the discount_tcb of this RampMetrics.  # noqa: E501

        The discount amount for the TCB.  # noqa: E501

        :return: The discount_tcb of this RampMetrics.  # noqa: E501
        :rtype: float
        """
        return self._discount_tcb

    @discount_tcb.setter
    def discount_tcb(self, discount_tcb):
        """Sets the discount_tcb of this RampMetrics.

        The discount amount for the TCB.  # noqa: E501

        :param discount_tcb: The discount_tcb of this RampMetrics.  # noqa: E501
        :type: float
        """

        self._discount_tcb = discount_tcb

    @property
    def discount_tcv(self):
        """Gets the discount_tcv of this RampMetrics.  # noqa: E501

        The discount amount for the TCV.  # noqa: E501

        :return: The discount_tcv of this RampMetrics.  # noqa: E501
        :rtype: float
        """
        return self._discount_tcv

    @discount_tcv.setter
    def discount_tcv(self, discount_tcv):
        """Sets the discount_tcv of this RampMetrics.

        The discount amount for the TCV.  # noqa: E501

        :param discount_tcv: The discount_tcv of this RampMetrics.  # noqa: E501
        :type: float
        """

        self._discount_tcv = discount_tcv

    @property
    def gross_tcb(self):
        """Gets the gross_tcb of this RampMetrics.  # noqa: E501

        The gross TCB value before discount charges are applied.  # noqa: E501

        :return: The gross_tcb of this RampMetrics.  # noqa: E501
        :rtype: float
        """
        return self._gross_tcb

    @gross_tcb.setter
    def gross_tcb(self, gross_tcb):
        """Sets the gross_tcb of this RampMetrics.

        The gross TCB value before discount charges are applied.  # noqa: E501

        :param gross_tcb: The gross_tcb of this RampMetrics.  # noqa: E501
        :type: float
        """

        self._gross_tcb = gross_tcb

    @property
    def gross_tcv(self):
        """Gets the gross_tcv of this RampMetrics.  # noqa: E501

        The gross TCV value before discount charges are applied.  # noqa: E501

        :return: The gross_tcv of this RampMetrics.  # noqa: E501
        :rtype: float
        """
        return self._gross_tcv

    @gross_tcv.setter
    def gross_tcv(self, gross_tcv):
        """Sets the gross_tcv of this RampMetrics.

        The gross TCV value before discount charges are applied.  # noqa: E501

        :param gross_tcv: The gross_tcv of this RampMetrics.  # noqa: E501
        :type: float
        """

        self._gross_tcv = gross_tcv

    @property
    def intervals(self):
        """Gets the intervals of this RampMetrics.  # noqa: E501

        Container for the intervals that the ramp is split into in its timeline.  # noqa: E501

        :return: The intervals of this RampMetrics.  # noqa: E501
        :rtype: list[RampIntervalMetrics]
        """
        return self._intervals

    @intervals.setter
    def intervals(self, intervals):
        """Sets the intervals of this RampMetrics.

        Container for the intervals that the ramp is split into in its timeline.  # noqa: E501

        :param intervals: The intervals of this RampMetrics.  # noqa: E501
        :type: list[RampIntervalMetrics]
        """

        self._intervals = intervals

    @property
    def name(self):
        """Gets the name of this RampMetrics.  # noqa: E501

        The name of the ramp.  # noqa: E501

        :return: The name of this RampMetrics.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this RampMetrics.

        The name of the ramp.  # noqa: E501

        :param name: The name of this RampMetrics.  # noqa: E501
        :type: str
        """

        self._name = name

    @property
    def net_tcb(self):
        """Gets the net_tcb of this RampMetrics.  # noqa: E501

        The net TCB value after discount charges are applied.  # noqa: E501

        :return: The net_tcb of this RampMetrics.  # noqa: E501
        :rtype: float
        """
        return self._net_tcb

    @net_tcb.setter
    def net_tcb(self, net_tcb):
        """Sets the net_tcb of this RampMetrics.

        The net TCB value after discount charges are applied.  # noqa: E501

        :param net_tcb: The net_tcb of this RampMetrics.  # noqa: E501
        :type: float
        """

        self._net_tcb = net_tcb

    @property
    def net_tcv(self):
        """Gets the net_tcv of this RampMetrics.  # noqa: E501

        The net TCV value after discount charges are applied.  # noqa: E501

        :return: The net_tcv of this RampMetrics.  # noqa: E501
        :rtype: float
        """
        return self._net_tcv

    @net_tcv.setter
    def net_tcv(self, net_tcv):
        """Sets the net_tcv of this RampMetrics.

        The net TCV value after discount charges are applied.  # noqa: E501

        :param net_tcv: The net_tcv of this RampMetrics.  # noqa: E501
        :type: float
        """

        self._net_tcv = net_tcv

    @property
    def number(self):
        """Gets the number of this RampMetrics.  # noqa: E501

        The number of the ramp. It is automaticcally generated by the billing system.  # noqa: E501

        :return: The number of this RampMetrics.  # noqa: E501
        :rtype: str
        """
        return self._number

    @number.setter
    def number(self, number):
        """Sets the number of this RampMetrics.

        The number of the ramp. It is automaticcally generated by the billing system.  # noqa: E501

        :param number: The number of this RampMetrics.  # noqa: E501
        :type: str
        """

        self._number = number

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(RampMetrics, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, RampMetrics):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
