# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).  # noqa: E501

    OpenAPI spec version: 2024-05-20
    Contact: docs@zuora.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class RatePlan(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'custom_fields': 'dict(str, object)',
        'product_rate_plan_id': 'str'
    }

    attribute_map = {
        'custom_fields': 'customFields',
        'product_rate_plan_id': 'productRatePlanId'
    }

    def __init__(self, custom_fields=None, product_rate_plan_id=None):  # noqa: E501
        """RatePlan - a model defined in Swagger"""  # noqa: E501
        self._custom_fields = None
        self._product_rate_plan_id = None
        self.discriminator = None
        if custom_fields is not None:
            self.custom_fields = custom_fields
        if product_rate_plan_id is not None:
            self.product_rate_plan_id = product_rate_plan_id

    @property
    def custom_fields(self):
        """Gets the custom_fields of this RatePlan.  # noqa: E501

        Container for custom fields.   # noqa: E501

        :return: The custom_fields of this RatePlan.  # noqa: E501
        :rtype: dict(str, object)
        """
        return self._custom_fields

    @custom_fields.setter
    def custom_fields(self, custom_fields):
        """Sets the custom_fields of this RatePlan.

        Container for custom fields.   # noqa: E501

        :param custom_fields: The custom_fields of this RatePlan.  # noqa: E501
        :type: dict(str, object)
        """

        self._custom_fields = custom_fields

    @property
    def product_rate_plan_id(self):
        """Gets the product_rate_plan_id of this RatePlan.  # noqa: E501

        Internal identifier of the product rate plan that the rate plan is based on.   # noqa: E501

        :return: The product_rate_plan_id of this RatePlan.  # noqa: E501
        :rtype: str
        """
        return self._product_rate_plan_id

    @product_rate_plan_id.setter
    def product_rate_plan_id(self, product_rate_plan_id):
        """Sets the product_rate_plan_id of this RatePlan.

        Internal identifier of the product rate plan that the rate plan is based on.   # noqa: E501

        :param product_rate_plan_id: The product_rate_plan_id of this RatePlan.  # noqa: E501
        :type: str
        """

        self._product_rate_plan_id = product_rate_plan_id

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(RatePlan, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, RatePlan):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
