# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).  # noqa: E501

    OpenAPI spec version: 2024-05-20
    Contact: docs@zuora.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class RefundCreditMemoRequest(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'comment': 'str',
        'custom_rates': 'list[CustomRates]',
        'finance_information': 'CreateNonRefRefundFinanceInformation',
        'gateway_id': 'str',
        'gateway_options': 'GatewayOptions',
        'items': 'list[RefundCreditMemoItemRequest]',
        'method_type': 'PaymentMethodType',
        'payment_method_id': 'str',
        'reason_code': 'str',
        'reference_id': 'str',
        'refund_date': 'date',
        'second_refund_reference_id': 'str',
        'soft_descriptor': 'str',
        'soft_descriptor_phone': 'str',
        'total_amount': 'float',
        'type': 'str',
        'integration_id__ns': 'str',
        'integration_status__ns': 'str',
        'origin__ns': 'str',
        'sync_date__ns': 'str',
        'syncto_net_suite__ns': 'str'
    }

    attribute_map = {
        'comment': 'comment',
        'custom_rates': 'customRates',
        'finance_information': 'financeInformation',
        'gateway_id': 'gatewayId',
        'gateway_options': 'gatewayOptions',
        'items': 'items',
        'method_type': 'methodType',
        'payment_method_id': 'paymentMethodId',
        'reason_code': 'reasonCode',
        'reference_id': 'referenceId',
        'refund_date': 'refundDate',
        'second_refund_reference_id': 'secondRefundReferenceId',
        'soft_descriptor': 'softDescriptor',
        'soft_descriptor_phone': 'softDescriptorPhone',
        'total_amount': 'totalAmount',
        'type': 'type',
        'integration_id__ns': 'IntegrationId__NS',
        'integration_status__ns': 'IntegrationStatus__NS',
        'origin__ns': 'Origin__NS',
        'sync_date__ns': 'SyncDate__NS',
        'syncto_net_suite__ns': 'SynctoNetSuite__NS'
    }

    def __init__(self, comment=None, custom_rates=None, finance_information=None, gateway_id=None, gateway_options=None, items=None, method_type=None, payment_method_id=None, reason_code=None, reference_id=None, refund_date=None, second_refund_reference_id=None, soft_descriptor=None, soft_descriptor_phone=None, total_amount=None, type=None, integration_id__ns=None, integration_status__ns=None, origin__ns=None, sync_date__ns=None, syncto_net_suite__ns=None):  # noqa: E501
        """RefundCreditMemoRequest - a model defined in Swagger"""  # noqa: E501
        self._comment = None
        self._custom_rates = None
        self._finance_information = None
        self._gateway_id = None
        self._gateway_options = None
        self._items = None
        self._method_type = None
        self._payment_method_id = None
        self._reason_code = None
        self._reference_id = None
        self._refund_date = None
        self._second_refund_reference_id = None
        self._soft_descriptor = None
        self._soft_descriptor_phone = None
        self._total_amount = None
        self._type = None
        self._integration_id__ns = None
        self._integration_status__ns = None
        self._origin__ns = None
        self._sync_date__ns = None
        self._syncto_net_suite__ns = None
        self.discriminator = None
        if comment is not None:
            self.comment = comment
        if custom_rates is not None:
            self.custom_rates = custom_rates
        if finance_information is not None:
            self.finance_information = finance_information
        if gateway_id is not None:
            self.gateway_id = gateway_id
        if gateway_options is not None:
            self.gateway_options = gateway_options
        if items is not None:
            self.items = items
        if method_type is not None:
            self.method_type = method_type
        if payment_method_id is not None:
            self.payment_method_id = payment_method_id
        if reason_code is not None:
            self.reason_code = reason_code
        if reference_id is not None:
            self.reference_id = reference_id
        if refund_date is not None:
            self.refund_date = refund_date
        if second_refund_reference_id is not None:
            self.second_refund_reference_id = second_refund_reference_id
        if soft_descriptor is not None:
            self.soft_descriptor = soft_descriptor
        if soft_descriptor_phone is not None:
            self.soft_descriptor_phone = soft_descriptor_phone
        self.total_amount = total_amount
        self.type = type
        if integration_id__ns is not None:
            self.integration_id__ns = integration_id__ns
        if integration_status__ns is not None:
            self.integration_status__ns = integration_status__ns
        if origin__ns is not None:
            self.origin__ns = origin__ns
        if sync_date__ns is not None:
            self.sync_date__ns = sync_date__ns
        if syncto_net_suite__ns is not None:
            self.syncto_net_suite__ns = syncto_net_suite__ns

    @property
    def comment(self):
        """Gets the comment of this RefundCreditMemoRequest.  # noqa: E501

        Comments about the refund.  # noqa: E501

        :return: The comment of this RefundCreditMemoRequest.  # noqa: E501
        :rtype: str
        """
        return self._comment

    @comment.setter
    def comment(self, comment):
        """Sets the comment of this RefundCreditMemoRequest.

        Comments about the refund.  # noqa: E501

        :param comment: The comment of this RefundCreditMemoRequest.  # noqa: E501
        :type: str
        """

        self._comment = comment

    @property
    def custom_rates(self):
        """Gets the custom_rates of this RefundCreditMemoRequest.  # noqa: E501

        It contains Home currency and Reporting currency custom rates currencies. The maximum number of items is 2 (you can pass the Home currency item, Reporting currency item, or both).  **Note**: The API custom rate feature is permission controlled.  # noqa: E501

        :return: The custom_rates of this RefundCreditMemoRequest.  # noqa: E501
        :rtype: list[CustomRates]
        """
        return self._custom_rates

    @custom_rates.setter
    def custom_rates(self, custom_rates):
        """Sets the custom_rates of this RefundCreditMemoRequest.

        It contains Home currency and Reporting currency custom rates currencies. The maximum number of items is 2 (you can pass the Home currency item, Reporting currency item, or both).  **Note**: The API custom rate feature is permission controlled.  # noqa: E501

        :param custom_rates: The custom_rates of this RefundCreditMemoRequest.  # noqa: E501
        :type: list[CustomRates]
        """

        self._custom_rates = custom_rates

    @property
    def finance_information(self):
        """Gets the finance_information of this RefundCreditMemoRequest.  # noqa: E501


        :return: The finance_information of this RefundCreditMemoRequest.  # noqa: E501
        :rtype: CreateNonRefRefundFinanceInformation
        """
        return self._finance_information

    @finance_information.setter
    def finance_information(self, finance_information):
        """Sets the finance_information of this RefundCreditMemoRequest.


        :param finance_information: The finance_information of this RefundCreditMemoRequest.  # noqa: E501
        :type: CreateNonRefRefundFinanceInformation
        """

        self._finance_information = finance_information

    @property
    def gateway_id(self):
        """Gets the gateway_id of this RefundCreditMemoRequest.  # noqa: E501

        The ID of the gateway instance that processes the refund. This field can be specified only for electronic refunds. The ID must be a valid gateway instance ID, and this gateway must support the specific payment method.   If no gateway ID is specified, the default gateway in the billing account configuration will be used. If no gateway is specified in the billing account, the default gateway of the corresponding tenant will be used.   # noqa: E501

        :return: The gateway_id of this RefundCreditMemoRequest.  # noqa: E501
        :rtype: str
        """
        return self._gateway_id

    @gateway_id.setter
    def gateway_id(self, gateway_id):
        """Sets the gateway_id of this RefundCreditMemoRequest.

        The ID of the gateway instance that processes the refund. This field can be specified only for electronic refunds. The ID must be a valid gateway instance ID, and this gateway must support the specific payment method.   If no gateway ID is specified, the default gateway in the billing account configuration will be used. If no gateway is specified in the billing account, the default gateway of the corresponding tenant will be used.   # noqa: E501

        :param gateway_id: The gateway_id of this RefundCreditMemoRequest.  # noqa: E501
        :type: str
        """

        self._gateway_id = gateway_id

    @property
    def gateway_options(self):
        """Gets the gateway_options of this RefundCreditMemoRequest.  # noqa: E501


        :return: The gateway_options of this RefundCreditMemoRequest.  # noqa: E501
        :rtype: GatewayOptions
        """
        return self._gateway_options

    @gateway_options.setter
    def gateway_options(self, gateway_options):
        """Sets the gateway_options of this RefundCreditMemoRequest.


        :param gateway_options: The gateway_options of this RefundCreditMemoRequest.  # noqa: E501
        :type: GatewayOptions
        """

        self._gateway_options = gateway_options

    @property
    def items(self):
        """Gets the items of this RefundCreditMemoRequest.  # noqa: E501

        Container for credit memo items. The maximum number of items is 1,000.  **Note:** This field is only available if you have the [Invoice Item Settlement](https://knowledgecenter.zuora.com/Billing/Billing_and_Payments/Invoice_Settlement/C_Invoice_Item_Settlement) feature enabled. Invoice Item Settlement must be used together with other Invoice Settlement features (Unapplied Payments, and Credit and Debit memos).  If you wish to enable Invoice Settlement, see [Invoice Settlement Enablement and Checklist Guide](https://knowledgecenter.zuora.com/Billing/Billing_and_Payments/Invoice_Settlement/Invoice_Settlement_Migration_Checklist_and_Guide) for more information.  # noqa: E501

        :return: The items of this RefundCreditMemoRequest.  # noqa: E501
        :rtype: list[RefundCreditMemoItemRequest]
        """
        return self._items

    @items.setter
    def items(self, items):
        """Sets the items of this RefundCreditMemoRequest.

        Container for credit memo items. The maximum number of items is 1,000.  **Note:** This field is only available if you have the [Invoice Item Settlement](https://knowledgecenter.zuora.com/Billing/Billing_and_Payments/Invoice_Settlement/C_Invoice_Item_Settlement) feature enabled. Invoice Item Settlement must be used together with other Invoice Settlement features (Unapplied Payments, and Credit and Debit memos).  If you wish to enable Invoice Settlement, see [Invoice Settlement Enablement and Checklist Guide](https://knowledgecenter.zuora.com/Billing/Billing_and_Payments/Invoice_Settlement/Invoice_Settlement_Migration_Checklist_and_Guide) for more information.  # noqa: E501

        :param items: The items of this RefundCreditMemoRequest.  # noqa: E501
        :type: list[RefundCreditMemoItemRequest]
        """

        self._items = items

    @property
    def method_type(self):
        """Gets the method_type of this RefundCreditMemoRequest.  # noqa: E501


        :return: The method_type of this RefundCreditMemoRequest.  # noqa: E501
        :rtype: PaymentMethodType
        """
        return self._method_type

    @method_type.setter
    def method_type(self, method_type):
        """Sets the method_type of this RefundCreditMemoRequest.


        :param method_type: The method_type of this RefundCreditMemoRequest.  # noqa: E501
        :type: PaymentMethodType
        """

        self._method_type = method_type

    @property
    def payment_method_id(self):
        """Gets the payment_method_id of this RefundCreditMemoRequest.  # noqa: E501

        The ID of the payment method used for the refund. This field is required for an electronic refund, and the value must be an electronic payment method ID. This field must be left empty for an external refund.    # noqa: E501

        :return: The payment_method_id of this RefundCreditMemoRequest.  # noqa: E501
        :rtype: str
        """
        return self._payment_method_id

    @payment_method_id.setter
    def payment_method_id(self, payment_method_id):
        """Sets the payment_method_id of this RefundCreditMemoRequest.

        The ID of the payment method used for the refund. This field is required for an electronic refund, and the value must be an electronic payment method ID. This field must be left empty for an external refund.    # noqa: E501

        :param payment_method_id: The payment_method_id of this RefundCreditMemoRequest.  # noqa: E501
        :type: str
        """

        self._payment_method_id = payment_method_id

    @property
    def reason_code(self):
        """Gets the reason_code of this RefundCreditMemoRequest.  # noqa: E501

        A code identifying the reason for the transaction. The value must be an existing reason code or empty. If you do not specify a value, Zuora uses the default reason code.  # noqa: E501

        :return: The reason_code of this RefundCreditMemoRequest.  # noqa: E501
        :rtype: str
        """
        return self._reason_code

    @reason_code.setter
    def reason_code(self, reason_code):
        """Sets the reason_code of this RefundCreditMemoRequest.

        A code identifying the reason for the transaction. The value must be an existing reason code or empty. If you do not specify a value, Zuora uses the default reason code.  # noqa: E501

        :param reason_code: The reason_code of this RefundCreditMemoRequest.  # noqa: E501
        :type: str
        """

        self._reason_code = reason_code

    @property
    def reference_id(self):
        """Gets the reference_id of this RefundCreditMemoRequest.  # noqa: E501

        The transaction ID returned by the payment gateway for an electronic refund. Use this field to reconcile refunds between your gateway and Zuora Payments.  # noqa: E501

        :return: The reference_id of this RefundCreditMemoRequest.  # noqa: E501
        :rtype: str
        """
        return self._reference_id

    @reference_id.setter
    def reference_id(self, reference_id):
        """Sets the reference_id of this RefundCreditMemoRequest.

        The transaction ID returned by the payment gateway for an electronic refund. Use this field to reconcile refunds between your gateway and Zuora Payments.  # noqa: E501

        :param reference_id: The reference_id of this RefundCreditMemoRequest.  # noqa: E501
        :type: str
        """

        self._reference_id = reference_id

    @property
    def refund_date(self):
        """Gets the refund_date of this RefundCreditMemoRequest.  # noqa: E501

        The date when the refund takes effect, in `yyyy-mm-dd` format. The date of the refund cannot be before the credit memo date. Specify this field only for external refunds. Zuora automatically generates this field for electronic refunds.  # noqa: E501

        :return: The refund_date of this RefundCreditMemoRequest.  # noqa: E501
        :rtype: date
        """
        return self._refund_date

    @refund_date.setter
    def refund_date(self, refund_date):
        """Sets the refund_date of this RefundCreditMemoRequest.

        The date when the refund takes effect, in `yyyy-mm-dd` format. The date of the refund cannot be before the credit memo date. Specify this field only for external refunds. Zuora automatically generates this field for electronic refunds.  # noqa: E501

        :param refund_date: The refund_date of this RefundCreditMemoRequest.  # noqa: E501
        :type: date
        """

        self._refund_date = refund_date

    @property
    def second_refund_reference_id(self):
        """Gets the second_refund_reference_id of this RefundCreditMemoRequest.  # noqa: E501

        The transaction ID returned by the payment gateway if there is an additional transaction for the refund. Use this field to reconcile payments between your gateway and Zuora Payments.  # noqa: E501

        :return: The second_refund_reference_id of this RefundCreditMemoRequest.  # noqa: E501
        :rtype: str
        """
        return self._second_refund_reference_id

    @second_refund_reference_id.setter
    def second_refund_reference_id(self, second_refund_reference_id):
        """Sets the second_refund_reference_id of this RefundCreditMemoRequest.

        The transaction ID returned by the payment gateway if there is an additional transaction for the refund. Use this field to reconcile payments between your gateway and Zuora Payments.  # noqa: E501

        :param second_refund_reference_id: The second_refund_reference_id of this RefundCreditMemoRequest.  # noqa: E501
        :type: str
        """

        self._second_refund_reference_id = second_refund_reference_id

    @property
    def soft_descriptor(self):
        """Gets the soft_descriptor of this RefundCreditMemoRequest.  # noqa: E501

        A payment gateway-specific field that maps to Zuora for the gateways, Orbital, Vantiv and Verifi.  # noqa: E501

        :return: The soft_descriptor of this RefundCreditMemoRequest.  # noqa: E501
        :rtype: str
        """
        return self._soft_descriptor

    @soft_descriptor.setter
    def soft_descriptor(self, soft_descriptor):
        """Sets the soft_descriptor of this RefundCreditMemoRequest.

        A payment gateway-specific field that maps to Zuora for the gateways, Orbital, Vantiv and Verifi.  # noqa: E501

        :param soft_descriptor: The soft_descriptor of this RefundCreditMemoRequest.  # noqa: E501
        :type: str
        """

        self._soft_descriptor = soft_descriptor

    @property
    def soft_descriptor_phone(self):
        """Gets the soft_descriptor_phone of this RefundCreditMemoRequest.  # noqa: E501

        A payment gateway-specific field that maps to Zuora for the gateways, Orbital, Vantiv and Verifi.  # noqa: E501

        :return: The soft_descriptor_phone of this RefundCreditMemoRequest.  # noqa: E501
        :rtype: str
        """
        return self._soft_descriptor_phone

    @soft_descriptor_phone.setter
    def soft_descriptor_phone(self, soft_descriptor_phone):
        """Sets the soft_descriptor_phone of this RefundCreditMemoRequest.

        A payment gateway-specific field that maps to Zuora for the gateways, Orbital, Vantiv and Verifi.  # noqa: E501

        :param soft_descriptor_phone: The soft_descriptor_phone of this RefundCreditMemoRequest.  # noqa: E501
        :type: str
        """

        self._soft_descriptor_phone = soft_descriptor_phone

    @property
    def total_amount(self):
        """Gets the total_amount of this RefundCreditMemoRequest.  # noqa: E501

        The total amount of the refund. The amount cannot exceed the unapplied amount of the associated credit memo. If the original credit memo was applied to one or more invoices or debit memos, you have to unapply a full or partial credit memo from the invoices or debit memos, and then refund the full or partial unapplied credit memo to your customers.  # noqa: E501

        :return: The total_amount of this RefundCreditMemoRequest.  # noqa: E501
        :rtype: float
        """
        return self._total_amount

    @total_amount.setter
    def total_amount(self, total_amount):
        """Sets the total_amount of this RefundCreditMemoRequest.

        The total amount of the refund. The amount cannot exceed the unapplied amount of the associated credit memo. If the original credit memo was applied to one or more invoices or debit memos, you have to unapply a full or partial credit memo from the invoices or debit memos, and then refund the full or partial unapplied credit memo to your customers.  # noqa: E501

        :param total_amount: The total_amount of this RefundCreditMemoRequest.  # noqa: E501
        :type: float
        """
        if total_amount is None:
            raise ValueError("Invalid value for `total_amount`, must not be `None`")  # noqa: E501

        self._total_amount = total_amount

    @property
    def type(self):
        """Gets the type of this RefundCreditMemoRequest.  # noqa: E501

        The type of the refund.  # noqa: E501

        :return: The type of this RefundCreditMemoRequest.  # noqa: E501
        :rtype: str
        """
        return self._type

    @type.setter
    def type(self, type):
        """Sets the type of this RefundCreditMemoRequest.

        The type of the refund.  # noqa: E501

        :param type: The type of this RefundCreditMemoRequest.  # noqa: E501
        :type: str
        """
        if type is None:
            raise ValueError("Invalid value for `type`, must not be `None`")  # noqa: E501
        allowed_values = ["External", "Electronic"]  # noqa: E501
        if type not in allowed_values:
            raise ValueError(
                "Invalid value for `type` ({0}), must be one of {1}"  # noqa: E501
                .format(type, allowed_values)
            )

        self._type = type

    @property
    def integration_id__ns(self):
        """Gets the integration_id__ns of this RefundCreditMemoRequest.  # noqa: E501

        ID of the corresponding object in NetSuite. Only available if you have installed the [Zuora Connector for NetSuite](https://www.zuora.com/connect/app/?appId=265).   # noqa: E501

        :return: The integration_id__ns of this RefundCreditMemoRequest.  # noqa: E501
        :rtype: str
        """
        return self._integration_id__ns

    @integration_id__ns.setter
    def integration_id__ns(self, integration_id__ns):
        """Sets the integration_id__ns of this RefundCreditMemoRequest.

        ID of the corresponding object in NetSuite. Only available if you have installed the [Zuora Connector for NetSuite](https://www.zuora.com/connect/app/?appId=265).   # noqa: E501

        :param integration_id__ns: The integration_id__ns of this RefundCreditMemoRequest.  # noqa: E501
        :type: str
        """

        self._integration_id__ns = integration_id__ns

    @property
    def integration_status__ns(self):
        """Gets the integration_status__ns of this RefundCreditMemoRequest.  # noqa: E501

        Status of the refund's synchronization with NetSuite. Only available if you have installed the [Zuora Connector for NetSuite](https://www.zuora.com/connect/app/?appId=265).   # noqa: E501

        :return: The integration_status__ns of this RefundCreditMemoRequest.  # noqa: E501
        :rtype: str
        """
        return self._integration_status__ns

    @integration_status__ns.setter
    def integration_status__ns(self, integration_status__ns):
        """Sets the integration_status__ns of this RefundCreditMemoRequest.

        Status of the refund's synchronization with NetSuite. Only available if you have installed the [Zuora Connector for NetSuite](https://www.zuora.com/connect/app/?appId=265).   # noqa: E501

        :param integration_status__ns: The integration_status__ns of this RefundCreditMemoRequest.  # noqa: E501
        :type: str
        """

        self._integration_status__ns = integration_status__ns

    @property
    def origin__ns(self):
        """Gets the origin__ns of this RefundCreditMemoRequest.  # noqa: E501

        Origin of the corresponding object in NetSuite. Only available if you have installed the [Zuora Connector for NetSuite](https://www.zuora.com/connect/app/?appId=265).   # noqa: E501

        :return: The origin__ns of this RefundCreditMemoRequest.  # noqa: E501
        :rtype: str
        """
        return self._origin__ns

    @origin__ns.setter
    def origin__ns(self, origin__ns):
        """Sets the origin__ns of this RefundCreditMemoRequest.

        Origin of the corresponding object in NetSuite. Only available if you have installed the [Zuora Connector for NetSuite](https://www.zuora.com/connect/app/?appId=265).   # noqa: E501

        :param origin__ns: The origin__ns of this RefundCreditMemoRequest.  # noqa: E501
        :type: str
        """

        self._origin__ns = origin__ns

    @property
    def sync_date__ns(self):
        """Gets the sync_date__ns of this RefundCreditMemoRequest.  # noqa: E501

        Date when the refund was synchronized with NetSuite. Only available if you have installed the [Zuora Connector for NetSuite](https://www.zuora.com/connect/app/?appId=265).   # noqa: E501

        :return: The sync_date__ns of this RefundCreditMemoRequest.  # noqa: E501
        :rtype: str
        """
        return self._sync_date__ns

    @sync_date__ns.setter
    def sync_date__ns(self, sync_date__ns):
        """Sets the sync_date__ns of this RefundCreditMemoRequest.

        Date when the refund was synchronized with NetSuite. Only available if you have installed the [Zuora Connector for NetSuite](https://www.zuora.com/connect/app/?appId=265).   # noqa: E501

        :param sync_date__ns: The sync_date__ns of this RefundCreditMemoRequest.  # noqa: E501
        :type: str
        """

        self._sync_date__ns = sync_date__ns

    @property
    def syncto_net_suite__ns(self):
        """Gets the syncto_net_suite__ns of this RefundCreditMemoRequest.  # noqa: E501

        Specifies whether the refund should be synchronized with NetSuite. Only available if you have installed the [Zuora Connector for NetSuite](https://www.zuora.com/connect/app/?appId=265).   # noqa: E501

        :return: The syncto_net_suite__ns of this RefundCreditMemoRequest.  # noqa: E501
        :rtype: str
        """
        return self._syncto_net_suite__ns

    @syncto_net_suite__ns.setter
    def syncto_net_suite__ns(self, syncto_net_suite__ns):
        """Sets the syncto_net_suite__ns of this RefundCreditMemoRequest.

        Specifies whether the refund should be synchronized with NetSuite. Only available if you have installed the [Zuora Connector for NetSuite](https://www.zuora.com/connect/app/?appId=265).   # noqa: E501

        :param syncto_net_suite__ns: The syncto_net_suite__ns of this RefundCreditMemoRequest.  # noqa: E501
        :type: str
        """

        self._syncto_net_suite__ns = syncto_net_suite__ns

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(RefundCreditMemoRequest, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, RefundCreditMemoRequest):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
