# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).  # noqa: E501

    OpenAPI spec version: 2024-05-20
    Contact: docs@zuora.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class RenewalTerm(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'period': 'int',
        'period_type': 'TermPeriodType'
    }

    attribute_map = {
        'period': 'period',
        'period_type': 'periodType'
    }

    def __init__(self, period=None, period_type=None):  # noqa: E501
        """RenewalTerm - a model defined in Swagger"""  # noqa: E501
        self._period = None
        self._period_type = None
        self.discriminator = None
        if period is not None:
            self.period = period
        if period_type is not None:
            self.period_type = period_type

    @property
    def period(self):
        """Gets the period of this RenewalTerm.  # noqa: E501

        Duration of the renewal term in months, years, days, or weeks, depending on the value of the `periodType` field.   # noqa: E501

        :return: The period of this RenewalTerm.  # noqa: E501
        :rtype: int
        """
        return self._period

    @period.setter
    def period(self, period):
        """Sets the period of this RenewalTerm.

        Duration of the renewal term in months, years, days, or weeks, depending on the value of the `periodType` field.   # noqa: E501

        :param period: The period of this RenewalTerm.  # noqa: E501
        :type: int
        """

        self._period = period

    @property
    def period_type(self):
        """Gets the period_type of this RenewalTerm.  # noqa: E501


        :return: The period_type of this RenewalTerm.  # noqa: E501
        :rtype: TermPeriodType
        """
        return self._period_type

    @period_type.setter
    def period_type(self, period_type):
        """Sets the period_type of this RenewalTerm.


        :param period_type: The period_type of this RenewalTerm.  # noqa: E501
        :type: TermPeriodType
        """

        self._period_type = period_type

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(RenewalTerm, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, RenewalTerm):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
