# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).  # noqa: E501

    OpenAPI spec version: 2024-05-20
    Contact: docs@zuora.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class RetryPaymentScheduleItem(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'id': 'str',
        'payment_gateway_id': 'str',
        'payment_method_id': 'str'
    }

    attribute_map = {
        'id': 'id',
        'payment_gateway_id': 'paymentGatewayId',
        'payment_method_id': 'paymentMethodId'
    }

    def __init__(self, id=None, payment_gateway_id=None, payment_method_id=None):  # noqa: E501
        """RetryPaymentScheduleItem - a model defined in Swagger"""  # noqa: E501
        self._id = None
        self._payment_gateway_id = None
        self._payment_method_id = None
        self.discriminator = None
        if id is not None:
            self.id = id
        if payment_gateway_id is not None:
            self.payment_gateway_id = payment_gateway_id
        if payment_method_id is not None:
            self.payment_method_id = payment_method_id

    @property
    def id(self):
        """Gets the id of this RetryPaymentScheduleItem.  # noqa: E501

        Specifies the ID of the payment schedule item to be retried.   # noqa: E501

        :return: The id of this RetryPaymentScheduleItem.  # noqa: E501
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this RetryPaymentScheduleItem.

        Specifies the ID of the payment schedule item to be retried.   # noqa: E501

        :param id: The id of this RetryPaymentScheduleItem.  # noqa: E501
        :type: str
        """

        self._id = id

    @property
    def payment_gateway_id(self):
        """Gets the payment_gateway_id of this RetryPaymentScheduleItem.  # noqa: E501

        Specifies the ID of a payment gateway that will be used in the retry.   # noqa: E501

        :return: The payment_gateway_id of this RetryPaymentScheduleItem.  # noqa: E501
        :rtype: str
        """
        return self._payment_gateway_id

    @payment_gateway_id.setter
    def payment_gateway_id(self, payment_gateway_id):
        """Sets the payment_gateway_id of this RetryPaymentScheduleItem.

        Specifies the ID of a payment gateway that will be used in the retry.   # noqa: E501

        :param payment_gateway_id: The payment_gateway_id of this RetryPaymentScheduleItem.  # noqa: E501
        :type: str
        """

        self._payment_gateway_id = payment_gateway_id

    @property
    def payment_method_id(self):
        """Gets the payment_method_id of this RetryPaymentScheduleItem.  # noqa: E501

        Specifies the ID of a payment method that will be used in the retry.   # noqa: E501

        :return: The payment_method_id of this RetryPaymentScheduleItem.  # noqa: E501
        :rtype: str
        """
        return self._payment_method_id

    @payment_method_id.setter
    def payment_method_id(self, payment_method_id):
        """Sets the payment_method_id of this RetryPaymentScheduleItem.

        Specifies the ID of a payment method that will be used in the retry.   # noqa: E501

        :param payment_method_id: The payment_method_id of this RetryPaymentScheduleItem.  # noqa: E501
        :type: str
        """

        self._payment_method_id = payment_method_id

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(RetryPaymentScheduleItem, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, RetryPaymentScheduleItem):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
