# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).  # noqa: E501

    OpenAPI spec version: 2024-05-20
    Contact: docs@zuora.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six
from zuora_sdk.models.common_response import CommonResponse  # noqa: F401,E501

class ReverseCreditMemoResponse(CommonResponse):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'credit_memo': 'ReverseCreditMemoResponseCreditMemo',
        'debit_memo': 'ReverseCreditMemoResponseDebitMemo'
    }
    if hasattr(CommonResponse, "swagger_types"):
        swagger_types.update(CommonResponse.swagger_types)

    attribute_map = {
        'credit_memo': 'creditMemo',
        'debit_memo': 'debitMemo'
    }
    if hasattr(CommonResponse, "attribute_map"):
        attribute_map.update(CommonResponse.attribute_map)

    def __init__(self, credit_memo=None, debit_memo=None, *args, **kwargs):  # noqa: E501
        """ReverseCreditMemoResponse - a model defined in Swagger"""  # noqa: E501
        self._credit_memo = None
        self._debit_memo = None
        self.discriminator = None
        if credit_memo is not None:
            self.credit_memo = credit_memo
        if debit_memo is not None:
            self.debit_memo = debit_memo
        CommonResponse.__init__(self, *args, **kwargs)

    @property
    def credit_memo(self):
        """Gets the credit_memo of this ReverseCreditMemoResponse.  # noqa: E501


        :return: The credit_memo of this ReverseCreditMemoResponse.  # noqa: E501
        :rtype: ReverseCreditMemoResponseCreditMemo
        """
        return self._credit_memo

    @credit_memo.setter
    def credit_memo(self, credit_memo):
        """Sets the credit_memo of this ReverseCreditMemoResponse.


        :param credit_memo: The credit_memo of this ReverseCreditMemoResponse.  # noqa: E501
        :type: ReverseCreditMemoResponseCreditMemo
        """

        self._credit_memo = credit_memo

    @property
    def debit_memo(self):
        """Gets the debit_memo of this ReverseCreditMemoResponse.  # noqa: E501


        :return: The debit_memo of this ReverseCreditMemoResponse.  # noqa: E501
        :rtype: ReverseCreditMemoResponseDebitMemo
        """
        return self._debit_memo

    @debit_memo.setter
    def debit_memo(self, debit_memo):
        """Sets the debit_memo of this ReverseCreditMemoResponse.


        :param debit_memo: The debit_memo of this ReverseCreditMemoResponse.  # noqa: E501
        :type: ReverseCreditMemoResponseDebitMemo
        """

        self._debit_memo = debit_memo

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(ReverseCreditMemoResponse, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ReverseCreditMemoResponse):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
