# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).  # noqa: E501

    OpenAPI spec version: 2024-05-20
    Contact: docs@zuora.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class ReversePaymentRequest(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'amount': 'float',
        'gateway_reconciliation_reason': 'str',
        'gateway_reconciliation_status': 'str',
        'gateway_response': 'str',
        'gateway_response_code': 'str',
        'payout_id': 'str',
        'reference_id': 'str',
        'second_reference_id': 'str',
        'settled_on': 'str'
    }

    attribute_map = {
        'amount': 'amount',
        'gateway_reconciliation_reason': 'gatewayReconciliationReason',
        'gateway_reconciliation_status': 'gatewayReconciliationStatus',
        'gateway_response': 'gatewayResponse',
        'gateway_response_code': 'gatewayResponseCode',
        'payout_id': 'payoutId',
        'reference_id': 'referenceId',
        'second_reference_id': 'secondReferenceId',
        'settled_on': 'settledOn'
    }

    def __init__(self, amount=None, gateway_reconciliation_reason=None, gateway_reconciliation_status=None, gateway_response=None, gateway_response_code=None, payout_id=None, reference_id=None, second_reference_id=None, settled_on=None):  # noqa: E501
        """ReversePaymentRequest - a model defined in Swagger"""  # noqa: E501
        self._amount = None
        self._gateway_reconciliation_reason = None
        self._gateway_reconciliation_status = None
        self._gateway_response = None
        self._gateway_response_code = None
        self._payout_id = None
        self._reference_id = None
        self._second_reference_id = None
        self._settled_on = None
        self.discriminator = None
        self.amount = amount
        if gateway_reconciliation_reason is not None:
            self.gateway_reconciliation_reason = gateway_reconciliation_reason
        if gateway_reconciliation_status is not None:
            self.gateway_reconciliation_status = gateway_reconciliation_status
        if gateway_response is not None:
            self.gateway_response = gateway_response
        if gateway_response_code is not None:
            self.gateway_response_code = gateway_response_code
        if payout_id is not None:
            self.payout_id = payout_id
        if reference_id is not None:
            self.reference_id = reference_id
        if second_reference_id is not None:
            self.second_reference_id = second_reference_id
        if settled_on is not None:
            self.settled_on = settled_on

    @property
    def amount(self):
        """Gets the amount of this ReversePaymentRequest.  # noqa: E501

        The amount that needs to be reversed (chargeback). It cannot be greater than the total Payment amount.    # noqa: E501

        :return: The amount of this ReversePaymentRequest.  # noqa: E501
        :rtype: float
        """
        return self._amount

    @amount.setter
    def amount(self, amount):
        """Sets the amount of this ReversePaymentRequest.

        The amount that needs to be reversed (chargeback). It cannot be greater than the total Payment amount.    # noqa: E501

        :param amount: The amount of this ReversePaymentRequest.  # noqa: E501
        :type: float
        """
        if amount is None:
            raise ValueError("Invalid value for `amount`, must not be `None`")  # noqa: E501

        self._amount = amount

    @property
    def gateway_reconciliation_reason(self):
        """Gets the gateway_reconciliation_reason of this ReversePaymentRequest.  # noqa: E501

        The reason of gateway reconciliation.   # noqa: E501

        :return: The gateway_reconciliation_reason of this ReversePaymentRequest.  # noqa: E501
        :rtype: str
        """
        return self._gateway_reconciliation_reason

    @gateway_reconciliation_reason.setter
    def gateway_reconciliation_reason(self, gateway_reconciliation_reason):
        """Sets the gateway_reconciliation_reason of this ReversePaymentRequest.

        The reason of gateway reconciliation.   # noqa: E501

        :param gateway_reconciliation_reason: The gateway_reconciliation_reason of this ReversePaymentRequest.  # noqa: E501
        :type: str
        """

        self._gateway_reconciliation_reason = gateway_reconciliation_reason

    @property
    def gateway_reconciliation_status(self):
        """Gets the gateway_reconciliation_status of this ReversePaymentRequest.  # noqa: E501

        The status of gateway reconciliation.   # noqa: E501

        :return: The gateway_reconciliation_status of this ReversePaymentRequest.  # noqa: E501
        :rtype: str
        """
        return self._gateway_reconciliation_status

    @gateway_reconciliation_status.setter
    def gateway_reconciliation_status(self, gateway_reconciliation_status):
        """Sets the gateway_reconciliation_status of this ReversePaymentRequest.

        The status of gateway reconciliation.   # noqa: E501

        :param gateway_reconciliation_status: The gateway_reconciliation_status of this ReversePaymentRequest.  # noqa: E501
        :type: str
        """

        self._gateway_reconciliation_status = gateway_reconciliation_status

    @property
    def gateway_response(self):
        """Gets the gateway_response of this ReversePaymentRequest.  # noqa: E501

        The transaction response returned by the gateway for this transaction. If the transaction was declined, this reason is provided in the message.   # noqa: E501

        :return: The gateway_response of this ReversePaymentRequest.  # noqa: E501
        :rtype: str
        """
        return self._gateway_response

    @gateway_response.setter
    def gateway_response(self, gateway_response):
        """Sets the gateway_response of this ReversePaymentRequest.

        The transaction response returned by the gateway for this transaction. If the transaction was declined, this reason is provided in the message.   # noqa: E501

        :param gateway_response: The gateway_response of this ReversePaymentRequest.  # noqa: E501
        :type: str
        """

        self._gateway_response = gateway_response

    @property
    def gateway_response_code(self):
        """Gets the gateway_response_code of this ReversePaymentRequest.  # noqa: E501

        Response message Code returned by the gateway about the transaction status.   # noqa: E501

        :return: The gateway_response_code of this ReversePaymentRequest.  # noqa: E501
        :rtype: str
        """
        return self._gateway_response_code

    @gateway_response_code.setter
    def gateway_response_code(self, gateway_response_code):
        """Sets the gateway_response_code of this ReversePaymentRequest.

        Response message Code returned by the gateway about the transaction status.   # noqa: E501

        :param gateway_response_code: The gateway_response_code of this ReversePaymentRequest.  # noqa: E501
        :type: str
        """

        self._gateway_response_code = gateway_response_code

    @property
    def payout_id(self):
        """Gets the payout_id of this ReversePaymentRequest.  # noqa: E501

        The payout ID from the gateway side.   # noqa: E501

        :return: The payout_id of this ReversePaymentRequest.  # noqa: E501
        :rtype: str
        """
        return self._payout_id

    @payout_id.setter
    def payout_id(self, payout_id):
        """Sets the payout_id of this ReversePaymentRequest.

        The payout ID from the gateway side.   # noqa: E501

        :param payout_id: The payout_id of this ReversePaymentRequest.  # noqa: E501
        :type: str
        """

        self._payout_id = payout_id

    @property
    def reference_id(self):
        """Gets the reference_id of this ReversePaymentRequest.  # noqa: E501

        Unique Id generated by the gateway for each transaction. Use this ID to find the respective Zuora Payment ID.    # noqa: E501

        :return: The reference_id of this ReversePaymentRequest.  # noqa: E501
        :rtype: str
        """
        return self._reference_id

    @reference_id.setter
    def reference_id(self, reference_id):
        """Sets the reference_id of this ReversePaymentRequest.

        Unique Id generated by the gateway for each transaction. Use this ID to find the respective Zuora Payment ID.    # noqa: E501

        :param reference_id: The reference_id of this ReversePaymentRequest.  # noqa: E501
        :type: str
        """

        self._reference_id = reference_id

    @property
    def second_reference_id(self):
        """Gets the second_reference_id of this ReversePaymentRequest.  # noqa: E501

        The second reference Id. Some gateways use two unique transaction IDs.   # noqa: E501

        :return: The second_reference_id of this ReversePaymentRequest.  # noqa: E501
        :rtype: str
        """
        return self._second_reference_id

    @second_reference_id.setter
    def second_reference_id(self, second_reference_id):
        """Sets the second_reference_id of this ReversePaymentRequest.

        The second reference Id. Some gateways use two unique transaction IDs.   # noqa: E501

        :param second_reference_id: The second_reference_id of this ReversePaymentRequest.  # noqa: E501
        :type: str
        """

        self._second_reference_id = second_reference_id

    @property
    def settled_on(self):
        """Gets the settled_on of this ReversePaymentRequest.  # noqa: E501

        The date and time of the transaction settlement. The format is `yyyy-mm-dd hh:mm:ss`.   # noqa: E501

        :return: The settled_on of this ReversePaymentRequest.  # noqa: E501
        :rtype: str
        """
        return self._settled_on

    @settled_on.setter
    def settled_on(self, settled_on):
        """Sets the settled_on of this ReversePaymentRequest.

        The date and time of the transaction settlement. The format is `yyyy-mm-dd hh:mm:ss`.   # noqa: E501

        :param settled_on: The settled_on of this ReversePaymentRequest.  # noqa: E501
        :type: str
        """

        self._settled_on = settled_on

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(ReversePaymentRequest, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ReversePaymentRequest):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
