# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).  # noqa: E501

    OpenAPI spec version: 2024-05-20
    Contact: docs@zuora.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class SettingComponentKeyValue(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'errors': 'list[str]',
        'original_payload': 'object',
        'response': 'list[ConfigurationTemplateContent]',
        'segregation_keys': 'list[str]'
    }

    attribute_map = {
        'errors': 'errors',
        'original_payload': 'originalPayload',
        'response': 'response',
        'segregation_keys': 'segregationKeys'
    }

    def __init__(self, errors=None, original_payload=None, response=None, segregation_keys=None):  # noqa: E501
        """SettingComponentKeyValue - a model defined in Swagger"""  # noqa: E501
        self._errors = None
        self._original_payload = None
        self._response = None
        self._segregation_keys = None
        self.discriminator = None
        if errors is not None:
            self.errors = errors
        if original_payload is not None:
            self.original_payload = original_payload
        if response is not None:
            self.response = response
        if segregation_keys is not None:
            self.segregation_keys = segregation_keys

    @property
    def errors(self):
        """Gets the errors of this SettingComponentKeyValue.  # noqa: E501


        :return: The errors of this SettingComponentKeyValue.  # noqa: E501
        :rtype: list[str]
        """
        return self._errors

    @errors.setter
    def errors(self, errors):
        """Sets the errors of this SettingComponentKeyValue.


        :param errors: The errors of this SettingComponentKeyValue.  # noqa: E501
        :type: list[str]
        """

        self._errors = errors

    @property
    def original_payload(self):
        """Gets the original_payload of this SettingComponentKeyValue.  # noqa: E501

        Json node object contains metadata.  # noqa: E501

        :return: The original_payload of this SettingComponentKeyValue.  # noqa: E501
        :rtype: object
        """
        return self._original_payload

    @original_payload.setter
    def original_payload(self, original_payload):
        """Sets the original_payload of this SettingComponentKeyValue.

        Json node object contains metadata.  # noqa: E501

        :param original_payload: The original_payload of this SettingComponentKeyValue.  # noqa: E501
        :type: object
        """

        self._original_payload = original_payload

    @property
    def response(self):
        """Gets the response of this SettingComponentKeyValue.  # noqa: E501


        :return: The response of this SettingComponentKeyValue.  # noqa: E501
        :rtype: list[ConfigurationTemplateContent]
        """
        return self._response

    @response.setter
    def response(self, response):
        """Sets the response of this SettingComponentKeyValue.


        :param response: The response of this SettingComponentKeyValue.  # noqa: E501
        :type: list[ConfigurationTemplateContent]
        """

        self._response = response

    @property
    def segregation_keys(self):
        """Gets the segregation_keys of this SettingComponentKeyValue.  # noqa: E501


        :return: The segregation_keys of this SettingComponentKeyValue.  # noqa: E501
        :rtype: list[str]
        """
        return self._segregation_keys

    @segregation_keys.setter
    def segregation_keys(self, segregation_keys):
        """Sets the segregation_keys of this SettingComponentKeyValue.


        :param segregation_keys: The segregation_keys of this SettingComponentKeyValue.  # noqa: E501
        :type: list[str]
        """

        self._segregation_keys = segregation_keys

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(SettingComponentKeyValue, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, SettingComponentKeyValue):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
