# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).  # noqa: E501

    OpenAPI spec version: 2024-05-20
    Contact: docs@zuora.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class SettingValueResponse(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'body': 'dict(str, object)',
        'error_messages': 'list[str]',
        'status': 'str'
    }

    attribute_map = {
        'body': 'body',
        'error_messages': 'errorMessages',
        'status': 'status'
    }

    def __init__(self, body=None, error_messages=None, status=None):  # noqa: E501
        """SettingValueResponse - a model defined in Swagger"""  # noqa: E501
        self._body = None
        self._error_messages = None
        self._status = None
        self.discriminator = None
        if body is not None:
            self.body = body
        if error_messages is not None:
            self.error_messages = error_messages
        if status is not None:
            self.status = status

    @property
    def body(self):
        """Gets the body of this SettingValueResponse.  # noqa: E501

        Response body if the request is executed successfully.  # noqa: E501

        :return: The body of this SettingValueResponse.  # noqa: E501
        :rtype: dict(str, object)
        """
        return self._body

    @body.setter
    def body(self, body):
        """Sets the body of this SettingValueResponse.

        Response body if the request is executed successfully.  # noqa: E501

        :param body: The body of this SettingValueResponse.  # noqa: E501
        :type: dict(str, object)
        """

        self._body = body

    @property
    def error_messages(self):
        """Gets the error_messages of this SettingValueResponse.  # noqa: E501

        An array of error messages if errors occur when executing the request.   # noqa: E501

        :return: The error_messages of this SettingValueResponse.  # noqa: E501
        :rtype: list[str]
        """
        return self._error_messages

    @error_messages.setter
    def error_messages(self, error_messages):
        """Sets the error_messages of this SettingValueResponse.

        An array of error messages if errors occur when executing the request.   # noqa: E501

        :param error_messages: The error_messages of this SettingValueResponse.  # noqa: E501
        :type: list[str]
        """

        self._error_messages = error_messages

    @property
    def status(self):
        """Gets the status of this SettingValueResponse.  # noqa: E501

        User readable response status, for example, 502 BAD_GATEWAY.   # noqa: E501

        :return: The status of this SettingValueResponse.  # noqa: E501
        :rtype: str
        """
        return self._status

    @status.setter
    def status(self, status):
        """Sets the status of this SettingValueResponse.

        User readable response status, for example, 502 BAD_GATEWAY.   # noqa: E501

        :param status: The status of this SettingValueResponse.  # noqa: E501
        :type: str
        """

        self._status = status

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(SettingValueResponse, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, SettingValueResponse):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
