# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).  # noqa: E501

    OpenAPI spec version: 2024-05-20
    Contact: docs@zuora.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class SubscriptionData(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'custom_fields': 'dict(str, object)',
        'invoice_separately': 'bool',
        'notes': 'str',
        'rate_plans': 'list[RatePlan]',
        'start_date': 'date',
        'subscription_number': 'str',
        'terms': 'TermInfo'
    }

    attribute_map = {
        'custom_fields': 'customFields',
        'invoice_separately': 'invoiceSeparately',
        'notes': 'notes',
        'rate_plans': 'ratePlans',
        'start_date': 'startDate',
        'subscription_number': 'subscriptionNumber',
        'terms': 'terms'
    }

    def __init__(self, custom_fields=None, invoice_separately=None, notes=None, rate_plans=None, start_date=None, subscription_number=None, terms=None):  # noqa: E501
        """SubscriptionData - a model defined in Swagger"""  # noqa: E501
        self._custom_fields = None
        self._invoice_separately = None
        self._notes = None
        self._rate_plans = None
        self._start_date = None
        self._subscription_number = None
        self._terms = None
        self.discriminator = None
        if custom_fields is not None:
            self.custom_fields = custom_fields
        if invoice_separately is not None:
            self.invoice_separately = invoice_separately
        if notes is not None:
            self.notes = notes
        if rate_plans is not None:
            self.rate_plans = rate_plans
        if start_date is not None:
            self.start_date = start_date
        if subscription_number is not None:
            self.subscription_number = subscription_number
        if terms is not None:
            self.terms = terms

    @property
    def custom_fields(self):
        """Gets the custom_fields of this SubscriptionData.  # noqa: E501

        Container for custom fields.   # noqa: E501

        :return: The custom_fields of this SubscriptionData.  # noqa: E501
        :rtype: dict(str, object)
        """
        return self._custom_fields

    @custom_fields.setter
    def custom_fields(self, custom_fields):
        """Sets the custom_fields of this SubscriptionData.

        Container for custom fields.   # noqa: E501

        :param custom_fields: The custom_fields of this SubscriptionData.  # noqa: E501
        :type: dict(str, object)
        """

        self._custom_fields = custom_fields

    @property
    def invoice_separately(self):
        """Gets the invoice_separately of this SubscriptionData.  # noqa: E501

        Specifies whether the subscription appears on a separate invoice when Zuora generates invoices.   # noqa: E501

        :return: The invoice_separately of this SubscriptionData.  # noqa: E501
        :rtype: bool
        """
        return self._invoice_separately

    @invoice_separately.setter
    def invoice_separately(self, invoice_separately):
        """Sets the invoice_separately of this SubscriptionData.

        Specifies whether the subscription appears on a separate invoice when Zuora generates invoices.   # noqa: E501

        :param invoice_separately: The invoice_separately of this SubscriptionData.  # noqa: E501
        :type: bool
        """

        self._invoice_separately = invoice_separately

    @property
    def notes(self):
        """Gets the notes of this SubscriptionData.  # noqa: E501

        Notes about the subscription. These notes are only visible to Zuora users.   # noqa: E501

        :return: The notes of this SubscriptionData.  # noqa: E501
        :rtype: str
        """
        return self._notes

    @notes.setter
    def notes(self, notes):
        """Sets the notes of this SubscriptionData.

        Notes about the subscription. These notes are only visible to Zuora users.   # noqa: E501

        :param notes: The notes of this SubscriptionData.  # noqa: E501
        :type: str
        """

        self._notes = notes

    @property
    def rate_plans(self):
        """Gets the rate_plans of this SubscriptionData.  # noqa: E501


        :return: The rate_plans of this SubscriptionData.  # noqa: E501
        :rtype: list[RatePlan]
        """
        return self._rate_plans

    @rate_plans.setter
    def rate_plans(self, rate_plans):
        """Sets the rate_plans of this SubscriptionData.


        :param rate_plans: The rate_plans of this SubscriptionData.  # noqa: E501
        :type: list[RatePlan]
        """

        self._rate_plans = rate_plans

    @property
    def start_date(self):
        """Gets the start_date of this SubscriptionData.  # noqa: E501


        :return: The start_date of this SubscriptionData.  # noqa: E501
        :rtype: date
        """
        return self._start_date

    @start_date.setter
    def start_date(self, start_date):
        """Sets the start_date of this SubscriptionData.


        :param start_date: The start_date of this SubscriptionData.  # noqa: E501
        :type: date
        """

        self._start_date = start_date

    @property
    def subscription_number(self):
        """Gets the subscription_number of this SubscriptionData.  # noqa: E501

        Subscription number of the subscription to create, for example, A-S00000001.  If you do not set this field, Zuora will generate a subscription number.   # noqa: E501

        :return: The subscription_number of this SubscriptionData.  # noqa: E501
        :rtype: str
        """
        return self._subscription_number

    @subscription_number.setter
    def subscription_number(self, subscription_number):
        """Sets the subscription_number of this SubscriptionData.

        Subscription number of the subscription to create, for example, A-S00000001.  If you do not set this field, Zuora will generate a subscription number.   # noqa: E501

        :param subscription_number: The subscription_number of this SubscriptionData.  # noqa: E501
        :type: str
        """

        self._subscription_number = subscription_number

    @property
    def terms(self):
        """Gets the terms of this SubscriptionData.  # noqa: E501


        :return: The terms of this SubscriptionData.  # noqa: E501
        :rtype: TermInfo
        """
        return self._terms

    @terms.setter
    def terms(self, terms):
        """Sets the terms of this SubscriptionData.


        :param terms: The terms of this SubscriptionData.  # noqa: E501
        :type: TermInfo
        """

        self._terms = terms

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(SubscriptionData, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, SubscriptionData):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
