# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).  # noqa: E501

    OpenAPI spec version: 2024-05-20
    Contact: docs@zuora.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class UpdateOrderActionChargeTriggerDate(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'charge_number': 'str',
        'specific_trigger_date': 'date'
    }

    attribute_map = {
        'charge_number': 'chargeNumber',
        'specific_trigger_date': 'specificTriggerDate'
    }

    def __init__(self, charge_number=None, specific_trigger_date=None):  # noqa: E501
        """UpdateOrderActionChargeTriggerDate - a model defined in Swagger"""  # noqa: E501
        self._charge_number = None
        self._specific_trigger_date = None
        self.discriminator = None
        if charge_number is not None:
            self.charge_number = charge_number
        if specific_trigger_date is not None:
            self.specific_trigger_date = specific_trigger_date

    @property
    def charge_number(self):
        """Gets the charge_number of this UpdateOrderActionChargeTriggerDate.  # noqa: E501

        Charge number of the charge which needs the triggering date to be provided. The charge's `triggerEvent` must have been set as `SpecificDate`.  # noqa: E501

        :return: The charge_number of this UpdateOrderActionChargeTriggerDate.  # noqa: E501
        :rtype: str
        """
        return self._charge_number

    @charge_number.setter
    def charge_number(self, charge_number):
        """Sets the charge_number of this UpdateOrderActionChargeTriggerDate.

        Charge number of the charge which needs the triggering date to be provided. The charge's `triggerEvent` must have been set as `SpecificDate`.  # noqa: E501

        :param charge_number: The charge_number of this UpdateOrderActionChargeTriggerDate.  # noqa: E501
        :type: str
        """

        self._charge_number = charge_number

    @property
    def specific_trigger_date(self):
        """Gets the specific_trigger_date of this UpdateOrderActionChargeTriggerDate.  # noqa: E501

        Date in YYYY-MM-DD format. The specific trigger date you are to set for the charge.  # noqa: E501

        :return: The specific_trigger_date of this UpdateOrderActionChargeTriggerDate.  # noqa: E501
        :rtype: date
        """
        return self._specific_trigger_date

    @specific_trigger_date.setter
    def specific_trigger_date(self, specific_trigger_date):
        """Sets the specific_trigger_date of this UpdateOrderActionChargeTriggerDate.

        Date in YYYY-MM-DD format. The specific trigger date you are to set for the charge.  # noqa: E501

        :param specific_trigger_date: The specific_trigger_date of this UpdateOrderActionChargeTriggerDate.  # noqa: E501
        :type: date
        """

        self._specific_trigger_date = specific_trigger_date

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(UpdateOrderActionChargeTriggerDate, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, UpdateOrderActionChargeTriggerDate):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
