# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).  # noqa: E501

    OpenAPI spec version: 2024-05-20
    Contact: docs@zuora.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class UpdateOrderSubscriptionsOrderActionsCustomFields(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'custom_fields': 'dict(str, object)',
        'order_action_id': 'str',
        'sequence': 'int'
    }

    attribute_map = {
        'custom_fields': 'customFields',
        'order_action_id': 'orderActionId',
        'sequence': 'sequence'
    }

    def __init__(self, custom_fields=None, order_action_id=None, sequence=None):  # noqa: E501
        """UpdateOrderSubscriptionsOrderActionsCustomFields - a model defined in Swagger"""  # noqa: E501
        self._custom_fields = None
        self._order_action_id = None
        self._sequence = None
        self.discriminator = None
        if custom_fields is not None:
            self.custom_fields = custom_fields
        if order_action_id is not None:
            self.order_action_id = order_action_id
        if sequence is not None:
            self.sequence = sequence

    @property
    def custom_fields(self):
        """Gets the custom_fields of this UpdateOrderSubscriptionsOrderActionsCustomFields.  # noqa: E501

        Container for custom fields of an Order Action object.   # noqa: E501

        :return: The custom_fields of this UpdateOrderSubscriptionsOrderActionsCustomFields.  # noqa: E501
        :rtype: dict(str, object)
        """
        return self._custom_fields

    @custom_fields.setter
    def custom_fields(self, custom_fields):
        """Sets the custom_fields of this UpdateOrderSubscriptionsOrderActionsCustomFields.

        Container for custom fields of an Order Action object.   # noqa: E501

        :param custom_fields: The custom_fields of this UpdateOrderSubscriptionsOrderActionsCustomFields.  # noqa: E501
        :type: dict(str, object)
        """

        self._custom_fields = custom_fields

    @property
    def order_action_id(self):
        """Gets the order_action_id of this UpdateOrderSubscriptionsOrderActionsCustomFields.  # noqa: E501

        The Id of the order action in the order. You can provide either the `sequence` or the `orderActionId` field to specify which order action to update. You cannot use then both at the same time.   # noqa: E501

        :return: The order_action_id of this UpdateOrderSubscriptionsOrderActionsCustomFields.  # noqa: E501
        :rtype: str
        """
        return self._order_action_id

    @order_action_id.setter
    def order_action_id(self, order_action_id):
        """Sets the order_action_id of this UpdateOrderSubscriptionsOrderActionsCustomFields.

        The Id of the order action in the order. You can provide either the `sequence` or the `orderActionId` field to specify which order action to update. You cannot use then both at the same time.   # noqa: E501

        :param order_action_id: The order_action_id of this UpdateOrderSubscriptionsOrderActionsCustomFields.  # noqa: E501
        :type: str
        """

        self._order_action_id = order_action_id

    @property
    def sequence(self):
        """Gets the sequence of this UpdateOrderSubscriptionsOrderActionsCustomFields.  # noqa: E501

        The sequence number of the order action in the order. You can provide either the `sequence` or the `orderActionId` field to specify which order action to update. You cannot use then both at the same time.   # noqa: E501

        :return: The sequence of this UpdateOrderSubscriptionsOrderActionsCustomFields.  # noqa: E501
        :rtype: int
        """
        return self._sequence

    @sequence.setter
    def sequence(self, sequence):
        """Sets the sequence of this UpdateOrderSubscriptionsOrderActionsCustomFields.

        The sequence number of the order action in the order. You can provide either the `sequence` or the `orderActionId` field to specify which order action to update. You cannot use then both at the same time.   # noqa: E501

        :param sequence: The sequence of this UpdateOrderSubscriptionsOrderActionsCustomFields.  # noqa: E501
        :type: int
        """

        self._sequence = sequence

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(UpdateOrderSubscriptionsOrderActionsCustomFields, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, UpdateOrderSubscriptionsOrderActionsCustomFields):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
