# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).  # noqa: E501

    OpenAPI spec version: 2024-05-20
    Contact: docs@zuora.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six
from zuora_sdk.models.common_response import CommonResponse  # noqa: F401,E501

class UpdateOrderTriggerDatesResponse(CommonResponse):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'account_number': 'str',
        'order_number': 'str',
        'status': 'str',
        'subscriptions': 'list[UpdateOrderTriggerDateResponse]'
    }
    if hasattr(CommonResponse, "swagger_types"):
        swagger_types.update(CommonResponse.swagger_types)

    attribute_map = {
        'account_number': 'accountNumber',
        'order_number': 'orderNumber',
        'status': 'status',
        'subscriptions': 'subscriptions'
    }
    if hasattr(CommonResponse, "attribute_map"):
        attribute_map.update(CommonResponse.attribute_map)

    def __init__(self, account_number=None, order_number=None, status=None, subscriptions=None, *args, **kwargs):  # noqa: E501
        """UpdateOrderTriggerDatesResponse - a model defined in Swagger"""  # noqa: E501
        self._account_number = None
        self._order_number = None
        self._status = None
        self._subscriptions = None
        self.discriminator = None
        if account_number is not None:
            self.account_number = account_number
        if order_number is not None:
            self.order_number = order_number
        if status is not None:
            self.status = status
        if subscriptions is not None:
            self.subscriptions = subscriptions
        CommonResponse.__init__(self, *args, **kwargs)

    @property
    def account_number(self):
        """Gets the account_number of this UpdateOrderTriggerDatesResponse.  # noqa: E501

        The account number for the order.  # noqa: E501

        :return: The account_number of this UpdateOrderTriggerDatesResponse.  # noqa: E501
        :rtype: str
        """
        return self._account_number

    @account_number.setter
    def account_number(self, account_number):
        """Sets the account_number of this UpdateOrderTriggerDatesResponse.

        The account number for the order.  # noqa: E501

        :param account_number: The account_number of this UpdateOrderTriggerDatesResponse.  # noqa: E501
        :type: str
        """

        self._account_number = account_number

    @property
    def order_number(self):
        """Gets the order_number of this UpdateOrderTriggerDatesResponse.  # noqa: E501

        The order number of the order updated.  # noqa: E501

        :return: The order_number of this UpdateOrderTriggerDatesResponse.  # noqa: E501
        :rtype: str
        """
        return self._order_number

    @order_number.setter
    def order_number(self, order_number):
        """Sets the order_number of this UpdateOrderTriggerDatesResponse.

        The order number of the order updated.  # noqa: E501

        :param order_number: The order_number of this UpdateOrderTriggerDatesResponse.  # noqa: E501
        :type: str
        """

        self._order_number = order_number

    @property
    def status(self):
        """Gets the status of this UpdateOrderTriggerDatesResponse.  # noqa: E501

        Status of the order.  # noqa: E501

        :return: The status of this UpdateOrderTriggerDatesResponse.  # noqa: E501
        :rtype: str
        """
        return self._status

    @status.setter
    def status(self, status):
        """Sets the status of this UpdateOrderTriggerDatesResponse.

        Status of the order.  # noqa: E501

        :param status: The status of this UpdateOrderTriggerDatesResponse.  # noqa: E501
        :type: str
        """
        allowed_values = ["Completed", "Pending"]  # noqa: E501
        if status not in allowed_values:
            raise ValueError(
                "Invalid value for `status` ({0}), must be one of {1}"  # noqa: E501
                .format(status, allowed_values)
            )

        self._status = status

    @property
    def subscriptions(self):
        """Gets the subscriptions of this UpdateOrderTriggerDatesResponse.  # noqa: E501

        The subscriptions updated.  # noqa: E501

        :return: The subscriptions of this UpdateOrderTriggerDatesResponse.  # noqa: E501
        :rtype: list[UpdateOrderTriggerDateResponse]
        """
        return self._subscriptions

    @subscriptions.setter
    def subscriptions(self, subscriptions):
        """Sets the subscriptions of this UpdateOrderTriggerDatesResponse.

        The subscriptions updated.  # noqa: E501

        :param subscriptions: The subscriptions of this UpdateOrderTriggerDatesResponse.  # noqa: E501
        :type: list[UpdateOrderTriggerDateResponse]
        """

        self._subscriptions = subscriptions

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(UpdateOrderTriggerDatesResponse, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, UpdateOrderTriggerDatesResponse):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
