# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).  # noqa: E501

    OpenAPI spec version: 2024-05-20
    Contact: docs@zuora.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class UpdateSubscriptionChargeCustomFieldsOfASpecifiedVersion(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'charge_id': 'str',
        'charge_number': 'str',
        'custom_fields': 'dict(str, object)'
    }

    attribute_map = {
        'charge_id': 'chargeId',
        'charge_number': 'chargeNumber',
        'custom_fields': 'customFields'
    }

    def __init__(self, charge_id=None, charge_number=None, custom_fields=None):  # noqa: E501
        """UpdateSubscriptionChargeCustomFieldsOfASpecifiedVersion - a model defined in Swagger"""  # noqa: E501
        self._charge_id = None
        self._charge_number = None
        self._custom_fields = None
        self.discriminator = None
        if charge_id is not None:
            self.charge_id = charge_id
        if charge_number is not None:
            self.charge_number = charge_number
        if custom_fields is not None:
            self.custom_fields = custom_fields

    @property
    def charge_id(self):
        """Gets the charge_id of this UpdateSubscriptionChargeCustomFieldsOfASpecifiedVersion.  # noqa: E501

        Use either this field or the `chargeNumber` field to specify the charge for which you will be updating the custom fields. By using this field you actually specify a specific charge segment of a charge. See [Segmented rate plan charges](https://knowledgecenter.zuora.com/Central_Platform/API/G_SOAP_API/E1_SOAP_API_Object_Reference/RatePlanCharge#Segmented_rate_plan_charges) for more information about charge segments.   # noqa: E501

        :return: The charge_id of this UpdateSubscriptionChargeCustomFieldsOfASpecifiedVersion.  # noqa: E501
        :rtype: str
        """
        return self._charge_id

    @charge_id.setter
    def charge_id(self, charge_id):
        """Sets the charge_id of this UpdateSubscriptionChargeCustomFieldsOfASpecifiedVersion.

        Use either this field or the `chargeNumber` field to specify the charge for which you will be updating the custom fields. By using this field you actually specify a specific charge segment of a charge. See [Segmented rate plan charges](https://knowledgecenter.zuora.com/Central_Platform/API/G_SOAP_API/E1_SOAP_API_Object_Reference/RatePlanCharge#Segmented_rate_plan_charges) for more information about charge segments.   # noqa: E501

        :param charge_id: The charge_id of this UpdateSubscriptionChargeCustomFieldsOfASpecifiedVersion.  # noqa: E501
        :type: str
        """

        self._charge_id = charge_id

    @property
    def charge_number(self):
        """Gets the charge_number of this UpdateSubscriptionChargeCustomFieldsOfASpecifiedVersion.  # noqa: E501

        Use either this field or the `chargeId` field to specify the charge for which you will be updating the custom fields. By using this field you actually specify the last charge segment of a charge. See [Segmented rate plan charges](https://knowledgecenter.zuora.com/Central_Platform/API/G_SOAP_API/E1_SOAP_API_Object_Reference/RatePlanCharge#Segmented_rate_plan_charges) for more information about charge segments.   # noqa: E501

        :return: The charge_number of this UpdateSubscriptionChargeCustomFieldsOfASpecifiedVersion.  # noqa: E501
        :rtype: str
        """
        return self._charge_number

    @charge_number.setter
    def charge_number(self, charge_number):
        """Sets the charge_number of this UpdateSubscriptionChargeCustomFieldsOfASpecifiedVersion.

        Use either this field or the `chargeId` field to specify the charge for which you will be updating the custom fields. By using this field you actually specify the last charge segment of a charge. See [Segmented rate plan charges](https://knowledgecenter.zuora.com/Central_Platform/API/G_SOAP_API/E1_SOAP_API_Object_Reference/RatePlanCharge#Segmented_rate_plan_charges) for more information about charge segments.   # noqa: E501

        :param charge_number: The charge_number of this UpdateSubscriptionChargeCustomFieldsOfASpecifiedVersion.  # noqa: E501
        :type: str
        """

        self._charge_number = charge_number

    @property
    def custom_fields(self):
        """Gets the custom_fields of this UpdateSubscriptionChargeCustomFieldsOfASpecifiedVersion.  # noqa: E501

        Container for custom fields of a Rate Plan Charge object.   # noqa: E501

        :return: The custom_fields of this UpdateSubscriptionChargeCustomFieldsOfASpecifiedVersion.  # noqa: E501
        :rtype: dict(str, object)
        """
        return self._custom_fields

    @custom_fields.setter
    def custom_fields(self, custom_fields):
        """Sets the custom_fields of this UpdateSubscriptionChargeCustomFieldsOfASpecifiedVersion.

        Container for custom fields of a Rate Plan Charge object.   # noqa: E501

        :param custom_fields: The custom_fields of this UpdateSubscriptionChargeCustomFieldsOfASpecifiedVersion.  # noqa: E501
        :type: dict(str, object)
        """

        self._custom_fields = custom_fields

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(UpdateSubscriptionChargeCustomFieldsOfASpecifiedVersion, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, UpdateSubscriptionChargeCustomFieldsOfASpecifiedVersion):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
