# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).  # noqa: E501

    OpenAPI spec version: 2024-05-20
    Contact: docs@zuora.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class WriteOffCreditMemoRequest(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'comment': 'str',
        'memo_date': 'date',
        'reason_code': 'str'
    }

    attribute_map = {
        'comment': 'comment',
        'memo_date': 'memoDate',
        'reason_code': 'reasonCode'
    }

    def __init__(self, comment=None, memo_date=None, reason_code=None):  # noqa: E501
        """WriteOffCreditMemoRequest - a model defined in Swagger"""  # noqa: E501
        self._comment = None
        self._memo_date = None
        self._reason_code = None
        self.discriminator = None
        if comment is not None:
            self.comment = comment
        if memo_date is not None:
            self.memo_date = memo_date
        if reason_code is not None:
            self.reason_code = reason_code

    @property
    def comment(self):
        """Gets the comment of this WriteOffCreditMemoRequest.  # noqa: E501

        Comments about the debit memo.   # noqa: E501

        :return: The comment of this WriteOffCreditMemoRequest.  # noqa: E501
        :rtype: str
        """
        return self._comment

    @comment.setter
    def comment(self, comment):
        """Sets the comment of this WriteOffCreditMemoRequest.

        Comments about the debit memo.   # noqa: E501

        :param comment: The comment of this WriteOffCreditMemoRequest.  # noqa: E501
        :type: str
        """

        self._comment = comment

    @property
    def memo_date(self):
        """Gets the memo_date of this WriteOffCreditMemoRequest.  # noqa: E501

        The creation date of the debit memo and the effective date of the credit memo. Credit memos are applied to the corresponding debit memos on `memoDate`. By default, `memoDate` is set to the current date.   # noqa: E501

        :return: The memo_date of this WriteOffCreditMemoRequest.  # noqa: E501
        :rtype: date
        """
        return self._memo_date

    @memo_date.setter
    def memo_date(self, memo_date):
        """Sets the memo_date of this WriteOffCreditMemoRequest.

        The creation date of the debit memo and the effective date of the credit memo. Credit memos are applied to the corresponding debit memos on `memoDate`. By default, `memoDate` is set to the current date.   # noqa: E501

        :param memo_date: The memo_date of this WriteOffCreditMemoRequest.  # noqa: E501
        :type: date
        """

        self._memo_date = memo_date

    @property
    def reason_code(self):
        """Gets the reason_code of this WriteOffCreditMemoRequest.  # noqa: E501

        A code identifying the reason for the transaction. The value must be an existing reason code or empty. The default value is `Write-off`.   # noqa: E501

        :return: The reason_code of this WriteOffCreditMemoRequest.  # noqa: E501
        :rtype: str
        """
        return self._reason_code

    @reason_code.setter
    def reason_code(self, reason_code):
        """Sets the reason_code of this WriteOffCreditMemoRequest.

        A code identifying the reason for the transaction. The value must be an existing reason code or empty. The default value is `Write-off`.   # noqa: E501

        :param reason_code: The reason_code of this WriteOffCreditMemoRequest.  # noqa: E501
        :type: str
        """

        self._reason_code = reason_code

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(WriteOffCreditMemoRequest, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, WriteOffCreditMemoRequest):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
